import * as i0 from '@angular/core';
import { HostBinding, ChangeDetectionStrategy, ViewEncapsulation, Component, NgModule, InjectionToken, Input, Attribute, EventEmitter, inject, ElementRef, ViewChild, Output, ContentChild, Directive, Injectable } from '@angular/core';
import { __decorate, __metadata } from 'tslib';
import { applyCssClass, DynamicComponentService } from '@fundamental-ngx/cdk/utils';
import * as i1 from '@fundamental-ngx/core/content-density';
import { contentDensityObserverProviders } from '@fundamental-ngx/core/content-density';
import { Subscription, first } from 'rxjs';
import { A11yModule } from '@angular/cdk/a11y';
import * as i1$1 from '@fundamental-ngx/core/popover';
import { PopoverComponent, PopoverControlComponent, PopoverBodyComponent } from '@fundamental-ngx/core/popover';
import { NgTemplateOutlet } from '@angular/common';
import { IconComponent } from '@fundamental-ngx/core/icon';
import { InlineHelpDirective } from '@fundamental-ngx/core/inline-help';
import { LinkComponent } from '@fundamental-ngx/core/link';

/**
 * Used for easily displaying forms with a margin. Not necessary for fundamental forms to be functional.
 *
 * ```html
 * <div fd-fieldset
 *     <div fd-form-item>
 *         ...
 *     </div>
 * </div>
 * ```
 */
class FieldsetComponent {
    constructor() {
        /** @hidden */
        this.fdFieldClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FieldsetComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: FieldsetComponent, isStandalone: true, selector: "[fd-fieldset]", host: { properties: { "class.fd-fieldset": "this.fdFieldClass" } }, ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, styles: [".fd-form-group{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column}.fd-form-group:after,.fd-form-group:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group--inline{-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row wrap;flex-flow:row wrap;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start}.fd-form-group--with-spacing{gap:.625rem}.fd-form-group__header{border:0;-webkit-box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--sapGroup_TitleBackground);box-sizing:border-box;height:2.75rem;width:100%}.fd-form-group__header:after,.fd-form-group__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group__header[class*=-compact],.fd-form-group__header[class*=-condensed],[class*=-compact] .fd-form-group__header:not([class*=-cozy]),[class*=-condensed] .fd-form-group__header:not([class*=-cozy]){height:2rem}.fd-form-group__header-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--sapFontHeader6Size);font-weight:400;font-weight:700;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-form-group__header-text:after,.fd-form-group__header-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-fieldset{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;min-inline-size:auto;padding-block:0;padding-inline:0}.fd-fieldset:after,.fd-fieldset:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-fieldset__legend{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:block;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-fieldset__legend:after,.fd-fieldset__legend:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-fieldset__legend.is-disabled{opacity:var(--sapContent_DisabledOpacity,.4)}\n/*! Bundled license information:\n\nfundamental-styles/dist/fieldset.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FieldsetComponent, decorators: [{
            type: Component,
            args: [{ selector: '[fd-fieldset]', template: `<ng-content></ng-content>`, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, styles: [".fd-form-group{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column}.fd-form-group:after,.fd-form-group:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group--inline{-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row wrap;flex-flow:row wrap;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start}.fd-form-group--with-spacing{gap:.625rem}.fd-form-group__header{border:0;-webkit-box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--sapGroup_TitleBackground);box-sizing:border-box;height:2.75rem;width:100%}.fd-form-group__header:after,.fd-form-group__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group__header[class*=-compact],.fd-form-group__header[class*=-condensed],[class*=-compact] .fd-form-group__header:not([class*=-cozy]),[class*=-condensed] .fd-form-group__header:not([class*=-cozy]){height:2rem}.fd-form-group__header-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--sapFontHeader6Size);font-weight:400;font-weight:700;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-form-group__header-text:after,.fd-form-group__header-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-fieldset{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;min-inline-size:auto;padding-block:0;padding-inline:0}.fd-fieldset:after,.fd-fieldset:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-fieldset__legend{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:block;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-fieldset__legend:after,.fd-fieldset__legend:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-fieldset__legend.is-disabled{opacity:var(--sapContent_DisabledOpacity,.4)}\n/*! Bundled license information:\n\nfundamental-styles/dist/fieldset.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], propDecorators: { fdFieldClass: [{
                type: HostBinding,
                args: ['class.fd-fieldset']
            }] } });

/**
 * @deprecated
 * Import `FieldsetComponent` directly as a standalone component.
 */
class FieldSetModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FieldSetModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: FieldSetModule, imports: [FieldsetComponent], exports: [FieldsetComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FieldSetModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FieldSetModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [FieldsetComponent],
                    exports: [FieldsetComponent]
                }]
        }] });

/** An injection token, that should be used with all controls, that can be put inside `fd-form-item` */
const FORM_ITEM_CONTROL = new InjectionToken('Form Item Control');
/** Utility function to provide `FORM_ITEM_CONTROL` injection token  */
function registerFormItemControl(control) {
    return {
        provide: FORM_ITEM_CONTROL,
        useExisting: control,
        multi: true
    };
}

/**
 * Directive intended for use on form controls.
 *
 * ```html
 * <input type="text" fd-form-control />
 * ```
 */
class FormControlComponent {
    /** @hidden */
    get ariaLabelBinding() {
        return this.ariaLabelAttr || this.ariaLabel || '';
    }
    /** @hidden */
    get ariaLabelledByBinding() {
        return this.ariaLabelledByAttr || this.ariaLabelledBy || '';
    }
    /** @hidden */
    constructor(elementRef, _contentDensityObserver, ariaLabelAttr, ariaLabelledByAttr) {
        this.elementRef = elementRef;
        this.ariaLabelAttr = ariaLabelAttr;
        this.ariaLabelledByAttr = ariaLabelledByAttr;
        /**
         *  The state of the form control - applies css classes.
         *  Can be `success`, `error`, `warning`, `information` or blank for default.
         */
        this.state = null;
        /** @hidden */
        this._subscriptions = new Subscription();
        _contentDensityObserver.subscribe();
    }
    /**
     * @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        const tagName = this.elementRef.nativeElement.tagName.toLowerCase();
        return [
            this.state ? 'is-' + this.state : '',
            this.class,
            tagName === 'textarea' ? 'fd-textarea' : tagName === 'input' ? 'fd-input' : ''
        ];
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnDestroy() {
        this._subscriptions.unsubscribe();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormControlComponent, deps: [{ token: i0.ElementRef }, { token: i1.ContentDensityObserver }, { token: 'aria-label', attribute: true }, { token: 'aria-labelledby', attribute: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: FormControlComponent, isStandalone: true, selector: "input[fd-form-control], textarea[fd-form-control]", inputs: { state: "state", type: "type", class: "class", ariaLabel: "ariaLabel", ariaLabelledBy: "ariaLabelledBy" }, host: { properties: { "attr.type": "this.type", "attr.aria-label": "this.ariaLabelBinding", "attr.aria-labelledby": "this.ariaLabelledByBinding" } }, providers: [registerFormItemControl(FormControlComponent), contentDensityObserverProviders()], usesOnChanges: true, ngImport: i0, template: ` <ng-content></ng-content>`, isInline: true, styles: [".fd-input{-webkit-appearance:none;-moz-appearance:none;appearance:none;background:var(--sapField_BackgroundStyle,var(--sapField_BackgroundStyle));background-color:var(--sapField_Background,var(--sapField_Background));border:0;border:var(--sapField_BorderWidth) var(--sapField_BorderStyle) var(--sapField_BorderColor);border-radius:var(--sapField_BorderCornerRadius);-webkit-box-shadow:var(--sapField_Shadow);box-shadow:var(--sapField_Shadow);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapField_TextColor);cursor:text;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:var(--fdInput_Height,var(--sapElement_Height));line-height:normal;margin-block:0;margin-block:var(--fdInput_Field_Margin_Block,.25rem);margin-inline:0;min-height:var(--fdInput_Height,var(--sapElement_Height));min-width:2.75rem;outline:none;overflow:hidden;padding-block:0;padding-inline:0;padding-inline:var(--fdInput_Field_Padding_Inline,.625rem);text-overflow:ellipsis;text-shadow:var(--fdInput_Text_Shadow);white-space:nowrap;width:100%;z-index:1}.fd-input:after,.fd-input:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-input::-webkit-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-input::-moz-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-input:-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-input::-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-input::placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-input[dir=rtl]::-webkit-input-placeholder,[dir=rtl] .fd-input::-webkit-input-placeholder{text-indent:.125rem}.fd-input[dir=rtl]::-moz-placeholder,[dir=rtl] .fd-input::-moz-placeholder{text-indent:.125rem}.fd-input[dir=rtl]:-ms-input-placeholder,[dir=rtl] .fd-input:-ms-input-placeholder{text-indent:.125rem}.fd-input[dir=rtl]::-ms-input-placeholder,[dir=rtl] .fd-input::-ms-input-placeholder{text-indent:.125rem}.fd-input[dir=rtl]::placeholder,[dir=rtl] .fd-input::placeholder{text-indent:.125rem}.fd-input::-moz-selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-input::selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-input::-ms-clear{display:none}.fd-input.is-hover,.fd-input:hover{background:var(--sapField_Hover_BackgroundStyle,var(--sapField_Hover_BackgroundStyle));background-color:var(--sapField_Hover_Background,var(--sapField_Hover_Background));border-color:var(--sapField_Hover_BorderColor);-webkit-box-shadow:var(--fdInput_Box_Shadow_Hover);box-shadow:var(--fdInput_Box_Shadow_Hover)}.fd-input.is-focus,.fd-input:focus{background:var(--sapField_Focus_Background,var(--sapField_Focus_Background));-webkit-box-shadow:none;box-shadow:none;outline:var(--fdInput_Outline_Color) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:var(--fdInput_Outline_Offset);z-index:5}.fd-input[type=search]::-webkit-search-cancel-button,.fd-input[type=search]::-webkit-search-decoration,.fd-input[type=search]::-webkit-search-results-button,.fd-input[type=search]::-webkit-search-results-decoration{-webkit-appearance:none;appearance:none}.fd-input[aria-expanded=false]{z-index:0}.fd-input.is-expanded,.fd-input[aria-expanded=true]{z-index:4}.fd-input[class*=-compact],.fd-input[class*=-condensed],[class*=-compact] .fd-input:not([class*=-cozy]),[class*=-condensed] .fd-input:not([class*=-cozy]){-webkit-box-sizing:border-box;box-sizing:border-box;height:var(--fdInput_Compact_Height,var(--sapElement_Compact_Height));margin-block:var(--fdInput_Field_Compact_Margin_Block,.1875rem);margin-inline:0;min-height:var(--fdInput_Compact_Height,var(--sapElement_Compact_Height));min-width:var(--fdInput_Field_Compact_Min_Width,2rem);padding-block:0;padding-inline:var(--fdInput_Field_Compact_Padding,.5rem)}.fd-input--no-number-spinner{-webkit-appearance:textfield;-moz-appearance:textfield;appearance:textfield}.fd-input--no-number-spinner::-webkit-inner-spin-button,.fd-input--no-number-spinner::-webkit-outer-spin-button{-webkit-appearance:none;appearance:none;margin-block:0;margin-inline:0}.fd-input.right-align{text-align:right}.fd-input.is-success{background:var(--sapField_SuccessBackgroundStyle);background-color:var(--sapField_SuccessBackground);border:var(--sapField_SuccessColor) var(--sapField_SuccessBorderWidth) var(--sapField_SuccessBorderStyle);-webkit-box-shadow:var(--sapField_SuccessShadow);box-shadow:var(--sapField_SuccessShadow)}.fd-input.is-success.is-hover,.fd-input.is-success:hover{background-color:var(--fdInput_Success_Background_Color_Hover);border-color:var(--sapField_SuccessColor);-webkit-box-shadow:var(--fdInput_Success_Box_Shadow_Hover);box-shadow:var(--fdInput_Success_Box_Shadow_Hover)}.fd-input.is-success.is-focus,.fd-input.is-success:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Success_Outline_Color);z-index:5}.fd-input.is-success.is-focus.is-hover,.fd-input.is-success.is-focus:hover,.fd-input.is-success:focus.is-hover,.fd-input.is-success:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-input.is-success.is-expanded,.fd-input.is-success[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Success_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-input.is-error{background:var(--sapField_InvalidBackgroundStyle);background-color:var(--sapField_InvalidBackground);border:var(--sapField_InvalidColor) var(--sapField_InvalidBorderWidth) var(--sapField_InvalidBorderStyle);-webkit-box-shadow:var(--sapField_InvalidShadow);box-shadow:var(--sapField_InvalidShadow)}.fd-input.is-error.is-hover,.fd-input.is-error:hover{background-color:var(--fdInput_Error_Background_Color_Hover);border-color:var(--sapField_InvalidColor);-webkit-box-shadow:var(--fdInput_Error_Box_Shadow_Hover);box-shadow:var(--fdInput_Error_Box_Shadow_Hover)}.fd-input.is-error.is-focus,.fd-input.is-error:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Error_Outline_Color);z-index:5}.fd-input.is-error.is-focus.is-hover,.fd-input.is-error.is-focus:hover,.fd-input.is-error:focus.is-hover,.fd-input.is-error:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-input.is-error.is-expanded,.fd-input.is-error[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Error_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-input.is-warning{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle);-webkit-box-shadow:var(--sapField_WarningShadow);box-shadow:var(--sapField_WarningShadow)}.fd-input.is-warning.is-hover,.fd-input.is-warning:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-input.is-warning.is-focus,.fd-input.is-warning:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-input.is-warning.is-focus.is-hover,.fd-input.is-warning.is-focus:hover,.fd-input.is-warning:focus.is-hover,.fd-input.is-warning:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-input.is-warning.is-expanded,.fd-input.is-warning[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-input.is-alert{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle)}.fd-input.is-alert.is-hover,.fd-input.is-alert:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-input.is-alert.is-focus,.fd-input.is-alert:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-input.is-alert.is-focus.is-hover,.fd-input.is-alert.is-focus:hover,.fd-input.is-alert:focus.is-hover,.fd-input.is-alert:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-input.is-alert.is-expanded,.fd-input.is-alert[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-input.is-information{background:var(--sapField_InformationBackgroundStyle);background-color:var(--sapField_InformationBackground);border:var(--sapField_InformationColor) var(--sapField_InformationBorderWidth) var(--sapField_InformationBorderStyle);-webkit-box-shadow:var(--sapField_InformationShadow);box-shadow:var(--sapField_InformationShadow)}.fd-input.is-information.is-hover,.fd-input.is-information:hover{background-color:var(--fdInput_Information_Background_Color_Hover);border-color:var(--sapField_InformationColor);-webkit-box-shadow:var(--fdInput_Information_Box_Shadow_Hover);box-shadow:var(--fdInput_Information_Box_Shadow_Hover)}.fd-input.is-information.is-focus,.fd-input.is-information:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Information_Outline_Color);z-index:5}.fd-input.is-information.is-focus.is-hover,.fd-input.is-information.is-focus:hover,.fd-input.is-information:focus.is-hover,.fd-input.is-information:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-input.is-information.is-expanded,.fd-input.is-information[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Information_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-input.is-alert,.fd-input.is-error,.fd-input.is-warning{font-style:var(--fdInput_State_Text_Style);font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert::-webkit-input-placeholder,.fd-input.is-error::-webkit-input-placeholder,.fd-input.is-warning::-webkit-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert::-moz-placeholder,.fd-input.is-error::-moz-placeholder,.fd-input.is-warning::-moz-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert:-ms-input-placeholder,.fd-input.is-error:-ms-input-placeholder,.fd-input.is-warning:-ms-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert::-ms-input-placeholder,.fd-input.is-error::-ms-input-placeholder,.fd-input.is-warning::-ms-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert::placeholder,.fd-input.is-error::placeholder,.fd-input.is-warning::placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert.is-focus,.fd-input.is-alert:focus,.fd-input.is-error.is-focus,.fd-input.is-error:focus,.fd-input.is-information.is-focus,.fd-input.is-information:focus,.fd-input.is-warning.is-focus,.fd-input.is-warning:focus{outline-offset:var(--fdInput_Outline_Offset_States);z-index:5}.fd-input.is-error::-webkit-input-placeholder{color:var(--sapField_TextColor)}.fd-input.is-error::-moz-placeholder{color:var(--sapField_TextColor)}.fd-input.is-error:-ms-input-placeholder{color:var(--sapField_TextColor)}.fd-input.is-error::-ms-input-placeholder{color:var(--sapField_TextColor)}.fd-input.is-error::placeholder{color:var(--sapField_TextColor)}.fd-input.is-disabled,.fd-input:disabled,.fd-input[aria-disabled=true]{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-input.is-disabled::-webkit-input-placeholder,.fd-input:disabled::-webkit-input-placeholder,.fd-input[aria-disabled=true]::-webkit-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-disabled::-moz-placeholder,.fd-input:disabled::-moz-placeholder,.fd-input[aria-disabled=true]::-moz-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-disabled:-ms-input-placeholder,.fd-input:disabled:-ms-input-placeholder,.fd-input[aria-disabled=true]:-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-disabled::-ms-input-placeholder,.fd-input:disabled::-ms-input-placeholder,.fd-input[aria-disabled=true]::-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-disabled::placeholder,.fd-input:disabled::placeholder,.fd-input[aria-disabled=true]::placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly,.fd-input[aria-readonly=true],.fd-input[readonly]{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-input.is-readonly::-webkit-input-placeholder,.fd-input[aria-readonly=true]::-webkit-input-placeholder,.fd-input[readonly]::-webkit-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly::-moz-placeholder,.fd-input[aria-readonly=true]::-moz-placeholder,.fd-input[readonly]::-moz-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly:-ms-input-placeholder,.fd-input[aria-readonly=true]:-ms-input-placeholder,.fd-input[readonly]:-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly::-ms-input-placeholder,.fd-input[aria-readonly=true]::-ms-input-placeholder,.fd-input[readonly]::-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly::placeholder,.fd-input[aria-readonly=true]::placeholder,.fd-input[readonly]::placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly.is-focus,.fd-input.is-readonly.is-hover,.fd-input.is-readonly:focus,.fd-input.is-readonly:hover,.fd-input[aria-readonly=true].is-focus,.fd-input[aria-readonly=true].is-hover,.fd-input[aria-readonly=true]:focus,.fd-input[aria-readonly=true]:hover,.fd-input[readonly].is-focus,.fd-input[readonly].is-hover,.fd-input[readonly]:focus,.fd-input[readonly]:hover{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-input.is-readonly.is-focus,.fd-input.is-readonly:focus,.fd-input[aria-readonly=true].is-focus,.fd-input[aria-readonly=true]:focus,.fd-input[readonly].is-focus,.fd-input[readonly]:focus{z-index:5}.fd-textarea{-webkit-appearance:none;-moz-appearance:none;appearance:none;background:var(--sapField_BackgroundStyle,var(--sapField_BackgroundStyle));background-color:var(--sapField_Background,var(--sapField_Background));border:0;border:var(--sapField_BorderWidth) var(--sapField_BorderStyle) var(--sapField_BorderColor);border-radius:var(--sapField_BorderCornerRadius);-webkit-box-shadow:var(--sapField_Shadow);box-shadow:var(--sapField_Shadow);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapField_TextColor);cursor:text;display:block;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:var(--fdInput_Height,var(--sapElement_Height));height:auto;line-height:normal;line-height:var(--fdTextarea_Line_Height);margin-block:0;margin-block:var(--fdInput_Field_Margin_Block,.25rem);margin-block:.25rem;margin-inline:0;min-height:var(--fdInput_Height,var(--sapElement_Height));min-height:2.25rem;min-width:2.75rem;min-width:6rem;outline:none;overflow:hidden;overflow:auto;padding-block:0;padding-block:.5rem;padding-inline:0;padding-inline:var(--fdInput_Field_Padding_Inline,.625rem);padding-inline:.75rem;padding-inline:.625rem;position:relative;resize:none;scrollbar-color:var(--fdScrollbar_Thumb_Color) var(--fdScrollbar_Track_Color);text-overflow:ellipsis;text-shadow:var(--fdInput_Text_Shadow);white-space:nowrap;white-space:pre-wrap;width:100%;z-index:1}.fd-textarea.is-focus,.fd-textarea:focus{outline:none}.fd-textarea::-webkit-scrollbar{height:var(--fdScrollbar_Dimension);width:var(--fdScrollbar_Dimension)}.fd-textarea::-webkit-scrollbar-corner,.fd-textarea::-webkit-scrollbar-track{background-color:var(--fdScrollbar_Track_Color)}.fd-textarea::-webkit-scrollbar-thumb{background-color:transparent;border:var(--fdScrollbar_Thumb_Offset) solid transparent;border-radius:calc(var(--fdScrollbar_Thumb_Border_Radius) - var(--fdScrollbar_Thumb_Offset));-webkit-box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Color);box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Color)}.fd-textarea::-webkit-scrollbar-thumb:active,.fd-textarea::-webkit-scrollbar-thumb:hover{-webkit-box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Hover_Color);box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Hover_Color)}.fd-textarea:after,.fd-textarea:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-textarea::-webkit-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-textarea::-moz-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-textarea:-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-textarea::-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-textarea::placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-textarea[dir=rtl]::-webkit-input-placeholder,[dir=rtl] .fd-textarea::-webkit-input-placeholder{text-indent:.125rem}.fd-textarea[dir=rtl]::-moz-placeholder,[dir=rtl] .fd-textarea::-moz-placeholder{text-indent:.125rem}.fd-textarea[dir=rtl]:-ms-input-placeholder,[dir=rtl] .fd-textarea:-ms-input-placeholder{text-indent:.125rem}.fd-textarea[dir=rtl]::-ms-input-placeholder,[dir=rtl] .fd-textarea::-ms-input-placeholder{text-indent:.125rem}.fd-textarea[dir=rtl]::placeholder,[dir=rtl] .fd-textarea::placeholder{text-indent:.125rem}.fd-textarea::-moz-selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-textarea::selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-textarea::-ms-clear{display:none}.fd-textarea.is-hover,.fd-textarea:hover{background:var(--sapField_Hover_BackgroundStyle,var(--sapField_Hover_BackgroundStyle));background-color:var(--sapField_Hover_Background,var(--sapField_Hover_Background));border-color:var(--sapField_Hover_BorderColor);-webkit-box-shadow:var(--fdInput_Box_Shadow_Hover);box-shadow:var(--fdInput_Box_Shadow_Hover)}.fd-textarea.is-focus,.fd-textarea:focus{background:var(--sapField_Focus_Background,var(--sapField_Focus_Background));-webkit-box-shadow:none;box-shadow:none;outline:var(--fdInput_Outline_Color) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:var(--fdInput_Outline_Offset);z-index:5}.fd-textarea.is-success{background:var(--sapField_SuccessBackgroundStyle);background-color:var(--sapField_SuccessBackground);border:var(--sapField_SuccessColor) var(--sapField_SuccessBorderWidth) var(--sapField_SuccessBorderStyle);-webkit-box-shadow:var(--sapField_SuccessShadow);box-shadow:var(--sapField_SuccessShadow)}.fd-textarea.is-success.is-hover,.fd-textarea.is-success:hover{background-color:var(--fdInput_Success_Background_Color_Hover);border-color:var(--sapField_SuccessColor);-webkit-box-shadow:var(--fdInput_Success_Box_Shadow_Hover);box-shadow:var(--fdInput_Success_Box_Shadow_Hover)}.fd-textarea.is-success.is-focus,.fd-textarea.is-success:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Success_Outline_Color);z-index:5}.fd-textarea.is-success.is-focus.is-hover,.fd-textarea.is-success.is-focus:hover,.fd-textarea.is-success:focus.is-hover,.fd-textarea.is-success:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-success.is-expanded,.fd-textarea.is-success[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Success_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-textarea.is-error{background:var(--sapField_InvalidBackgroundStyle);background-color:var(--sapField_InvalidBackground);border:var(--sapField_InvalidColor) var(--sapField_InvalidBorderWidth) var(--sapField_InvalidBorderStyle);-webkit-box-shadow:var(--sapField_InvalidShadow);box-shadow:var(--sapField_InvalidShadow)}.fd-textarea.is-error.is-hover,.fd-textarea.is-error:hover{background-color:var(--fdInput_Error_Background_Color_Hover);border-color:var(--sapField_InvalidColor);-webkit-box-shadow:var(--fdInput_Error_Box_Shadow_Hover);box-shadow:var(--fdInput_Error_Box_Shadow_Hover)}.fd-textarea.is-error.is-focus,.fd-textarea.is-error:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Error_Outline_Color);z-index:5}.fd-textarea.is-error.is-focus.is-hover,.fd-textarea.is-error.is-focus:hover,.fd-textarea.is-error:focus.is-hover,.fd-textarea.is-error:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-error.is-expanded,.fd-textarea.is-error[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Error_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-textarea.is-warning{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle);-webkit-box-shadow:var(--sapField_WarningShadow);box-shadow:var(--sapField_WarningShadow)}.fd-textarea.is-warning.is-hover,.fd-textarea.is-warning:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-textarea.is-warning.is-focus,.fd-textarea.is-warning:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-textarea.is-warning.is-focus.is-hover,.fd-textarea.is-warning.is-focus:hover,.fd-textarea.is-warning:focus.is-hover,.fd-textarea.is-warning:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-warning.is-expanded,.fd-textarea.is-warning[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-textarea.is-alert{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle)}.fd-textarea.is-alert.is-hover,.fd-textarea.is-alert:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-textarea.is-alert.is-focus,.fd-textarea.is-alert:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-textarea.is-alert.is-focus.is-hover,.fd-textarea.is-alert.is-focus:hover,.fd-textarea.is-alert:focus.is-hover,.fd-textarea.is-alert:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-alert.is-expanded,.fd-textarea.is-alert[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-textarea.is-information{background:var(--sapField_InformationBackgroundStyle);background-color:var(--sapField_InformationBackground);border:var(--sapField_InformationColor) var(--sapField_InformationBorderWidth) var(--sapField_InformationBorderStyle);-webkit-box-shadow:var(--sapField_InformationShadow);box-shadow:var(--sapField_InformationShadow)}.fd-textarea.is-information.is-hover,.fd-textarea.is-information:hover{background-color:var(--fdInput_Information_Background_Color_Hover);border-color:var(--sapField_InformationColor);-webkit-box-shadow:var(--fdInput_Information_Box_Shadow_Hover);box-shadow:var(--fdInput_Information_Box_Shadow_Hover)}.fd-textarea.is-information.is-focus,.fd-textarea.is-information:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Information_Outline_Color);z-index:5}.fd-textarea.is-information.is-focus.is-hover,.fd-textarea.is-information.is-focus:hover,.fd-textarea.is-information:focus.is-hover,.fd-textarea.is-information:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-information.is-expanded,.fd-textarea.is-information[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Information_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-textarea.is-alert,.fd-textarea.is-error,.fd-textarea.is-warning{font-style:var(--fdInput_State_Text_Style);font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert::-webkit-input-placeholder,.fd-textarea.is-error::-webkit-input-placeholder,.fd-textarea.is-warning::-webkit-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert::-moz-placeholder,.fd-textarea.is-error::-moz-placeholder,.fd-textarea.is-warning::-moz-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert:-ms-input-placeholder,.fd-textarea.is-error:-ms-input-placeholder,.fd-textarea.is-warning:-ms-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert::-ms-input-placeholder,.fd-textarea.is-error::-ms-input-placeholder,.fd-textarea.is-warning::-ms-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert::placeholder,.fd-textarea.is-error::placeholder,.fd-textarea.is-warning::placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert.is-focus,.fd-textarea.is-alert:focus,.fd-textarea.is-error.is-focus,.fd-textarea.is-error:focus,.fd-textarea.is-information.is-focus,.fd-textarea.is-information:focus,.fd-textarea.is-warning.is-focus,.fd-textarea.is-warning:focus{outline-offset:var(--fdInput_Outline_Offset_States);z-index:5}.fd-textarea.is-error::-webkit-input-placeholder{color:var(--sapField_TextColor)}.fd-textarea.is-error::-moz-placeholder{color:var(--sapField_TextColor)}.fd-textarea.is-error:-ms-input-placeholder{color:var(--sapField_TextColor)}.fd-textarea.is-error::-ms-input-placeholder{color:var(--sapField_TextColor)}.fd-textarea.is-error::placeholder{color:var(--sapField_TextColor)}.fd-textarea.is-disabled,.fd-textarea:disabled,.fd-textarea[aria-disabled=true]{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-textarea.is-disabled::-webkit-input-placeholder,.fd-textarea:disabled::-webkit-input-placeholder,.fd-textarea[aria-disabled=true]::-webkit-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-disabled::-moz-placeholder,.fd-textarea:disabled::-moz-placeholder,.fd-textarea[aria-disabled=true]::-moz-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-disabled:-ms-input-placeholder,.fd-textarea:disabled:-ms-input-placeholder,.fd-textarea[aria-disabled=true]:-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-disabled::-ms-input-placeholder,.fd-textarea:disabled::-ms-input-placeholder,.fd-textarea[aria-disabled=true]::-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-disabled::placeholder,.fd-textarea:disabled::placeholder,.fd-textarea[aria-disabled=true]::placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly,.fd-textarea[aria-readonly=true],.fd-textarea[readonly]{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-readonly::-webkit-input-placeholder,.fd-textarea[aria-readonly=true]::-webkit-input-placeholder,.fd-textarea[readonly]::-webkit-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly::-moz-placeholder,.fd-textarea[aria-readonly=true]::-moz-placeholder,.fd-textarea[readonly]::-moz-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly:-ms-input-placeholder,.fd-textarea[aria-readonly=true]:-ms-input-placeholder,.fd-textarea[readonly]:-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly::-ms-input-placeholder,.fd-textarea[aria-readonly=true]::-ms-input-placeholder,.fd-textarea[readonly]::-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly::placeholder,.fd-textarea[aria-readonly=true]::placeholder,.fd-textarea[readonly]::placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly.is-focus,.fd-textarea.is-readonly.is-hover,.fd-textarea.is-readonly:focus,.fd-textarea.is-readonly:hover,.fd-textarea[aria-readonly=true].is-focus,.fd-textarea[aria-readonly=true].is-hover,.fd-textarea[aria-readonly=true]:focus,.fd-textarea[aria-readonly=true]:hover,.fd-textarea[readonly].is-focus,.fd-textarea[readonly].is-hover,.fd-textarea[readonly]:focus,.fd-textarea[readonly]:hover{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-readonly.is-focus,.fd-textarea.is-readonly:focus,.fd-textarea[aria-readonly=true].is-focus,.fd-textarea[aria-readonly=true]:focus,.fd-textarea[readonly].is-focus,.fd-textarea[readonly]:focus{z-index:5}.fd-textarea.is-readonly,.fd-textarea[readonly]{background:var(--sapField_ReadOnly_Background);border:var(--sapField_BorderWidth) dashed var(--sapField_ReadOnly_BorderColor);border-radius:var(--sapField_BorderCornerRadius)}.fd-textarea.is-readonly.is-hover,.fd-textarea.is-readonly:hover,.fd-textarea[readonly].is-hover,.fd-textarea[readonly]:hover{background:var(--sapField_ReadOnly_Background)}.fd-textarea.is-readonly.is-focus,.fd-textarea.is-readonly:focus,.fd-textarea[readonly].is-focus,.fd-textarea[readonly]:focus{background:var(--sapField_ReadOnly_Background);outline-offset:-.25rem;z-index:5}.fd-textarea::-webkit-scrollbar-corner,.fd-textarea::-webkit-scrollbar-track{background:transparent;border-radius:0 var(--sapField_BorderCornerRadius) var(--sapField_BorderCornerRadius) 0!important}.fd-textarea[aria-expanded=false]{z-index:0}.fd-textarea.is-expanded,.fd-textarea[aria-expanded=true]{z-index:4}.fd-textarea[class*=-compact],.fd-textarea[class*=-condensed],[class*=-compact] .fd-textarea:not([class*=-cozy]),[class*=-condensed] .fd-textarea:not([class*=-cozy]){margin-block:.1875rem;margin-inline:0;min-height:1.625rem;padding-block:.1875rem;padding-inline:.5rem}.fd-textarea-counter{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:var(--sapFontSmallSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-block:.375rem .5rem;padding-inline:0;padding-inline:.125rem;text-align:end;text-overflow:ellipsis;white-space:nowrap}.fd-textarea-counter:after,.fd-textarea-counter:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-textarea-counter.is-disabled,.fd-textarea-counter.is-readonly,.fd-textarea-counter:disabled,.fd-textarea-counter[aria-disabled=true],.fd-textarea-counter[readonly]{display:none}.fd-textarea-counter-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:center;-ms-flex-align:center;align-items:center;padding-block:.375rem .5rem}.fd-textarea-counter-container:after,.fd-textarea-counter-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-textarea-counter-container .fd-textarea-counter{padding-block:0;-webkit-margin-start:auto;margin-inline-start:auto}.fd-textarea--ai{position:relative}.fd-textarea--ai:has(.fd-ai-busy-indicator){padding-block:0;padding-inline:0}.fd-textarea--ai .fd-toolbar--ai{bottom:0;left:0;position:absolute;right:0}.fd-input.is-readonly,.fd-input[aria-readonly=true],.fd-input[readonly],.fd-input.is-readonly.is-hover,.fd-input.is-readonly:hover,.fd-input[aria-readonly=true].is-hover,.fd-input[aria-readonly=true]:hover,.fd-input[readonly].is-hover,.fd-input[readonly]:hover{z-index:1!important}.fd-input.is-readonly.is-focus,.fd-input.is-readonly:focus,.fd-input[aria-readonly=true].is-focus,.fd-input[aria-readonly=true]:focus,.fd-input[readonly].is-focus,.fd-input[readonly]:focus{z-index:1!important}\n/*! Bundled license information:\n\nfundamental-styles/dist/textarea.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], FormControlComponent.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'input[fd-form-control], textarea[fd-form-control]', template: ` <ng-content></ng-content>`, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, providers: [registerFormItemControl(FormControlComponent), contentDensityObserverProviders()], styles: [".fd-input{-webkit-appearance:none;-moz-appearance:none;appearance:none;background:var(--sapField_BackgroundStyle,var(--sapField_BackgroundStyle));background-color:var(--sapField_Background,var(--sapField_Background));border:0;border:var(--sapField_BorderWidth) var(--sapField_BorderStyle) var(--sapField_BorderColor);border-radius:var(--sapField_BorderCornerRadius);-webkit-box-shadow:var(--sapField_Shadow);box-shadow:var(--sapField_Shadow);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapField_TextColor);cursor:text;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:var(--fdInput_Height,var(--sapElement_Height));line-height:normal;margin-block:0;margin-block:var(--fdInput_Field_Margin_Block,.25rem);margin-inline:0;min-height:var(--fdInput_Height,var(--sapElement_Height));min-width:2.75rem;outline:none;overflow:hidden;padding-block:0;padding-inline:0;padding-inline:var(--fdInput_Field_Padding_Inline,.625rem);text-overflow:ellipsis;text-shadow:var(--fdInput_Text_Shadow);white-space:nowrap;width:100%;z-index:1}.fd-input:after,.fd-input:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-input::-webkit-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-input::-moz-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-input:-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-input::-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-input::placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-input[dir=rtl]::-webkit-input-placeholder,[dir=rtl] .fd-input::-webkit-input-placeholder{text-indent:.125rem}.fd-input[dir=rtl]::-moz-placeholder,[dir=rtl] .fd-input::-moz-placeholder{text-indent:.125rem}.fd-input[dir=rtl]:-ms-input-placeholder,[dir=rtl] .fd-input:-ms-input-placeholder{text-indent:.125rem}.fd-input[dir=rtl]::-ms-input-placeholder,[dir=rtl] .fd-input::-ms-input-placeholder{text-indent:.125rem}.fd-input[dir=rtl]::placeholder,[dir=rtl] .fd-input::placeholder{text-indent:.125rem}.fd-input::-moz-selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-input::selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-input::-ms-clear{display:none}.fd-input.is-hover,.fd-input:hover{background:var(--sapField_Hover_BackgroundStyle,var(--sapField_Hover_BackgroundStyle));background-color:var(--sapField_Hover_Background,var(--sapField_Hover_Background));border-color:var(--sapField_Hover_BorderColor);-webkit-box-shadow:var(--fdInput_Box_Shadow_Hover);box-shadow:var(--fdInput_Box_Shadow_Hover)}.fd-input.is-focus,.fd-input:focus{background:var(--sapField_Focus_Background,var(--sapField_Focus_Background));-webkit-box-shadow:none;box-shadow:none;outline:var(--fdInput_Outline_Color) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:var(--fdInput_Outline_Offset);z-index:5}.fd-input[type=search]::-webkit-search-cancel-button,.fd-input[type=search]::-webkit-search-decoration,.fd-input[type=search]::-webkit-search-results-button,.fd-input[type=search]::-webkit-search-results-decoration{-webkit-appearance:none;appearance:none}.fd-input[aria-expanded=false]{z-index:0}.fd-input.is-expanded,.fd-input[aria-expanded=true]{z-index:4}.fd-input[class*=-compact],.fd-input[class*=-condensed],[class*=-compact] .fd-input:not([class*=-cozy]),[class*=-condensed] .fd-input:not([class*=-cozy]){-webkit-box-sizing:border-box;box-sizing:border-box;height:var(--fdInput_Compact_Height,var(--sapElement_Compact_Height));margin-block:var(--fdInput_Field_Compact_Margin_Block,.1875rem);margin-inline:0;min-height:var(--fdInput_Compact_Height,var(--sapElement_Compact_Height));min-width:var(--fdInput_Field_Compact_Min_Width,2rem);padding-block:0;padding-inline:var(--fdInput_Field_Compact_Padding,.5rem)}.fd-input--no-number-spinner{-webkit-appearance:textfield;-moz-appearance:textfield;appearance:textfield}.fd-input--no-number-spinner::-webkit-inner-spin-button,.fd-input--no-number-spinner::-webkit-outer-spin-button{-webkit-appearance:none;appearance:none;margin-block:0;margin-inline:0}.fd-input.right-align{text-align:right}.fd-input.is-success{background:var(--sapField_SuccessBackgroundStyle);background-color:var(--sapField_SuccessBackground);border:var(--sapField_SuccessColor) var(--sapField_SuccessBorderWidth) var(--sapField_SuccessBorderStyle);-webkit-box-shadow:var(--sapField_SuccessShadow);box-shadow:var(--sapField_SuccessShadow)}.fd-input.is-success.is-hover,.fd-input.is-success:hover{background-color:var(--fdInput_Success_Background_Color_Hover);border-color:var(--sapField_SuccessColor);-webkit-box-shadow:var(--fdInput_Success_Box_Shadow_Hover);box-shadow:var(--fdInput_Success_Box_Shadow_Hover)}.fd-input.is-success.is-focus,.fd-input.is-success:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Success_Outline_Color);z-index:5}.fd-input.is-success.is-focus.is-hover,.fd-input.is-success.is-focus:hover,.fd-input.is-success:focus.is-hover,.fd-input.is-success:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-input.is-success.is-expanded,.fd-input.is-success[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Success_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-input.is-error{background:var(--sapField_InvalidBackgroundStyle);background-color:var(--sapField_InvalidBackground);border:var(--sapField_InvalidColor) var(--sapField_InvalidBorderWidth) var(--sapField_InvalidBorderStyle);-webkit-box-shadow:var(--sapField_InvalidShadow);box-shadow:var(--sapField_InvalidShadow)}.fd-input.is-error.is-hover,.fd-input.is-error:hover{background-color:var(--fdInput_Error_Background_Color_Hover);border-color:var(--sapField_InvalidColor);-webkit-box-shadow:var(--fdInput_Error_Box_Shadow_Hover);box-shadow:var(--fdInput_Error_Box_Shadow_Hover)}.fd-input.is-error.is-focus,.fd-input.is-error:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Error_Outline_Color);z-index:5}.fd-input.is-error.is-focus.is-hover,.fd-input.is-error.is-focus:hover,.fd-input.is-error:focus.is-hover,.fd-input.is-error:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-input.is-error.is-expanded,.fd-input.is-error[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Error_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-input.is-warning{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle);-webkit-box-shadow:var(--sapField_WarningShadow);box-shadow:var(--sapField_WarningShadow)}.fd-input.is-warning.is-hover,.fd-input.is-warning:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-input.is-warning.is-focus,.fd-input.is-warning:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-input.is-warning.is-focus.is-hover,.fd-input.is-warning.is-focus:hover,.fd-input.is-warning:focus.is-hover,.fd-input.is-warning:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-input.is-warning.is-expanded,.fd-input.is-warning[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-input.is-alert{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle)}.fd-input.is-alert.is-hover,.fd-input.is-alert:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-input.is-alert.is-focus,.fd-input.is-alert:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-input.is-alert.is-focus.is-hover,.fd-input.is-alert.is-focus:hover,.fd-input.is-alert:focus.is-hover,.fd-input.is-alert:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-input.is-alert.is-expanded,.fd-input.is-alert[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-input.is-information{background:var(--sapField_InformationBackgroundStyle);background-color:var(--sapField_InformationBackground);border:var(--sapField_InformationColor) var(--sapField_InformationBorderWidth) var(--sapField_InformationBorderStyle);-webkit-box-shadow:var(--sapField_InformationShadow);box-shadow:var(--sapField_InformationShadow)}.fd-input.is-information.is-hover,.fd-input.is-information:hover{background-color:var(--fdInput_Information_Background_Color_Hover);border-color:var(--sapField_InformationColor);-webkit-box-shadow:var(--fdInput_Information_Box_Shadow_Hover);box-shadow:var(--fdInput_Information_Box_Shadow_Hover)}.fd-input.is-information.is-focus,.fd-input.is-information:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Information_Outline_Color);z-index:5}.fd-input.is-information.is-focus.is-hover,.fd-input.is-information.is-focus:hover,.fd-input.is-information:focus.is-hover,.fd-input.is-information:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-input.is-information.is-expanded,.fd-input.is-information[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Information_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-input.is-alert,.fd-input.is-error,.fd-input.is-warning{font-style:var(--fdInput_State_Text_Style);font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert::-webkit-input-placeholder,.fd-input.is-error::-webkit-input-placeholder,.fd-input.is-warning::-webkit-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert::-moz-placeholder,.fd-input.is-error::-moz-placeholder,.fd-input.is-warning::-moz-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert:-ms-input-placeholder,.fd-input.is-error:-ms-input-placeholder,.fd-input.is-warning:-ms-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert::-ms-input-placeholder,.fd-input.is-error::-ms-input-placeholder,.fd-input.is-warning::-ms-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert::placeholder,.fd-input.is-error::placeholder,.fd-input.is-warning::placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-input.is-alert.is-focus,.fd-input.is-alert:focus,.fd-input.is-error.is-focus,.fd-input.is-error:focus,.fd-input.is-information.is-focus,.fd-input.is-information:focus,.fd-input.is-warning.is-focus,.fd-input.is-warning:focus{outline-offset:var(--fdInput_Outline_Offset_States);z-index:5}.fd-input.is-error::-webkit-input-placeholder{color:var(--sapField_TextColor)}.fd-input.is-error::-moz-placeholder{color:var(--sapField_TextColor)}.fd-input.is-error:-ms-input-placeholder{color:var(--sapField_TextColor)}.fd-input.is-error::-ms-input-placeholder{color:var(--sapField_TextColor)}.fd-input.is-error::placeholder{color:var(--sapField_TextColor)}.fd-input.is-disabled,.fd-input:disabled,.fd-input[aria-disabled=true]{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-input.is-disabled::-webkit-input-placeholder,.fd-input:disabled::-webkit-input-placeholder,.fd-input[aria-disabled=true]::-webkit-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-disabled::-moz-placeholder,.fd-input:disabled::-moz-placeholder,.fd-input[aria-disabled=true]::-moz-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-disabled:-ms-input-placeholder,.fd-input:disabled:-ms-input-placeholder,.fd-input[aria-disabled=true]:-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-disabled::-ms-input-placeholder,.fd-input:disabled::-ms-input-placeholder,.fd-input[aria-disabled=true]::-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-disabled::placeholder,.fd-input:disabled::placeholder,.fd-input[aria-disabled=true]::placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly,.fd-input[aria-readonly=true],.fd-input[readonly]{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-input.is-readonly::-webkit-input-placeholder,.fd-input[aria-readonly=true]::-webkit-input-placeholder,.fd-input[readonly]::-webkit-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly::-moz-placeholder,.fd-input[aria-readonly=true]::-moz-placeholder,.fd-input[readonly]::-moz-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly:-ms-input-placeholder,.fd-input[aria-readonly=true]:-ms-input-placeholder,.fd-input[readonly]:-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly::-ms-input-placeholder,.fd-input[aria-readonly=true]::-ms-input-placeholder,.fd-input[readonly]::-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly::placeholder,.fd-input[aria-readonly=true]::placeholder,.fd-input[readonly]::placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-input.is-readonly.is-focus,.fd-input.is-readonly.is-hover,.fd-input.is-readonly:focus,.fd-input.is-readonly:hover,.fd-input[aria-readonly=true].is-focus,.fd-input[aria-readonly=true].is-hover,.fd-input[aria-readonly=true]:focus,.fd-input[aria-readonly=true]:hover,.fd-input[readonly].is-focus,.fd-input[readonly].is-hover,.fd-input[readonly]:focus,.fd-input[readonly]:hover{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-input.is-readonly.is-focus,.fd-input.is-readonly:focus,.fd-input[aria-readonly=true].is-focus,.fd-input[aria-readonly=true]:focus,.fd-input[readonly].is-focus,.fd-input[readonly]:focus{z-index:5}.fd-textarea{-webkit-appearance:none;-moz-appearance:none;appearance:none;background:var(--sapField_BackgroundStyle,var(--sapField_BackgroundStyle));background-color:var(--sapField_Background,var(--sapField_Background));border:0;border:var(--sapField_BorderWidth) var(--sapField_BorderStyle) var(--sapField_BorderColor);border-radius:var(--sapField_BorderCornerRadius);-webkit-box-shadow:var(--sapField_Shadow);box-shadow:var(--sapField_Shadow);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapField_TextColor);cursor:text;display:block;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:var(--fdInput_Height,var(--sapElement_Height));height:auto;line-height:normal;line-height:var(--fdTextarea_Line_Height);margin-block:0;margin-block:var(--fdInput_Field_Margin_Block,.25rem);margin-block:.25rem;margin-inline:0;min-height:var(--fdInput_Height,var(--sapElement_Height));min-height:2.25rem;min-width:2.75rem;min-width:6rem;outline:none;overflow:hidden;overflow:auto;padding-block:0;padding-block:.5rem;padding-inline:0;padding-inline:var(--fdInput_Field_Padding_Inline,.625rem);padding-inline:.75rem;padding-inline:.625rem;position:relative;resize:none;scrollbar-color:var(--fdScrollbar_Thumb_Color) var(--fdScrollbar_Track_Color);text-overflow:ellipsis;text-shadow:var(--fdInput_Text_Shadow);white-space:nowrap;white-space:pre-wrap;width:100%;z-index:1}.fd-textarea.is-focus,.fd-textarea:focus{outline:none}.fd-textarea::-webkit-scrollbar{height:var(--fdScrollbar_Dimension);width:var(--fdScrollbar_Dimension)}.fd-textarea::-webkit-scrollbar-corner,.fd-textarea::-webkit-scrollbar-track{background-color:var(--fdScrollbar_Track_Color)}.fd-textarea::-webkit-scrollbar-thumb{background-color:transparent;border:var(--fdScrollbar_Thumb_Offset) solid transparent;border-radius:calc(var(--fdScrollbar_Thumb_Border_Radius) - var(--fdScrollbar_Thumb_Offset));-webkit-box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Color);box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Color)}.fd-textarea::-webkit-scrollbar-thumb:active,.fd-textarea::-webkit-scrollbar-thumb:hover{-webkit-box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Hover_Color);box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Hover_Color)}.fd-textarea:after,.fd-textarea:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-textarea::-webkit-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-textarea::-moz-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-textarea:-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-textarea::-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-textarea::placeholder{color:var(--sapField_PlaceholderTextColor);font-style:var(--fdPlaceholder_Font_Style)}.fd-textarea[dir=rtl]::-webkit-input-placeholder,[dir=rtl] .fd-textarea::-webkit-input-placeholder{text-indent:.125rem}.fd-textarea[dir=rtl]::-moz-placeholder,[dir=rtl] .fd-textarea::-moz-placeholder{text-indent:.125rem}.fd-textarea[dir=rtl]:-ms-input-placeholder,[dir=rtl] .fd-textarea:-ms-input-placeholder{text-indent:.125rem}.fd-textarea[dir=rtl]::-ms-input-placeholder,[dir=rtl] .fd-textarea::-ms-input-placeholder{text-indent:.125rem}.fd-textarea[dir=rtl]::placeholder,[dir=rtl] .fd-textarea::placeholder{text-indent:.125rem}.fd-textarea::-moz-selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-textarea::selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-textarea::-ms-clear{display:none}.fd-textarea.is-hover,.fd-textarea:hover{background:var(--sapField_Hover_BackgroundStyle,var(--sapField_Hover_BackgroundStyle));background-color:var(--sapField_Hover_Background,var(--sapField_Hover_Background));border-color:var(--sapField_Hover_BorderColor);-webkit-box-shadow:var(--fdInput_Box_Shadow_Hover);box-shadow:var(--fdInput_Box_Shadow_Hover)}.fd-textarea.is-focus,.fd-textarea:focus{background:var(--sapField_Focus_Background,var(--sapField_Focus_Background));-webkit-box-shadow:none;box-shadow:none;outline:var(--fdInput_Outline_Color) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:var(--fdInput_Outline_Offset);z-index:5}.fd-textarea.is-success{background:var(--sapField_SuccessBackgroundStyle);background-color:var(--sapField_SuccessBackground);border:var(--sapField_SuccessColor) var(--sapField_SuccessBorderWidth) var(--sapField_SuccessBorderStyle);-webkit-box-shadow:var(--sapField_SuccessShadow);box-shadow:var(--sapField_SuccessShadow)}.fd-textarea.is-success.is-hover,.fd-textarea.is-success:hover{background-color:var(--fdInput_Success_Background_Color_Hover);border-color:var(--sapField_SuccessColor);-webkit-box-shadow:var(--fdInput_Success_Box_Shadow_Hover);box-shadow:var(--fdInput_Success_Box_Shadow_Hover)}.fd-textarea.is-success.is-focus,.fd-textarea.is-success:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Success_Outline_Color);z-index:5}.fd-textarea.is-success.is-focus.is-hover,.fd-textarea.is-success.is-focus:hover,.fd-textarea.is-success:focus.is-hover,.fd-textarea.is-success:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-success.is-expanded,.fd-textarea.is-success[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Success_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-textarea.is-error{background:var(--sapField_InvalidBackgroundStyle);background-color:var(--sapField_InvalidBackground);border:var(--sapField_InvalidColor) var(--sapField_InvalidBorderWidth) var(--sapField_InvalidBorderStyle);-webkit-box-shadow:var(--sapField_InvalidShadow);box-shadow:var(--sapField_InvalidShadow)}.fd-textarea.is-error.is-hover,.fd-textarea.is-error:hover{background-color:var(--fdInput_Error_Background_Color_Hover);border-color:var(--sapField_InvalidColor);-webkit-box-shadow:var(--fdInput_Error_Box_Shadow_Hover);box-shadow:var(--fdInput_Error_Box_Shadow_Hover)}.fd-textarea.is-error.is-focus,.fd-textarea.is-error:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Error_Outline_Color);z-index:5}.fd-textarea.is-error.is-focus.is-hover,.fd-textarea.is-error.is-focus:hover,.fd-textarea.is-error:focus.is-hover,.fd-textarea.is-error:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-error.is-expanded,.fd-textarea.is-error[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Error_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-textarea.is-warning{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle);-webkit-box-shadow:var(--sapField_WarningShadow);box-shadow:var(--sapField_WarningShadow)}.fd-textarea.is-warning.is-hover,.fd-textarea.is-warning:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-textarea.is-warning.is-focus,.fd-textarea.is-warning:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-textarea.is-warning.is-focus.is-hover,.fd-textarea.is-warning.is-focus:hover,.fd-textarea.is-warning:focus.is-hover,.fd-textarea.is-warning:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-warning.is-expanded,.fd-textarea.is-warning[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-textarea.is-alert{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle)}.fd-textarea.is-alert.is-hover,.fd-textarea.is-alert:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-textarea.is-alert.is-focus,.fd-textarea.is-alert:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-textarea.is-alert.is-focus.is-hover,.fd-textarea.is-alert.is-focus:hover,.fd-textarea.is-alert:focus.is-hover,.fd-textarea.is-alert:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-alert.is-expanded,.fd-textarea.is-alert[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-textarea.is-information{background:var(--sapField_InformationBackgroundStyle);background-color:var(--sapField_InformationBackground);border:var(--sapField_InformationColor) var(--sapField_InformationBorderWidth) var(--sapField_InformationBorderStyle);-webkit-box-shadow:var(--sapField_InformationShadow);box-shadow:var(--sapField_InformationShadow)}.fd-textarea.is-information.is-hover,.fd-textarea.is-information:hover{background-color:var(--fdInput_Information_Background_Color_Hover);border-color:var(--sapField_InformationColor);-webkit-box-shadow:var(--fdInput_Information_Box_Shadow_Hover);box-shadow:var(--fdInput_Information_Box_Shadow_Hover)}.fd-textarea.is-information.is-focus,.fd-textarea.is-information:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Information_Outline_Color);z-index:5}.fd-textarea.is-information.is-focus.is-hover,.fd-textarea.is-information.is-focus:hover,.fd-textarea.is-information:focus.is-hover,.fd-textarea.is-information:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-information.is-expanded,.fd-textarea.is-information[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Information_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-textarea.is-alert,.fd-textarea.is-error,.fd-textarea.is-warning{font-style:var(--fdInput_State_Text_Style);font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert::-webkit-input-placeholder,.fd-textarea.is-error::-webkit-input-placeholder,.fd-textarea.is-warning::-webkit-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert::-moz-placeholder,.fd-textarea.is-error::-moz-placeholder,.fd-textarea.is-warning::-moz-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert:-ms-input-placeholder,.fd-textarea.is-error:-ms-input-placeholder,.fd-textarea.is-warning:-ms-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert::-ms-input-placeholder,.fd-textarea.is-error::-ms-input-placeholder,.fd-textarea.is-warning::-ms-input-placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert::placeholder,.fd-textarea.is-error::placeholder,.fd-textarea.is-warning::placeholder{font-weight:var(--fdInput_State_Font_Weight)}.fd-textarea.is-alert.is-focus,.fd-textarea.is-alert:focus,.fd-textarea.is-error.is-focus,.fd-textarea.is-error:focus,.fd-textarea.is-information.is-focus,.fd-textarea.is-information:focus,.fd-textarea.is-warning.is-focus,.fd-textarea.is-warning:focus{outline-offset:var(--fdInput_Outline_Offset_States);z-index:5}.fd-textarea.is-error::-webkit-input-placeholder{color:var(--sapField_TextColor)}.fd-textarea.is-error::-moz-placeholder{color:var(--sapField_TextColor)}.fd-textarea.is-error:-ms-input-placeholder{color:var(--sapField_TextColor)}.fd-textarea.is-error::-ms-input-placeholder{color:var(--sapField_TextColor)}.fd-textarea.is-error::placeholder{color:var(--sapField_TextColor)}.fd-textarea.is-disabled,.fd-textarea:disabled,.fd-textarea[aria-disabled=true]{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-textarea.is-disabled::-webkit-input-placeholder,.fd-textarea:disabled::-webkit-input-placeholder,.fd-textarea[aria-disabled=true]::-webkit-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-disabled::-moz-placeholder,.fd-textarea:disabled::-moz-placeholder,.fd-textarea[aria-disabled=true]::-moz-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-disabled:-ms-input-placeholder,.fd-textarea:disabled:-ms-input-placeholder,.fd-textarea[aria-disabled=true]:-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-disabled::-ms-input-placeholder,.fd-textarea:disabled::-ms-input-placeholder,.fd-textarea[aria-disabled=true]::-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-disabled::placeholder,.fd-textarea:disabled::placeholder,.fd-textarea[aria-disabled=true]::placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly,.fd-textarea[aria-readonly=true],.fd-textarea[readonly]{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-readonly::-webkit-input-placeholder,.fd-textarea[aria-readonly=true]::-webkit-input-placeholder,.fd-textarea[readonly]::-webkit-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly::-moz-placeholder,.fd-textarea[aria-readonly=true]::-moz-placeholder,.fd-textarea[readonly]::-moz-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly:-ms-input-placeholder,.fd-textarea[aria-readonly=true]:-ms-input-placeholder,.fd-textarea[readonly]:-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly::-ms-input-placeholder,.fd-textarea[aria-readonly=true]::-ms-input-placeholder,.fd-textarea[readonly]::-ms-input-placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly::placeholder,.fd-textarea[aria-readonly=true]::placeholder,.fd-textarea[readonly]::placeholder{color:var(--fdInput_Non_Interactive_State_Placeholder_Color);opacity:0}.fd-textarea.is-readonly.is-focus,.fd-textarea.is-readonly.is-hover,.fd-textarea.is-readonly:focus,.fd-textarea.is-readonly:hover,.fd-textarea[aria-readonly=true].is-focus,.fd-textarea[aria-readonly=true].is-hover,.fd-textarea[aria-readonly=true]:focus,.fd-textarea[aria-readonly=true]:hover,.fd-textarea[readonly].is-focus,.fd-textarea[readonly].is-hover,.fd-textarea[readonly]:focus,.fd-textarea[readonly]:hover{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-textarea.is-readonly.is-focus,.fd-textarea.is-readonly:focus,.fd-textarea[aria-readonly=true].is-focus,.fd-textarea[aria-readonly=true]:focus,.fd-textarea[readonly].is-focus,.fd-textarea[readonly]:focus{z-index:5}.fd-textarea.is-readonly,.fd-textarea[readonly]{background:var(--sapField_ReadOnly_Background);border:var(--sapField_BorderWidth) dashed var(--sapField_ReadOnly_BorderColor);border-radius:var(--sapField_BorderCornerRadius)}.fd-textarea.is-readonly.is-hover,.fd-textarea.is-readonly:hover,.fd-textarea[readonly].is-hover,.fd-textarea[readonly]:hover{background:var(--sapField_ReadOnly_Background)}.fd-textarea.is-readonly.is-focus,.fd-textarea.is-readonly:focus,.fd-textarea[readonly].is-focus,.fd-textarea[readonly]:focus{background:var(--sapField_ReadOnly_Background);outline-offset:-.25rem;z-index:5}.fd-textarea::-webkit-scrollbar-corner,.fd-textarea::-webkit-scrollbar-track{background:transparent;border-radius:0 var(--sapField_BorderCornerRadius) var(--sapField_BorderCornerRadius) 0!important}.fd-textarea[aria-expanded=false]{z-index:0}.fd-textarea.is-expanded,.fd-textarea[aria-expanded=true]{z-index:4}.fd-textarea[class*=-compact],.fd-textarea[class*=-condensed],[class*=-compact] .fd-textarea:not([class*=-cozy]),[class*=-condensed] .fd-textarea:not([class*=-cozy]){margin-block:.1875rem;margin-inline:0;min-height:1.625rem;padding-block:.1875rem;padding-inline:.5rem}.fd-textarea-counter{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:var(--sapFontSmallSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-block:.375rem .5rem;padding-inline:0;padding-inline:.125rem;text-align:end;text-overflow:ellipsis;white-space:nowrap}.fd-textarea-counter:after,.fd-textarea-counter:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-textarea-counter.is-disabled,.fd-textarea-counter.is-readonly,.fd-textarea-counter:disabled,.fd-textarea-counter[aria-disabled=true],.fd-textarea-counter[readonly]{display:none}.fd-textarea-counter-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:center;-ms-flex-align:center;align-items:center;padding-block:.375rem .5rem}.fd-textarea-counter-container:after,.fd-textarea-counter-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-textarea-counter-container .fd-textarea-counter{padding-block:0;-webkit-margin-start:auto;margin-inline-start:auto}.fd-textarea--ai{position:relative}.fd-textarea--ai:has(.fd-ai-busy-indicator){padding-block:0;padding-inline:0}.fd-textarea--ai .fd-toolbar--ai{bottom:0;left:0;position:absolute;right:0}.fd-input.is-readonly,.fd-input[aria-readonly=true],.fd-input[readonly],.fd-input.is-readonly.is-hover,.fd-input.is-readonly:hover,.fd-input[aria-readonly=true].is-hover,.fd-input[aria-readonly=true]:hover,.fd-input[readonly].is-hover,.fd-input[readonly]:hover{z-index:1!important}.fd-input.is-readonly.is-focus,.fd-input.is-readonly:focus,.fd-input[aria-readonly=true].is-focus,.fd-input[aria-readonly=true]:focus,.fd-input[readonly].is-focus,.fd-input[readonly]:focus{z-index:1!important}\n/*! Bundled license information:\n\nfundamental-styles/dist/textarea.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.ContentDensityObserver }, { type: undefined, decorators: [{
                    type: Attribute,
                    args: ['aria-label']
                }] }, { type: undefined, decorators: [{
                    type: Attribute,
                    args: ['aria-labelledby']
                }] }], propDecorators: { state: [{
                type: Input
            }], type: [{
                type: HostBinding,
                args: ['attr.type']
            }, {
                type: Input
            }], class: [{
                type: Input
            }], ariaLabel: [{
                type: Input
            }], ariaLabelledBy: [{
                type: Input
            }], ariaLabelBinding: [{
                type: HostBinding,
                args: ['attr.aria-label']
            }], ariaLabelledByBinding: [{
                type: HostBinding,
                args: ['attr.aria-labelledby']
            }], buildComponentCssClass: [] } });

/**
 * @deprecated
 * Import `FormControlComponent` directly as a standalone component.
 */
class FormControlModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormControlModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: FormControlModule, imports: [FormControlComponent], exports: [FormControlComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormControlModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormControlModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [FormControlComponent],
                    exports: [FormControlComponent]
                }]
        }] });

/**
 * Represents a form group element.
 *
 * ```html
 * <fd-form-group>
 *     <div fd-form-item>
 *         <input fd-form-control type="radio" checked>
 *         <fd-form-label>Option One</fd-form-label>
 *     </div>
 * </fd-form-group>
 * ```
 */
class FormGroupComponent {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
        /** @hidden */
        this.fdFormGroupClass = true;
    }
    /** This method is responsible for building a css class based on current state
     *  It is implementation of CssClassBuilder interface and
     *  should be used with @applyCssClass decorator
     */
    buildComponentCssClass() {
        return [this.isInline ? 'fd-form-group--inline' : ''];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormGroupComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: FormGroupComponent, isStandalone: true, selector: "fd-form-group", inputs: { isInline: "isInline" }, host: { properties: { "class.fd-form-group": "this.fdFormGroupClass" } }, usesOnChanges: true, ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, styles: [".fd-form-group{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column}.fd-form-group:after,.fd-form-group:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group--inline{-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row wrap;flex-flow:row wrap;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start}.fd-form-group--with-spacing{gap:.625rem}.fd-form-group__header{border:0;-webkit-box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--sapGroup_TitleBackground);box-sizing:border-box;height:2.75rem;width:100%}.fd-form-group__header:after,.fd-form-group__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group__header[class*=-compact],.fd-form-group__header[class*=-condensed],[class*=-compact] .fd-form-group__header:not([class*=-cozy]),[class*=-condensed] .fd-form-group__header:not([class*=-cozy]){height:2rem}.fd-form-group__header-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--sapFontHeader6Size);font-weight:400;font-weight:700;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-form-group__header-text:after,.fd-form-group__header-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}\n/*! Bundled license information:\n\nfundamental-styles/dist/form-group.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], FormGroupComponent.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-form-group', template: `<ng-content></ng-content>`, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, styles: [".fd-form-group{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column}.fd-form-group:after,.fd-form-group:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group--inline{-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row wrap;flex-flow:row wrap;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start}.fd-form-group--with-spacing{gap:.625rem}.fd-form-group__header{border:0;-webkit-box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--sapGroup_TitleBackground);box-sizing:border-box;height:2.75rem;width:100%}.fd-form-group__header:after,.fd-form-group__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group__header[class*=-compact],.fd-form-group__header[class*=-condensed],[class*=-compact] .fd-form-group__header:not([class*=-cozy]),[class*=-condensed] .fd-form-group__header:not([class*=-cozy]){height:2rem}.fd-form-group__header-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--sapFontHeader6Size);font-weight:400;font-weight:700;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-form-group__header-text:after,.fd-form-group__header-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}\n/*! Bundled license information:\n\nfundamental-styles/dist/form-group.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { fdFormGroupClass: [{
                type: HostBinding,
                args: ['class.fd-form-group']
            }], isInline: [{
                type: Input
            }], buildComponentCssClass: [] } });

/**
 * @deprecated
 * Import `FormGroupComponent` directly as a standalone component.
 */
class FormGroupModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: FormGroupModule, imports: [FormGroupComponent], exports: [FormGroupComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormGroupModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [FormGroupComponent],
                    exports: [FormGroupComponent]
                }]
        }] });

/**
 *
 * ```html
 * <h4 fd-form-header>Form Header</h4>
 * ```
 */
class FormHeaderComponent {
    constructor() {
        /** @hidden */
        this.fdFormHeaderClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: FormHeaderComponent, isStandalone: true, selector: "[fd-form-header]", host: { properties: { "class.fd-form-header": "this.fdFormHeaderClass" } }, ngImport: i0, template: `<span class="fd-form-header__text"><ng-content></ng-content></span>`, isInline: true, styles: [".fd-form-header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--sapGroup_TitleBackground);-webkit-box-shadow:0 var(--fdFormHeader_Border_Width) 0 var(--sapGroup_TitleBorderColor);box-shadow:0 var(--fdFormHeader_Border_Width) 0 var(--sapGroup_TitleBorderColor);height:2.75rem;padding-inline:1rem;width:100%}.fd-form-header:after,.fd-form-header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-header__text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--sapFontHeader4Size);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-form-header__text:after,.fd-form-header__text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}\n/*! Bundled license information:\n\nfundamental-styles/dist/form-header.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: '[fd-form-header]', template: `<span class="fd-form-header__text"><ng-content></ng-content></span>`, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, styles: [".fd-form-header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--sapGroup_TitleBackground);-webkit-box-shadow:0 var(--fdFormHeader_Border_Width) 0 var(--sapGroup_TitleBorderColor);box-shadow:0 var(--fdFormHeader_Border_Width) 0 var(--sapGroup_TitleBorderColor);height:2.75rem;padding-inline:1rem;width:100%}.fd-form-header:after,.fd-form-header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-header__text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--sapFontHeader4Size);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-form-header__text:after,.fd-form-header__text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}\n/*! Bundled license information:\n\nfundamental-styles/dist/form-header.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], propDecorators: { fdFormHeaderClass: [{
                type: HostBinding,
                args: ['class.fd-form-header']
            }] } });

/**
 * @deprecated
 * Import `FormHeaderComponent` directly as a standalone component.
 */
class FormHeaderModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormHeaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: FormHeaderModule, imports: [FormHeaderComponent], exports: [FormHeaderComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormHeaderModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormHeaderModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [FormHeaderComponent],
                    exports: [FormHeaderComponent]
                }]
        }] });

class FormInputMessageGroupComponent {
    constructor() {
        /**
         * To allow user to determine what event he wants to trigger the messages to show
         * Accepts any [HTML DOM Events](https://www.w3schools.com/jsref/dom_obj_event.asp).
         */
        this.triggers = ['focusin', 'focusout'];
        /**
         * Allows the user to decide if he wants to keep the error message after they click outside
         * Whether the popover should close when a click is made outside its boundaries.
         */
        this.closeOnOutsideClick = false;
        /** Whether the popover should have an arrow. */
        this.noArrow = true;
        /** Whether the popover should close when the escape key is pressed. */
        this.closeOnEscapeKey = false;
        /** The placement of the popover. It can be one of: top, top-start, top-end, bottom,
         *  bottom-start, bottom-end, right, right-start, right-end, left, left-start, left-end. */
        this.placement = 'bottom-start';
        /**
         * @experimental
         * Container element, in which form message popover will be rendered.
         */
        this.placementContainer = 'body';
        /** Whether the message is open. Can be used through two-way binding. */
        this.isOpen = false;
        /**
         * Whether the popover should prevent page scrolling when space key is pressed.
         **/
        this.preventSpaceKeyScroll = true;
        /** Event emitted when the state of the isOpen property changes. */
        this.isOpenChange = new EventEmitter();
        /** @hidden */
        this._elementRef = inject(ElementRef);
    }
    /**
     * Function is called every time message changes isOpen attribute
     */
    openChanged(isOpen) {
        this.isOpenChange.emit(isOpen);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormInputMessageGroupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: FormInputMessageGroupComponent, isStandalone: true, selector: "fd-form-input-message-group", inputs: { triggers: "triggers", closeOnOutsideClick: "closeOnOutsideClick", fillControlMode: "fillControlMode", noArrow: "noArrow", closeOnEscapeKey: "closeOnEscapeKey", placement: "placement", placementContainer: "placementContainer", isOpen: "isOpen", preventSpaceKeyScroll: "preventSpaceKeyScroll" }, outputs: { isOpenChange: "isOpenChange" }, viewQueries: [{ propertyName: "_popoverPlacementContainer", first: true, predicate: ["popoverPlacementContainer"], descendants: true, read: ElementRef }, { propertyName: "_popover", first: true, predicate: ["popover"], descendants: true }], ngImport: i0, template: "@if (placementContainer === 'self') {\n    <div #popoverPlacementContainer class=\"fd-form-input-message__container\"></div>\n}\n<fd-popover\n    class=\"fd-form-input-message-group\"\n    additionalBodyClass=\"fd-popover__body--input-message-group\"\n    #popover\n    [placement]=\"placement\"\n    [triggers]=\"triggers\"\n    [noArrow]=\"noArrow\"\n    [closeOnEscapeKey]=\"closeOnEscapeKey\"\n    [fillControlMode]=\"fillControlMode\"\n    [closeOnOutsideClick]=\"closeOnOutsideClick\"\n    [disableScrollbar]=\"true\"\n    [isOpen]=\"isOpen\"\n    [placementContainer]=\"_popoverPlacementContainer\"\n    [preventSpaceKeyScroll]=\"preventSpaceKeyScroll\"\n    (isOpenChange)=\"openChanged($event)\"\n>\n    <fd-popover-control>\n        <ng-content></ng-content>\n    </fd-popover-control>\n    <fd-popover-body>\n        <ng-content select=\"fd-form-message\"></ng-content>\n    </fd-popover-body>\n</fd-popover>\n", styles: [".fd-popover-container-custom--message{flex-grow:1}.fd-popover-container-custom{border:none}.fd-form-input-message-group.fd-popover-custom,.fd-form-input-message-group .fd-input{display:block}.fd-popover__body.fd-popover__body--input-message-group{margin-top:0!important;z-index:999}.fd-form-input-message__container{position:fixed;top:0;left:0;width:100%;height:100%;pointer-events:none}\n"], dependencies: [{ kind: "component", type: PopoverComponent, selector: "fd-popover", inputs: ["title", "trigger", "fixedPosition", "id", "mobile", "mobileConfig", "preventSpaceKeyScroll"] }, { kind: "component", type: PopoverControlComponent, selector: "fd-popover-control, [fdPopoverControl]" }, { kind: "component", type: PopoverBodyComponent, selector: "fd-popover-body", inputs: ["minWidth", "maxWidth", "minHeight", "maxHeight"] }, { kind: "ngmodule", type: A11yModule }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormInputMessageGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-form-input-message-group', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, imports: [PopoverComponent, PopoverControlComponent, PopoverBodyComponent, A11yModule], template: "@if (placementContainer === 'self') {\n    <div #popoverPlacementContainer class=\"fd-form-input-message__container\"></div>\n}\n<fd-popover\n    class=\"fd-form-input-message-group\"\n    additionalBodyClass=\"fd-popover__body--input-message-group\"\n    #popover\n    [placement]=\"placement\"\n    [triggers]=\"triggers\"\n    [noArrow]=\"noArrow\"\n    [closeOnEscapeKey]=\"closeOnEscapeKey\"\n    [fillControlMode]=\"fillControlMode\"\n    [closeOnOutsideClick]=\"closeOnOutsideClick\"\n    [disableScrollbar]=\"true\"\n    [isOpen]=\"isOpen\"\n    [placementContainer]=\"_popoverPlacementContainer\"\n    [preventSpaceKeyScroll]=\"preventSpaceKeyScroll\"\n    (isOpenChange)=\"openChanged($event)\"\n>\n    <fd-popover-control>\n        <ng-content></ng-content>\n    </fd-popover-control>\n    <fd-popover-body>\n        <ng-content select=\"fd-form-message\"></ng-content>\n    </fd-popover-body>\n</fd-popover>\n", styles: [".fd-popover-container-custom--message{flex-grow:1}.fd-popover-container-custom{border:none}.fd-form-input-message-group.fd-popover-custom,.fd-form-input-message-group .fd-input{display:block}.fd-popover__body.fd-popover__body--input-message-group{margin-top:0!important;z-index:999}.fd-form-input-message__container{position:fixed;top:0;left:0;width:100%;height:100%;pointer-events:none}\n"] }]
        }], propDecorators: { triggers: [{
                type: Input
            }], closeOnOutsideClick: [{
                type: Input
            }], fillControlMode: [{
                type: Input
            }], noArrow: [{
                type: Input
            }], closeOnEscapeKey: [{
                type: Input
            }], placement: [{
                type: Input
            }], placementContainer: [{
                type: Input
            }], isOpen: [{
                type: Input
            }], preventSpaceKeyScroll: [{
                type: Input
            }], isOpenChange: [{
                type: Output
            }], _popoverPlacementContainer: [{
                type: ViewChild,
                args: ['popoverPlacementContainer', { static: false, read: ElementRef }]
            }], _popover: [{
                type: ViewChild,
                args: ['popover']
            }] } });

/**
 * @deprecated
 * Import `FormInputMessageGroupComponent` directly as a standalone component.
 */
class FormInputMessageGroupModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormInputMessageGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: FormInputMessageGroupModule, imports: [FormInputMessageGroupComponent], exports: [FormInputMessageGroupComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormInputMessageGroupModule, imports: [FormInputMessageGroupComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormInputMessageGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [FormInputMessageGroupComponent],
                    exports: [FormInputMessageGroupComponent]
                }]
        }] });

let formLabelIdCount = 0;
/**
 * Label to be linked to a form control.
 *
 * ```html
 * <label fd-form-label for="input-id">Label Text</label>
 * <input fd-form-control type="text" id="input-id" />
 * ```
 */
class FormLabelComponent {
    constructor() {
        /** Whether form is required. */
        this.required = false;
        /** Whether label text should be appended with colon. */
        this.colon = false;
        /** Align label on end. */
        this.alignLabelEnd = false;
        /** Inline help content. Could be just a string or complex template */
        this.inlineHelpContent = null;
        /** Glyph of icon triggering inline help. */
        this.inlineHelpGlyph = 'question-mark';
        /** Trigger event names for the inline help. */
        this.inlineHelpTriggers = [
            'mouseenter',
            'mouseleave',
            'focusin',
            'focusout',
            { trigger: 'click', openAction: true, closeAction: true }
        ];
        /** If inline help trigger icon should be placed after, or before text. */
        this.inlineHelpPlacement = 'after';
        /** Whether to allow the text of the form label to wrap. */
        this.allowWrap = false;
        /** @hidden */
        this.defaultClass = true;
        /** @hidden */
        this.inlineHelpClass = true;
        /** @hidden */
        this.inlineHelpAfter = true;
        /** @hidden */
        this._formLabelId = `fd-form-label-${++formLabelIdCount}`;
    }
    /** Inline help label. */
    set inlineHelpLabel(label) {
        this._inlineHelpLabel = label;
    }
    get inlineHelpLabel() {
        if (this._inlineHelpLabel) {
            return this._inlineHelpLabel;
        }
        return typeof this.inlineHelpContent === 'string' ? this.inlineHelpContent : '';
    }
    /** @hidden */
    // eslint-disable-next-line @angular-eslint/no-input-rename
    set formLabelId(value) {
        this._formLabelId = value || this._formLabelId;
    }
    get formLabelId() {
        return this._formLabelId;
    }
    /** @hidden */
    ngOnChanges() {
        this.inlineHelpClass = !!this.inlineHelpContent;
        this.inlineHelpAfter = !!this.inlineHelpContent && this.inlineHelpPlacement === 'after';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormLabelComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: FormLabelComponent, isStandalone: true, selector: "[fd-form-label]", inputs: { required: "required", colon: "colon", alignLabelEnd: "alignLabelEnd", inlineHelpContent: "inlineHelpContent", inlineHelpGlyph: "inlineHelpGlyph", inlineHelpTriggers: "inlineHelpTriggers", inlineHelpBodyPlacement: "inlineHelpBodyPlacement", inlineHelpPlacement: "inlineHelpPlacement", allowWrap: "allowWrap", inlineHelpLabel: "inlineHelpLabel", formLabelId: ["id", "formLabelId"] }, host: { properties: { "class.fd-form-label__wrapper--align-end": "this.alignLabelEnd", "class.fd-form-label__wrapper": "this.defaultClass", "class.fd-form-label__wrapper--inline-help": "this.inlineHelpClass", "class.fd-form-label__wrapper--inline-help--after": "this.inlineHelpAfter", "id": "this.formLabelId" } }, usesOnChanges: true, ngImport: i0, template: "<ng-template #inlineHelpRef>\n    <span fd-link [undecorated]=\"true\" class=\"fd-form-label__inline-help\">\n        @if (inlineHelpContent) {\n            <fd-icon\n                class=\"fd-form-label__help\"\n                [class.fd-form-label__help--after]=\"inlineHelpPlacement === 'after'\"\n                [glyph]=\"inlineHelpGlyph\"\n                [triggers]=\"inlineHelpTriggers\"\n                [fd-inline-help]=\"inlineHelpContent\"\n                [ariaLabel]=\"inlineHelpLabel\"\n                [placement]=\"inlineHelpBodyPlacement\"\n                tabindex=\"0\"\n            ></fd-icon>\n        }\n    </span>\n</ng-template>\n@if (inlineHelpPlacement === 'before' && inlineHelpContent) {\n    <ng-template [ngTemplateOutlet]=\"inlineHelpRef\"></ng-template>\n}\n<span\n    class=\"fd-form-label\"\n    [class.fd-form-label--allow-wrap]=\"allowWrap\"\n    [class.fd-form-label--required]=\"required\"\n    [class.fd-form-label--colon]=\"colon\"\n>\n    <ng-content></ng-content>\n</span>\n@if (inlineHelpPlacement === 'after' && inlineHelpContent) {\n    <ng-template [ngTemplateOutlet]=\"inlineHelpRef\"></ng-template>\n}\n", styles: [".fd-form-label{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;max-width:100%;overflow:hidden;padding-block:0;padding-inline:0;position:relative;text-overflow:ellipsis;white-space:nowrap;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content;-webkit-margin-end:.5rem;cursor:text;margin-inline-end:.5rem;-ms-flex-item-align:start;align-self:flex-start}.fd-form-label:after,.fd-form-label:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-label.is-disabled{opacity:.4}.fd-form-label--unit-description{color:var(--sapField_TextColor);margin-block:0;margin-inline:0;padding-block:0;padding-inline:.25rem 0}.fd-form-label--required,.fd-form-label[aria-required=true]{-webkit-padding-end:.5rem;padding-inline-end:.5rem}.fd-form-label--required:after,.fd-form-label[aria-required=true]:after{color:var(--sapField_RequiredColor);content:\"*\"/\"\";font-size:var(--sapFontLargeSize);font-weight:700;position:absolute;right:0;top:0}.fd-form-label--required[dir=rtl]:after,.fd-form-label[aria-required=true][dir=rtl]:after,[dir=rtl] .fd-form-label--required:after,[dir=rtl] .fd-form-label[aria-required=true]:after{left:0;right:auto}.fd-form-label--colon{-webkit-padding-end:.25rem;padding-inline-end:.25rem}.fd-form-label--colon:before{color:inherit;content:\":\";font-size:var(--sapFontSize);position:absolute;right:0;top:0}.fd-form-label--colon[dir=rtl]:before,[dir=rtl] .fd-form-label--colon:before{left:0;right:auto}.fd-form-label--colon.fd-form-label--required,.fd-form-label--colon[aria-required=true]{-webkit-padding-end:.75rem;padding-inline-end:.75rem}.fd-form-label--colon.fd-form-label--required:before,.fd-form-label--colon[aria-required=true]:before{right:.5rem}.fd-form-label--colon.fd-form-label--required[dir=rtl]:before,.fd-form-label--colon[aria-required=true][dir=rtl]:before,[dir=rtl] .fd-form-label--colon.fd-form-label--required:before,[dir=rtl] .fd-form-label--colon[aria-required=true]:before{left:.5rem;right:auto}.fd-form-label--inline-help{display:-webkit-box;display:-ms-flexbox;display:flex;width:100%;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-form-label--stand-alone{-ms-flex-item-align:center;align-self:center;-webkit-margin-end:0;margin-inline-end:0}.fd-form-label{display:inline-block}.fd-form-label__inline-help{position:relative;top:.125rem}.fd-form-label--allow-wrap{text-wrap:auto}.fd-form-label__wrapper{position:relative;display:flex;padding-bottom:.125rem}.fd-form-label__wrapper--align-end{justify-content:flex-end}.fd-form-label__wrapper span.fd-form-label{margin-bottom:-.125rem}.fd-form-label__wrapper--inline-help{display:flex;padding-left:0rem}[dir=rtl] .fd-form-label__wrapper--inline-help,.fd-form-label__wrapper--inline-help[dir=rtl],.fd-form-label__wrapper--inline-help--after{padding-left:0;padding-right:0rem}[dir=rtl] .fd-form-label__wrapper--inline-help--after,.fd-form-label__wrapper--inline-help--after[dir=rtl]{padding-right:0;padding-left:0rem}.fd-form-label__help{position:relative;vertical-align:middle;left:0;right:auto}[dir=rtl] .fd-form-label__help,.fd-form-label__help[dir=rtl],.fd-form-label__help--after{right:0;left:auto}[dir=rtl] .fd-form-label__help--after,.fd-form-label__help--after[dir=rtl]{left:0;right:auto}.fd-container.fd-form-layout-grid-container.fd-form-group .fd-form-item .fd-form-label--colon,.fd-container.fd-form-layout-grid-container .fd-form-group .fd-form-item .fd-form-label--colon{padding-inline-end:.25rem}.fd-container.fd-form-layout-grid-container.fd-form-group .fd-form-item .fd-form-label--required,.fd-container.fd-form-layout-grid-container .fd-form-group .fd-form-item .fd-form-label--required{padding-inline-end:.5rem}.fd-container.fd-form-layout-grid-container.fd-form-group .fd-form-item .fd-form-label--required.fd-form-label--colon,.fd-container.fd-form-layout-grid-container .fd-form-group .fd-form-item .fd-form-label--required.fd-form-label--colon{padding-inline-end:.75rem}.fd-form-item .fd-form-label--colon{padding-inline-end:.25rem}.fd-form-item .fd-form-label--required{padding-inline-end:.5rem}.fd-form-item .fd-form-label--required.fd-form-label--colon{padding-inline-end:.75rem}\n/*! Bundled license information:\n\nfundamental-styles/dist/form-label.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], dependencies: [{ kind: "component", type: LinkComponent, selector: "[fdLink], [fd-link]", inputs: ["class", "emphasized", "disabled", "inverted", "subtle", "undecorated"] }, { kind: "component", type: IconComponent, selector: "fd-icon", inputs: ["glyph", "font", "color", "background", "class", "ariaLabel", "ariaHidden"] }, { kind: "directive", type: InlineHelpDirective, selector: "[fd-inline-help]:not([fd-inline-help-template]), [fd-inline-help-template]:not([fd-inline-help])", inputs: ["triggers", "noArrow", "closeOnEscapeKey", "closeOnOutsideClick", "fd-inline-help"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormLabelComponent, decorators: [{
            type: Component,
            args: [{ selector: '[fd-form-label]', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [LinkComponent, IconComponent, InlineHelpDirective, NgTemplateOutlet], template: "<ng-template #inlineHelpRef>\n    <span fd-link [undecorated]=\"true\" class=\"fd-form-label__inline-help\">\n        @if (inlineHelpContent) {\n            <fd-icon\n                class=\"fd-form-label__help\"\n                [class.fd-form-label__help--after]=\"inlineHelpPlacement === 'after'\"\n                [glyph]=\"inlineHelpGlyph\"\n                [triggers]=\"inlineHelpTriggers\"\n                [fd-inline-help]=\"inlineHelpContent\"\n                [ariaLabel]=\"inlineHelpLabel\"\n                [placement]=\"inlineHelpBodyPlacement\"\n                tabindex=\"0\"\n            ></fd-icon>\n        }\n    </span>\n</ng-template>\n@if (inlineHelpPlacement === 'before' && inlineHelpContent) {\n    <ng-template [ngTemplateOutlet]=\"inlineHelpRef\"></ng-template>\n}\n<span\n    class=\"fd-form-label\"\n    [class.fd-form-label--allow-wrap]=\"allowWrap\"\n    [class.fd-form-label--required]=\"required\"\n    [class.fd-form-label--colon]=\"colon\"\n>\n    <ng-content></ng-content>\n</span>\n@if (inlineHelpPlacement === 'after' && inlineHelpContent) {\n    <ng-template [ngTemplateOutlet]=\"inlineHelpRef\"></ng-template>\n}\n", styles: [".fd-form-label{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;max-width:100%;overflow:hidden;padding-block:0;padding-inline:0;position:relative;text-overflow:ellipsis;white-space:nowrap;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content;-webkit-margin-end:.5rem;cursor:text;margin-inline-end:.5rem;-ms-flex-item-align:start;align-self:flex-start}.fd-form-label:after,.fd-form-label:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-label.is-disabled{opacity:.4}.fd-form-label--unit-description{color:var(--sapField_TextColor);margin-block:0;margin-inline:0;padding-block:0;padding-inline:.25rem 0}.fd-form-label--required,.fd-form-label[aria-required=true]{-webkit-padding-end:.5rem;padding-inline-end:.5rem}.fd-form-label--required:after,.fd-form-label[aria-required=true]:after{color:var(--sapField_RequiredColor);content:\"*\"/\"\";font-size:var(--sapFontLargeSize);font-weight:700;position:absolute;right:0;top:0}.fd-form-label--required[dir=rtl]:after,.fd-form-label[aria-required=true][dir=rtl]:after,[dir=rtl] .fd-form-label--required:after,[dir=rtl] .fd-form-label[aria-required=true]:after{left:0;right:auto}.fd-form-label--colon{-webkit-padding-end:.25rem;padding-inline-end:.25rem}.fd-form-label--colon:before{color:inherit;content:\":\";font-size:var(--sapFontSize);position:absolute;right:0;top:0}.fd-form-label--colon[dir=rtl]:before,[dir=rtl] .fd-form-label--colon:before{left:0;right:auto}.fd-form-label--colon.fd-form-label--required,.fd-form-label--colon[aria-required=true]{-webkit-padding-end:.75rem;padding-inline-end:.75rem}.fd-form-label--colon.fd-form-label--required:before,.fd-form-label--colon[aria-required=true]:before{right:.5rem}.fd-form-label--colon.fd-form-label--required[dir=rtl]:before,.fd-form-label--colon[aria-required=true][dir=rtl]:before,[dir=rtl] .fd-form-label--colon.fd-form-label--required:before,[dir=rtl] .fd-form-label--colon[aria-required=true]:before{left:.5rem;right:auto}.fd-form-label--inline-help{display:-webkit-box;display:-ms-flexbox;display:flex;width:100%;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-form-label--stand-alone{-ms-flex-item-align:center;align-self:center;-webkit-margin-end:0;margin-inline-end:0}.fd-form-label{display:inline-block}.fd-form-label__inline-help{position:relative;top:.125rem}.fd-form-label--allow-wrap{text-wrap:auto}.fd-form-label__wrapper{position:relative;display:flex;padding-bottom:.125rem}.fd-form-label__wrapper--align-end{justify-content:flex-end}.fd-form-label__wrapper span.fd-form-label{margin-bottom:-.125rem}.fd-form-label__wrapper--inline-help{display:flex;padding-left:0rem}[dir=rtl] .fd-form-label__wrapper--inline-help,.fd-form-label__wrapper--inline-help[dir=rtl],.fd-form-label__wrapper--inline-help--after{padding-left:0;padding-right:0rem}[dir=rtl] .fd-form-label__wrapper--inline-help--after,.fd-form-label__wrapper--inline-help--after[dir=rtl]{padding-right:0;padding-left:0rem}.fd-form-label__help{position:relative;vertical-align:middle;left:0;right:auto}[dir=rtl] .fd-form-label__help,.fd-form-label__help[dir=rtl],.fd-form-label__help--after{right:0;left:auto}[dir=rtl] .fd-form-label__help--after,.fd-form-label__help--after[dir=rtl]{left:0;right:auto}.fd-container.fd-form-layout-grid-container.fd-form-group .fd-form-item .fd-form-label--colon,.fd-container.fd-form-layout-grid-container .fd-form-group .fd-form-item .fd-form-label--colon{padding-inline-end:.25rem}.fd-container.fd-form-layout-grid-container.fd-form-group .fd-form-item .fd-form-label--required,.fd-container.fd-form-layout-grid-container .fd-form-group .fd-form-item .fd-form-label--required{padding-inline-end:.5rem}.fd-container.fd-form-layout-grid-container.fd-form-group .fd-form-item .fd-form-label--required.fd-form-label--colon,.fd-container.fd-form-layout-grid-container .fd-form-group .fd-form-item .fd-form-label--required.fd-form-label--colon{padding-inline-end:.75rem}.fd-form-item .fd-form-label--colon{padding-inline-end:.25rem}.fd-form-item .fd-form-label--required{padding-inline-end:.5rem}.fd-form-item .fd-form-label--required.fd-form-label--colon{padding-inline-end:.75rem}\n/*! Bundled license information:\n\nfundamental-styles/dist/form-label.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], propDecorators: { required: [{
                type: Input
            }], colon: [{
                type: Input
            }], alignLabelEnd: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-form-label__wrapper--align-end']
            }], inlineHelpContent: [{
                type: Input
            }], inlineHelpGlyph: [{
                type: Input
            }], inlineHelpTriggers: [{
                type: Input
            }], inlineHelpBodyPlacement: [{
                type: Input
            }], inlineHelpPlacement: [{
                type: Input
            }], allowWrap: [{
                type: Input
            }], inlineHelpLabel: [{
                type: Input
            }], defaultClass: [{
                type: HostBinding,
                args: ['class.fd-form-label__wrapper']
            }], inlineHelpClass: [{
                type: HostBinding,
                args: ['class.fd-form-label__wrapper--inline-help']
            }], inlineHelpAfter: [{
                type: HostBinding,
                args: ['class.fd-form-label__wrapper--inline-help--after']
            }], formLabelId: [{
                type: Input,
                args: ['id']
            }, {
                type: HostBinding,
                args: ['id']
            }] } });

/**
 * Directive to be applied to the parent of a form control.
 *
 * ```html
 * <div fd-form-item>
 *     <input fd-form-control type="text" />
 * </div>
 * ```
 */
class FormItemComponent {
    /** @hidden */
    constructor(ngZone) {
        this.ngZone = ngZone;
        /** Whether the form item is inline. */
        this.isInline = false;
        /** Whether the form item is horizontal. */
        this.horizontal = false;
        /** @hidden */
        this.fdFormItemClass = true;
    }
    /** @hidden */
    ngAfterViewInit() {
        if (this.formLabel && this.formItemControl && !this.formItemControl.ariaLabelledBy) {
            this.ngZone.onStable.pipe(first()).subscribe(() => {
                if (this.formLabel && this.formItemControl) {
                    this.formItemControl.ariaLabelledBy = this.formLabel.formLabelId;
                }
            });
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormItemComponent, deps: [{ token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: FormItemComponent, isStandalone: true, selector: "[fd-form-item]", inputs: { isInline: "isInline", horizontal: "horizontal" }, host: { properties: { "class.fd-form-item--inline": "this.isInline", "class.fd-form-item--horizontal": "this.horizontal", "class.fd-form-item": "this.fdFormItemClass" } }, queries: [{ propertyName: "formLabel", first: true, predicate: FormLabelComponent, descendants: true }, { propertyName: "formItemControl", first: true, predicate: FORM_ITEM_CONTROL, descendants: true }], ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, styles: [".fd-form-item{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-flex:1;-ms-flex:1;flex:1;position:relative}.fd-form-item:after,.fd-form-item:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-item__label-container{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between}.fd-form-item__label-container label{-ms-flex-item-align:center;align-self:center}.fd-form-item__label-container button{-webkit-margin-start:auto;margin-inline-start:auto}.fd-form-item--horizontal{-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-form-item--horizontal .fd-form-label{-webkit-padding-after:0;margin-block:auto;margin-inline:0 .5rem;padding-block-end:0}.fd-form-item--horizontal .fd-input{-webkit-box-flex:1;-ms-flex:1;flex:1}.fd-form-item .fd-form-message:not(:first-child){margin-top:-.25rem}.fd-form-item.fd-list__form-item{-webkit-box-flex:initial;-ms-flex:initial;flex:initial}.fd-form-item--horizontal .fd-form-label__wrapper{margin-right:.5rem}[dir=rtl] .fd-form-item--horizontal .fd-form-label__wrapper,.fd-form-item--horizontal .fd-form-label__wrapper[dir=rtl]{margin-left:.5rem;margin-right:0}\n/*! Bundled license information:\n\nfundamental-styles/dist/form-item.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormItemComponent, decorators: [{
            type: Component,
            args: [{ selector: '[fd-form-item]', template: `<ng-content></ng-content>`, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, styles: [".fd-form-item{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-flex:1;-ms-flex:1;flex:1;position:relative}.fd-form-item:after,.fd-form-item:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-item__label-container{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between}.fd-form-item__label-container label{-ms-flex-item-align:center;align-self:center}.fd-form-item__label-container button{-webkit-margin-start:auto;margin-inline-start:auto}.fd-form-item--horizontal{-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-form-item--horizontal .fd-form-label{-webkit-padding-after:0;margin-block:auto;margin-inline:0 .5rem;padding-block-end:0}.fd-form-item--horizontal .fd-input{-webkit-box-flex:1;-ms-flex:1;flex:1}.fd-form-item .fd-form-message:not(:first-child){margin-top:-.25rem}.fd-form-item.fd-list__form-item{-webkit-box-flex:initial;-ms-flex:initial;flex:initial}.fd-form-item--horizontal .fd-form-label__wrapper{margin-right:.5rem}[dir=rtl] .fd-form-item--horizontal .fd-form-label__wrapper,.fd-form-item--horizontal .fd-form-label__wrapper[dir=rtl]{margin-left:.5rem;margin-right:0}\n/*! Bundled license information:\n\nfundamental-styles/dist/form-item.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], ctorParameters: () => [{ type: i0.NgZone }], propDecorators: { isInline: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-form-item--inline']
            }], horizontal: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-form-item--horizontal']
            }], fdFormItemClass: [{
                type: HostBinding,
                args: ['class.fd-form-item']
            }], formLabel: [{
                type: ContentChild,
                args: [FormLabelComponent]
            }], formItemControl: [{
                type: ContentChild,
                args: [FORM_ITEM_CONTROL]
            }] } });

/**
 * @deprecated
 * Import `FormItemComponent` directly as a standalone component.
 */
class FormItemModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormItemModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: FormItemModule, imports: [FormItemComponent], exports: [FormItemComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormItemModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormItemModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [FormItemComponent],
                    exports: [FormItemComponent]
                }]
        }] });

/**
 * @deprecated
 * Import `FormLabelComponent` directly as a standalone component.
 */
class FormLabelModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormLabelModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: FormLabelModule, imports: [FormLabelComponent], exports: [FormLabelComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormLabelModule, imports: [FormLabelComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormLabelModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [FormLabelComponent],
                    exports: [FormLabelComponent]
                }]
        }] });

/**
 * Applies css to a legend html element.
 *
 * <legend fd-form-legend>Legend</legend>
 */
class FormLegendDirective {
    constructor() {
        /** @hidden */
        this.fdFormLegendClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormLegendDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: FormLegendDirective, isStandalone: true, selector: "[fd-form-legend]", host: { properties: { "class.fd-fieldset__legend": "this.fdFormLegendClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormLegendDirective, decorators: [{
            type: Directive,
            args: [{
                    // TODO to be discussed
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-form-legend]',
                    standalone: true
                }]
        }], propDecorators: { fdFormLegendClass: [{
                type: HostBinding,
                args: ['class.fd-fieldset__legend']
            }] } });

/**
 * @deprecated
 * Import `FormLegendDirective` directly as a standalone directive.
 */
class FormLegendModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormLegendModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: FormLegendModule, imports: [FormLegendDirective], exports: [FormLegendDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormLegendModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormLegendModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [FormLegendDirective],
                    exports: [FormLegendDirective]
                }]
        }] });

const CSS_CLASS_NAME = {
    message: 'fd-form-message',
    messageStatic: 'fd-form-message--static',
    messageEmbedded: 'fd-form-message--embedded',
    messageSuccess: 'fd-form-message--success',
    messageError: 'fd-form-message--error',
    messageWarning: 'fd-form-message--warning',
    messageInformation: 'fd-form-message--information'
};
/** Get form message CSS class accordingly to its type */
function getTypeClassName(size) {
    switch (size) {
        case 'error':
            return CSS_CLASS_NAME.messageError;
        case 'success':
            return CSS_CLASS_NAME.messageSuccess;
        case 'warning':
            return CSS_CLASS_NAME.messageWarning;
        case 'information':
            return CSS_CLASS_NAME.messageInformation;
        default:
            return null;
    }
}

/**
 * Form message. Intended to be displayed with a form control for validation purposes.
 */
class FormMessageComponent {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
        /** Whether message should be in static mode, without popover. It's mostly used for forms component, that contain dropdown */
        this.static = false;
        /**
         * Whether message is used inside popovers or dialogs.
         * When it is enabled box shadow is removed and message is expanded to whole container width
         */
        this.embedded = false;
    }
    /** @hidden */
    buildComponentCssClass() {
        return [
            CSS_CLASS_NAME.message,
            this.static ? CSS_CLASS_NAME.messageStatic : '',
            this.embedded ? CSS_CLASS_NAME.messageEmbedded : '',
            getTypeClassName(this.type),
            this.class
        ].filter((v) => !!v);
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormMessageComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: FormMessageComponent, isStandalone: true, selector: "fd-form-message", inputs: { type: "type", static: "static", embedded: "embedded", class: "class" }, host: { attributes: { "aria-live": "assertive", "aria-atomic": "true" } }, providers: [DynamicComponentService], usesOnChanges: true, ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, styles: [".fd-form-message{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);forced-color-adjust:none;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap;-webkit-box-align:center;-ms-flex-align:center;align-items:center;border:var(--fdMessage_Border);border-radius:var(--fdMessage_Border_Radius)!important;-webkit-box-shadow:var(--fdMessage_Box_Shadow);box-shadow:var(--fdMessage_Box_Shadow);color:var(--sapTextColor);font-size:var(--sapFontSmallSize);font-weight:400;line-height:normal;max-width:22rem;min-width:6rem;padding-block:.5rem;padding-inline:.5rem;white-space:pre-line!important;width:100%}.fd-form-message:after,.fd-form-message:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-message[dir=rtl],[dir=rtl] .fd-form-message{right:0}.fd-form-message:before{display:var(--fdMessage_Icon_Display);-ms-flex-item-align:start;align-self:flex-start;-webkit-margin-end:.375rem;font-family:SAP-icons;font-size:1rem;margin-inline-end:.375rem}.fd-form-message--static{width:auto}.fd-form-message--embedded{-webkit-box-shadow:none;box-shadow:none;max-width:100%}.fd-form-message--error{background-color:var(--sapErrorBackground)}.fd-form-message--error:before{color:var(--sapNegativeElementColor);content:\"\\e0b1\"}.fd-form-message--warning{background-color:var(--sapWarningBackground)}.fd-form-message--warning:before{color:var(--sapCriticalElementColor);content:\"\\e201\"}.fd-form-message--success{background-color:var(--sapSuccessBackground)}.fd-form-message--success:before{color:var(--sapPositiveElementColor);content:\"\\e203\"}.fd-form-message--information{background-color:var(--sapInformationBackground)}.fd-form-message--information:before{color:var(--sapInformativeElementColor);content:\"\\e202\"}\n/*! Bundled license information:\n\nfundamental-styles/dist/form-message.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], FormMessageComponent.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormMessageComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-form-message', template: `<ng-content></ng-content>`, host: {
                        'aria-live': 'assertive',
                        'aria-atomic': 'true'
                    }, providers: [DynamicComponentService], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, styles: [".fd-form-message{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);forced-color-adjust:none;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap;-webkit-box-align:center;-ms-flex-align:center;align-items:center;border:var(--fdMessage_Border);border-radius:var(--fdMessage_Border_Radius)!important;-webkit-box-shadow:var(--fdMessage_Box_Shadow);box-shadow:var(--fdMessage_Box_Shadow);color:var(--sapTextColor);font-size:var(--sapFontSmallSize);font-weight:400;line-height:normal;max-width:22rem;min-width:6rem;padding-block:.5rem;padding-inline:.5rem;white-space:pre-line!important;width:100%}.fd-form-message:after,.fd-form-message:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-message[dir=rtl],[dir=rtl] .fd-form-message{right:0}.fd-form-message:before{display:var(--fdMessage_Icon_Display);-ms-flex-item-align:start;align-self:flex-start;-webkit-margin-end:.375rem;font-family:SAP-icons;font-size:1rem;margin-inline-end:.375rem}.fd-form-message--static{width:auto}.fd-form-message--embedded{-webkit-box-shadow:none;box-shadow:none;max-width:100%}.fd-form-message--error{background-color:var(--sapErrorBackground)}.fd-form-message--error:before{color:var(--sapNegativeElementColor);content:\"\\e0b1\"}.fd-form-message--warning{background-color:var(--sapWarningBackground)}.fd-form-message--warning:before{color:var(--sapCriticalElementColor);content:\"\\e201\"}.fd-form-message--success{background-color:var(--sapSuccessBackground)}.fd-form-message--success:before{color:var(--sapPositiveElementColor);content:\"\\e203\"}.fd-form-message--information{background-color:var(--sapInformationBackground)}.fd-form-message--information:before{color:var(--sapInformativeElementColor);content:\"\\e202\"}\n/*! Bundled license information:\n\nfundamental-styles/dist/form-message.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { type: [{
                type: Input
            }], static: [{
                type: Input
            }], embedded: [{
                type: Input
            }], class: [{
                type: Input
            }], buildComponentCssClass: [] } });

/**
 * @deprecated
 * Import `FormMessageComponent` directly as a standalone component.
 */
class FormMessageModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormMessageModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: FormMessageModule, imports: [FormMessageComponent], exports: [FormMessageComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormMessageModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormMessageModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [FormMessageComponent],
                    exports: [FormMessageComponent]
                }]
        }] });

class PopoverFormMessageService {
    /** @hidden */
    constructor(_popoverService) {
        this._popoverService = _popoverService;
        /** @hidden */
        this._hidden = false;
    }
    /** @hidden */
    set message(message) {
        this._message = message;
        this._updatePopover();
    }
    /** @hidden */
    set triggers(triggers) {
        this._popoverService.triggers = triggers;
        this._popoverService._refreshTriggerListeners();
    }
    /** Initialise popover service with trigger element */
    init(triggerElement) {
        this._popoverService.initialise(triggerElement);
    }
    /** Forces hidden state onto popover, without any collision with triggering events */
    hide() {
        this._hidden = true;
        this._updatePopover();
    }
    /** Removes hidden state onto popover, without any collision with triggering events */
    show() {
        this._hidden = false;
        this._updatePopover();
    }
    /** @hidden */
    _getAdditionalClass() {
        return [this._shouldBeHidden() ? 'fd-popover__body--hidden' : ''].filter((v) => !!v);
    }
    /** @hidden */
    _updatePopover() {
        this._popoverService.additionalBodyClass = this._getAdditionalClass().join(' ');
        this._popoverService.updateContent(this._message, null);
    }
    /** @hidden */
    _shouldBeHidden() {
        return this._hidden || !this._message;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: PopoverFormMessageService, deps: [{ token: i1$1.PopoverService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: PopoverFormMessageService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: PopoverFormMessageService, decorators: [{
            type: Injectable
        }], ctorParameters: () => [{ type: i1$1.PopoverService }] });

class FormModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: FormModule, imports: [FieldsetComponent,
            FormControlComponent,
            FormItemComponent,
            FormItemComponent,
            FormLabelComponent,
            FormHeaderComponent,
            FormLegendDirective,
            FormMessageComponent,
            FormInputMessageGroupComponent,
            FormGroupComponent], exports: [FieldsetComponent,
            FormControlComponent,
            FormItemComponent,
            FormItemComponent,
            FormLabelComponent,
            FormHeaderComponent,
            FormLegendDirective,
            FormMessageComponent,
            FormInputMessageGroupComponent,
            FormGroupComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormModule, imports: [FormLabelComponent,
            FormInputMessageGroupComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: FormModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        FieldsetComponent,
                        FormControlComponent,
                        FormItemComponent,
                        FormItemComponent,
                        FormLabelComponent,
                        FormHeaderComponent,
                        FormLegendDirective,
                        FormMessageComponent,
                        FormInputMessageGroupComponent,
                        FormGroupComponent
                    ],
                    exports: [
                        FieldsetComponent,
                        FormControlComponent,
                        FormItemComponent,
                        FormItemComponent,
                        FormLabelComponent,
                        FormHeaderComponent,
                        FormLegendDirective,
                        FormMessageComponent,
                        FormInputMessageGroupComponent,
                        FormGroupComponent
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { FORM_ITEM_CONTROL, FieldSetModule, FieldsetComponent, FormControlComponent, FormControlModule, FormGroupComponent, FormGroupModule, FormHeaderComponent, FormHeaderModule, FormInputMessageGroupComponent, FormInputMessageGroupModule, FormItemComponent, FormItemModule, FormLabelComponent, FormLabelModule, FormLegendDirective, FormLegendModule, FormMessageComponent, FormMessageModule, FormModule, PopoverFormMessageService, registerFormItemControl };
//# sourceMappingURL=fundamental-ngx-core-form.mjs.map
