import { __decorate, __metadata } from 'tslib';
import * as i0 from '@angular/core';
import { InjectionToken, inject, ElementRef, Input, ChangeDetectionStrategy, ViewEncapsulation, Component, NgModule } from '@angular/core';
import { applyCssClass } from '@fundamental-ngx/cdk/utils';
import { IconComponent } from '@fundamental-ngx/core/icon';

const FD_GENERIC_TAG_COMPONENT = new InjectionToken('FdGenericTagComponent');

class GenericTagComponent {
    constructor() {
        /**
         *  Aria defines role description for the Generic Tag
         */
        this.ariaRoleDescription = 'Generic Tag';
        /** @hidden */
        this.elementRef = inject(ElementRef);
    }
    /** @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return buildObjectStatusCssClasses(this);
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GenericTagComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: GenericTagComponent, isStandalone: true, selector: "[fd-generic-tag]", inputs: { class: "class", type: "type", name: "name", value: "value", ariaRoleDescription: "ariaRoleDescription" }, host: { attributes: { "role": "button" }, properties: { "attr.tabindex": "0", "attr.aria-roledescription": "ariaRoleDescription" } }, providers: [
            {
                provide: FD_GENERIC_TAG_COMPONENT,
                useExisting: GenericTagComponent
            }
        ], usesOnChanges: true, ngImport: i0, template: "@if (type) {\n    <fd-icon\n        class=\"fd-generic-tag__icon\"\n        [glyph]=\"type ? 'message-' + type : ''\"\n        role=\"presentation\"\n        aria-hidden=\"true\"\n    ></fd-icon>\n}\n<span class=\"fd-generic-tag__name\">{{ name }}</span>\n@if (value) {\n    <span class=\"fd-generic-tag__value\">{{ value }}</span>\n}\n", styles: [".fd-generic-tag{--fdGenericTag_Spacing:.375rem;--fdGenericTag_Margin:.5625rem;--fdGenericTag_Decorator_Position:0;--fdGenericTag_Decorator_Color:var(--sapNeutralElementColor);--fdGenericTag_Background_Color:var(--sapNeutralBackground);--fdGenericTag_Icon_Color:var(--sapNeutralElementColor);--fdGenericTag_Name_Color:var(--sapList_TextColor);--fdGenericTag_Name_Text_Shadow:var(--sapContent_TextShadow);--fdGenericTag_Value_Color:var(--sapNeutralTextColor);--fdGenericTag_Value_Text_Shadow:var(--sapContent_TextShadow);--fdGenericTag_Text_Min_Width:1.5625rem;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background:var(--fdGenericTag_Decorator_Position) 0/var(--fdGenericTag_Spacing) 100% no-repeat -webkit-gradient(linear,left bottom,left top,from(var(--fdGenericTag_Decorator_Color)),to(var(--fdGenericTag_Decorator_Color)));background:var(--fdGenericTag_Decorator_Position) 0/var(--fdGenericTag_Spacing) 100% no-repeat linear-gradient(0deg,var(--fdGenericTag_Decorator_Color),var(--fdGenericTag_Decorator_Color));background-color:var(--fdGenericTag_Background_Color);border-radius:var(--sapButton_BorderCornerRadius);-webkit-box-shadow:var(--sapContent_Shadow0);box-shadow:var(--sapContent_Shadow0);cursor:pointer;gap:var(--fdGenericTag_Spacing);height:1.625rem;margin-block:var(--fdGenericTag_Margin);margin-inline:0;padding-inline:.75rem .375rem;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content}.fd-generic-tag:after,.fd-generic-tag:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-generic-tag__icon[class*=sap-icon]{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--fdGenericTag_Icon_Color);font-size:1rem}.fd-generic-tag__name,.fd-generic-tag__value{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;min-width:var(--fdGenericTag_Text_Min_Width);overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-generic-tag__name:after,.fd-generic-tag__name:before,.fd-generic-tag__value:after,.fd-generic-tag__value:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-generic-tag__name{color:var(--fdGenericTag_Name_Color);text-shadow:var(--fdGenericTag_Name_Text_Shadow)}.fd-generic-tag__value{-webkit-margin-start:.75rem;color:var(--fdGenericTag_Value_Color);margin-inline-start:.75rem;text-shadow:var(--fdGenericTag_Value_Text_Shadow)}.fd-generic-tag.is-hover,.fd-generic-tag:hover{--fdGenericTag_Background_Color:var(--sapList_Hover_Background);--fdGenericTag_Name_Color:var(--fdGenericTag_Name_Color_Hover);--fdGenericTag_Value_Color:var(--fdGenericTag_Value_Color_Hover_Neutral);--fdGenericTag_Icon_Color:var(--fdGenericTag_Icon_Color_Hover_Neutral);--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Value_Text_Shadow:none}.fd-generic-tag.is-active,.fd-generic-tag:active{--fdGenericTag_Background_Color:var(--sapList_Active_Background);--fdGenericTag_Name_Color:var(--sapList_Active_TextColor);--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Icon_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Text_Shadow:none}.fd-generic-tag.is-active,.fd-generic-tag.is-focus,.fd-generic-tag:active,.fd-generic-tag:focus{outline:var(--sapContent_FocusColor) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:var(--fdGenericTag_Spacing_Outline_Offset)}.fd-generic-tag.is-focus,.fd-generic-tag:focus{z-index:5}.fd-generic-tag[dir=rtl],[dir=rtl] .fd-generic-tag{--fdGenericTag_Decorator_Position:100%}.fd-generic-tag[class*=-compact],[class*=-compact] .fd-generic-tag:not([class*=-cozy]){--fdGenericTag_Margin:.1875rem}.fd-generic-tag.fd-generic-tag--error{--fdGenericTag_Value_Color:var(--sapNegativeTextColor);--fdGenericTag_Icon_Color:var(--sapNegativeElementColor);--fdGenericTag_Decorator_Color:var(--sapNegativeElementColor);--fdGenericTag_Background_Color:var(--sapErrorBackground)}.fd-generic-tag.fd-generic-tag--error.is-hover,.fd-generic-tag.fd-generic-tag--error:hover{--fdGenericTag_Value_Color:var(--fdGenericTag_Value_Color_Hover_Error);--fdGenericTag_Icon_Color:var(--fdGenericTag_Icon_Color_Hover_Error);--fdGenericTag_Background_Color:var(--sapList_Hover_Background);--fdGenericTag_Name_Color:var(--fdGenericTag_Name_Color_Hover)}.fd-generic-tag.fd-generic-tag--error.is-active,.fd-generic-tag.fd-generic-tag--error:active{--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Value_Text_Shadow:none;--fdGenericTag_Background_Color:var(--sapList_Active_Background);--fdGenericTag_Name_Color:var(--sapList_Active_TextColor);--fdGenericTag_Icon_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Color:var(--sapList_Active_TextColor)}.fd-generic-tag.fd-generic-tag--warning{--fdGenericTag_Value_Color:var(--sapCriticalTextColor);--fdGenericTag_Icon_Color:var(--sapCriticalElementColor);--fdGenericTag_Decorator_Color:var(--sapCriticalElementColor);--fdGenericTag_Background_Color:var(--sapWarningBackground)}.fd-generic-tag.fd-generic-tag--warning.is-hover,.fd-generic-tag.fd-generic-tag--warning:hover{--fdGenericTag_Value_Color:var(--fdGenericTag_Value_Color_Hover_Warning);--fdGenericTag_Icon_Color:var(--fdGenericTag_Icon_Color_Hover_Warning);--fdGenericTag_Background_Color:var(--sapList_Hover_Background);--fdGenericTag_Name_Color:var(--fdGenericTag_Name_Color_Hover)}.fd-generic-tag.fd-generic-tag--warning.is-active,.fd-generic-tag.fd-generic-tag--warning:active{--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Value_Text_Shadow:none;--fdGenericTag_Background_Color:var(--sapList_Active_Background);--fdGenericTag_Name_Color:var(--sapList_Active_TextColor);--fdGenericTag_Icon_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Color:var(--sapList_Active_TextColor)}.fd-generic-tag.fd-generic-tag--success{--fdGenericTag_Value_Color:var(--sapPositiveTextColor);--fdGenericTag_Icon_Color:var(--sapPositiveElementColor);--fdGenericTag_Decorator_Color:var(--sapPositiveElementColor);--fdGenericTag_Background_Color:var(--sapSuccessBackground)}.fd-generic-tag.fd-generic-tag--success.is-hover,.fd-generic-tag.fd-generic-tag--success:hover{--fdGenericTag_Value_Color:var(--fdGenericTag_Value_Color_Hover_Success);--fdGenericTag_Icon_Color:var(--fdGenericTag_Icon_Color_Hover_Success);--fdGenericTag_Background_Color:var(--sapList_Hover_Background);--fdGenericTag_Name_Color:var(--fdGenericTag_Name_Color_Hover)}.fd-generic-tag.fd-generic-tag--success.is-active,.fd-generic-tag.fd-generic-tag--success:active{--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Value_Text_Shadow:none;--fdGenericTag_Background_Color:var(--sapList_Active_Background);--fdGenericTag_Name_Color:var(--sapList_Active_TextColor);--fdGenericTag_Icon_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Color:var(--sapList_Active_TextColor)}.fd-generic-tag.fd-generic-tag--information{--fdGenericTag_Value_Color:var(--sapInformativeTextColor);--fdGenericTag_Icon_Color:var(--sapInformativeElementColor);--fdGenericTag_Decorator_Color:var(--sapInformativeElementColor);--fdGenericTag_Background_Color:var(--sapInformationBackground)}.fd-generic-tag.fd-generic-tag--information.is-hover,.fd-generic-tag.fd-generic-tag--information:hover{--fdGenericTag_Value_Color:var(--fdGenericTag_Value_Color_Hover_Information);--fdGenericTag_Icon_Color:var(--fdGenericTag_Icon_Color_Hover_Information);--fdGenericTag_Background_Color:var(--sapList_Hover_Background);--fdGenericTag_Name_Color:var(--fdGenericTag_Name_Color_Hover)}.fd-generic-tag.fd-generic-tag--information.is-active,.fd-generic-tag.fd-generic-tag--information:active{--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Value_Text_Shadow:none;--fdGenericTag_Background_Color:var(--sapList_Active_Background);--fdGenericTag_Name_Color:var(--sapList_Active_TextColor);--fdGenericTag_Icon_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Color:var(--sapList_Active_TextColor)}\n/*! Bundled license information:\n\nfundamental-styles/dist/generic-tag.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], dependencies: [{ kind: "component", type: IconComponent, selector: "fd-icon", inputs: ["glyph", "font", "color", "background", "class", "ariaLabel", "ariaHidden"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], GenericTagComponent.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GenericTagComponent, decorators: [{
            type: Component,
            args: [{ selector: '[fd-generic-tag]', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: FD_GENERIC_TAG_COMPONENT,
                            useExisting: GenericTagComponent
                        }
                    ], host: {
                        '[attr.tabindex]': '0',
                        '[attr.aria-roledescription]': 'ariaRoleDescription',
                        role: 'button'
                    }, imports: [IconComponent], template: "@if (type) {\n    <fd-icon\n        class=\"fd-generic-tag__icon\"\n        [glyph]=\"type ? 'message-' + type : ''\"\n        role=\"presentation\"\n        aria-hidden=\"true\"\n    ></fd-icon>\n}\n<span class=\"fd-generic-tag__name\">{{ name }}</span>\n@if (value) {\n    <span class=\"fd-generic-tag__value\">{{ value }}</span>\n}\n", styles: [".fd-generic-tag{--fdGenericTag_Spacing:.375rem;--fdGenericTag_Margin:.5625rem;--fdGenericTag_Decorator_Position:0;--fdGenericTag_Decorator_Color:var(--sapNeutralElementColor);--fdGenericTag_Background_Color:var(--sapNeutralBackground);--fdGenericTag_Icon_Color:var(--sapNeutralElementColor);--fdGenericTag_Name_Color:var(--sapList_TextColor);--fdGenericTag_Name_Text_Shadow:var(--sapContent_TextShadow);--fdGenericTag_Value_Color:var(--sapNeutralTextColor);--fdGenericTag_Value_Text_Shadow:var(--sapContent_TextShadow);--fdGenericTag_Text_Min_Width:1.5625rem;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background:var(--fdGenericTag_Decorator_Position) 0/var(--fdGenericTag_Spacing) 100% no-repeat -webkit-gradient(linear,left bottom,left top,from(var(--fdGenericTag_Decorator_Color)),to(var(--fdGenericTag_Decorator_Color)));background:var(--fdGenericTag_Decorator_Position) 0/var(--fdGenericTag_Spacing) 100% no-repeat linear-gradient(0deg,var(--fdGenericTag_Decorator_Color),var(--fdGenericTag_Decorator_Color));background-color:var(--fdGenericTag_Background_Color);border-radius:var(--sapButton_BorderCornerRadius);-webkit-box-shadow:var(--sapContent_Shadow0);box-shadow:var(--sapContent_Shadow0);cursor:pointer;gap:var(--fdGenericTag_Spacing);height:1.625rem;margin-block:var(--fdGenericTag_Margin);margin-inline:0;padding-inline:.75rem .375rem;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content}.fd-generic-tag:after,.fd-generic-tag:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-generic-tag__icon[class*=sap-icon]{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--fdGenericTag_Icon_Color);font-size:1rem}.fd-generic-tag__name,.fd-generic-tag__value{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;min-width:var(--fdGenericTag_Text_Min_Width);overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-generic-tag__name:after,.fd-generic-tag__name:before,.fd-generic-tag__value:after,.fd-generic-tag__value:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-generic-tag__name{color:var(--fdGenericTag_Name_Color);text-shadow:var(--fdGenericTag_Name_Text_Shadow)}.fd-generic-tag__value{-webkit-margin-start:.75rem;color:var(--fdGenericTag_Value_Color);margin-inline-start:.75rem;text-shadow:var(--fdGenericTag_Value_Text_Shadow)}.fd-generic-tag.is-hover,.fd-generic-tag:hover{--fdGenericTag_Background_Color:var(--sapList_Hover_Background);--fdGenericTag_Name_Color:var(--fdGenericTag_Name_Color_Hover);--fdGenericTag_Value_Color:var(--fdGenericTag_Value_Color_Hover_Neutral);--fdGenericTag_Icon_Color:var(--fdGenericTag_Icon_Color_Hover_Neutral);--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Value_Text_Shadow:none}.fd-generic-tag.is-active,.fd-generic-tag:active{--fdGenericTag_Background_Color:var(--sapList_Active_Background);--fdGenericTag_Name_Color:var(--sapList_Active_TextColor);--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Icon_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Text_Shadow:none}.fd-generic-tag.is-active,.fd-generic-tag.is-focus,.fd-generic-tag:active,.fd-generic-tag:focus{outline:var(--sapContent_FocusColor) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:var(--fdGenericTag_Spacing_Outline_Offset)}.fd-generic-tag.is-focus,.fd-generic-tag:focus{z-index:5}.fd-generic-tag[dir=rtl],[dir=rtl] .fd-generic-tag{--fdGenericTag_Decorator_Position:100%}.fd-generic-tag[class*=-compact],[class*=-compact] .fd-generic-tag:not([class*=-cozy]){--fdGenericTag_Margin:.1875rem}.fd-generic-tag.fd-generic-tag--error{--fdGenericTag_Value_Color:var(--sapNegativeTextColor);--fdGenericTag_Icon_Color:var(--sapNegativeElementColor);--fdGenericTag_Decorator_Color:var(--sapNegativeElementColor);--fdGenericTag_Background_Color:var(--sapErrorBackground)}.fd-generic-tag.fd-generic-tag--error.is-hover,.fd-generic-tag.fd-generic-tag--error:hover{--fdGenericTag_Value_Color:var(--fdGenericTag_Value_Color_Hover_Error);--fdGenericTag_Icon_Color:var(--fdGenericTag_Icon_Color_Hover_Error);--fdGenericTag_Background_Color:var(--sapList_Hover_Background);--fdGenericTag_Name_Color:var(--fdGenericTag_Name_Color_Hover)}.fd-generic-tag.fd-generic-tag--error.is-active,.fd-generic-tag.fd-generic-tag--error:active{--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Value_Text_Shadow:none;--fdGenericTag_Background_Color:var(--sapList_Active_Background);--fdGenericTag_Name_Color:var(--sapList_Active_TextColor);--fdGenericTag_Icon_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Color:var(--sapList_Active_TextColor)}.fd-generic-tag.fd-generic-tag--warning{--fdGenericTag_Value_Color:var(--sapCriticalTextColor);--fdGenericTag_Icon_Color:var(--sapCriticalElementColor);--fdGenericTag_Decorator_Color:var(--sapCriticalElementColor);--fdGenericTag_Background_Color:var(--sapWarningBackground)}.fd-generic-tag.fd-generic-tag--warning.is-hover,.fd-generic-tag.fd-generic-tag--warning:hover{--fdGenericTag_Value_Color:var(--fdGenericTag_Value_Color_Hover_Warning);--fdGenericTag_Icon_Color:var(--fdGenericTag_Icon_Color_Hover_Warning);--fdGenericTag_Background_Color:var(--sapList_Hover_Background);--fdGenericTag_Name_Color:var(--fdGenericTag_Name_Color_Hover)}.fd-generic-tag.fd-generic-tag--warning.is-active,.fd-generic-tag.fd-generic-tag--warning:active{--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Value_Text_Shadow:none;--fdGenericTag_Background_Color:var(--sapList_Active_Background);--fdGenericTag_Name_Color:var(--sapList_Active_TextColor);--fdGenericTag_Icon_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Color:var(--sapList_Active_TextColor)}.fd-generic-tag.fd-generic-tag--success{--fdGenericTag_Value_Color:var(--sapPositiveTextColor);--fdGenericTag_Icon_Color:var(--sapPositiveElementColor);--fdGenericTag_Decorator_Color:var(--sapPositiveElementColor);--fdGenericTag_Background_Color:var(--sapSuccessBackground)}.fd-generic-tag.fd-generic-tag--success.is-hover,.fd-generic-tag.fd-generic-tag--success:hover{--fdGenericTag_Value_Color:var(--fdGenericTag_Value_Color_Hover_Success);--fdGenericTag_Icon_Color:var(--fdGenericTag_Icon_Color_Hover_Success);--fdGenericTag_Background_Color:var(--sapList_Hover_Background);--fdGenericTag_Name_Color:var(--fdGenericTag_Name_Color_Hover)}.fd-generic-tag.fd-generic-tag--success.is-active,.fd-generic-tag.fd-generic-tag--success:active{--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Value_Text_Shadow:none;--fdGenericTag_Background_Color:var(--sapList_Active_Background);--fdGenericTag_Name_Color:var(--sapList_Active_TextColor);--fdGenericTag_Icon_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Color:var(--sapList_Active_TextColor)}.fd-generic-tag.fd-generic-tag--information{--fdGenericTag_Value_Color:var(--sapInformativeTextColor);--fdGenericTag_Icon_Color:var(--sapInformativeElementColor);--fdGenericTag_Decorator_Color:var(--sapInformativeElementColor);--fdGenericTag_Background_Color:var(--sapInformationBackground)}.fd-generic-tag.fd-generic-tag--information.is-hover,.fd-generic-tag.fd-generic-tag--information:hover{--fdGenericTag_Value_Color:var(--fdGenericTag_Value_Color_Hover_Information);--fdGenericTag_Icon_Color:var(--fdGenericTag_Icon_Color_Hover_Information);--fdGenericTag_Background_Color:var(--sapList_Hover_Background);--fdGenericTag_Name_Color:var(--fdGenericTag_Name_Color_Hover)}.fd-generic-tag.fd-generic-tag--information.is-active,.fd-generic-tag.fd-generic-tag--information:active{--fdGenericTag_Name_Text_Shadow:none;--fdGenericTag_Value_Text_Shadow:none;--fdGenericTag_Background_Color:var(--sapList_Active_Background);--fdGenericTag_Name_Color:var(--sapList_Active_TextColor);--fdGenericTag_Icon_Color:var(--sapList_Active_TextColor);--fdGenericTag_Value_Color:var(--sapList_Active_TextColor)}\n/*! Bundled license information:\n\nfundamental-styles/dist/generic-tag.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], propDecorators: { class: [{
                type: Input
            }], type: [{
                type: Input
            }], name: [{
                type: Input,
                args: [{ required: true }]
            }], value: [{
                type: Input
            }], ariaRoleDescription: [{
                type: Input
            }], buildComponentCssClass: [] } });
const buildObjectStatusCssClasses = (data) => [
    'fd-generic-tag',
    data.type ? `fd-generic-tag--${data.type}` : '',
    data.class || ''
];

class GenericTagModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GenericTagModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: GenericTagModule, imports: [GenericTagComponent], exports: [GenericTagComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GenericTagModule, imports: [GenericTagComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GenericTagModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [GenericTagComponent],
                    exports: [GenericTagComponent]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { FD_GENERIC_TAG_COMPONENT, GenericTagComponent, GenericTagModule };
//# sourceMappingURL=fundamental-ngx-core-generic-tag.mjs.map
