import * as i0 from '@angular/core';
import { ChangeDetectionStrategy, Component, HostBinding, Directive, Input, ViewEncapsulation, NgModule } from '@angular/core';
import { __decorate, __metadata } from 'tslib';
import * as i1 from '@angular/platform-browser';
import { applyCssClass } from '@fundamental-ngx/cdk/utils';
import { Subscription, fromEvent, debounceTime } from 'rxjs';

class IllustratedMessageActionsComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageActionsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: IllustratedMessageActionsComponent, isStandalone: true, selector: "fd-illustrated-message-actions", host: { classAttribute: "fd-illustrated-message__actions" }, ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageActionsComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-illustrated-message-actions',
                    template: `<ng-content></ng-content>`,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: {
                        class: 'fd-illustrated-message__actions'
                    },
                    standalone: true
                }]
        }] });

class IllustratedMessageFigcaptionComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageFigcaptionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: IllustratedMessageFigcaptionComponent, isStandalone: true, selector: "[fd-illustrated-message-figcaption]", host: { classAttribute: "fd-illustrated-message__figcaption" }, ngImport: i0, template: `
        <ng-content select="[fd-illustrated-message-title]"></ng-content>
        <ng-content select="[fd-illustrated-message-text]"></ng-content>
    `, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageFigcaptionComponent, decorators: [{
            type: Component,
            args: [{
                    // eslint-disable-next-line @angular-eslint/component-selector
                    selector: '[fd-illustrated-message-figcaption]',
                    template: `
        <ng-content select="[fd-illustrated-message-title]"></ng-content>
        <ng-content select="[fd-illustrated-message-text]"></ng-content>
    `,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: {
                        class: 'fd-illustrated-message__figcaption'
                    },
                    standalone: true
                }]
        }] });

class IllustratedMessageTextDirective {
    constructor() {
        /** @hidden */
        this.fdIllustratedMessageTextClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageTextDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: IllustratedMessageTextDirective, isStandalone: true, selector: "[fd-illustrated-message-text]", host: { properties: { "class.fd-illustrated-message__text": "this.fdIllustratedMessageTextClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageTextDirective, decorators: [{
            type: Directive,
            args: [{
                    // TODO to be discussed
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-illustrated-message-text]',
                    standalone: true
                }]
        }], propDecorators: { fdIllustratedMessageTextClass: [{
                type: HostBinding,
                args: ['class.fd-illustrated-message__text']
            }] } });

class IllustratedMessageTitleDirective {
    constructor() {
        /** @hidden */
        this.fdIllustratedMessageTitleClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageTitleDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: IllustratedMessageTitleDirective, isStandalone: true, selector: "[fd-illustrated-message-title]", host: { properties: { "class.fd-illustrated-message__title": "this.fdIllustratedMessageTitleClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageTitleDirective, decorators: [{
            type: Directive,
            args: [{
                    // TODO to be discussed
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-illustrated-message-title]',
                    standalone: true
                }]
        }], propDecorators: { fdIllustratedMessageTitleClass: [{
                type: HostBinding,
                args: ['class.fd-illustrated-message__title']
            }] } });

var IllustratedMessageTypes;
(function (IllustratedMessageTypes) {
    IllustratedMessageTypes["SCENE"] = "scene";
    IllustratedMessageTypes["DIALOG"] = "dialog";
    IllustratedMessageTypes["SPOT"] = "spot";
    IllustratedMessageTypes["DOT"] = "dot";
    IllustratedMessageTypes["BASE"] = "base";
})(IllustratedMessageTypes || (IllustratedMessageTypes = {}));
let illustratedMessageUniqueId = 0;
class IllustratedMessageComponent {
    /** @hidden */
    constructor(elementRef, _cdRef, _sanitizer) {
        this.elementRef = elementRef;
        this._cdRef = _cdRef;
        this._sanitizer = _sanitizer;
        /**
         * When set to true will remove the illustration from the Illustrated Message
         * The default is set to false
         */
        this.noSvg = false;
        /**
         * Id of the Illustrated Message
         * If not provided, a default one is generated
         */
        this.id = 'fd-illustrated-message-' + illustratedMessageUniqueId++;
        /** @hidden */
        this._subscriptions = new Subscription();
    }
    /**
     * @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return [
            'fd-illustrated-message',
            this._tempType ? `fd-illustrated-message--${this._tempType}` : '',
            this.class || ''
        ].filter(Boolean);
    }
    /** @hidden */
    ngOnChanges(changes) {
        if ('svgConfig' in changes) {
            this._constructHref();
        }
    }
    /** @hidden */
    ngOnInit() {
        const resizeSubscription = fromEvent(window, 'resize')
            .pipe(debounceTime(200)) // reduce frequent calls during window resizing
            .subscribe(() => this._constructHref());
        this._subscriptions.add(resizeSubscription);
    }
    /** @hidden */
    ngAfterContentChecked() {
        this._constructHref();
    }
    /** @hidden */
    ngOnDestroy() {
        this._subscriptions.unsubscribe();
    }
    /** @hidden */
    _constructHref() {
        this._inlineSvg = undefined;
        const containerWidth = this.elementRef.nativeElement.offsetWidth;
        this._tempType = this.type;
        if (!this.type && containerWidth > 0) {
            this._tempType = this._determineIllustratedMessageType(containerWidth);
        }
        const inlineSvg = this.svgConfig?.[this._tempType]?.file;
        if (inlineSvg) {
            this._inlineSvg = this._sanitizer.bypassSecurityTrustHtml(inlineSvg);
        }
        this._href = this.svgConfig ? this._getHrefByType(this._tempType, this.svgConfig) : '';
        this.buildComponentCssClass();
        this._cdRef.markForCheck();
    }
    /** @hidden */
    _determineIllustratedMessageType(width) {
        if (width >= 682) {
            return IllustratedMessageTypes.SCENE;
        }
        else if (width >= 361) {
            return IllustratedMessageTypes.DIALOG;
        }
        else if (width >= 261) {
            return IllustratedMessageTypes.SPOT;
        }
        else if (width >= 161) {
            return IllustratedMessageTypes.DOT;
        }
        return IllustratedMessageTypes.BASE;
    }
    /** @hidden */
    _getHrefByType(type, svgConfig) {
        switch (type) {
            case IllustratedMessageTypes.SCENE:
                return `${svgConfig.scene?.url || ''}#${svgConfig.scene?.id}`;
            case IllustratedMessageTypes.DIALOG:
                return `${svgConfig.dialog?.url || ''}#${svgConfig.dialog?.id}`;
            case IllustratedMessageTypes.SPOT:
                return `${svgConfig.spot?.url || ''}#${svgConfig.spot?.id}`;
            case IllustratedMessageTypes.DOT:
                return `${svgConfig.dot?.url || ''}#${svgConfig.dot?.id}`;
            default:
                return '';
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageComponent, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: i1.DomSanitizer }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: IllustratedMessageComponent, isStandalone: true, selector: "[fd-illustrated-message]", inputs: { type: "type", svgConfig: "svgConfig", svgAriaLabel: "svgAriaLabel", noSvg: "noSvg", id: "id", class: "class" }, host: { properties: { "attr.id": "this.id" } }, usesOnChanges: true, ngImport: i0, template: "<div class=\"fd-illustrated-message__container\">\n    @if (!noSvg) {\n        <svg class=\"fd-illustrated-message__illustration\" [attr.aria-label]=\"svgAriaLabel\">\n            <use [attr.href]=\"_href\"></use>\n        </svg>\n    }\n    @if (_inlineSvg) {\n        <div [style.display]=\"'none'\" [innerHTML]=\"_inlineSvg\"></div>\n    }\n    <ng-content select=\"[fd-illustrated-message-figcaption]\"></ng-content>\n</div>\n<ng-content select=\"fd-illustrated-message-actions\"></ng-content>\n", styles: [".fd-illustrated-message{--illustratedMessagePadding:1rem;--illustratedMessageMaxWidth:auto;--actionsMarginInline:0;--actionsMarginBlock:1rem;--actionsPaddingInlineStart:0;--actionsPaddingInlineEnd:0;--illustrationMinWidth:15rem;--illustrationMaxWidth:20rem;--illustrationMinHeight:11.25rem;--illustrationMaxHeight:15rem;--illustrationMarginBlock:2rem;--illustrationMarginInlineStart:0;--illustrationMarginInlineEnd:0;--illustrationDisplay:flex;--containerFlexDirection:column;--figcaptionMaxWidth:61.9375rem;--titleMinWidth:auto;--titleMarginBottom:1rem;--titleFontSize:var(--sapFontHeader2Size);--textMinWidth:auto;--textMarginBottom:.5rem;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-align:center;-ms-flex-align:center;align-items:center;max-width:var(--illustratedMessageMaxWidth);min-height:100%;padding-block:var(--illustratedMessagePadding);padding-inline:var(--illustratedMessagePadding);text-align:center;width:100%}.fd-illustrated-message:after,.fd-illustrated-message:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message-responsive-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;container-type:inline-size;height:100%;min-height:100%;width:100%}.fd-illustrated-message-responsive-container:after,.fd-illustrated-message-responsive-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-ms-flex-direction:var(--containerFlexDirection);flex-direction:var(--containerFlexDirection)}.fd-illustrated-message__container:after,.fd-illustrated-message__container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__illustration{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:var(--illustrationDisplay);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:auto;line-height:normal;margin-block:0;margin-block:var(--illustrationMarginBlock);margin-inline:0;margin-inline:var(--illustrationMarginInlineStart) var(--illustrationMarginInlineEnd);max-height:var(--illustrationMaxHeight);max-width:var(--illustrationMaxWidth);min-height:var(--illustrationMinHeight);min-width:var(--illustrationMinWidth);padding-block:0;padding-inline:0;width:auto}.fd-illustrated-message__illustration:after,.fd-illustrated-message__illustration:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__figcaption{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-align:center;-ms-flex-align:center;align-items:center;max-width:var(--figcaptionMaxWidth);overflow:hidden}.fd-illustrated-message__figcaption:after,.fd-illustrated-message__figcaption:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--titleFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;text-align:center;width:100%;-webkit-margin-after:var(--titleMarginBottom);margin-block-end:var(--titleMarginBottom)}.fd-illustrated-message__title:after,.fd-illustrated-message__title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1.5;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;text-align:center;text-wrap:wrap;-webkit-margin-after:var(--textMarginBottom);margin-block-end:var(--textMarginBottom)}.fd-illustrated-message__text:after,.fd-illustrated-message__text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__actions{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;gap:.5rem;margin-block:var(--actionsMarginBlock);margin-inline:var(--actionsMarginInline);padding-inline:var(--actionsPaddingInlineStart) var(--actionsPaddingInlineEnd)}.fd-illustrated-message__actions:after,.fd-illustrated-message__actions:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message--dialog{--illustrationMinWidth:10rem;--illustrationMinHeight:10rem;--illustrationMaxWidth:10rem;--illustrationMaxHeight:10rem;--illustrationMarginBlock:1rem;--titleMarginBottom:.5rem;--titleFontSize:var(--sapFontHeader3Size);--figcaptionMaxWidth:40.5625rem;--actionsMarginBlock:.5rem 1rem}.fd-illustrated-message--spot{--illustratedMessagePadding:.5rem;--illustrationMinWidth:8rem;--illustrationMinHeight:8rem;--illustrationMaxWidth:8rem;--illustrationMaxHeight:8rem;--illustrationMarginBlock:0 .5rem;--titleMarginBottom:.5rem;--titleFontSize:var(--sapFontHeader4Size);--figcaptionMaxWidth:21.5rem;--actionsMarginBlock:.5rem}.fd-illustrated-message--dot{--illustratedMessagePadding:.25rem;--containerFlexDirection:row;--illustrationMinWidth:2.8125rem;--illustrationMaxWidth:2.8125rem;--illustrationMinHeight:2.8125rem;--illustrationMaxHeight:2.8125rem;--illustrationMarginBlock:0;--illustrationMarginInlineEnd:.25rem;--figcaptionMaxWidth:12.6875rem;--titleMarginBottom:.25rem;--titleFontSize:var(--sapFontHeader5Size);--textMarginBottom:.313rem;--actionsMarginBlock:.25rem;--actionsMarginInline:auto;--actionsPaddingInlineStart:var(--illustrationMaxWidth)}.fd-illustrated-message--base{--illustratedMessagePadding:.25rem;--illustratedMessageMaxWidth:auto;--illustrationDisplay:none;--figcaptionMaxWidth:12.6875rem;--titleMarginBottom:.25rem;--titleFontSize:var(--sapFontHeader5Size);--textMarginBottom:.313rem;--actionsMarginBlock:.25rem;--actionsMarginInline:auto;--actionsPaddingInlineStart:0}@container (width <= 681px){.fd-illustrated-message{--illustrationMinWidth:10rem;--illustrationMinHeight:10rem;--illustrationMaxWidth:10rem;--illustrationMaxHeight:10rem;--illustrationMarginBlock:1rem;--titleMarginBottom:.5rem;--titleFontSize:var(--sapFontHeader3Size);--figcaptionMaxWidth:40.5625rem;--actionsMarginBlock:.5rem 1rem}}@container (width <= 360px){.fd-illustrated-message{--illustratedMessagePadding:.5rem;--illustrationMinWidth:8rem;--illustrationMinHeight:8rem;--illustrationMaxWidth:8rem;--illustrationMaxHeight:8rem;--illustrationMarginBlock:0 .5rem;--titleMarginBottom:.5rem;--titleFontSize:var(--sapFontHeader4Size);--figcaptionMaxWidth:21.5rem;--actionsMarginBlock:.5rem}}@container (width <= 260px){.fd-illustrated-message{--illustratedMessagePadding:.25rem;--containerFlexDirection:row;--illustrationMinWidth:2.8125rem;--illustrationMaxWidth:2.8125rem;--illustrationMinHeight:2.8125rem;--illustrationMaxHeight:2.8125rem;--illustrationMarginBlock:0;--illustrationMarginInlineEnd:.25rem;--figcaptionMaxWidth:12.6875rem;--titleMarginBottom:.25rem;--titleFontSize:var(--sapFontHeader5Size);--textMarginBottom:.313rem;--actionsMarginBlock:.25rem;--actionsMarginInline:auto;--actionsPaddingInlineStart:var(--illustrationMaxWidth)}}@container (width <= 160px){.fd-illustrated-message{--illustratedMessagePadding:.25rem;--illustratedMessageMaxWidth:auto;--illustrationDisplay:none;--figcaptionMaxWidth:12.6875rem;--titleMarginBottom:.25rem;--titleFontSize:var(--sapFontHeader5Size);--textMarginBottom:.313rem;--actionsMarginBlock:.25rem;--actionsMarginInline:auto;--actionsPaddingInlineStart:0}}.fd-illustrated-message__illustration{height:var(--illustrationMaxWidth)}\n/*! Bundled license information:\n\nfundamental-styles/dist/illustrated-message.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], IllustratedMessageComponent.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageComponent, decorators: [{
            type: Component,
            args: [{ selector: '[fd-illustrated-message]', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, imports: [], template: "<div class=\"fd-illustrated-message__container\">\n    @if (!noSvg) {\n        <svg class=\"fd-illustrated-message__illustration\" [attr.aria-label]=\"svgAriaLabel\">\n            <use [attr.href]=\"_href\"></use>\n        </svg>\n    }\n    @if (_inlineSvg) {\n        <div [style.display]=\"'none'\" [innerHTML]=\"_inlineSvg\"></div>\n    }\n    <ng-content select=\"[fd-illustrated-message-figcaption]\"></ng-content>\n</div>\n<ng-content select=\"fd-illustrated-message-actions\"></ng-content>\n", styles: [".fd-illustrated-message{--illustratedMessagePadding:1rem;--illustratedMessageMaxWidth:auto;--actionsMarginInline:0;--actionsMarginBlock:1rem;--actionsPaddingInlineStart:0;--actionsPaddingInlineEnd:0;--illustrationMinWidth:15rem;--illustrationMaxWidth:20rem;--illustrationMinHeight:11.25rem;--illustrationMaxHeight:15rem;--illustrationMarginBlock:2rem;--illustrationMarginInlineStart:0;--illustrationMarginInlineEnd:0;--illustrationDisplay:flex;--containerFlexDirection:column;--figcaptionMaxWidth:61.9375rem;--titleMinWidth:auto;--titleMarginBottom:1rem;--titleFontSize:var(--sapFontHeader2Size);--textMinWidth:auto;--textMarginBottom:.5rem;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-align:center;-ms-flex-align:center;align-items:center;max-width:var(--illustratedMessageMaxWidth);min-height:100%;padding-block:var(--illustratedMessagePadding);padding-inline:var(--illustratedMessagePadding);text-align:center;width:100%}.fd-illustrated-message:after,.fd-illustrated-message:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message-responsive-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;container-type:inline-size;height:100%;min-height:100%;width:100%}.fd-illustrated-message-responsive-container:after,.fd-illustrated-message-responsive-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-ms-flex-direction:var(--containerFlexDirection);flex-direction:var(--containerFlexDirection)}.fd-illustrated-message__container:after,.fd-illustrated-message__container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__illustration{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:var(--illustrationDisplay);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:auto;line-height:normal;margin-block:0;margin-block:var(--illustrationMarginBlock);margin-inline:0;margin-inline:var(--illustrationMarginInlineStart) var(--illustrationMarginInlineEnd);max-height:var(--illustrationMaxHeight);max-width:var(--illustrationMaxWidth);min-height:var(--illustrationMinHeight);min-width:var(--illustrationMinWidth);padding-block:0;padding-inline:0;width:auto}.fd-illustrated-message__illustration:after,.fd-illustrated-message__illustration:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__figcaption{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-align:center;-ms-flex-align:center;align-items:center;max-width:var(--figcaptionMaxWidth);overflow:hidden}.fd-illustrated-message__figcaption:after,.fd-illustrated-message__figcaption:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--titleFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;text-align:center;width:100%;-webkit-margin-after:var(--titleMarginBottom);margin-block-end:var(--titleMarginBottom)}.fd-illustrated-message__title:after,.fd-illustrated-message__title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1.5;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;text-align:center;text-wrap:wrap;-webkit-margin-after:var(--textMarginBottom);margin-block-end:var(--textMarginBottom)}.fd-illustrated-message__text:after,.fd-illustrated-message__text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message__actions{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;gap:.5rem;margin-block:var(--actionsMarginBlock);margin-inline:var(--actionsMarginInline);padding-inline:var(--actionsPaddingInlineStart) var(--actionsPaddingInlineEnd)}.fd-illustrated-message__actions:after,.fd-illustrated-message__actions:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-illustrated-message--dialog{--illustrationMinWidth:10rem;--illustrationMinHeight:10rem;--illustrationMaxWidth:10rem;--illustrationMaxHeight:10rem;--illustrationMarginBlock:1rem;--titleMarginBottom:.5rem;--titleFontSize:var(--sapFontHeader3Size);--figcaptionMaxWidth:40.5625rem;--actionsMarginBlock:.5rem 1rem}.fd-illustrated-message--spot{--illustratedMessagePadding:.5rem;--illustrationMinWidth:8rem;--illustrationMinHeight:8rem;--illustrationMaxWidth:8rem;--illustrationMaxHeight:8rem;--illustrationMarginBlock:0 .5rem;--titleMarginBottom:.5rem;--titleFontSize:var(--sapFontHeader4Size);--figcaptionMaxWidth:21.5rem;--actionsMarginBlock:.5rem}.fd-illustrated-message--dot{--illustratedMessagePadding:.25rem;--containerFlexDirection:row;--illustrationMinWidth:2.8125rem;--illustrationMaxWidth:2.8125rem;--illustrationMinHeight:2.8125rem;--illustrationMaxHeight:2.8125rem;--illustrationMarginBlock:0;--illustrationMarginInlineEnd:.25rem;--figcaptionMaxWidth:12.6875rem;--titleMarginBottom:.25rem;--titleFontSize:var(--sapFontHeader5Size);--textMarginBottom:.313rem;--actionsMarginBlock:.25rem;--actionsMarginInline:auto;--actionsPaddingInlineStart:var(--illustrationMaxWidth)}.fd-illustrated-message--base{--illustratedMessagePadding:.25rem;--illustratedMessageMaxWidth:auto;--illustrationDisplay:none;--figcaptionMaxWidth:12.6875rem;--titleMarginBottom:.25rem;--titleFontSize:var(--sapFontHeader5Size);--textMarginBottom:.313rem;--actionsMarginBlock:.25rem;--actionsMarginInline:auto;--actionsPaddingInlineStart:0}@container (width <= 681px){.fd-illustrated-message{--illustrationMinWidth:10rem;--illustrationMinHeight:10rem;--illustrationMaxWidth:10rem;--illustrationMaxHeight:10rem;--illustrationMarginBlock:1rem;--titleMarginBottom:.5rem;--titleFontSize:var(--sapFontHeader3Size);--figcaptionMaxWidth:40.5625rem;--actionsMarginBlock:.5rem 1rem}}@container (width <= 360px){.fd-illustrated-message{--illustratedMessagePadding:.5rem;--illustrationMinWidth:8rem;--illustrationMinHeight:8rem;--illustrationMaxWidth:8rem;--illustrationMaxHeight:8rem;--illustrationMarginBlock:0 .5rem;--titleMarginBottom:.5rem;--titleFontSize:var(--sapFontHeader4Size);--figcaptionMaxWidth:21.5rem;--actionsMarginBlock:.5rem}}@container (width <= 260px){.fd-illustrated-message{--illustratedMessagePadding:.25rem;--containerFlexDirection:row;--illustrationMinWidth:2.8125rem;--illustrationMaxWidth:2.8125rem;--illustrationMinHeight:2.8125rem;--illustrationMaxHeight:2.8125rem;--illustrationMarginBlock:0;--illustrationMarginInlineEnd:.25rem;--figcaptionMaxWidth:12.6875rem;--titleMarginBottom:.25rem;--titleFontSize:var(--sapFontHeader5Size);--textMarginBottom:.313rem;--actionsMarginBlock:.25rem;--actionsMarginInline:auto;--actionsPaddingInlineStart:var(--illustrationMaxWidth)}}@container (width <= 160px){.fd-illustrated-message{--illustratedMessagePadding:.25rem;--illustratedMessageMaxWidth:auto;--illustrationDisplay:none;--figcaptionMaxWidth:12.6875rem;--titleMarginBottom:.25rem;--titleFontSize:var(--sapFontHeader5Size);--textMarginBottom:.313rem;--actionsMarginBlock:.25rem;--actionsMarginInline:auto;--actionsPaddingInlineStart:0}}.fd-illustrated-message__illustration{height:var(--illustrationMaxWidth)}\n/*! Bundled license information:\n\nfundamental-styles/dist/illustrated-message.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: i1.DomSanitizer }], propDecorators: { type: [{
                type: Input
            }], svgConfig: [{
                type: Input
            }], svgAriaLabel: [{
                type: Input
            }], noSvg: [{
                type: Input
            }], id: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['attr.id']
            }], class: [{
                type: Input
            }], buildComponentCssClass: [] } });

const components = [
    IllustratedMessageComponent,
    IllustratedMessageActionsComponent,
    IllustratedMessageFigcaptionComponent,
    IllustratedMessageTextDirective,
    IllustratedMessageTitleDirective
];
class IllustratedMessageModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageModule, imports: [IllustratedMessageComponent,
            IllustratedMessageActionsComponent,
            IllustratedMessageFigcaptionComponent,
            IllustratedMessageTextDirective,
            IllustratedMessageTitleDirective], exports: [IllustratedMessageComponent,
            IllustratedMessageActionsComponent,
            IllustratedMessageFigcaptionComponent,
            IllustratedMessageTextDirective,
            IllustratedMessageTitleDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: IllustratedMessageModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [...components],
                    exports: [...components]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { IllustratedMessageActionsComponent, IllustratedMessageComponent, IllustratedMessageFigcaptionComponent, IllustratedMessageModule, IllustratedMessageTextDirective, IllustratedMessageTitleDirective, IllustratedMessageTypes };
//# sourceMappingURL=fundamental-ngx-core-illustrated-message.mjs.map
