import * as i0 from '@angular/core';
import { Directive, InjectionToken, input, inject, ElementRef, ContentChildren, ChangeDetectionStrategy, ViewEncapsulation, Component, DestroyRef, Renderer2, signal, computed, HostListener, contentChildren, contentChild, viewChild, ViewContainerRef, ChangeDetectorRef, ComponentFactoryResolver, effect, Type, TemplateRef, Injector, DOCUMENT, Inject, Optional, Injectable, NgModule } from '@angular/core';
import { FD_BUTTON_COMPONENT } from '@fundamental-ngx/core/button';
import { takeUntilDestroyed } from '@angular/core/rxjs-interop';
import { merge, Subject, BehaviorSubject, fromEvent } from 'rxjs';
import { startWith, switchMap, debounceTime, filter, take } from 'rxjs/operators';
import { resolveTranslationSignal, FD_LANGUAGE, TranslationResolver } from '@fundamental-ngx/i18n';
import { ENTER, SPACE, ESCAPE } from '@angular/cdk/keycodes';
import * as i1 from '@fundamental-ngx/cdk/utils';
import { RtlService, KeyUtil, AbstractFdNgxClass, DynamicComponentService } from '@fundamental-ngx/cdk/utils';
import { IconComponent } from '@fundamental-ngx/core/icon';
import { ConfigurableFocusTrapFactory } from '@angular/cdk/a11y';
import { Router, NavigationStart } from '@angular/router';

class NotificationFooterContentDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationFooterContentDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NotificationFooterContentDirective, isStandalone: true, selector: "[fdNotificationFooterContent], [fd-notification-footer-content]", host: { classAttribute: "fd-notification__footer-content" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationFooterContentDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdNotificationFooterContent], [fd-notification-footer-content]',
                    standalone: true,
                    host: {
                        class: 'fd-notification__footer-content'
                    }
                }]
        }] });

class NotificationGroupGrowingItemTitleDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupGrowingItemTitleDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NotificationGroupGrowingItemTitleDirective, isStandalone: true, selector: "[fdNotificationGroupGrowingItemTitle], [fd-notification-group-growing-item-title]", host: { classAttribute: "fd-notification-group__growing-item-title" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupGrowingItemTitleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdNotificationGroupGrowingItemTitle], [fd-notification-group-growing-item-title]',
                    standalone: true,
                    host: {
                        class: 'fd-notification-group__growing-item-title'
                    }
                }]
        }] });

const FD_NOTIFICATION = new InjectionToken('FdNotificationComponent');
const FD_NOTIFICATION_TITLE = new InjectionToken('FdNotificationTitleDirective');
const FD_NOTIFICATION_PARAGRAPH = new InjectionToken('FdNotificationParagraphDirective');
const FD_NOTIFICATION_GROUP_HEADER = new InjectionToken('FdNotificationGroupHeaderComponent');
const FD_NOTIFICATION_GROUP_HEADER_TITLE = new InjectionToken('FdNotificationGroupHeaderTitleDirective');
const FD_NOTIFICATION_GROUP_LIST = new InjectionToken('FdNotificationGroupListComponent');
const FD_NOTIFICATION_FOOTER = new InjectionToken('FdNotificationFooterComponent');

let notificationGroupHeaderTitleCounter = 0;
class NotificationGroupHeaderTitleDirective {
    constructor() {
        /**
         * aria-level for the title
         * a numeric value from 1 to 6
         * default value is 3
         */
        this.ariaLevel = input(3);
        /**
         * id for the notification group header title
         * if not set, a default value is provided
         */
        this.id = input('fd-notification-group-header-title-' + ++notificationGroupHeaderTitleCounter);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupHeaderTitleDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "17.1.0", version: "20.0.2", type: NotificationGroupHeaderTitleDirective, isStandalone: true, selector: "[fdNotificationGroupHeaderTitle], [fd-notification-group-header-title]", inputs: { ariaLevel: { classPropertyName: "ariaLevel", publicName: "ariaLevel", isSignal: true, isRequired: false, transformFunction: null }, id: { classPropertyName: "id", publicName: "id", isSignal: true, isRequired: false, transformFunction: null } }, host: { attributes: { "role": "heading" }, properties: { "attr.aria-level": "ariaLevel()", "attr.id": "id()" }, classAttribute: "fd-notification-group__header-title" }, providers: [
            {
                provide: FD_NOTIFICATION_GROUP_HEADER_TITLE,
                useExisting: NotificationGroupHeaderTitleDirective
            }
        ], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupHeaderTitleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdNotificationGroupHeaderTitle], [fd-notification-group-header-title]',
                    standalone: true,
                    host: {
                        class: 'fd-notification-group__header-title',
                        role: 'heading',
                        '[attr.aria-level]': 'ariaLevel()',
                        '[attr.id]': 'id()'
                    },
                    providers: [
                        {
                            provide: FD_NOTIFICATION_GROUP_HEADER_TITLE,
                            useExisting: NotificationGroupHeaderTitleDirective
                        }
                    ]
                }]
        }] });

class NotificationListDirective {
    constructor() {
        /**
         * aria-label attribute for the element
         * Default is set to 'Notifications'
         */
        this.ariaLabel = input('Notifications');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationListDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "17.1.0", version: "20.0.2", type: NotificationListDirective, isStandalone: true, selector: "[fdNotificationList], [fd-notification-list]", inputs: { ariaLabel: { classPropertyName: "ariaLabel", publicName: "ariaLabel", isSignal: true, isRequired: false, transformFunction: null } }, host: { attributes: { "role": "list" }, properties: { "attr.aria-label": "ariaLabel()" }, classAttribute: "fd-notification-list" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationListDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdNotificationList], [fd-notification-list]',
                    standalone: true,
                    host: {
                        class: 'fd-notification-list',
                        role: 'list',
                        '[attr.aria-label]': 'ariaLabel()'
                    }
                }]
        }] });

class NotificationMessageStripContainerDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationMessageStripContainerDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NotificationMessageStripContainerDirective, isStandalone: true, selector: "[fdNotificationMessageStripContainer], [fd-notification-message-strip-container]", host: { classAttribute: "fd-notification__message-strip-container" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationMessageStripContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdNotificationMessageStripContainer], [fd-notification-message-strip-container]',
                    standalone: true,
                    host: {
                        class: 'fd-notification__message-strip-container'
                    }
                }]
        }] });

class NotificationMessageStripDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationMessageStripDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NotificationMessageStripDirective, isStandalone: true, selector: "[fdNotificationMessageStrip], [fd-notification-message-strip]", host: { classAttribute: "fd-notification-message-strip" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationMessageStripDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdNotificationMessageStrip], [fd-notification-message-strip]',
                    standalone: true,
                    host: {
                        class: 'fd-notification-message-strip'
                    }
                }]
        }] });

let notificationParagraphCounter = 0;
class NotificationParagraphDirective {
    constructor() {
        /**
         * id for the notification paragraph
         * if not set, a default value is provided
         */
        this.id = input('fd-notification-paragraph-' + ++notificationParagraphCounter);
        /** @hidden */
        this.elementRef = inject(ElementRef);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationParagraphDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "17.1.0", version: "20.0.2", type: NotificationParagraphDirective, isStandalone: true, selector: "[fdNotificationParagraph], [fd-notification-paragraph]", inputs: { id: { classPropertyName: "id", publicName: "id", isSignal: true, isRequired: false, transformFunction: null } }, host: { properties: { "attr.id": "id()" }, classAttribute: "fd-notification__paragraph" }, providers: [
            {
                provide: FD_NOTIFICATION_PARAGRAPH,
                useExisting: NotificationParagraphDirective
            }
        ], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationParagraphDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdNotificationParagraph], [fd-notification-paragraph]',
                    standalone: true,
                    host: {
                        class: 'fd-notification__paragraph',
                        '[attr.id]': 'id()'
                    },
                    providers: [
                        {
                            provide: FD_NOTIFICATION_PARAGRAPH,
                            useExisting: NotificationParagraphDirective
                        }
                    ]
                }]
        }] });

class NotificationPopoverDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationPopoverDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NotificationPopoverDirective, isStandalone: true, selector: "[fdNotificationPopover], [fd-notification-popover]", host: { attributes: { "role": "dialog" }, classAttribute: "fd-notification-popover" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationPopoverDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdNotificationPopover], [fd-notification-popover]',
                    standalone: true,
                    host: {
                        class: 'fd-notification-popover',
                        role: 'dialog'
                    }
                }]
        }] });

class NotificationSeparatorDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationSeparatorDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NotificationSeparatorDirective, isStandalone: true, selector: "[fdNotificationSeparator], [fd-notification-separator]", host: { classAttribute: "fd-notification__separator" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationSeparatorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdNotificationSeparator], [fd-notification-separator]',
                    standalone: true,
                    host: {
                        class: 'fd-notification__separator'
                    }
                }]
        }] });

let notificationTitleCounter = 0;
class NotificationTitleDirective {
    constructor() {
        /**
         * Whether the notification title is unread.
         * default is false
         */
        this.unread = input(false);
        /**
         * id for the notification title
         * if not set, a default value is provided
         */
        this.id = input('fd-notification-title-' + ++notificationTitleCounter);
        /** @hidden */
        this.elementRef = inject(ElementRef);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationTitleDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "17.1.0", version: "20.0.2", type: NotificationTitleDirective, isStandalone: true, selector: "[fdNotificationTitle], [fd-notification-title]", inputs: { unread: { classPropertyName: "unread", publicName: "unread", isSignal: true, isRequired: false, transformFunction: null }, id: { classPropertyName: "id", publicName: "id", isSignal: true, isRequired: false, transformFunction: null } }, host: { properties: { "class.fd-notification__title--unread": "unread()", "attr.id": "id()" }, classAttribute: "fd-notification__title" }, providers: [
            {
                provide: FD_NOTIFICATION_TITLE,
                useExisting: NotificationTitleDirective
            }
        ], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationTitleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdNotificationTitle], [fd-notification-title]',
                    standalone: true,
                    host: {
                        class: 'fd-notification__title',
                        '[class.fd-notification__title--unread]': 'unread()',
                        '[attr.id]': 'id()'
                    },
                    providers: [
                        {
                            provide: FD_NOTIFICATION_TITLE,
                            useExisting: NotificationTitleDirective
                        }
                    ]
                }]
        }] });

class NotificationActionsComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationActionsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: NotificationActionsComponent, isStandalone: true, selector: "fd-notification-actions", host: { classAttribute: "fd-notification__actions" }, queries: [{ propertyName: "buttons", predicate: FD_BUTTON_COMPONENT }], ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationActionsComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-notification-actions',
                    template: `<ng-content></ng-content>`,
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    standalone: true,
                    host: {
                        class: 'fd-notification__actions'
                    }
                }]
        }], propDecorators: { buttons: [{
                type: ContentChildren,
                args: [FD_BUTTON_COMPONENT]
            }] } });

let notificationHeaderCounter = 0;
class NotificationHeaderComponent {
    constructor() {
        /**
         * Unique id for the notification header
         * if not set, a default value is provided
         */
        this.uniqueId = input('fd-notification-header-' + ++notificationHeaderCounter);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "20.0.2", type: NotificationHeaderComponent, isStandalone: true, selector: "fd-notification-header", inputs: { uniqueId: { classPropertyName: "uniqueId", publicName: "uniqueId", isSignal: true, isRequired: false, transformFunction: null } }, host: { properties: { "attr.id": "uniqueId()" }, classAttribute: "fd-notification__header" }, ngImport: i0, template: `<ng-content select="fd-icon"></ng-content>
        <ng-content select="[fd-notification-title]"></ng-content> `, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationHeaderComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-notification-header',
                    template: `<ng-content select="fd-icon"></ng-content>
        <ng-content select="[fd-notification-title]"></ng-content> `,
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    standalone: true,
                    host: {
                        class: 'fd-notification__header',
                        '[attr.id]': 'uniqueId()'
                    }
                }]
        }] });

class NotificationGroupBaseDirective {
    constructor() {
        /** @hidden */
        this._destroyRef = inject(DestroyRef);
        /** @hidden */
        this._renderer = inject(Renderer2);
    }
    /** @hidden */
    ngAfterViewInit() {
        // TODO: update startWith args to be "undefined" after migration to rxjs 7.
        // Now it throws irrelevant warning about deprecation
        const headersChanges$ = this.notificationHeader.changes.pipe(startWith(0));
        const actionsChanges$ = this.notificationActions.changes.pipe(startWith(0), switchMap(() => {
            // also listen to button changes for each notificationActions component
            const buttonsChanges$ = this.notificationActions
                .toArray()
                .reduce((acc, c) => acc.concat(c.buttons.changes), []);
            return merge(buttonsChanges$).pipe(startWith(0));
        }));
        merge(headersChanges$, actionsChanges$)
            .pipe(debounceTime(10), // omitting extra emissions
        filter(() => this.notificationHeader.length > 0 && this.notificationActions.length > 0), takeUntilDestroyed(this._destroyRef))
            .subscribe(() => {
            // using only the first header for "aria-describedby" of associated buttons
            const firstHeader = this.notificationHeader.first;
            this.notificationActions.forEach((actionsComponent) => {
                actionsComponent.buttons
                    .toArray()
                    .map((b) => b.elementRef.nativeElement)
                    // skipping buttons that already have this attribute
                    .filter((b) => !b.hasAttribute('aria-describedby'))
                    .forEach((b) => {
                    // setting aria-describedby on each button with an id of related header
                    this._renderer.setAttribute(b, 'aria-describedby', firstHeader.uniqueId());
                });
            });
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupBaseDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NotificationGroupBaseDirective, isStandalone: true, queries: [{ propertyName: "notificationHeader", predicate: NotificationHeaderComponent, descendants: true }, { propertyName: "notificationActions", predicate: NotificationActionsComponent }], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupBaseDirective, decorators: [{
            type: Directive
        }], propDecorators: { notificationHeader: [{
                type: ContentChildren,
                args: [NotificationHeaderComponent, { descendants: true }]
            }], notificationActions: [{
                type: ContentChildren,
                args: [NotificationActionsComponent]
            }] } });

class NotificationBodyComponent extends NotificationGroupBaseDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationBodyComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: NotificationBodyComponent, isStandalone: true, selector: "fd-notification-body", host: { classAttribute: "fd-notification__body" }, usesInheritance: true, ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationBodyComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-notification-body',
                    template: `<ng-content></ng-content>`,
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    standalone: true,
                    host: {
                        class: 'fd-notification__body'
                    }
                }]
        }] });

class NotificationContentComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationContentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: NotificationContentComponent, isStandalone: true, selector: "fd-notification-content", host: { classAttribute: "fd-notification__content" }, ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationContentComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-notification-content',
                    template: `<ng-content></ng-content>`,
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    standalone: true,
                    host: {
                        class: 'fd-notification__content'
                    }
                }]
        }] });

class NotificationFooterComponent {
    constructor() {
        /**
         * Controls the visibility of the expand/collapse button.
         * Set to `true` when the title or description is truncated or the content is expanded.
         */
        this.showTrigger = signal(false);
        /**
         * Indicates whether the content is currently expanded.
         * When `true`, the full title and description are shown;
         * when `false`, they are truncated after the second line.
         */
        this.expanded = signal(false);
        /**
         * Custom label for the expand button.
         * Defaults to `'More'`.
         */
        this.moreLabel = input();
        /** Custom label for the collapse button.
         * Defaults to `'Less'`.
         */
        this.lessLabel = input();
        /** @hidden */
        this._defaultMoreLabel = resolveTranslationSignal('coreNotification.triggerMoreLabel');
        /** @hidden */
        this._defaultLessLabel = resolveTranslationSignal('coreNotification.triggerLessLabel');
    }
    /** @hidden */
    onTriggerClick() {
        this.expanded.set(!this.expanded());
    }
    /**
     * Label for the trigger button
     * @hidden
     **/
    get triggerLabel() {
        const moreLabel = this.moreLabel() || this._defaultMoreLabel();
        const lessLabel = this.lessLabel() || this._defaultLessLabel();
        return this.expanded() ? lessLabel : moreLabel;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationFooterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: NotificationFooterComponent, isStandalone: true, selector: "fd-notification-footer", inputs: { moreLabel: { classPropertyName: "moreLabel", publicName: "moreLabel", isSignal: true, isRequired: false, transformFunction: null }, lessLabel: { classPropertyName: "lessLabel", publicName: "lessLabel", isSignal: true, isRequired: false, transformFunction: null } }, host: { classAttribute: "fd-notification__footer" }, providers: [
            {
                provide: FD_NOTIFICATION_FOOTER,
                useExisting: NotificationFooterComponent
            }
        ], ngImport: i0, template: `<ng-content></ng-content>
        @if (showTrigger()) {
            <a role="button" class="fd-link fd-notification__link" tabindex="0" (click)="onTriggerClick()">
                <span class="fd-link__content">{{ triggerLabel }}</span>
            </a>
        } `, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationFooterComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-notification-footer',
                    template: `<ng-content></ng-content>
        @if (showTrigger()) {
            <a role="button" class="fd-link fd-notification__link" tabindex="0" (click)="onTriggerClick()">
                <span class="fd-link__content">{{ triggerLabel }}</span>
            </a>
        } `,
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    standalone: true,
                    host: {
                        class: 'fd-notification__footer'
                    },
                    providers: [
                        {
                            provide: FD_NOTIFICATION_FOOTER,
                            useExisting: NotificationFooterComponent
                        }
                    ]
                }]
        }] });

class NotificationGroupGrowingItemComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupGrowingItemComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: NotificationGroupGrowingItemComponent, isStandalone: true, selector: "fd-notification-group-growing-item", host: { attributes: { "role": "button" }, properties: { "tabindex": "0" }, classAttribute: "fd-notification-group__growing-item" }, ngImport: i0, template: `<ng-content select="[fd-notification-group-growing-item-title]"></ng-content> <ng-content></ng-content>`, isInline: true }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupGrowingItemComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-notification-group-growing-item',
                    standalone: true,
                    template: `<ng-content select="[fd-notification-group-growing-item-title]"></ng-content> <ng-content></ng-content>`,
                    host: {
                        class: 'fd-notification-group__growing-item',
                        role: 'button',
                        '[tabindex]': '0'
                    }
                }]
        }] });

class NotificationGroupHeaderComponent extends NotificationGroupBaseDirective {
    constructor() {
        super(...arguments);
        /**
         * Title for the group header
         * default value: "Expand/Collapse"
         */
        this.title = signal('');
        /**
         * id of the list element that the group header controls
         * string value
         */
        this.ariaControls = signal('');
        /** @hidden */
        this.expanded = signal(false);
        /** @hidden */
        this._buttonIcon$ = computed(() => this.expanded() ? 'slim-arrow-down' : this._rtlService?.rtlSignal() ? 'slim-arrow-left' : 'slim-arrow-right');
        /** @hidden */
        this._rtlService = inject(RtlService, { optional: true });
        /** @hidden */
        this._lang$ = inject(FD_LANGUAGE);
        /** @hidden */
        this._translationResolver = new TranslationResolver();
    }
    /** @hidden */
    keydownHandler(event) {
        if (KeyUtil.isKeyCode(event, [ENTER, SPACE])) {
            this.toggleExpand();
            event.preventDefault();
        }
    }
    /** Method that toggles the Notification list content */
    toggleExpand() {
        this.expanded.update((expanded) => !expanded);
    }
    /** @hidden */
    ngOnInit() {
        this._lang$.pipe(takeUntilDestroyed(this._destroyRef)).subscribe((lang) => {
            this.title.set(this._translationResolver.resolve(lang, 'coreNotification.groupHeaderTitle'));
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupHeaderComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: NotificationGroupHeaderComponent, isStandalone: true, selector: "fd-notification-group-header", host: { attributes: { "role": "button" }, listeners: { "click": "toggleExpand()", "keydown": "keydownHandler($event)" }, properties: { "tabindex": "0", "attr.title": "title()", "attr.aria-controls": "ariaControls()", "attr.aria-expanded": "expanded()" }, classAttribute: "fd-notification-group__header" }, providers: [
            {
                provide: FD_NOTIFICATION_GROUP_HEADER,
                useExisting: NotificationGroupHeaderComponent
            }
        ], usesInheritance: true, ngImport: i0, template: `
        <span class="fd-notification-group__header-arrow">
            <fd-icon [glyph]="_buttonIcon$()"></fd-icon>
        </span>
        <ng-content select="fd-notification-group-header-title"></ng-content>
        <ng-content></ng-content>
    `, isInline: true, dependencies: [{ kind: "component", type: IconComponent, selector: "fd-icon", inputs: ["glyph", "font", "color", "background", "class", "ariaLabel", "ariaHidden"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupHeaderComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-notification-group-header',
                    template: `
        <span class="fd-notification-group__header-arrow">
            <fd-icon [glyph]="_buttonIcon$()"></fd-icon>
        </span>
        <ng-content select="fd-notification-group-header-title"></ng-content>
        <ng-content></ng-content>
    `,
                    host: {
                        class: 'fd-notification-group__header',
                        role: 'button',
                        '[tabindex]': '0',
                        '[attr.title]': 'title()',
                        '[attr.aria-controls]': 'ariaControls()',
                        '[attr.aria-expanded]': 'expanded()',
                        '(click)': 'toggleExpand()'
                    },
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [IconComponent],
                    providers: [
                        {
                            provide: FD_NOTIFICATION_GROUP_HEADER,
                            useExisting: NotificationGroupHeaderComponent
                        }
                    ]
                }]
        }], propDecorators: { keydownHandler: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }] } });

let notificationGroupListCounter = 0;
class NotificationGroupListComponent {
    constructor() {
        /**
         * id of the element labelling the group list
         */
        this.ariaLabelledBy = input();
        /**
         * id for the notification group list
         * if not set, a default value is provided
         */
        this.id = input('fd-notification-group-list-' + ++notificationGroupListCounter);
        /**
         * @hidden
         */
        this.notifications = contentChildren(FD_NOTIFICATION);
    }
    /**
     * @hidden
     */
    ngAfterViewInit() {
        this.notifications()?.forEach((notification) => {
            notification.role.set('listitem');
            notification.ariaLevel.set(2);
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupListComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.2.0", version: "20.0.2", type: NotificationGroupListComponent, isStandalone: true, selector: "fd-notification-group-list", inputs: { ariaLabelledBy: { classPropertyName: "ariaLabelledBy", publicName: "ariaLabelledBy", isSignal: true, isRequired: false, transformFunction: null }, id: { classPropertyName: "id", publicName: "id", isSignal: true, isRequired: false, transformFunction: null } }, host: { attributes: { "role": "list" }, properties: { "attr.id": "id()" }, classAttribute: "fd-notification-group__list" }, providers: [
            {
                provide: FD_NOTIFICATION_GROUP_LIST,
                useExisting: NotificationGroupListComponent
            }
        ], queries: [{ propertyName: "notifications", predicate: FD_NOTIFICATION, isSignal: true }], ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupListComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-notification-group-list',
                    template: `<ng-content></ng-content>`,
                    host: {
                        class: 'fd-notification-group__list',
                        role: 'list',
                        '[attr.id]': 'id()'
                    },
                    providers: [
                        {
                            provide: FD_NOTIFICATION_GROUP_LIST,
                            useExisting: NotificationGroupListComponent
                        }
                    ],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: []
                }]
        }] });

class NotificationGroupComponent {
    constructor() {
        /**
         * Whether the group is expanded
         * default value is false
         */
        this.expanded = input(false);
        /**
         * input property to set aria-label
         * accepts a string value
         */
        this.ariaLabel = input();
        /** @hidden */
        this.ariaLabelledBy = computed(() => this.groupTitle()?.id());
        /** @hidden */
        this.ariaDescription = computed(() => `${this._descriptionString()} ${this.groupHeader()?.expanded() ? this._expandedString() : this._collapsedString()}`);
        /** @hidden */
        this.isExpanded = computed(() => this.groupHeader()?.expanded());
        /** @hidden */
        this.groupHeader = contentChild(FD_NOTIFICATION_GROUP_HEADER);
        /** @hidden */
        this.groupTitle = contentChild(FD_NOTIFICATION_GROUP_HEADER_TITLE);
        /** @hidden */
        this.groupList = contentChild(FD_NOTIFICATION_GROUP_LIST);
        /** @hidden */
        this._descriptionString = signal('');
        /** @hidden */
        this._expandedString = signal('');
        /** @hidden */
        this._collapsedString = signal('');
        /** @hidden */
        this._destroyRef = inject(DestroyRef);
        /** @hidden */
        this._lang$ = inject(FD_LANGUAGE);
        /** @hidden */
        this._translationResolver = new TranslationResolver();
    }
    /** @hidden */
    ngAfterViewInit() {
        this.groupHeader()?.ariaControls.set(this.groupList()?.id());
        this.groupHeader()?.expanded.set(this.expanded());
    }
    /** @hidden */
    ngOnInit() {
        this._lang$.pipe(takeUntilDestroyed(this._destroyRef)).subscribe((lang) => {
            this._expandedString.set(this._translationResolver.resolve(lang, 'coreNotification.groupAriaDescriptionExpanded'));
            this._collapsedString.set(this._translationResolver.resolve(lang, 'coreNotification.groupAriaDescriptionCollapsed'));
            this._descriptionString.set(this._translationResolver.resolve(lang, 'coreNotification.groupAriaDescription'));
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: NotificationGroupComponent, isStandalone: true, selector: "fd-notification-group", inputs: { expanded: { classPropertyName: "expanded", publicName: "expanded", isSignal: true, isRequired: false, transformFunction: null }, ariaLabel: { classPropertyName: "ariaLabel", publicName: "ariaLabel", isSignal: true, isRequired: false, transformFunction: null } }, host: { attributes: { "role": "listitem" }, properties: { "tabindex": "-1", "attr.aria-level": "1", "attr.aria-label": "ariaLabel()", "attr.aria-labelledby": "ariaLabelledBy()", "attr.aria-description": "ariaDescription()" }, classAttribute: "fd-notification-group" }, queries: [{ propertyName: "groupHeader", first: true, predicate: FD_NOTIFICATION_GROUP_HEADER, descendants: true, isSignal: true }, { propertyName: "groupTitle", first: true, predicate: FD_NOTIFICATION_GROUP_HEADER_TITLE, descendants: true, isSignal: true }, { propertyName: "groupList", first: true, predicate: FD_NOTIFICATION_GROUP_LIST, descendants: true, isSignal: true }], ngImport: i0, template: `<div class="fd-notification-group__wrapper">
        <ng-content select="fd-notification-group-header"></ng-content>
        @if (isExpanded()) {
            <ng-content select="fd-notification-group-list"></ng-content>
            <ng-content select="fd-notification-group-growing-item"></ng-content>
        }
    </div>`, isInline: true }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationGroupComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-notification-group',
                    standalone: true,
                    template: `<div class="fd-notification-group__wrapper">
        <ng-content select="fd-notification-group-header"></ng-content>
        @if (isExpanded()) {
            <ng-content select="fd-notification-group-list"></ng-content>
            <ng-content select="fd-notification-group-growing-item"></ng-content>
        }
    </div>`,
                    host: {
                        class: 'fd-notification-group',
                        role: 'listitem',
                        '[tabindex]': '-1',
                        '[attr.aria-level]': '1',
                        '[attr.aria-label]': 'ariaLabel()',
                        '[attr.aria-labelledby]': 'ariaLabelledBy()',
                        '[attr.aria-description]': 'ariaDescription()'
                    }
                }]
        }] });

class NotificationLinkComponent {
    constructor() {
        /**
         * signal to control the show more/less
         * default value is false
         */
        this.showMore = signal(false);
    }
    /**
     * Method to toggle show more functionality
     */
    toggleShowMore() {
        this.showMore.update((value) => !value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationLinkComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: NotificationLinkComponent, isStandalone: true, selector: "fd-notification-link", host: { attributes: { "tabindex": "0", "role": "link" }, listeners: { "click": "toggleShowMore()" }, classAttribute: "fd-link fd-notification__link" }, ngImport: i0, template: `<span class="fd-link__content">{{ showMore() ? 'Less' : 'More' }}</span>`, isInline: true }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationLinkComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-notification-link',
                    standalone: true,
                    template: `<span class="fd-link__content">{{ showMore() ? 'Less' : 'More' }}</span>`,
                    host: {
                        class: 'fd-link fd-notification__link',
                        tabindex: '0',
                        role: 'link',
                        '(click)': 'toggleShowMore()'
                    }
                }]
        }] });

/**
 * Configuration for opening a notification with the NotificationService.
 */
class NotificationConfig {
    constructor() {
        /** The container that the notification is appended to. By default, it is appended to the body. */
        this.container = 'body';
        /**
         * Whether the notification should trap focus within itself.
         * @default true
         */
        this.shouldTrapFocus = true;
    }
}

/**
 * Reference to a notification component generated via the NotificationService.
 * It can be injected into the content component through the constructor.
 * For a template, it is declared as part of the implicit context, see examples.
 */
class NotificationRef {
    /** @hidden */
    constructor() {
        /** @hidden */
        this._afterClosed = new Subject();
        this.afterClosed = this._afterClosed.asObservable();
    }
    /**
     * Closes the notification and passes the argument to the afterClosed observable.
     * @param result Value passed back to the observable as a result.
     */
    close(result) {
        this._afterClosed.next(result);
        this._afterClosed.complete();
    }
    /**
     * Dismisses the notification and passes the argument to the afterClosed observable as an error.
     * @param reason Value passed back to the observable as an error.
     */
    dismiss(reason) {
        this._afterClosed.error(reason);
    }
}

class NotificationComponent extends AbstractFdNgxClass {
    /** @hidden */
    constructor() {
        super();
        /** @hidden */
        this.containerRef = viewChild('vc', { read: ViewContainerRef });
        /** User defined width for the notification */
        this.width = input();
        /** Whether the notificatioon is in mobile mode */
        this.mobile = input(false);
        /** @hidden */
        this._dir$ = computed(() => (this._rtlService?.rtlSignal() ? 'rtl' : 'ltr'));
        /**
         * aria-level of the Notificaion
         * should be set to 2 in Notification Group
         * default value is undefined
         */
        this.ariaLevel = signal(undefined);
        /**
         * role of the Notificaion
         * should be set to 'listitem' in Notification Group
         * default value is undefined
         */
        this.role = signal(undefined);
        /**
         * whether the Notificaion is selected
         * default is set to false
         */
        this.selected = input(false);
        /** Whether the notification is dismissed with the ESC key */
        this.escKeyCloseable = false;
        /** Whether the notification should close with router change */
        this.closeOnNavigation = true;
        /** aria-labelledby attribute for the notification component element. */
        this.ariaLabelledBy = signal(null);
        /** Reference to the child content */
        this.childContent = undefined;
        /** @hidden */
        this._notificationTitle = contentChild(FD_NOTIFICATION_TITLE);
        /** @hidden */
        this._notificationParagraph = contentChild(FD_NOTIFICATION_PARAGRAPH);
        /** @hidden */
        this._notificationFooter = contentChild(FD_NOTIFICATION_FOOTER);
        /** @hidden */
        this._destroyRef = inject(DestroyRef);
        /** @hidden */
        this._afterViewInit$ = new BehaviorSubject(false);
        /** @hidden */
        this._cdRef = inject(ChangeDetectorRef);
        /** @hidden */
        this._componentFactoryResolver = inject(ComponentFactoryResolver);
        /** @hidden */
        this._router = inject(Router);
        /** @hidden */
        this._focusTrapFactory = inject(ConfigurableFocusTrapFactory);
        /** @hidden */
        this._notificationConfig = inject(NotificationConfig, { optional: true });
        /** @hidden */
        this._notificationRef = inject(NotificationRef, { optional: true });
        /** @hidden */
        this._rtlService = inject(RtlService, { optional: true });
        /** @hidden */
        this._isTitleTruncated = signal(false);
        /** @hidden */
        this._isParagraphTruncated = signal(false);
        /** @hidden */
        this._hasTruncation = computed(() => this._isTitleTruncated() || this._isParagraphTruncated());
        /** @hidden */
        this._expanded = computed(() => this._notificationFooter()?.expanded() ?? false);
        if (this._notificationConfig) {
            this._setNotificationConfig(this._notificationConfig);
        }
        effect(() => {
            this._updateExpandedClass();
        });
    }
    /** @hidden Listen and close notification on Escape key */
    _closeNotificationEsc(event) {
        if (this.escKeyCloseable && KeyUtil.isKeyCode(event, ESCAPE) && this._notificationRef) {
            this._notificationRef.dismiss('escape');
        }
    }
    /** @hidden */
    ngOnInit() {
        this._listenAndCloseOnNavigation();
        this._setProperties();
        this._attachResizeListener();
    }
    /** @hidden */
    ngAfterViewInit() {
        if (this.childContent) {
            if (this.childContent instanceof Type) {
                this._loadFromComponent(this.childContent);
            }
            if (this.childContent instanceof TemplateRef) {
                this._loadFromTemplate(this.childContent);
            }
        }
        if (this._notificationTitle()) {
            this.ariaLabelledBy.set(this._notificationTitle()?.id());
        }
        else if (this._notificationParagraph()) {
            this.ariaLabelledBy.set(this._notificationParagraph()?.id());
        }
        this._checkTruncation();
        this._observeNotificationResize();
        this._afterViewInit$.next(true);
        this._cdRef.detectChanges();
    }
    /** @hidden */
    ngOnDestroy() {
        this._observer?.disconnect();
    }
    /**
     * Moves the focus inside the focus trap.
     * @returns
     * Returns a promise that resolves with a boolean, depending on whether focus was moved successfully.
     */
    async trapFocus() {
        // waiting for afterViewInit hook to fire
        await this._afterViewInit$.pipe(filter(Boolean), take(1), takeUntilDestroyed(this._destroyRef)).toPromise();
        if (!this._focusTrap) {
            this._focusTrap = this._focusTrapFactory.create(this.elementRef.nativeElement);
        }
        return this._focusTrap.focusFirstTabbableElementWhenReady();
    }
    /** @hidden */
    _setProperties() {
        this._addClassToElement('fd-notification');
    }
    /** @hidden */
    _observeNotificationResize() {
        const el = this.elementRef.nativeElement;
        if (typeof ResizeObserver !== 'undefined') {
            this._observer = new ResizeObserver(() => {
                this._checkTruncation();
                this._cdRef.markForCheck();
            });
            this._observer.observe(el);
        }
    }
    /** @hidden */
    _updateExpandedClass() {
        const isExpanded = this._expanded();
        [this._notificationTitle(), this._notificationParagraph()].forEach((ref) => {
            ref?.elementRef.nativeElement.classList.toggle('is-expanded', isExpanded);
        });
    }
    /** @hidden */
    _checkTruncation() {
        const titleEl = this._notificationTitle()?.elementRef.nativeElement;
        const paragraphEl = this._notificationParagraph()?.elementRef.nativeElement;
        const footer = this._notificationFooter();
        if (titleEl) {
            this._isTitleTruncated.set(titleEl.scrollHeight > titleEl.clientHeight);
        }
        if (paragraphEl) {
            this._isParagraphTruncated.set(paragraphEl.scrollHeight > paragraphEl.clientHeight);
        }
        if (footer) {
            footer.showTrigger.set(this._hasTruncation() || this._expanded());
        }
        this._updateExpandedClass();
    }
    /** @hidden */
    _attachResizeListener() {
        fromEvent(window, 'resize', { passive: true })
            .pipe(debounceTime(100), takeUntilDestroyed(this._destroyRef))
            .subscribe(() => this._onWindowResize());
    }
    /** @hidden */
    _onWindowResize() {
        this._checkTruncation();
        this._cdRef.markForCheck();
    }
    /** @hidden Listen on NavigationStart event and dismiss the dialog */
    _listenAndCloseOnNavigation() {
        if (this._router && this._notificationRef) {
            this._router.events
                .pipe(filter((event) => event instanceof NavigationStart && this.closeOnNavigation), takeUntilDestroyed(this._destroyRef))
                .subscribe(() => this._notificationRef?.dismiss());
        }
    }
    /** @hidden */
    _loadFromComponent(content) {
        this.containerRef()?.clear();
        const componentFactory = this._componentFactoryResolver.resolveComponentFactory(content);
        this.componentRef = this.containerRef()?.createComponent(componentFactory);
    }
    /** @hidden */
    _loadFromTemplate(content) {
        this.containerRef()?.clear();
        const context = {
            $implicit: this._notificationRef
        };
        this.componentRef = this.containerRef()?.createEmbeddedView(content, context);
    }
    /** @hidden */
    _setNotificationConfig(notificationConfig) {
        Object.keys(notificationConfig || {})
            .filter((key) => key !== 'data' && key !== 'container')
            .forEach((key) => (this[key] = notificationConfig[key]));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.2.0", version: "20.0.2", type: NotificationComponent, isStandalone: true, selector: "fd-notification", inputs: { width: { classPropertyName: "width", publicName: "width", isSignal: true, isRequired: false, transformFunction: null }, mobile: { classPropertyName: "mobile", publicName: "mobile", isSignal: true, isRequired: false, transformFunction: null }, selected: { classPropertyName: "selected", publicName: "selected", isSignal: true, isRequired: false, transformFunction: null } }, host: { listeners: { "window:keyup": "_closeNotificationEsc($event)" }, properties: { "attr.aria-labelledby": "ariaLabelledBy()", "attr.aria-label": "ariaLabel", "attr.aria-level": "ariaLevel()", "attr.role": "role()", "attr.dir": "_dir$()", "attr.id": "id", "tabindex": "0", "style.width": "width" } }, providers: [
            {
                provide: FD_NOTIFICATION,
                useExisting: NotificationComponent
            }
        ], queries: [{ propertyName: "_notificationTitle", first: true, predicate: FD_NOTIFICATION_TITLE, descendants: true, isSignal: true }, { propertyName: "_notificationParagraph", first: true, predicate: FD_NOTIFICATION_PARAGRAPH, descendants: true, isSignal: true }, { propertyName: "_notificationFooter", first: true, predicate: FD_NOTIFICATION_FOOTER, descendants: true, isSignal: true }], viewQueries: [{ propertyName: "containerRef", first: true, predicate: ["vc"], descendants: true, read: ViewContainerRef, isSignal: true }], usesInheritance: true, ngImport: i0, template: `
        <ng-content></ng-content>
        <ng-container #vc></ng-container>
    `, isInline: true, styles: ["@charset \"UTF-8\";.fd-link{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapLinkColor);cursor:pointer;display:var(--fdLink_Display,inline-block);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;text-shadow:var(--sapContent_TextShadow);-webkit-box-align:center;-ms-flex-align:center;align-items:center;line-height:inherit;line-height:var(--fdLink_Line_Height,1.125rem);-webkit-text-decoration:var(--fdLink_Text_Decoration,none);text-decoration:var(--fdLink_Text_Decoration,none);text-underline-offset:.125rem;-webkit-transition:all .125s ease-in;transition:all .125s ease-in}.fd-link:after,.fd-link:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-link__content{-webkit-text-decoration:var(--fdLink_Text_Content_Decoration,none);text-decoration:var(--fdLink_Text_Content_Decoration,none)}.fd-link.is-hover,.fd-link:hover{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Hover,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Hover,none)}.fd-link.is-focus,.fd-link:focus{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Focus,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Focus,none)}.fd-link.is-active,.fd-link:active{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Active,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Active,none)}.fd-link.is-disabled,.fd-link:disabled,.fd-link[aria-disabled=true]{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Disabled,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Disabled,none)}.fd-link--subtle{--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Subtle,none);--fdLink_Text_Content_Decoration_Hover:var(--fdLink_Text_Content_Decoration_Subtle_Hover,none);--fdLink_Text_Content_Decoration_Active:var(--fdLink_Text_Content_Decoration_Subtle_Active,none);--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Subtle,none);--fdLink_Text_Decoration_Hover:var(--fdLink_Text_Decoration_Subtle_Hover,none);--fdLink_Text_Decoration_Active:var(--fdLink_Text_Decoration_Subtle_Active,none)}.fd-link--undecorated{--fdLink_Text_Decoration:none;--fdLink_Text_Decoration_Subtle:none;--fdLink_Text_Decoration_Subtle_Hover:none;--fdLink_Text_Decoration_Subtle_Active:none;--fdLink_Text_Decoration_Hover:none;--fdLink_Text_Decoration_Focus:none;--fdLink_Text_Decoration_Active:none;--fdLink_Text_Decoration_Visited:none;--fdLink_Text_Decoration_Disabled:none;--fdLink_Text_Content_Decoration:none;--fdLink_Text_Content_Decoration_Subtle:none;--fdLink_Text_Content_Decoration_Subtle_Hover:none;--fdLink_Text_Content_Decoration_Subtle_Active:none;--fdLink_Text_Content_Decoration_Hover:none;--fdLink_Text_Content_Decoration_Focus:none;--fdLink_Text_Content_Decoration_Active:none;--fdLink_Text_Content_Decoration_Visited:none;--fdLink_Text_Content_Decoration_Disabled:none}.fd-link--emphasized{font-family:var(--sapFontBoldFamily)}.fd-link:visited{color:var(--sapLink_Visited_Color)}.fd-link.is-hover,.fd-link:hover{color:var(--sapLink_Hover_Color)}.fd-link.is-focus,.fd-link:focus{background-color:var(--fdLink_Focus_Background);border-radius:var(--fdLink_Focus_Border_Radius);-webkit-box-shadow:none;box-shadow:none;color:var(--fdLink_Text_Focus_Color);outline:var(--fdLink_Hover_Outline_Color) var(--fdLink_Hover_Outline_Style) var(--fdLink_Hover_Outline_Width);outline-offset:var(--fdLink_Hover_Outline_Offset);text-shadow:var(--fdLink_Focus_Text_Shadow)}.fd-link.is-active,.fd-link:active{color:var(--sapLink_Active_Color)}.fd-link.is-active.is-focus,.fd-link.is-active:focus,.fd-link:active.is-focus,.fd-link:active:focus{background-color:transparent;z-index:5}.fd-link--inverted{text-shadow:none}.fd-link--inverted,.fd-link--inverted.is-hover,.fd-link--inverted:hover{color:var(--sapLink_InvertedColor)}.fd-link--inverted.is-focus,.fd-link--inverted:focus{outline-color:var(--sapContent_ContrastFocusColor);z-index:5}.fd-link--subtle{color:var(--sapLink_SubtleColor)}.fd-link.is-disabled,.fd-link:disabled,.fd-link[aria-disabled=true]{color:var(--sapLinkColor);opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-link>img{vertical-align:bottom}.fd-link [class*=sap-icon],.fd-link[class*=sap-icon]{color:var(--sapLinkColor);display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;line-height:1;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-link [class*=sap-icon]:first-child,.fd-link[class*=sap-icon]:first-child{-webkit-margin-end:var(--fdLink_Icon_Spacing,0);margin-inline-end:var(--fdLink_Icon_Spacing,0)}.fd-link [class*=sap-icon]:last-child,.fd-link[class*=sap-icon]:last-child{-webkit-margin-start:var(--fdLink_Icon_Spacing,0);margin-inline-start:var(--fdLink_Icon_Spacing,0)}.fd-link.is-hover [class*=sap-icon],.fd-link.is-hover[class*=sap-icon],.fd-link:hover [class*=sap-icon],.fd-link:hover[class*=sap-icon]{color:var(--sapLink_Hover_Color);-webkit-text-decoration:var(--fdLink_Text_Decoration_Hover);text-decoration:var(--fdLink_Text_Decoration_Hover)}.fd-link.is-focus,.fd-link:focus{z-index:5}.fd-link.is-focus [class*=sap-icon],.fd-link.is-focus[class*=sap-icon],.fd-link:focus [class*=sap-icon],.fd-link:focus[class*=sap-icon]{color:var(--fdLink_Text_Focus_Color);-webkit-text-decoration:var(--fdLink_Text_Decoration_Focus);text-decoration:var(--fdLink_Text_Decoration_Focus)}.fd-link.is-active [class*=sap-icon],.fd-link.is-active[class*=sap-icon],.fd-link:active [class*=sap-icon],.fd-link:active[class*=sap-icon]{color:var(--sapLink_Active_Color);-webkit-text-decoration:var(--fdLink_Text_Decoration_Active);text-decoration:var(--fdLink_Text_Decoration_Active)}.fd-link:visited:not(:focus) [class*=sap-icon],.fd-link:visited:not(:focus)[class*=sap-icon]{color:var(--sapLink_Visited_Color)}.fd-notification{--fdNotification_Content_Gap:.75rem;--fdNotification_Actions_Offset:-.25rem;--fdNotification_Title_Font_Weight:normal;--fdNotification_Title_Line_Height:1.25rem;--fdNotification_Title_One_Button_Offset:2rem;--fdNotification_Title_Two_Buttons_Offset:4.375rem;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;--fdNotification_Background:var(--sapList_Background);--fdNotification_Title_Color:var(--sapList_TextColor);--fdNotification_Paragraph_Color:var(--sapList_TextColor);--fdNotification_Separator_Color:var(--sapContent_LabelColor);--fdNotification_Footer_Content_Color:var(--sapContent_LabelColor);--fdNotification_Border_Block_End_Color:var(--sapList_BorderColor);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Top_Color);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Left_Right_Color);background:var(--fdNotification_Background);border-block-end-color:var(--fdNotification_Border_Block_End_Color);border-block-start-color:var(--fdNotification_Border_Block_Start_Color);border-inline-color:var(--fdNotification_Border_Inline_Color);border-radius:var(--fdNotification_Border_Radius);border-style:solid;border-width:var(--sapList_BorderWidth);cursor:pointer}.fd-notification:after,.fd-notification:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification.is-hover,.fd-notification:hover{--fdNotification_Background:var(--fdNotification_Background_Hover)}.fd-notification.is-active,.fd-notification:active{--fdNotification_Background:var(--fdNotification_Background_Active);--fdNotification_Title_Color:var(--fdNotification_Title_Color_Active);--fdNotification_Paragraph_Color:var(--fdNotification_Paragraph_Color_Active);--fdNotification_Footer_Content_Color:var(--fdNotification_Footer_Content_Color_Active);--fdNotification_Separator_Color:var(--fdNotification_Separator_Color_Active);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Inline_Color_Active);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Block_Start_Color_Active);--fdNotification_Border_Block_End_Color:var(--fdNotification_Border_Block_End_Color_Active)}.fd-notification.is-selected,.fd-notification[aria-selected=true]{--fdNotification_Background:var(--fdNotification_Background_Selected);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Left_Right_Color_Selected);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Top_Color_Selected);--fdNotification_Border_Block_End_Color:var(--fdNotification_Border_Block_End_Color_Selected)}.fd-notification.is-selected.is-hover,.fd-notification.is-selected:hover,.fd-notification[aria-selected=true].is-hover,.fd-notification[aria-selected=true]:hover{--fdNotification_Background:var(--fdNotification_Background_Selected_Hover)}.fd-notification.is-focus,.fd-notification:focus{outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);outline-offset:-.25rem;z-index:5}.fd-notification:has(.fd-notification__actions):has(button) .fd-notification__title{-webkit-padding-end:var(--fdNotification_Title_One_Button_Offset);padding-inline-end:var(--fdNotification_Title_One_Button_Offset)}.fd-notification:has(.fd-notification__actions):has(button+button) .fd-notification__title{-webkit-padding-end:var(--fdNotification_Title_Two_Buttons_Offset);padding-inline-end:var(--fdNotification_Title_Two_Buttons_Offset)}.fd-notification__body{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;gap:.75rem;padding-block:1rem;padding-inline:1rem;position:relative}.fd-notification__body:after,.fd-notification__body:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start;gap:var(--fdNotification_Content_Gap);width:100%}.fd-notification__content:after,.fd-notification__content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;gap:.25rem;width:100%}.fd-notification__header:after,.fd-notification__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__header>[class*=sap-icon]{-webkit-padding-before:.125rem;padding-block-start:.125rem}.fd-notification__actions{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;right:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;gap:.125rem;padding-block:.5rem 0;padding-inline:.25rem .5rem;position:absolute;top:0}.fd-notification__actions:after,.fd-notification__actions:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__actions[dir=rtl],[dir=rtl] .fd-notification__actions{left:0;right:auto}.fd-notification__title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-line-clamp:2;-webkit-box-orient:vertical;overflow:hidden;text-overflow:ellipsis;white-space:normal;-webkit-box-flex:1;color:var(--sapList_TextColor);-ms-flex:1;flex:1;font-size:var(--sapFontHeader6Size);font-weight:var(--fdNotification_Title_Font_Weight);line-height:var(--fdNotification_Title_Line_Height);max-height:calc(var(--fdNotification_Title_Line_Height)*2)}.fd-notification__title:after,.fd-notification__title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__title--unread{--fdNotification_Title_Font_Weight:bold}.fd-notification__paragraph{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;font-family:var(--sapFontFamily);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-line-clamp:2;-webkit-box-orient:vertical;color:var(--sapList_TextColor);font-size:var(--sapFontSize);max-height:2.75rem;overflow:hidden;text-overflow:ellipsis;white-space:normal}.fd-notification__paragraph:after,.fd-notification__paragraph:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__footer{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-notification__footer:after,.fd-notification__footer:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__footer-content{color:var(--sapContent_LabelColor);max-width:50%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-notification__footer-content:only-child{max-width:100%}.fd-notification__separator{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;margin-inline:.5rem;padding-block:0;padding-inline:0}.fd-notification__separator:after,.fd-notification__separator:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__separator:before{content:\"\\b7\"}.fd-notification__message-strip-container{padding-block:1rem 0;padding-inline:1rem .5rem}.fd-notification__message-strip-container:empty{padding-block:0;padding-inline:0}.fd-notification__message-strip-container:has(.fd-has-display-none){padding-block:0;padding-inline:0}.fd-notification .fd-notification__link{-webkit-margin-start:1rem;margin-inline-start:1rem}.fd-notification-message-strip{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-block:.5rem;padding-inline:0;padding-inline:.5rem}.fd-notification-message-strip:after,.fd-notification-message-strip:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-list{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;list-style:none;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-notification-list:after,.fd-notification-list:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;list-style:none;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-notification-group:after,.fd-notification-group:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__wrapper{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-notification-group__wrapper:after,.fd-notification-group__wrapper:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background:var(--sapList_GroupHeaderBackground);cursor:pointer;gap:.75rem;height:var(--sapElement_LineHeight);margin-block:var(--fdNotification_Group_Header_Margin_Block);padding-inline:.5rem;-webkit-border-after:var(--sapList_BorderWidth) solid var(--fdNotification_Group_Header_Border_Bottom_Color);border-block-end:var(--sapList_BorderWidth) solid var(--fdNotification_Group_Header_Border_Bottom_Color)}.fd-notification-group__header:after,.fd-notification-group__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__header.is-focus,.fd-notification-group__header:focus{outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);outline-offset:-.25rem;z-index:5}.fd-notification-group__header-arrow{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;font-size:1rem;margin-inline:.5rem}.fd-notification-group__header-arrow:after,.fd-notification-group__header-arrow:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__header-arrow [class*=sap-icon]{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapContent_IconColor);height:1rem;max-height:1rem;max-width:1rem;min-height:1rem;min-width:1rem;width:1rem}.fd-notification-group__header-title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--fdNotification_Group_Header_Title_Color);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--fdNotification_Group_Header_Title_Font_Size);font-weight:400;font-weight:var(--fdNotification_Group_Header_Title_Font_Weight);forced-color-adjust:none;line-height:normal;line-height:2rem;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-notification-group__header-title:after,.fd-notification-group__header-title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__list{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;gap:var(--fdNotification_Group_List_Gap);list-style:none;margin-block:var(--fdNotification_Group_List_Margin_Block);margin-inline:var(--fdNotification_Group_List_Margin_Inline)}.fd-notification-group__list:after,.fd-notification-group__list:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__growing-item{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;--fdNotification_Background:var(--sapList_Background);--fdNotification_Title_Color:var(--sapList_TextColor);--fdNotification_Paragraph_Color:var(--sapList_TextColor);--fdNotification_Separator_Color:var(--sapContent_LabelColor);--fdNotification_Footer_Content_Color:var(--sapContent_LabelColor);--fdNotification_Border_Block_End_Color:var(--sapList_BorderColor);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Top_Color);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Left_Right_Color);background:var(--fdNotification_Background);border-block-end-color:var(--fdNotification_Border_Block_End_Color);border-block-start-color:var(--fdNotification_Border_Block_Start_Color);border-inline-color:var(--fdNotification_Border_Inline_Color);border-radius:var(--fdNotification_Border_Radius);border-style:solid;border-width:var(--sapList_BorderWidth);cursor:pointer;display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;gap:.5rem;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;margin-inline:var(--fdNotification_Growing_Item_Margin_Inline);padding-block:1rem;padding-inline:1rem;-webkit-margin-after:var(--fdNotification_Growing_Item_Margin_Block_End);margin-block-end:var(--fdNotification_Growing_Item_Margin_Block_End)}.fd-notification-group__growing-item:after,.fd-notification-group__growing-item:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__growing-item.is-hover,.fd-notification-group__growing-item:hover{--fdNotification_Background:var(--fdNotification_Background_Hover)}.fd-notification-group__growing-item.is-active,.fd-notification-group__growing-item:active{--fdNotification_Background:var(--fdNotification_Background_Active);--fdNotification_Title_Color:var(--fdNotification_Title_Color_Active);--fdNotification_Paragraph_Color:var(--fdNotification_Paragraph_Color_Active);--fdNotification_Footer_Content_Color:var(--fdNotification_Footer_Content_Color_Active);--fdNotification_Separator_Color:var(--fdNotification_Separator_Color_Active);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Inline_Color_Active);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Block_Start_Color_Active);--fdNotification_Border_Block_End_Color:var(--fdNotification_Border_Block_End_Color_Active)}.fd-notification-group__growing-item.is-selected,.fd-notification-group__growing-item[aria-selected=true]{--fdNotification_Background:var(--fdNotification_Background_Selected);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Left_Right_Color_Selected);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Top_Color_Selected);--fdNotification_Border_Block_End_Color:var(--fdNotification_Border_Block_End_Color_Selected)}.fd-notification-group__growing-item.is-selected.is-hover,.fd-notification-group__growing-item.is-selected:hover,.fd-notification-group__growing-item[aria-selected=true].is-hover,.fd-notification-group__growing-item[aria-selected=true]:hover{--fdNotification_Background:var(--fdNotification_Background_Selected_Hover)}.fd-notification-group__growing-item.is-focus,.fd-notification-group__growing-item:focus{outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);outline-offset:-.25rem;z-index:5}.fd-notification-group__growing-item-title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--fdNotification_Growing_Item_Title_Color);font-family:var(--sapFontFamily);font-family:var(--fdNotification_Growing_Item_Title_Font_Family);font-size:var(--sapFontSize);font-size:var(--fdNotification_Growing_Item_Title_Font_Size);font-weight:400;font-weight:var(--fdNotification_Growing_Item_Title_Font_Weight);forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-notification-group__growing-item-title:after,.fd-notification-group__growing-item-title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__growing-item-subtitle{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-notification-group__growing-item-subtitle:after,.fd-notification-group__growing-item-subtitle:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-popover{--fdNotification_Popover_Width:27rem;--fdNotification_Popover_Max_Width:27rem;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;max-height:40rem;max-width:var(--fdNotification_Popover_Max_Width);overflow-y:scroll;padding-block:0;padding-inline:0;width:var(--fdNotification_Popover_Width)}.fd-notification-popover:after,.fd-notification-popover:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}@media (width <= 599px){.fd-notification-popover{--fdNotification_Popover_Width:auto;--fdNotification_Popover_Max_Width:25rem}}.fd-notification-banner{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;right:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;gap:.5rem;top:0;-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end;position:absolute;-webkit-margin-end:2rem;margin-inline-end:2rem;-webkit-margin-before:2rem;margin-block-start:2rem;max-width:var(--fdNotification_Popover_Max_Width,26rem)}.fd-notification-banner:after,.fd-notification-banner:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-banner[dir=rtl],[dir=rtl] .fd-notification-banner{left:0;right:auto}.fd-notification-banner .fd-notification{-webkit-box-shadow:var(--sapContent_Shadow2);box-shadow:var(--sapContent_Shadow2);width:100%}@media (width <= 599px){.fd-notification-banner .fd-notification{--fdNotification_Popover_Max_Width:24rem}}.fd-notification[class*=-compact],[class*=-compact] .fd-notification:not([class*=-cozy]){--fdNotification_Content_Gap:.5rem;--fdNotification_Title_Offset:4rem;--fdNotification_Title_One_Button_Offset:2.75rem;--fdNotification_Title_Two_Buttons_Offset:4.875rem}.fd-notification{display:flex}.fd-notification-message-strip:has(.fd-has-display-none){padding-block:0;padding-inline:0}.fd-notification-container .fd-notification{margin-block-end:.5rem}.fd-notification__title.is-expanded,.fd-notification__paragraph.is-expanded{display:block;overflow:visible;max-height:max-content}\n/*! Bundled license information:\n\nfundamental-styles/dist/notification.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-notification', template: `
        <ng-content></ng-content>
        <ng-container #vc></ng-container>
    `, encapsulation: ViewEncapsulation.None, host: {
                        '[attr.aria-labelledby]': 'ariaLabelledBy()',
                        '[attr.aria-label]': 'ariaLabel',
                        '[attr.aria-level]': 'ariaLevel()',
                        '[attr.role]': 'role()',
                        '[attr.dir]': '_dir$()',
                        '[attr.id]': 'id',
                        '[tabindex]': '0',
                        '[style.width]': 'width'
                    }, providers: [
                        {
                            provide: FD_NOTIFICATION,
                            useExisting: NotificationComponent
                        }
                    ], changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, styles: ["@charset \"UTF-8\";.fd-link{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapLinkColor);cursor:pointer;display:var(--fdLink_Display,inline-block);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;text-shadow:var(--sapContent_TextShadow);-webkit-box-align:center;-ms-flex-align:center;align-items:center;line-height:inherit;line-height:var(--fdLink_Line_Height,1.125rem);-webkit-text-decoration:var(--fdLink_Text_Decoration,none);text-decoration:var(--fdLink_Text_Decoration,none);text-underline-offset:.125rem;-webkit-transition:all .125s ease-in;transition:all .125s ease-in}.fd-link:after,.fd-link:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-link__content{-webkit-text-decoration:var(--fdLink_Text_Content_Decoration,none);text-decoration:var(--fdLink_Text_Content_Decoration,none)}.fd-link.is-hover,.fd-link:hover{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Hover,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Hover,none)}.fd-link.is-focus,.fd-link:focus{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Focus,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Focus,none)}.fd-link.is-active,.fd-link:active{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Active,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Active,none)}.fd-link.is-disabled,.fd-link:disabled,.fd-link[aria-disabled=true]{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Disabled,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Disabled,none)}.fd-link--subtle{--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Subtle,none);--fdLink_Text_Content_Decoration_Hover:var(--fdLink_Text_Content_Decoration_Subtle_Hover,none);--fdLink_Text_Content_Decoration_Active:var(--fdLink_Text_Content_Decoration_Subtle_Active,none);--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Subtle,none);--fdLink_Text_Decoration_Hover:var(--fdLink_Text_Decoration_Subtle_Hover,none);--fdLink_Text_Decoration_Active:var(--fdLink_Text_Decoration_Subtle_Active,none)}.fd-link--undecorated{--fdLink_Text_Decoration:none;--fdLink_Text_Decoration_Subtle:none;--fdLink_Text_Decoration_Subtle_Hover:none;--fdLink_Text_Decoration_Subtle_Active:none;--fdLink_Text_Decoration_Hover:none;--fdLink_Text_Decoration_Focus:none;--fdLink_Text_Decoration_Active:none;--fdLink_Text_Decoration_Visited:none;--fdLink_Text_Decoration_Disabled:none;--fdLink_Text_Content_Decoration:none;--fdLink_Text_Content_Decoration_Subtle:none;--fdLink_Text_Content_Decoration_Subtle_Hover:none;--fdLink_Text_Content_Decoration_Subtle_Active:none;--fdLink_Text_Content_Decoration_Hover:none;--fdLink_Text_Content_Decoration_Focus:none;--fdLink_Text_Content_Decoration_Active:none;--fdLink_Text_Content_Decoration_Visited:none;--fdLink_Text_Content_Decoration_Disabled:none}.fd-link--emphasized{font-family:var(--sapFontBoldFamily)}.fd-link:visited{color:var(--sapLink_Visited_Color)}.fd-link.is-hover,.fd-link:hover{color:var(--sapLink_Hover_Color)}.fd-link.is-focus,.fd-link:focus{background-color:var(--fdLink_Focus_Background);border-radius:var(--fdLink_Focus_Border_Radius);-webkit-box-shadow:none;box-shadow:none;color:var(--fdLink_Text_Focus_Color);outline:var(--fdLink_Hover_Outline_Color) var(--fdLink_Hover_Outline_Style) var(--fdLink_Hover_Outline_Width);outline-offset:var(--fdLink_Hover_Outline_Offset);text-shadow:var(--fdLink_Focus_Text_Shadow)}.fd-link.is-active,.fd-link:active{color:var(--sapLink_Active_Color)}.fd-link.is-active.is-focus,.fd-link.is-active:focus,.fd-link:active.is-focus,.fd-link:active:focus{background-color:transparent;z-index:5}.fd-link--inverted{text-shadow:none}.fd-link--inverted,.fd-link--inverted.is-hover,.fd-link--inverted:hover{color:var(--sapLink_InvertedColor)}.fd-link--inverted.is-focus,.fd-link--inverted:focus{outline-color:var(--sapContent_ContrastFocusColor);z-index:5}.fd-link--subtle{color:var(--sapLink_SubtleColor)}.fd-link.is-disabled,.fd-link:disabled,.fd-link[aria-disabled=true]{color:var(--sapLinkColor);opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-link>img{vertical-align:bottom}.fd-link [class*=sap-icon],.fd-link[class*=sap-icon]{color:var(--sapLinkColor);display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;line-height:1;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-link [class*=sap-icon]:first-child,.fd-link[class*=sap-icon]:first-child{-webkit-margin-end:var(--fdLink_Icon_Spacing,0);margin-inline-end:var(--fdLink_Icon_Spacing,0)}.fd-link [class*=sap-icon]:last-child,.fd-link[class*=sap-icon]:last-child{-webkit-margin-start:var(--fdLink_Icon_Spacing,0);margin-inline-start:var(--fdLink_Icon_Spacing,0)}.fd-link.is-hover [class*=sap-icon],.fd-link.is-hover[class*=sap-icon],.fd-link:hover [class*=sap-icon],.fd-link:hover[class*=sap-icon]{color:var(--sapLink_Hover_Color);-webkit-text-decoration:var(--fdLink_Text_Decoration_Hover);text-decoration:var(--fdLink_Text_Decoration_Hover)}.fd-link.is-focus,.fd-link:focus{z-index:5}.fd-link.is-focus [class*=sap-icon],.fd-link.is-focus[class*=sap-icon],.fd-link:focus [class*=sap-icon],.fd-link:focus[class*=sap-icon]{color:var(--fdLink_Text_Focus_Color);-webkit-text-decoration:var(--fdLink_Text_Decoration_Focus);text-decoration:var(--fdLink_Text_Decoration_Focus)}.fd-link.is-active [class*=sap-icon],.fd-link.is-active[class*=sap-icon],.fd-link:active [class*=sap-icon],.fd-link:active[class*=sap-icon]{color:var(--sapLink_Active_Color);-webkit-text-decoration:var(--fdLink_Text_Decoration_Active);text-decoration:var(--fdLink_Text_Decoration_Active)}.fd-link:visited:not(:focus) [class*=sap-icon],.fd-link:visited:not(:focus)[class*=sap-icon]{color:var(--sapLink_Visited_Color)}.fd-notification{--fdNotification_Content_Gap:.75rem;--fdNotification_Actions_Offset:-.25rem;--fdNotification_Title_Font_Weight:normal;--fdNotification_Title_Line_Height:1.25rem;--fdNotification_Title_One_Button_Offset:2rem;--fdNotification_Title_Two_Buttons_Offset:4.375rem;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;--fdNotification_Background:var(--sapList_Background);--fdNotification_Title_Color:var(--sapList_TextColor);--fdNotification_Paragraph_Color:var(--sapList_TextColor);--fdNotification_Separator_Color:var(--sapContent_LabelColor);--fdNotification_Footer_Content_Color:var(--sapContent_LabelColor);--fdNotification_Border_Block_End_Color:var(--sapList_BorderColor);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Top_Color);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Left_Right_Color);background:var(--fdNotification_Background);border-block-end-color:var(--fdNotification_Border_Block_End_Color);border-block-start-color:var(--fdNotification_Border_Block_Start_Color);border-inline-color:var(--fdNotification_Border_Inline_Color);border-radius:var(--fdNotification_Border_Radius);border-style:solid;border-width:var(--sapList_BorderWidth);cursor:pointer}.fd-notification:after,.fd-notification:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification.is-hover,.fd-notification:hover{--fdNotification_Background:var(--fdNotification_Background_Hover)}.fd-notification.is-active,.fd-notification:active{--fdNotification_Background:var(--fdNotification_Background_Active);--fdNotification_Title_Color:var(--fdNotification_Title_Color_Active);--fdNotification_Paragraph_Color:var(--fdNotification_Paragraph_Color_Active);--fdNotification_Footer_Content_Color:var(--fdNotification_Footer_Content_Color_Active);--fdNotification_Separator_Color:var(--fdNotification_Separator_Color_Active);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Inline_Color_Active);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Block_Start_Color_Active);--fdNotification_Border_Block_End_Color:var(--fdNotification_Border_Block_End_Color_Active)}.fd-notification.is-selected,.fd-notification[aria-selected=true]{--fdNotification_Background:var(--fdNotification_Background_Selected);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Left_Right_Color_Selected);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Top_Color_Selected);--fdNotification_Border_Block_End_Color:var(--fdNotification_Border_Block_End_Color_Selected)}.fd-notification.is-selected.is-hover,.fd-notification.is-selected:hover,.fd-notification[aria-selected=true].is-hover,.fd-notification[aria-selected=true]:hover{--fdNotification_Background:var(--fdNotification_Background_Selected_Hover)}.fd-notification.is-focus,.fd-notification:focus{outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);outline-offset:-.25rem;z-index:5}.fd-notification:has(.fd-notification__actions):has(button) .fd-notification__title{-webkit-padding-end:var(--fdNotification_Title_One_Button_Offset);padding-inline-end:var(--fdNotification_Title_One_Button_Offset)}.fd-notification:has(.fd-notification__actions):has(button+button) .fd-notification__title{-webkit-padding-end:var(--fdNotification_Title_Two_Buttons_Offset);padding-inline-end:var(--fdNotification_Title_Two_Buttons_Offset)}.fd-notification__body{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;gap:.75rem;padding-block:1rem;padding-inline:1rem;position:relative}.fd-notification__body:after,.fd-notification__body:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start;gap:var(--fdNotification_Content_Gap);width:100%}.fd-notification__content:after,.fd-notification__content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;gap:.25rem;width:100%}.fd-notification__header:after,.fd-notification__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__header>[class*=sap-icon]{-webkit-padding-before:.125rem;padding-block-start:.125rem}.fd-notification__actions{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;right:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;gap:.125rem;padding-block:.5rem 0;padding-inline:.25rem .5rem;position:absolute;top:0}.fd-notification__actions:after,.fd-notification__actions:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__actions[dir=rtl],[dir=rtl] .fd-notification__actions{left:0;right:auto}.fd-notification__title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-line-clamp:2;-webkit-box-orient:vertical;overflow:hidden;text-overflow:ellipsis;white-space:normal;-webkit-box-flex:1;color:var(--sapList_TextColor);-ms-flex:1;flex:1;font-size:var(--sapFontHeader6Size);font-weight:var(--fdNotification_Title_Font_Weight);line-height:var(--fdNotification_Title_Line_Height);max-height:calc(var(--fdNotification_Title_Line_Height)*2)}.fd-notification__title:after,.fd-notification__title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__title--unread{--fdNotification_Title_Font_Weight:bold}.fd-notification__paragraph{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;font-family:var(--sapFontFamily);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-line-clamp:2;-webkit-box-orient:vertical;color:var(--sapList_TextColor);font-size:var(--sapFontSize);max-height:2.75rem;overflow:hidden;text-overflow:ellipsis;white-space:normal}.fd-notification__paragraph:after,.fd-notification__paragraph:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__footer{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-notification__footer:after,.fd-notification__footer:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__footer-content{color:var(--sapContent_LabelColor);max-width:50%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-notification__footer-content:only-child{max-width:100%}.fd-notification__separator{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;margin-inline:.5rem;padding-block:0;padding-inline:0}.fd-notification__separator:after,.fd-notification__separator:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification__separator:before{content:\"\\b7\"}.fd-notification__message-strip-container{padding-block:1rem 0;padding-inline:1rem .5rem}.fd-notification__message-strip-container:empty{padding-block:0;padding-inline:0}.fd-notification__message-strip-container:has(.fd-has-display-none){padding-block:0;padding-inline:0}.fd-notification .fd-notification__link{-webkit-margin-start:1rem;margin-inline-start:1rem}.fd-notification-message-strip{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-block:.5rem;padding-inline:0;padding-inline:.5rem}.fd-notification-message-strip:after,.fd-notification-message-strip:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-list{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;list-style:none;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-notification-list:after,.fd-notification-list:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;list-style:none;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-notification-group:after,.fd-notification-group:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__wrapper{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-notification-group__wrapper:after,.fd-notification-group__wrapper:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background:var(--sapList_GroupHeaderBackground);cursor:pointer;gap:.75rem;height:var(--sapElement_LineHeight);margin-block:var(--fdNotification_Group_Header_Margin_Block);padding-inline:.5rem;-webkit-border-after:var(--sapList_BorderWidth) solid var(--fdNotification_Group_Header_Border_Bottom_Color);border-block-end:var(--sapList_BorderWidth) solid var(--fdNotification_Group_Header_Border_Bottom_Color)}.fd-notification-group__header:after,.fd-notification-group__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__header.is-focus,.fd-notification-group__header:focus{outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);outline-offset:-.25rem;z-index:5}.fd-notification-group__header-arrow{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;font-size:1rem;margin-inline:.5rem}.fd-notification-group__header-arrow:after,.fd-notification-group__header-arrow:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__header-arrow [class*=sap-icon]{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapContent_IconColor);height:1rem;max-height:1rem;max-width:1rem;min-height:1rem;min-width:1rem;width:1rem}.fd-notification-group__header-title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--fdNotification_Group_Header_Title_Color);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--fdNotification_Group_Header_Title_Font_Size);font-weight:400;font-weight:var(--fdNotification_Group_Header_Title_Font_Weight);forced-color-adjust:none;line-height:normal;line-height:2rem;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-notification-group__header-title:after,.fd-notification-group__header-title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__list{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;gap:var(--fdNotification_Group_List_Gap);list-style:none;margin-block:var(--fdNotification_Group_List_Margin_Block);margin-inline:var(--fdNotification_Group_List_Margin_Inline)}.fd-notification-group__list:after,.fd-notification-group__list:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__growing-item{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;--fdNotification_Background:var(--sapList_Background);--fdNotification_Title_Color:var(--sapList_TextColor);--fdNotification_Paragraph_Color:var(--sapList_TextColor);--fdNotification_Separator_Color:var(--sapContent_LabelColor);--fdNotification_Footer_Content_Color:var(--sapContent_LabelColor);--fdNotification_Border_Block_End_Color:var(--sapList_BorderColor);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Top_Color);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Left_Right_Color);background:var(--fdNotification_Background);border-block-end-color:var(--fdNotification_Border_Block_End_Color);border-block-start-color:var(--fdNotification_Border_Block_Start_Color);border-inline-color:var(--fdNotification_Border_Inline_Color);border-radius:var(--fdNotification_Border_Radius);border-style:solid;border-width:var(--sapList_BorderWidth);cursor:pointer;display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;gap:.5rem;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;margin-inline:var(--fdNotification_Growing_Item_Margin_Inline);padding-block:1rem;padding-inline:1rem;-webkit-margin-after:var(--fdNotification_Growing_Item_Margin_Block_End);margin-block-end:var(--fdNotification_Growing_Item_Margin_Block_End)}.fd-notification-group__growing-item:after,.fd-notification-group__growing-item:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__growing-item.is-hover,.fd-notification-group__growing-item:hover{--fdNotification_Background:var(--fdNotification_Background_Hover)}.fd-notification-group__growing-item.is-active,.fd-notification-group__growing-item:active{--fdNotification_Background:var(--fdNotification_Background_Active);--fdNotification_Title_Color:var(--fdNotification_Title_Color_Active);--fdNotification_Paragraph_Color:var(--fdNotification_Paragraph_Color_Active);--fdNotification_Footer_Content_Color:var(--fdNotification_Footer_Content_Color_Active);--fdNotification_Separator_Color:var(--fdNotification_Separator_Color_Active);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Inline_Color_Active);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Block_Start_Color_Active);--fdNotification_Border_Block_End_Color:var(--fdNotification_Border_Block_End_Color_Active)}.fd-notification-group__growing-item.is-selected,.fd-notification-group__growing-item[aria-selected=true]{--fdNotification_Background:var(--fdNotification_Background_Selected);--fdNotification_Border_Inline_Color:var(--fdNotification_Border_Left_Right_Color_Selected);--fdNotification_Border_Block_Start_Color:var(--fdNotification_Border_Top_Color_Selected);--fdNotification_Border_Block_End_Color:var(--fdNotification_Border_Block_End_Color_Selected)}.fd-notification-group__growing-item.is-selected.is-hover,.fd-notification-group__growing-item.is-selected:hover,.fd-notification-group__growing-item[aria-selected=true].is-hover,.fd-notification-group__growing-item[aria-selected=true]:hover{--fdNotification_Background:var(--fdNotification_Background_Selected_Hover)}.fd-notification-group__growing-item.is-focus,.fd-notification-group__growing-item:focus{outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);outline-offset:-.25rem;z-index:5}.fd-notification-group__growing-item-title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--fdNotification_Growing_Item_Title_Color);font-family:var(--sapFontFamily);font-family:var(--fdNotification_Growing_Item_Title_Font_Family);font-size:var(--sapFontSize);font-size:var(--fdNotification_Growing_Item_Title_Font_Size);font-weight:400;font-weight:var(--fdNotification_Growing_Item_Title_Font_Weight);forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-notification-group__growing-item-title:after,.fd-notification-group__growing-item-title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-group__growing-item-subtitle{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-notification-group__growing-item-subtitle:after,.fd-notification-group__growing-item-subtitle:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-popover{--fdNotification_Popover_Width:27rem;--fdNotification_Popover_Max_Width:27rem;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;max-height:40rem;max-width:var(--fdNotification_Popover_Max_Width);overflow-y:scroll;padding-block:0;padding-inline:0;width:var(--fdNotification_Popover_Width)}.fd-notification-popover:after,.fd-notification-popover:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}@media (width <= 599px){.fd-notification-popover{--fdNotification_Popover_Width:auto;--fdNotification_Popover_Max_Width:25rem}}.fd-notification-banner{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;right:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;gap:.5rem;top:0;-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end;position:absolute;-webkit-margin-end:2rem;margin-inline-end:2rem;-webkit-margin-before:2rem;margin-block-start:2rem;max-width:var(--fdNotification_Popover_Max_Width,26rem)}.fd-notification-banner:after,.fd-notification-banner:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-notification-banner[dir=rtl],[dir=rtl] .fd-notification-banner{left:0;right:auto}.fd-notification-banner .fd-notification{-webkit-box-shadow:var(--sapContent_Shadow2);box-shadow:var(--sapContent_Shadow2);width:100%}@media (width <= 599px){.fd-notification-banner .fd-notification{--fdNotification_Popover_Max_Width:24rem}}.fd-notification[class*=-compact],[class*=-compact] .fd-notification:not([class*=-cozy]){--fdNotification_Content_Gap:.5rem;--fdNotification_Title_Offset:4rem;--fdNotification_Title_One_Button_Offset:2.75rem;--fdNotification_Title_Two_Buttons_Offset:4.875rem}.fd-notification{display:flex}.fd-notification-message-strip:has(.fd-has-display-none){padding-block:0;padding-inline:0}.fd-notification-container .fd-notification{margin-block-end:.5rem}.fd-notification__title.is-expanded,.fd-notification__paragraph.is-expanded{display:block;overflow:visible;max-height:max-content}\n/*! Bundled license information:\n\nfundamental-styles/dist/notification.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], ctorParameters: () => [], propDecorators: { _closeNotificationEsc: [{
                type: HostListener,
                args: ['window:keyup', ['$event']]
            }] } });

// eslint-disable-next-line @angular-eslint/component-class-suffix
class NotificationContainer {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationContainer, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: NotificationContainer, isStandalone: true, selector: "fd-notification-container", host: { classAttribute: "fd-notification-container" }, ngImport: i0, template: ``, isInline: true, styles: [".fd-notification-container{position:fixed;display:flex;flex-direction:column;z-index:5000;align-items:flex-end;top:2rem;right:2rem}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationContainer, decorators: [{
            type: Component,
            args: [{ selector: 'fd-notification-container', template: ``, host: {
                        class: 'fd-notification-container'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, styles: [".fd-notification-container{position:fixed;display:flex;flex-direction:column;z-index:5000;align-items:flex-end;top:2rem;right:2rem}\n"] }]
        }] });

class NotificationService {
    /**
     * @hidden
     */
    constructor(_dynamicComponentService, _document, _rtlService) {
        this._dynamicComponentService = _dynamicComponentService;
        this._document = _document;
        this._rtlService = _rtlService;
        /** @hidden */
        this.notifications = [];
    }
    /**
     * Opens a notification component with a content of type TemplateRef or Component Type
     * @param content Content of the notification component.
     * @param notificationConfig Configuration of the notification component.
     */
    open(content, notificationConfig = new NotificationConfig()) {
        // Reassigning Object And Service
        const notificationService = new NotificationRef();
        notificationConfig = Object.assign(new NotificationConfig(), notificationConfig);
        notificationService.data = notificationConfig.data;
        // Create Container if it doesn't exist
        if (!this.containerRef) {
            this.containerRef = this._dynamicComponentService.createDynamicComponent(content, NotificationContainer, notificationConfig);
        }
        // Pass Container reference to config
        notificationConfig.container = this.containerRef.location.nativeElement;
        const injector = Injector.create({
            providers: [
                { provide: NotificationConfig, useValue: notificationConfig },
                { provide: NotificationRef, useValue: notificationService },
                { provide: RtlService, useValue: this._rtlService }
            ]
        });
        // Create Notification Component
        const notificationComponentRef = this._dynamicComponentService.createDynamicComponent(content, NotificationComponent, notificationConfig, { injector });
        if (notificationConfig.shouldTrapFocus) {
            const element = this._document.activeElement;
            this._elementFocusedBeforeNotificationWasOpened =
                typeof element?.focus === 'function' ? element : undefined;
            notificationComponentRef.instance.trapFocus();
        }
        // Add To array
        this.notifications.push({
            notificationComponent: notificationComponentRef,
            notificationConfig
        });
        const defaultBehaviourOnClose = () => {
            this._destroyNotificationComponent(notificationComponentRef);
            refSub.unsubscribe();
        };
        const refSub = notificationService.afterClosed.subscribe({
            next: defaultBehaviourOnClose,
            error: defaultBehaviourOnClose
        });
        return notificationService;
    }
    /** Method to remove all of notifications from this service instance */
    destroyAll() {
        this.notifications.forEach((notification) => {
            this._destroyNotificationComponent(notification.notificationComponent);
        });
    }
    /** Method that informs if there is any notification opened in this service instance */
    isAnyOpened() {
        return this.notifications && this.notifications.length > 0;
    }
    /** @hidden Method that destroys the Notification component */
    _destroyNotificationComponent(notification) {
        this.notifications = this.notifications.filter((item) => item.notificationComponent !== notification);
        this._dynamicComponentService.destroyComponent(notification);
        // If there is no other notification Components, just remove container.
        if (this.notifications.length === 0 && this.containerRef) {
            this._dynamicComponentService.destroyComponent(this.containerRef);
            this.containerRef = null;
            this._restoreFocus();
        }
        else {
            // otherwise attempt to move focus to previous notification
            const last = this.notifications[this.notifications.length - 1];
            if (last.notificationConfig.shouldTrapFocus) {
                last.notificationComponent.instance.trapFocus();
            }
            else {
                this._restoreFocus();
            }
        }
    }
    /** @hidden attempts to focus previously selected element */
    _restoreFocus() {
        if (typeof this._elementFocusedBeforeNotificationWasOpened?.focus === 'function') {
            this._elementFocusedBeforeNotificationWasOpened.focus();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationService, deps: [{ token: i1.DynamicComponentService }, { token: DOCUMENT }, { token: i1.RtlService, optional: true }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationService, decorators: [{
            type: Injectable
        }], ctorParameters: () => [{ type: i1.DynamicComponentService }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: i1.RtlService, decorators: [{
                    type: Optional
                }] }] });

const components = [
    NotificationComponent,
    NotificationContainer,
    NotificationLinkComponent,
    NotificationBodyComponent,
    NotificationGroupComponent,
    NotificationHeaderComponent,
    NotificationFooterComponent,
    NotificationActionsComponent,
    NotificationContentComponent,
    NotificationGroupListComponent,
    NotificationGroupHeaderComponent,
    NotificationGroupGrowingItemComponent,
    NotificationListDirective,
    NotificationTitleDirective,
    NotificationPopoverDirective,
    NotificationSeparatorDirective,
    NotificationParagraphDirective,
    NotificationMessageStripDirective,
    NotificationFooterContentDirective,
    NotificationGroupHeaderTitleDirective,
    NotificationMessageStripContainerDirective,
    NotificationGroupGrowingItemTitleDirective
];
class NotificationModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: NotificationModule, imports: [NotificationComponent,
            NotificationContainer,
            NotificationLinkComponent,
            NotificationBodyComponent,
            NotificationGroupComponent,
            NotificationHeaderComponent,
            NotificationFooterComponent,
            NotificationActionsComponent,
            NotificationContentComponent,
            NotificationGroupListComponent,
            NotificationGroupHeaderComponent,
            NotificationGroupGrowingItemComponent,
            NotificationListDirective,
            NotificationTitleDirective,
            NotificationPopoverDirective,
            NotificationSeparatorDirective,
            NotificationParagraphDirective,
            NotificationMessageStripDirective,
            NotificationFooterContentDirective,
            NotificationGroupHeaderTitleDirective,
            NotificationMessageStripContainerDirective,
            NotificationGroupGrowingItemTitleDirective], exports: [NotificationComponent,
            NotificationContainer,
            NotificationLinkComponent,
            NotificationBodyComponent,
            NotificationGroupComponent,
            NotificationHeaderComponent,
            NotificationFooterComponent,
            NotificationActionsComponent,
            NotificationContentComponent,
            NotificationGroupListComponent,
            NotificationGroupHeaderComponent,
            NotificationGroupGrowingItemComponent,
            NotificationListDirective,
            NotificationTitleDirective,
            NotificationPopoverDirective,
            NotificationSeparatorDirective,
            NotificationParagraphDirective,
            NotificationMessageStripDirective,
            NotificationFooterContentDirective,
            NotificationGroupHeaderTitleDirective,
            NotificationMessageStripContainerDirective,
            NotificationGroupGrowingItemTitleDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationModule, providers: [DynamicComponentService, NotificationService], imports: [NotificationGroupHeaderComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NotificationModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [...components],
                    exports: [...components],
                    providers: [DynamicComponentService, NotificationService]
                }]
        }] });

// Directives

/**
 * Generated bundle index. Do not edit.
 */

export { FD_NOTIFICATION, FD_NOTIFICATION_FOOTER, FD_NOTIFICATION_GROUP_HEADER, FD_NOTIFICATION_GROUP_HEADER_TITLE, FD_NOTIFICATION_GROUP_LIST, FD_NOTIFICATION_PARAGRAPH, FD_NOTIFICATION_TITLE, NotificationActionsComponent, NotificationBodyComponent, NotificationComponent, NotificationConfig, NotificationContainer, NotificationContentComponent, NotificationFooterComponent, NotificationFooterContentDirective, NotificationGroupBaseDirective, NotificationGroupComponent, NotificationGroupGrowingItemComponent, NotificationGroupGrowingItemTitleDirective, NotificationGroupHeaderComponent, NotificationGroupHeaderTitleDirective, NotificationGroupListComponent, NotificationHeaderComponent, NotificationLinkComponent, NotificationListDirective, NotificationMessageStripContainerDirective, NotificationMessageStripDirective, NotificationModule, NotificationParagraphDirective, NotificationPopoverDirective, NotificationRef, NotificationSeparatorDirective, NotificationService, NotificationTitleDirective };
//# sourceMappingURL=fundamental-ngx-core-notification.mjs.map
