import { __decorate, __metadata } from 'tslib';
import * as i0 from '@angular/core';
import { Input, ChangeDetectionStrategy, ViewEncapsulation, Component, NgModule } from '@angular/core';
import { applyCssClass } from '@fundamental-ngx/cdk/utils';
import { FD_DEFAULT_ICON_FONT_FAMILY, IconComponent } from '@fundamental-ngx/core/icon';

class ObjectMarkerComponent {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
        /** Glyph font family */
        this.glyphFont = FD_DEFAULT_ICON_FONT_FAMILY;
        /** Whether the Object Status is clickable. */
        this.clickable = false;
    }
    /** @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return ['fd-object-marker', this.clickable ? 'fd-object-marker--link' : '', this.class];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ObjectMarkerComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: ObjectMarkerComponent, isStandalone: true, selector: "[fd-object-marker]", inputs: { class: "class", glyph: "glyph", glyphFont: "glyphFont", clickable: "clickable", label: "label" }, host: { properties: { "attr.tabindex": "clickable ? 0 : -1", "attr.role": "clickable ? \"link\" :\"\"" } }, usesOnChanges: true, ngImport: i0, template: `@if (glyph) {
            <fd-icon [glyph]="glyph" [font]="glyphFont" class="fd-object-marker__icon"></fd-icon>
        }
        @if (label) {
            <span class="fd-object-marker__text">{{ label }}</span>
        }
        <ng-content></ng-content>`, isInline: true, styles: [".fd-object-marker{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:1rem;font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1;margin-block:0;margin-inline:0;max-width:100%;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-object-marker:after,.fd-object-marker:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-object-marker--link{color:var(--sapLinkColor);cursor:pointer;display:var(--fdLink_Display,inline-block);text-shadow:var(--sapContent_TextShadow);-webkit-box-align:center;-ms-flex-align:center;align-items:center;line-height:inherit;-webkit-text-decoration:var(--fdLink_Text_Decoration,none);text-decoration:var(--fdLink_Text_Decoration,none);-webkit-transition:all .125s ease-in;transition:all .125s ease-in}.fd-object-marker--link--emphasized{font-family:var(--sapFontBoldFamily)}.fd-object-marker--link:visited{color:var(--sapLink_Visited_Color)}.fd-object-marker--link.is-hover,.fd-object-marker--link:hover{color:var(--sapLink_Hover_Color)}.fd-object-marker--link.is-focus,.fd-object-marker--link:focus{background-color:var(--fdLink_Focus_Background);border-radius:var(--fdLink_Focus_Border_Radius);-webkit-box-shadow:none;box-shadow:none;color:var(--fdLink_Text_Focus_Color);outline:var(--fdLink_Hover_Outline_Color) var(--fdLink_Hover_Outline_Style) var(--fdLink_Hover_Outline_Width);outline-offset:var(--fdLink_Hover_Outline_Offset);text-shadow:var(--fdLink_Focus_Text_Shadow)}.fd-object-marker--link.is-active,.fd-object-marker--link:active{color:var(--sapLink_Active_Color)}.fd-object-marker--link.is-active.is-focus,.fd-object-marker--link.is-active:focus,.fd-object-marker--link:active.is-focus,.fd-object-marker--link:active:focus{background-color:transparent;z-index:5}.fd-object-marker--link--inverted{text-shadow:none}.fd-object-marker--link--inverted,.fd-object-marker--link--inverted.is-hover,.fd-object-marker--link--inverted:hover{color:var(--sapLink_InvertedColor)}.fd-object-marker--link--inverted.is-focus,.fd-object-marker--link--inverted:focus{outline-color:var(--sapContent_ContrastFocusColor);z-index:5}.fd-object-marker--link--subtle{color:var(--sapLink_SubtleColor)}.fd-object-marker--link.is-disabled,.fd-object-marker--link:disabled,.fd-object-marker--link[aria-disabled=true]{color:var(--sapLinkColor);opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-object-marker--link>img{vertical-align:bottom}.fd-object-marker--link .fd-object-marker__text,.fd-object-marker--link__content{-webkit-text-decoration:var(--fdLink_Text_Content_Decoration,none);text-decoration:var(--fdLink_Text_Content_Decoration,none)}.fd-object-marker--link.is-hover,.fd-object-marker--link:hover{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Hover,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Hover,none)}.fd-object-marker--link.is-focus,.fd-object-marker--link:focus{z-index:5;--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Focus,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Focus,none)}.fd-object-marker--link.is-active,.fd-object-marker--link:active{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Active,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Active,none)}.fd-object-marker--link.is-disabled,.fd-object-marker--link:disabled,.fd-object-marker--link[aria-disabled=true]{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Disabled,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Disabled,none)}.fd-object-marker--link--subtle{--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Subtle,none);--fdLink_Text_Content_Decoration_Hover:var(--fdLink_Text_Content_Decoration_Subtle_Hover,none);--fdLink_Text_Content_Decoration_Active:var(--fdLink_Text_Content_Decoration_Subtle_Active,none);--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Subtle,none);--fdLink_Text_Decoration_Hover:var(--fdLink_Text_Decoration_Subtle_Hover,none);--fdLink_Text_Decoration_Active:var(--fdLink_Text_Decoration_Subtle_Active,none)}.fd-object-marker--link--undecorated{--fdLink_Text_Decoration:none;--fdLink_Text_Decoration_Subtle:none;--fdLink_Text_Decoration_Subtle_Hover:none;--fdLink_Text_Decoration_Subtle_Active:none;--fdLink_Text_Decoration_Hover:none;--fdLink_Text_Decoration_Focus:none;--fdLink_Text_Decoration_Active:none;--fdLink_Text_Decoration_Visited:none;--fdLink_Text_Decoration_Disabled:none;--fdLink_Text_Content_Decoration:none;--fdLink_Text_Content_Decoration_Subtle:none;--fdLink_Text_Content_Decoration_Subtle_Hover:none;--fdLink_Text_Content_Decoration_Subtle_Active:none;--fdLink_Text_Content_Decoration_Hover:none;--fdLink_Text_Content_Decoration_Focus:none;--fdLink_Text_Content_Decoration_Active:none;--fdLink_Text_Content_Decoration_Visited:none;--fdLink_Text_Content_Decoration_Disabled:none}.fd-object-marker__icon [class*=sap-icon],.fd-object-marker__icon[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;display:-webkit-box;display:-ms-flexbox;display:flex;font-size:inherit;line-height:1;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;font-size:1rem;line-height:normal;-webkit-padding-end:.25rem;color:var(--sapContent_MarkerIconColor);padding-inline-end:.25rem}.fd-object-marker__icon [class*=sap-icon]:first-child:last-child,.fd-object-marker__icon[class*=sap-icon]:first-child:last-child{padding-inline:0}.fd-object-marker:not(.fd-object-marker--link) .fd-object-marker__text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:1rem;font-style:normal;font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;word-break:break-word}.fd-object-marker:not(.fd-object-marker--link) .fd-object-marker__text:after,.fd-object-marker:not(.fd-object-marker--link) .fd-object-marker__text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-object-marker+.fd-object-marker{-webkit-margin-start:.5rem;margin-inline-start:.5rem}\n/*! Bundled license information:\n\nfundamental-styles/dist/object-marker.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], dependencies: [{ kind: "component", type: IconComponent, selector: "fd-icon", inputs: ["glyph", "font", "color", "background", "class", "ariaLabel", "ariaHidden"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], ObjectMarkerComponent.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ObjectMarkerComponent, decorators: [{
            type: Component,
            args: [{ selector: '[fd-object-marker]', template: `@if (glyph) {
            <fd-icon [glyph]="glyph" [font]="glyphFont" class="fd-object-marker__icon"></fd-icon>
        }
        @if (label) {
            <span class="fd-object-marker__text">{{ label }}</span>
        }
        <ng-content></ng-content>`, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, host: {
                        '[attr.tabindex]': 'clickable ? 0 : -1',
                        '[attr.role]': 'clickable ? "link" :""'
                    }, imports: [IconComponent], styles: [".fd-object-marker{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:1rem;font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1;margin-block:0;margin-inline:0;max-width:100%;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-object-marker:after,.fd-object-marker:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-object-marker--link{color:var(--sapLinkColor);cursor:pointer;display:var(--fdLink_Display,inline-block);text-shadow:var(--sapContent_TextShadow);-webkit-box-align:center;-ms-flex-align:center;align-items:center;line-height:inherit;-webkit-text-decoration:var(--fdLink_Text_Decoration,none);text-decoration:var(--fdLink_Text_Decoration,none);-webkit-transition:all .125s ease-in;transition:all .125s ease-in}.fd-object-marker--link--emphasized{font-family:var(--sapFontBoldFamily)}.fd-object-marker--link:visited{color:var(--sapLink_Visited_Color)}.fd-object-marker--link.is-hover,.fd-object-marker--link:hover{color:var(--sapLink_Hover_Color)}.fd-object-marker--link.is-focus,.fd-object-marker--link:focus{background-color:var(--fdLink_Focus_Background);border-radius:var(--fdLink_Focus_Border_Radius);-webkit-box-shadow:none;box-shadow:none;color:var(--fdLink_Text_Focus_Color);outline:var(--fdLink_Hover_Outline_Color) var(--fdLink_Hover_Outline_Style) var(--fdLink_Hover_Outline_Width);outline-offset:var(--fdLink_Hover_Outline_Offset);text-shadow:var(--fdLink_Focus_Text_Shadow)}.fd-object-marker--link.is-active,.fd-object-marker--link:active{color:var(--sapLink_Active_Color)}.fd-object-marker--link.is-active.is-focus,.fd-object-marker--link.is-active:focus,.fd-object-marker--link:active.is-focus,.fd-object-marker--link:active:focus{background-color:transparent;z-index:5}.fd-object-marker--link--inverted{text-shadow:none}.fd-object-marker--link--inverted,.fd-object-marker--link--inverted.is-hover,.fd-object-marker--link--inverted:hover{color:var(--sapLink_InvertedColor)}.fd-object-marker--link--inverted.is-focus,.fd-object-marker--link--inverted:focus{outline-color:var(--sapContent_ContrastFocusColor);z-index:5}.fd-object-marker--link--subtle{color:var(--sapLink_SubtleColor)}.fd-object-marker--link.is-disabled,.fd-object-marker--link:disabled,.fd-object-marker--link[aria-disabled=true]{color:var(--sapLinkColor);opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-object-marker--link>img{vertical-align:bottom}.fd-object-marker--link .fd-object-marker__text,.fd-object-marker--link__content{-webkit-text-decoration:var(--fdLink_Text_Content_Decoration,none);text-decoration:var(--fdLink_Text_Content_Decoration,none)}.fd-object-marker--link.is-hover,.fd-object-marker--link:hover{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Hover,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Hover,none)}.fd-object-marker--link.is-focus,.fd-object-marker--link:focus{z-index:5;--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Focus,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Focus,none)}.fd-object-marker--link.is-active,.fd-object-marker--link:active{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Active,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Active,none)}.fd-object-marker--link.is-disabled,.fd-object-marker--link:disabled,.fd-object-marker--link[aria-disabled=true]{--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Disabled,none);--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Disabled,none)}.fd-object-marker--link--subtle{--fdLink_Text_Content_Decoration:var(--fdLink_Text_Content_Decoration_Subtle,none);--fdLink_Text_Content_Decoration_Hover:var(--fdLink_Text_Content_Decoration_Subtle_Hover,none);--fdLink_Text_Content_Decoration_Active:var(--fdLink_Text_Content_Decoration_Subtle_Active,none);--fdLink_Text_Decoration:var(--fdLink_Text_Decoration_Subtle,none);--fdLink_Text_Decoration_Hover:var(--fdLink_Text_Decoration_Subtle_Hover,none);--fdLink_Text_Decoration_Active:var(--fdLink_Text_Decoration_Subtle_Active,none)}.fd-object-marker--link--undecorated{--fdLink_Text_Decoration:none;--fdLink_Text_Decoration_Subtle:none;--fdLink_Text_Decoration_Subtle_Hover:none;--fdLink_Text_Decoration_Subtle_Active:none;--fdLink_Text_Decoration_Hover:none;--fdLink_Text_Decoration_Focus:none;--fdLink_Text_Decoration_Active:none;--fdLink_Text_Decoration_Visited:none;--fdLink_Text_Decoration_Disabled:none;--fdLink_Text_Content_Decoration:none;--fdLink_Text_Content_Decoration_Subtle:none;--fdLink_Text_Content_Decoration_Subtle_Hover:none;--fdLink_Text_Content_Decoration_Subtle_Active:none;--fdLink_Text_Content_Decoration_Hover:none;--fdLink_Text_Content_Decoration_Focus:none;--fdLink_Text_Content_Decoration_Active:none;--fdLink_Text_Content_Decoration_Visited:none;--fdLink_Text_Content_Decoration_Disabled:none}.fd-object-marker__icon [class*=sap-icon],.fd-object-marker__icon[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;display:-webkit-box;display:-ms-flexbox;display:flex;font-size:inherit;line-height:1;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;font-size:1rem;line-height:normal;-webkit-padding-end:.25rem;color:var(--sapContent_MarkerIconColor);padding-inline-end:.25rem}.fd-object-marker__icon [class*=sap-icon]:first-child:last-child,.fd-object-marker__icon[class*=sap-icon]:first-child:last-child{padding-inline:0}.fd-object-marker:not(.fd-object-marker--link) .fd-object-marker__text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:1rem;font-style:normal;font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;word-break:break-word}.fd-object-marker:not(.fd-object-marker--link) .fd-object-marker__text:after,.fd-object-marker:not(.fd-object-marker--link) .fd-object-marker__text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-object-marker+.fd-object-marker{-webkit-margin-start:.5rem;margin-inline-start:.5rem}\n/*! Bundled license information:\n\nfundamental-styles/dist/object-marker.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { class: [{
                type: Input
            }], glyph: [{
                type: Input
            }], glyphFont: [{
                type: Input
            }], clickable: [{
                type: Input
            }], label: [{
                type: Input
            }], buildComponentCssClass: [] } });

/**
 * @deprecated
 * Use direct import of `ObjectMarkerComponent`
 */
class ObjectMarkerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ObjectMarkerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: ObjectMarkerModule, imports: [ObjectMarkerComponent], exports: [ObjectMarkerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ObjectMarkerModule, imports: [ObjectMarkerComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ObjectMarkerModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [ObjectMarkerComponent],
                    exports: [ObjectMarkerComponent]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { ObjectMarkerComponent, ObjectMarkerModule };
//# sourceMappingURL=fundamental-ngx-core-object-marker.mjs.map
