import * as i0 from '@angular/core';
import { Directive, ChangeDetectionStrategy, Component, Input, ViewEncapsulation, NgModule } from '@angular/core';
import { FormLabelComponent, FormItemComponent, FormGroupComponent } from '@fundamental-ngx/core/form';
import { TitleComponent } from '@fundamental-ngx/core/title';
import { BarComponent, BarLeftDirective, BarRightDirective, BarMiddleDirective, BarElementDirective } from '@fundamental-ngx/core/bar';
import { NgTemplateOutlet } from '@angular/common';
import { PopoverBodyHeaderDirective } from '@fundamental-ngx/core/popover';

class QuickViewGroupItemContentElementDirective {
    /** @hidden */
    static { this.class = 'fd-quick-view__group-item__content-element'; }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupItemContentElementDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: QuickViewGroupItemContentElementDirective, isStandalone: true, selector: "[fd-quick-view-group-item-content-element]", host: { classAttribute: "fd-quick-view__group-item__content-element" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupItemContentElementDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-quick-view-group-item-content-element]',
                    host: {
                        class: `${QuickViewGroupItemContentElementDirective.class}`
                    },
                    standalone: true
                }]
        }] });

class QuickViewGroupItemContentComponent {
    /** @hidden */
    constructor(_elRef) {
        this._elRef = _elRef;
    }
    /** @hidden */
    ngAfterViewInit() {
        this._bindElementAttributes();
    }
    /** @hidden
     * Needed for binding the id of the element and id of the proper label to aria-labelledby. */
    _bindElementAttributes() {
        const parentId = this._elRef.nativeElement.closest('.fd-form-item')?.id;
        const id = `${parentId}-content`;
        const element = this._elRef.nativeElement.querySelector(`.${QuickViewGroupItemContentElementDirective.class}`);
        if (element && parentId) {
            element.setAttribute('id', id);
            element.setAttribute('aria-labelledby', `${parentId}-label ${id}`);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupItemContentComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: QuickViewGroupItemContentComponent, isStandalone: true, selector: "fd-quick-view-group-item-content", ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupItemContentComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-quick-view-group-item-content',
                    template: `<ng-content></ng-content>`,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }] });

class QuickViewGroupItemLabelComponent {
    /** @hidden */
    constructor(_elRef) {
        this._elRef = _elRef;
    }
    /** @hidden */
    ngAfterViewInit() {
        this._bindElementAttributes();
    }
    /** @hidden
     * Needed for binding the id to the label element (and this id needed for aria-labelledby of proper element). */
    _bindElementAttributes() {
        const parentId = this._elRef.nativeElement.closest('.fd-form-item')?.id;
        const child = this._elRef.nativeElement.firstChild;
        if (child instanceof Element && parentId) {
            child.setAttribute('id', `${parentId}-label`);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupItemLabelComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: QuickViewGroupItemLabelComponent, isStandalone: true, selector: "fd-quick-view-group-item-label", ngImport: i0, template: "<label fd-form-label>\n    <ng-content></ng-content>\n</label>\n", dependencies: [{ kind: "component", type: FormLabelComponent, selector: "[fd-form-label]", inputs: ["required", "colon", "alignLabelEnd", "inlineHelpContent", "inlineHelpGlyph", "inlineHelpTriggers", "inlineHelpBodyPlacement", "inlineHelpPlacement", "allowWrap", "inlineHelpLabel", "id"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupItemLabelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-quick-view-group-item-label', changeDetection: ChangeDetectionStrategy.OnPush, imports: [FormLabelComponent], template: "<label fd-form-label>\n    <ng-content></ng-content>\n</label>\n" }]
        }], ctorParameters: () => [{ type: i0.ElementRef }] });

let quickViewGroupItemUniqueId = 0;
class QuickViewGroupItemComponent {
    constructor() {
        /** Id of the quick view element. */
        this.id = 'fd-quick-view-group-item-' + quickViewGroupItemUniqueId++;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupItemComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: QuickViewGroupItemComponent, isStandalone: true, selector: "fd-quick-view-group-item", inputs: { id: "id" }, ngImport: i0, template: "<div fd-form-item [id]=\"id\">\n    <ng-content></ng-content>\n</div>\n", dependencies: [{ kind: "component", type: FormItemComponent, selector: "[fd-form-item]", inputs: ["isInline", "horizontal"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-quick-view-group-item', changeDetection: ChangeDetectionStrategy.OnPush, imports: [FormItemComponent], template: "<div fd-form-item [id]=\"id\">\n    <ng-content></ng-content>\n</div>\n" }]
        }], propDecorators: { id: [{
                type: Input
            }] } });

let groupTitleUniqueId = 0;
class QuickViewGroupTitleComponent {
    constructor() {
        /** Id of the quick view group title. */
        this.id = 'fd-quick-view-group-title-' + groupTitleUniqueId++;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupTitleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: QuickViewGroupTitleComponent, isStandalone: true, selector: "fd-quick-view-group-title", inputs: { id: "id" }, ngImport: i0, template: "<div class=\"fd-form-group__header\" [attr.aria-labelledby]=\"id\">\n    <h1 class=\"fd-form-group__header-text\" [id]=\"id\">\n        <ng-content></ng-content>\n    </h1>\n</div>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupTitleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-quick-view-group-title', changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, template: "<div class=\"fd-form-group__header\" [attr.aria-labelledby]=\"id\">\n    <h1 class=\"fd-form-group__header-text\" [id]=\"id\">\n        <ng-content></ng-content>\n    </h1>\n</div>\n" }]
        }], propDecorators: { id: [{
                type: Input
            }] } });

class QuickViewGroupComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: QuickViewGroupComponent, isStandalone: true, selector: "fd-quick-view-group", ngImport: i0, template: "<fd-form-group role=\"group\">\n    <ng-content></ng-content>\n</fd-form-group>\n", dependencies: [{ kind: "component", type: FormGroupComponent, selector: "fd-form-group", inputs: ["isInline"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-quick-view-group', changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, imports: [FormGroupComponent], template: "<fd-form-group role=\"group\">\n    <ng-content></ng-content>\n</fd-form-group>\n" }]
        }] });

class QuickViewSubheaderSubtitleComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewSubheaderSubtitleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: QuickViewSubheaderSubtitleComponent, isStandalone: true, selector: "fd-quick-view-subheader-subtitle", ngImport: i0, template: "<div class=\"fd-quick-view__subtitle\">\n    <ng-content></ng-content>\n</div>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewSubheaderSubtitleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-quick-view-subheader-subtitle', changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, template: "<div class=\"fd-quick-view__subtitle\">\n    <ng-content></ng-content>\n</div>\n" }]
        }] });

class QuickViewSubheaderTitleComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewSubheaderTitleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: QuickViewSubheaderTitleComponent, isStandalone: true, selector: "fd-quick-view-subheader-title", ngImport: i0, template: "<h5 fd-title [headerSize]=\"5\">\n    <ng-content></ng-content>\n</h5>\n", dependencies: [{ kind: "component", type: TitleComponent, selector: "[fd-title], [fdTitle]", inputs: ["headerSize", "wrap"], exportAs: ["fd-title"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewSubheaderTitleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-quick-view-subheader-title', changeDetection: ChangeDetectionStrategy.OnPush, imports: [TitleComponent], template: "<h5 fd-title [headerSize]=\"5\">\n    <ng-content></ng-content>\n</h5>\n" }]
        }] });

class QuickViewSubheaderComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewSubheaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: QuickViewSubheaderComponent, isStandalone: true, selector: "fd-quick-view-subheader", ngImport: i0, template: "<div fd-bar barDesign=\"header-with-subheader\">\n    <div fd-bar-left>\n        <ng-content select=\"fd-avatar\"></ng-content>\n\n        <div class=\"fd-quick-view__subheader-text\">\n            <ng-content select=\"fd-quick-view-subheader-title\"></ng-content>\n            <ng-content select=\"fd-quick-view-subheader-subtitle\"></ng-content>\n        </div>\n    </div>\n</div>\n", dependencies: [{ kind: "component", type: BarComponent, selector: "[fd-bar]", inputs: ["class", "barDesign", "inPage", "inHomePage", "size", "role"] }, { kind: "directive", type: BarLeftDirective, selector: "[fd-bar-left]" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewSubheaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-quick-view-subheader', changeDetection: ChangeDetectionStrategy.OnPush, imports: [BarComponent, BarLeftDirective], template: "<div fd-bar barDesign=\"header-with-subheader\">\n    <div fd-bar-left>\n        <ng-content select=\"fd-avatar\"></ng-content>\n\n        <div class=\"fd-quick-view__subheader-text\">\n            <ng-content select=\"fd-quick-view-subheader-title\"></ng-content>\n            <ng-content select=\"fd-quick-view-subheader-subtitle\"></ng-content>\n        </div>\n    </div>\n</div>\n" }]
        }] });

class QuickViewTitleComponent {
    constructor() {
        /**
         * Alignment of title.
         * Options include 'left', 'right' and 'middle'. The default is set to 'middle'.
         * */
        this.align = 'middle';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewTitleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: QuickViewTitleComponent, isStandalone: true, selector: "fd-quick-view-title", inputs: { align: "align" }, ngImport: i0, template: "<div fd-popover-body-header>\n    <div fd-bar barDesign=\"header\">\n        @switch (align) {\n            @case ('left') {\n                <div fd-bar-left>\n                    <ng-template [ngTemplateOutlet]=\"barElement\"></ng-template>\n                </div>\n            }\n            @case ('right') {\n                <div fd-bar-right>\n                    <ng-template [ngTemplateOutlet]=\"barElement\"></ng-template>\n                </div>\n            }\n            @default {\n                <div fd-bar-middle>\n                    <ng-template [ngTemplateOutlet]=\"barElement\"></ng-template>\n                </div>\n            }\n        }\n    </div>\n</div>\n<ng-template #barElement>\n    <fd-bar-element>\n        <ng-content></ng-content>\n    </fd-bar-element>\n</ng-template>\n", dependencies: [{ kind: "directive", type: PopoverBodyHeaderDirective, selector: "[fdPopoverBodyHeader], [fd-popover-body-header]" }, { kind: "component", type: BarComponent, selector: "[fd-bar]", inputs: ["class", "barDesign", "inPage", "inHomePage", "size", "role"] }, { kind: "directive", type: BarLeftDirective, selector: "[fd-bar-left]" }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: BarRightDirective, selector: "[fd-bar-right]" }, { kind: "directive", type: BarMiddleDirective, selector: "[fd-bar-middle]" }, { kind: "directive", type: BarElementDirective, selector: "fd-bar-element", inputs: ["fullWidth"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewTitleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-quick-view-title', changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        PopoverBodyHeaderDirective,
                        BarComponent,
                        BarLeftDirective,
                        NgTemplateOutlet,
                        BarRightDirective,
                        BarMiddleDirective,
                        BarElementDirective
                    ], template: "<div fd-popover-body-header>\n    <div fd-bar barDesign=\"header\">\n        @switch (align) {\n            @case ('left') {\n                <div fd-bar-left>\n                    <ng-template [ngTemplateOutlet]=\"barElement\"></ng-template>\n                </div>\n            }\n            @case ('right') {\n                <div fd-bar-right>\n                    <ng-template [ngTemplateOutlet]=\"barElement\"></ng-template>\n                </div>\n            }\n            @default {\n                <div fd-bar-middle>\n                    <ng-template [ngTemplateOutlet]=\"barElement\"></ng-template>\n                </div>\n            }\n        }\n    </div>\n</div>\n<ng-template #barElement>\n    <fd-bar-element>\n        <ng-content></ng-content>\n    </fd-bar-element>\n</ng-template>\n" }]
        }], propDecorators: { align: [{
                type: Input
            }] } });

let quickViewUniqueId = 0;
class QuickViewComponent {
    constructor() {
        /** Id of the quick view element. */
        this.id = 'fd-quick-view-' + quickViewUniqueId++;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: QuickViewComponent, isStandalone: true, selector: "fd-quick-view", inputs: { id: "id" }, ngImport: i0, template: "<div class=\"fd-quick-view\" [id]=\"id\">\n    <ng-content select=\"fd-quick-view-title\"></ng-content>\n\n    <div class=\"fd-quick-view__content\">\n        <ng-content select=\"fd-quick-view-subheader\"></ng-content>\n        <ng-content select=\"fd-quick-view-group\"></ng-content>\n    </div>\n</div>\n", styles: [".fd-form-group{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column}.fd-form-group:after,.fd-form-group:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group--inline{-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row wrap;flex-flow:row wrap;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start}.fd-form-group--with-spacing{gap:.625rem}.fd-form-group__header{border:0;-webkit-box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--sapGroup_TitleBackground);box-sizing:border-box;height:2.75rem;width:100%}.fd-form-group__header:after,.fd-form-group__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group__header[class*=-compact],.fd-form-group__header[class*=-condensed],[class*=-compact] .fd-form-group__header:not([class*=-cozy]),[class*=-condensed] .fd-form-group__header:not([class*=-cozy]){height:2rem}.fd-form-group__header-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--sapFontHeader6Size);font-weight:400;font-weight:700;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-form-group__header-text:after,.fd-form-group__header-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-quick-view{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:inherit;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;min-width:20rem;padding-block:0;padding-inline:0}.fd-quick-view:after,.fd-quick-view:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-quick-view__content{background-color:var(--sapGroup_ContentBackground);border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-block:1rem;padding-inline:0;padding-inline:1rem}.fd-quick-view__content:after,.fd-quick-view__content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-quick-view__content .fd-form-item{gap:.25rem}.fd-quick-view__content .fd-bar{padding-block:0;padding-inline:0}.fd-quick-view__content .fd-bar--header-with-subheader{height:auto;-webkit-padding-after:.75rem;padding-block-end:.75rem}.fd-quick-view__content .fd-bar--header-with-subheader .fd-avatar{-webkit-margin-end:.75rem;margin-inline-end:.75rem}.fd-quick-view__content .fd-bar--header-with-subheader .fd-bar__left,.fd-quick-view__content .fd-bar--header-with-subheader .fd-bar__middle,.fd-quick-view__content .fd-bar--header-with-subheader .fd-bar__right{-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start}.fd-quick-view__subheader-text{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;gap:.25rem;-webkit-box-pack:center;-ms-flex-pack:center;height:100%;justify-content:center;max-width:100%;min-width:0}.fd-quick-view__subtitle{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapTile_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-quick-view__subtitle:after,.fd-quick-view__subtitle:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-quick-view .fd-input:not(input){border:none;height:auto;padding-block:0;padding-inline:0}.fd-dialog__body .fd-quick-view__content{padding-block:0}.fd-quick-view .fd-form-item{-webkit-padding-before:.75rem;padding-block-start:.75rem}.fd-quick-view .fd-form-item .fd-link{-ms-flex-item-align:start;align-self:flex-start}.fd-quick-view .fd-form-group__header+.fd-form-item{-webkit-padding-before:0;padding-block-start:0}.fd-quick-view .fd-title .fd-link{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;width:100%}.fd-popover__body .fd-quick-view__content{border-radius:var(--sapElement_BorderCornerRadius)}\n/*! Bundled license information:\n\nfundamental-styles/dist/quick-view.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-quick-view', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, template: "<div class=\"fd-quick-view\" [id]=\"id\">\n    <ng-content select=\"fd-quick-view-title\"></ng-content>\n\n    <div class=\"fd-quick-view__content\">\n        <ng-content select=\"fd-quick-view-subheader\"></ng-content>\n        <ng-content select=\"fd-quick-view-group\"></ng-content>\n    </div>\n</div>\n", styles: [".fd-form-group{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column}.fd-form-group:after,.fd-form-group:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group--inline{-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row wrap;flex-flow:row wrap;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start}.fd-form-group--with-spacing{gap:.625rem}.fd-form-group__header{border:0;-webkit-box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--sapGroup_TitleBackground);box-sizing:border-box;height:2.75rem;width:100%}.fd-form-group__header:after,.fd-form-group__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-form-group__header[class*=-compact],.fd-form-group__header[class*=-condensed],[class*=-compact] .fd-form-group__header:not([class*=-cozy]),[class*=-condensed] .fd-form-group__header:not([class*=-cozy]){height:2rem}.fd-form-group__header-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontFamily);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontSize);font-size:var(--sapFontHeader6Size);font-weight:400;font-weight:700;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-form-group__header-text:after,.fd-form-group__header-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-quick-view{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:inherit;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;min-width:20rem;padding-block:0;padding-inline:0}.fd-quick-view:after,.fd-quick-view:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-quick-view__content{background-color:var(--sapGroup_ContentBackground);border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-block:1rem;padding-inline:0;padding-inline:1rem}.fd-quick-view__content:after,.fd-quick-view__content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-quick-view__content .fd-form-item{gap:.25rem}.fd-quick-view__content .fd-bar{padding-block:0;padding-inline:0}.fd-quick-view__content .fd-bar--header-with-subheader{height:auto;-webkit-padding-after:.75rem;padding-block-end:.75rem}.fd-quick-view__content .fd-bar--header-with-subheader .fd-avatar{-webkit-margin-end:.75rem;margin-inline-end:.75rem}.fd-quick-view__content .fd-bar--header-with-subheader .fd-bar__left,.fd-quick-view__content .fd-bar--header-with-subheader .fd-bar__middle,.fd-quick-view__content .fd-bar--header-with-subheader .fd-bar__right{-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start}.fd-quick-view__subheader-text{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;gap:.25rem;-webkit-box-pack:center;-ms-flex-pack:center;height:100%;justify-content:center;max-width:100%;min-width:0}.fd-quick-view__subtitle{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapTile_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-quick-view__subtitle:after,.fd-quick-view__subtitle:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-quick-view .fd-input:not(input){border:none;height:auto;padding-block:0;padding-inline:0}.fd-dialog__body .fd-quick-view__content{padding-block:0}.fd-quick-view .fd-form-item{-webkit-padding-before:.75rem;padding-block-start:.75rem}.fd-quick-view .fd-form-item .fd-link{-ms-flex-item-align:start;align-self:flex-start}.fd-quick-view .fd-form-group__header+.fd-form-item{-webkit-padding-before:0;padding-block-start:0}.fd-quick-view .fd-title .fd-link{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;width:100%}.fd-popover__body .fd-quick-view__content{border-radius:var(--sapElement_BorderCornerRadius)}\n/*! Bundled license information:\n\nfundamental-styles/dist/quick-view.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], propDecorators: { id: [{
                type: Input
            }] } });

class QuickViewModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: QuickViewModule, imports: [QuickViewComponent,
            QuickViewTitleComponent,
            QuickViewSubheaderComponent,
            QuickViewSubheaderTitleComponent,
            QuickViewSubheaderSubtitleComponent,
            QuickViewGroupComponent,
            QuickViewGroupTitleComponent,
            QuickViewGroupItemComponent,
            QuickViewGroupItemLabelComponent,
            QuickViewGroupItemContentComponent,
            QuickViewGroupItemContentElementDirective], exports: [QuickViewComponent,
            QuickViewTitleComponent,
            QuickViewSubheaderComponent,
            QuickViewSubheaderTitleComponent,
            QuickViewSubheaderSubtitleComponent,
            QuickViewGroupComponent,
            QuickViewGroupTitleComponent,
            QuickViewGroupItemComponent,
            QuickViewGroupItemLabelComponent,
            QuickViewGroupItemContentComponent,
            QuickViewGroupItemContentElementDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewModule, imports: [QuickViewTitleComponent,
            QuickViewSubheaderComponent,
            QuickViewSubheaderTitleComponent,
            QuickViewGroupComponent,
            QuickViewGroupItemComponent,
            QuickViewGroupItemLabelComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: QuickViewModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        QuickViewComponent,
                        QuickViewTitleComponent,
                        QuickViewSubheaderComponent,
                        QuickViewSubheaderTitleComponent,
                        QuickViewSubheaderSubtitleComponent,
                        QuickViewGroupComponent,
                        QuickViewGroupTitleComponent,
                        QuickViewGroupItemComponent,
                        QuickViewGroupItemLabelComponent,
                        QuickViewGroupItemContentComponent,
                        QuickViewGroupItemContentElementDirective
                    ],
                    exports: [
                        QuickViewComponent,
                        QuickViewTitleComponent,
                        QuickViewSubheaderComponent,
                        QuickViewSubheaderTitleComponent,
                        QuickViewSubheaderSubtitleComponent,
                        QuickViewGroupComponent,
                        QuickViewGroupTitleComponent,
                        QuickViewGroupItemComponent,
                        QuickViewGroupItemLabelComponent,
                        QuickViewGroupItemContentComponent,
                        QuickViewGroupItemContentElementDirective
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { QuickViewComponent, QuickViewGroupComponent, QuickViewGroupItemComponent, QuickViewGroupItemContentComponent, QuickViewGroupItemContentElementDirective, QuickViewGroupItemLabelComponent, QuickViewGroupTitleComponent, QuickViewModule, QuickViewSubheaderComponent, QuickViewSubheaderSubtitleComponent, QuickViewSubheaderTitleComponent, QuickViewTitleComponent };
//# sourceMappingURL=fundamental-ngx-core-quick-view.mjs.map
