import { __decorate, __metadata } from 'tslib';
import * as i0 from '@angular/core';
import { HostBinding, Input, Directive, inject, ElementRef, EventEmitter, booleanAttribute, ViewChild, Output, ChangeDetectionStrategy, ViewEncapsulation, Component, NgModule } from '@angular/core';
import { applyCssClass } from '@fundamental-ngx/cdk/utils';
import { FD_DEFAULT_ICON_FONT_FAMILY, fdBuildIconClass } from '@fundamental-ngx/core/icon';

class NumericContentDirective {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
        /** @hidden */
        this.baseClass = true;
    }
    /**
     * @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return [
            'fd-numeric-content',
            this.size ? 'fd-numeric-content--' + this.size : '',
            this.class,
            this._isSmallTile() ? 'fd-numeric-content--small-tile' : ''
        ];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    _isSmallTile() {
        let retVal = false;
        if (this.elementRef.nativeElement.parentElement &&
            this.elementRef.nativeElement.parentElement.parentElement &&
            this.elementRef.nativeElement.parentElement.parentElement.classList.contains('fd-tile--s')) {
            retVal = true;
        }
        return retVal;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NumericContentDirective, isStandalone: true, selector: "[fd-numeric-content]", inputs: { class: "class", size: "size" }, host: { properties: { "class.fd-numeric-content": "this.baseClass" } }, usesOnChanges: true, ngImport: i0 }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], NumericContentDirective.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-numeric-content]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { class: [{
                type: Input
            }], size: [{
                type: Input
            }], baseClass: [{
                type: HostBinding,
                args: ['class.fd-numeric-content']
            }], buildComponentCssClass: [] } });
class NumericContentLaunchIconContainerDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentLaunchIconContainerDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NumericContentLaunchIconContainerDirective, isStandalone: true, selector: "[fd-numeric-content-launch-icon-container]", host: { properties: { "class.fd-numeric-content__launch-icon-container": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentLaunchIconContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-numeric-content-launch-icon-container]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-numeric-content__launch-icon-container']
            }] } });
class NumericContentLaunchIconDirective {
    constructor() {
        /** Glyph font family */
        this.glyphFont = FD_DEFAULT_ICON_FONT_FAMILY;
        /** @hidden */
        this.elementRef = inject(ElementRef);
    }
    /**
     * @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return [
            'fd-numeric-content__launch-icon',
            this.glyph ? fdBuildIconClass(this.glyphFont, this.glyph) : '',
            this.class
        ];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentLaunchIconDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NumericContentLaunchIconDirective, isStandalone: true, selector: "[fd-numeric-content-launch-icon]", inputs: { class: "class", glyph: "glyph", glyphFont: "glyphFont" }, usesOnChanges: true, ngImport: i0 }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], NumericContentLaunchIconDirective.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentLaunchIconDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-numeric-content-launch-icon]',
                    standalone: true
                }]
        }], propDecorators: { class: [{
                type: Input
            }], glyph: [{
                type: Input
            }], glyphFont: [{
                type: Input
            }], buildComponentCssClass: [] } });
class NumericContentKpiContainerDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentKpiContainerDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NumericContentKpiContainerDirective, isStandalone: true, selector: "[fd-numeric-content-kpi-container]", host: { properties: { "class.fd-numeric-content__kpi-container": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentKpiContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-numeric-content-kpi-container]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-numeric-content__kpi-container']
            }] } });
class NumericContentKpiDirective {
    constructor() {
        /** @hidden */
        this.elementRef = inject(ElementRef);
    }
    /**
     * @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return ['fd-numeric-content__kpi', this.state ? 'fd-numeric-content__kpi--' + this.state : '', this.class];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentKpiDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NumericContentKpiDirective, isStandalone: true, selector: "[fd-numeric-content-kpi]", inputs: { state: "state", class: "class", glyph: "glyph" }, usesOnChanges: true, ngImport: i0 }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], NumericContentKpiDirective.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentKpiDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-numeric-content-kpi]',
                    standalone: true
                }]
        }], propDecorators: { state: [{
                type: Input
            }], class: [{
                type: Input
            }], glyph: [{
                type: Input
            }], buildComponentCssClass: [] } });
class NumericContentScaleContainerDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentScaleContainerDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NumericContentScaleContainerDirective, isStandalone: true, selector: "[fd-numeric-content-scale-container]", host: { properties: { "class.fd-numeric-content__scale-container": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentScaleContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-numeric-content-scale-container]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-numeric-content__scale-container']
            }] } });
class NumericContentScaleArrowDirective {
    constructor() {
        /** Glyph font family */
        this.glyphFont = FD_DEFAULT_ICON_FONT_FAMILY;
        /** @hidden */
        this.elementRef = inject(ElementRef);
    }
    /** @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return [
            'fd-numeric-content__scale-arrow',
            this.glyph ? fdBuildIconClass(this.glyphFont, this.glyph) : '',
            this.class
        ];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentScaleArrowDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NumericContentScaleArrowDirective, isStandalone: true, selector: "[fd-numeric-content-scale-arrow]", inputs: { class: "class", glyph: "glyph", glyphFont: "glyphFont" }, usesOnChanges: true, ngImport: i0 }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], NumericContentScaleArrowDirective.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentScaleArrowDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-numeric-content-scale-arrow]',
                    standalone: true
                }]
        }], propDecorators: { class: [{
                type: Input
            }], glyph: [{
                type: Input
            }], glyphFont: [{
                type: Input
            }], buildComponentCssClass: [] } });
class NumericContentScaleDirective {
    constructor() {
        /** @hidden */
        this.elementRef = inject(ElementRef);
    }
    /**
     * @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return ['fd-numeric-content__scale', this.state ? 'fd-numeric-content__scale--' + this.state : '', this.class];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentScaleDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NumericContentScaleDirective, isStandalone: true, selector: "[fd-numeric-content-scale]", inputs: { state: "state", class: "class" }, usesOnChanges: true, ngImport: i0 }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], NumericContentScaleDirective.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentScaleDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-numeric-content-scale]',
                    standalone: true
                }]
        }], propDecorators: { state: [{
                type: Input
            }], class: [{
                type: Input
            }], buildComponentCssClass: [] } });
class NumericContentScaleTextDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentScaleTextDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: NumericContentScaleTextDirective, isStandalone: true, selector: "[fd-numeric-content-scale-text]", host: { properties: { "class.fd-numeric-content__scale-text": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: NumericContentScaleTextDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-numeric-content-scale-text]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-numeric-content__scale-text']
            }] } });

class TileContentDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
        /** Divides the tile content in to two columns. */
        this.twoColumn = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileContentDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileContentDirective, isStandalone: true, selector: "[fdTileContent], [fd-tile-content]", inputs: { twoColumn: "twoColumn" }, host: { properties: { "class.fd-tile__content": "this.baseClass", "class.fd-tile__content--2-col": "this.twoColumn" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileContentDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileContent], [fd-tile-content]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__content']
            }], twoColumn: [{
                type: HostBinding,
                args: ['class.fd-tile__content--2-col']
            }, {
                type: Input
            }] } });
class TileContentTextDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileContentTextDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileContentTextDirective, isStandalone: true, selector: "[fdTileContentText], [fd-tile-content-text]", host: { properties: { "class.fd-tile__content-text": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileContentTextDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileContentText], [fd-tile-content-text]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__content-text']
            }] } });
class TileFooterDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
        /** Divides the tile footer in to two columns. */
        this.twoColumn = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileFooterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileFooterDirective, isStandalone: true, selector: "[fdTileFooter], [fd-tile-footer]", inputs: { twoColumn: "twoColumn" }, host: { properties: { "class.fd-tile__footer": "this.baseClass", "class.fd-tile__footer--2-col": "this.twoColumn" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileFooterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileFooter], [fd-tile-footer]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__footer']
            }], twoColumn: [{
                type: HostBinding,
                args: ['class.fd-tile__footer--2-col']
            }, {
                type: Input
            }] } });
class TileFooterTextDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileFooterTextDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileFooterTextDirective, isStandalone: true, selector: "[fdTileFooterText], [fd-tile-footer-text]", host: { properties: { "class.fd-tile__footer-text": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileFooterTextDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileFooterText], [fd-tile-footer-text]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__footer-text']
            }] } });
class TileHeaderDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
        /** Divides the tile header in to two columns. */
        this.twoColumn = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileHeaderDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileHeaderDirective, isStandalone: true, selector: "[fdTileHeader], [fd-tile-header]", inputs: { twoColumn: "twoColumn" }, host: { properties: { "class.fd-tile__header": "this.baseClass", "class.fd-tile__header--2-col": "this.twoColumn" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileHeaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileHeader], [fd-tile-header]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__header']
            }], twoColumn: [{
                type: HostBinding,
                args: ['class.fd-tile__header--2-col']
            }, {
                type: Input
            }] } });
class TileHeaderContentDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileHeaderContentDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileHeaderContentDirective, isStandalone: true, selector: "[fdTileHeaderContent], [fd-tile-header-content]", host: { properties: { "class.fd-tile__header-content": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileHeaderContentDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileHeaderContent], [fd-tile-header-content]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__header-content']
            }] } });
class TileSectionDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileSectionDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileSectionDirective, isStandalone: true, selector: "[fdTileSection], [fd-tile-section]", host: { properties: { "class.fd-tile__section": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileSectionDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileSection], [fd-tile-section]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__section']
            }] } });
class TileSubtitleDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileSubtitleDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileSubtitleDirective, isStandalone: true, selector: "[fdTileTitle], [fd-tile-subtitle]", host: { properties: { "class.fd-tile__subtitle": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileSubtitleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileTitle], [fd-tile-subtitle]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__subtitle']
            }] } });
class TileTitleDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileTitleDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileTitleDirective, isStandalone: true, selector: "[fdTileTitle], [fd-tile-title]", host: { properties: { "class.fd-tile__title": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileTitleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileTitle], [fd-tile-title]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__title']
            }] } });
class TileTitleContainerDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileTitleContainerDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileTitleContainerDirective, isStandalone: true, selector: "[fdTileTitleContainer], [fd-tile-title-container]", host: { properties: { "class.fd-tile__title-container": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileTitleContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileTitleContainer], [fd-tile-title-container]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__title-container']
            }] } });
class TileRefreshDirective {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
        /** Glyph font family */
        this.glyphFont = FD_DEFAULT_ICON_FONT_FAMILY;
        /** Apply user custom styles */
        this.ariaLabel = 'Refresh';
    }
    /** @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return ['fd-tile__refresh', this.glyph ? fdBuildIconClass(this.glyphFont, this.glyph) : '', this.class];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileRefreshDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileRefreshDirective, isStandalone: true, selector: "[fdTileRefresh], [fd-tile-refresh]", inputs: { glyph: "glyph", glyphFont: "glyphFont", class: "class", ariaLabel: "ariaLabel" }, host: { properties: { "attr.aria-label": "this.ariaLabel" } }, usesOnChanges: true, ngImport: i0 }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], TileRefreshDirective.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileRefreshDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileRefresh], [fd-tile-refresh]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { glyph: [{
                type: Input
            }], glyphFont: [{
                type: Input
            }], class: [{
                type: Input
            }], ariaLabel: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['attr.aria-label']
            }], buildComponentCssClass: [] } });
let profileTileUniqueId = 0;
class TileProfileImgDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
        /** Id of the tile. */
        this.id = `fd-profileTile-${profileTileUniqueId++}`;
    }
    /** @hidden */
    get image() {
        return 'url(' + this.backgroundImage + ')';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileProfileImgDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileProfileImgDirective, isStandalone: true, selector: "[fdTileProfileImg], [fd-tile-profile-img]", inputs: { id: "id", ariaLabel: "ariaLabel", ariaLabelledby: "ariaLabelledby", backgroundImage: "backgroundImage" }, host: { attributes: { "attr.role": "img" }, properties: { "class.fd-tile__profile-img": "this.baseClass", "attr.id": "this.id", "attr.aria-label": "this.ariaLabel", "attr.aria-labelledby": "this.ariaLabelledby", "style.background-image": "this.image" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileProfileImgDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileProfileImg], [fd-tile-profile-img]',
                    host: {
                        'attr.role': 'img'
                    },
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__profile-img']
            }], id: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['attr.id']
            }], ariaLabel: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['attr.aria-label']
            }], ariaLabelledby: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['attr.aria-labelledby']
            }], backgroundImage: [{
                type: Input
            }], image: [{
                type: HostBinding,
                args: ['style.background-image']
            }] } });
class TileLogoDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileLogoDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileLogoDirective, isStandalone: true, selector: "[fdTileLogo], [fd-tile-logo]", host: { properties: { "class.fd-tile__logo": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileLogoDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileLogo], [fd-tile-logo]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__logo']
            }] } });
class TileToggleDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileToggleDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileToggleDirective, isStandalone: true, selector: "[fdTileToggle], [fd-tile-toggle]", host: { properties: { "class.fd-tile__toggle": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileToggleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileToggle], [fd-tile-toggle]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__toggle']
            }] } });
class TileContainerDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
        /** Whether or not the container is a 'list' type (used on screens smaller than 450px). */
        this.list = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileContainerDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileContainerDirective, isStandalone: true, selector: "[fdTileContainer], [fd-tile-container]", inputs: { list: "list" }, host: { properties: { "class.fd-tile-container": "this.baseClass", "class.fd-tile-container--list": "this.list" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileContainer], [fd-tile-container]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile-container']
            }], list: [{
                type: HostBinding,
                args: ['class.fd-tile-container--list']
            }, {
                type: Input
            }] } });
class TileBackgroundImgDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    /** @hidden */
    get image() {
        return 'url(' + this.backgroundImage + ')';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileBackgroundImgDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileBackgroundImgDirective, isStandalone: true, selector: "[fdTileBackgroundImg], [fd-tile-background-img]", inputs: { backgroundImage: "backgroundImage" }, host: { properties: { "class.fd-tile__background-img": "this.baseClass", "style.background-image": "this.image" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileBackgroundImgDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileBackgroundImg], [fd-tile-background-img]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__background-img']
            }], backgroundImage: [{
                type: Input
            }], image: [{
                type: HostBinding,
                args: ['style.background-image']
            }] } });
class TilePageIndicatorDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TilePageIndicatorDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TilePageIndicatorDirective, isStandalone: true, selector: "[fdTilePageIndicator], [fd-tile-page-indicator]", host: { properties: { "class.fd-tile__page-indicator": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TilePageIndicatorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTilePageIndicator], [fd-tile-page-indicator]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__page-indicator']
            }] } });
class TileActionCloseDirective {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
    }
    /** @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return ['fd-tile__action-close', this.class];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
        this._addCloseIcon();
    }
    /** @hidden */
    _addCloseIcon() {
        const element = generateIcon('decline');
        this.elementRef.nativeElement.appendChild(element);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileActionCloseDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileActionCloseDirective, isStandalone: true, selector: "[fdTileActionClose], [fd-tile-action-close]", inputs: { class: "class" }, usesOnChanges: true, ngImport: i0 }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], TileActionCloseDirective.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileActionCloseDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileActionClose], [fd-tile-action-close]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { class: [{
                type: Input
            }], buildComponentCssClass: [] } });
class TileActionIndicatorDirective {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
    }
    /** @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return ['fd-tile__action-indicator', this.class];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
        this._addIndicatorIcon();
    }
    /** @hidden */
    _addIndicatorIcon() {
        const element = generateIcon('overflow');
        this.elementRef.nativeElement.appendChild(element);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileActionIndicatorDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileActionIndicatorDirective, isStandalone: true, selector: "[fdTileActionIndicator], [fd-tile-action-indicator]", inputs: { class: "class" }, usesOnChanges: true, ngImport: i0 }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], TileActionIndicatorDirective.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileActionIndicatorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileActionIndicator], [fd-tile-action-indicator]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { class: [{
                type: Input
            }], buildComponentCssClass: [] } });
class TileActionContainerDirective {
    constructor() {
        /** @hidden */
        this.baseClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileActionContainerDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: TileActionContainerDirective, isStandalone: true, selector: "[fdTileActionContainer], [fd-tile-action-container]", host: { properties: { "class.fd-tile__action-container": "this.baseClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileActionContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdTileActionContainer], [fd-tile-action-container]',
                    standalone: true
                }]
        }], propDecorators: { baseClass: [{
                type: HostBinding,
                args: ['class.fd-tile__action-container']
            }] } });
function generateIcon(iconName) {
    const element = document.createElement('i');
    element.setAttribute('role', 'presentation');
    element.classList.add(`sap-icon--${iconName}`);
    return element;
}

class TileComponent {
    constructor() {
        /** Optional 'double' modifier to double the tile width. */
        this.double = false;
        /** Whether or not the tile is in 'action' mode. */
        this.action = false;
        /** Whether tile is focusable & clickable, (tileClick) event will be emitted on click. */
        this.clickable = false;
        /** Whether tile gets clicked or space/enter pressed. */
        this.tileClick = new EventEmitter();
    }
    /** @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return [
            'fd-tile',
            this.size ? 'fd-tile--' + this.size : '',
            this.double ? 'fd-tile--double' : '',
            this.type ? 'fd-tile--' + this.type : '',
            this.action ? 'fd-tile--action' : '',
            this.class
        ];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngAfterViewInit() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    get elementRef() {
        return this.ref;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: TileComponent, isStandalone: true, selector: "fd-tile", inputs: { class: "class", size: "size", double: "double", type: "type", action: "action", clickable: ["clickable", "clickable", booleanAttribute] }, outputs: { tileClick: "tileClick" }, viewQueries: [{ propertyName: "ref", first: true, predicate: ["container"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div\n    class=\"fd-tile\"\n    #container\n    [attr.tabindex]=\"clickable ? 0 : -1\"\n    (click)=\"clickable && tileClick.emit()\"\n    (keyup.enter)=\"clickable && tileClick.emit()\"\n    (keydown.space)=\"clickable && $event.preventDefault()\"\n    (keyup.space)=\"clickable && tileClick.emit()\"\n>\n    @if (action) {\n        <div class=\"fd-tile__overlay\"></div>\n    }\n    <ng-content select=\"[fd-tile-action-close]\"></ng-content>\n    <ng-content select=\"[fd-tile-action-indicator]\"></ng-content>\n    <ng-content select=\"[fd-badge]\"></ng-content>\n    <ng-content select=\"[fd-tile-header]\"></ng-content>\n    <ng-content select=\"[fd-tile-header-content]\"></ng-content>\n    <ng-content select=\"[fd-tile-content]\"></ng-content>\n    <ng-content select=\"[fd-tile-footer]\"></ng-content>\n    <ng-content select=\"[fd-tile-action-container]\"></ng-content>\n    <ng-content></ng-content>\n</div>\n", styles: [".fd-tile{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:11rem;line-height:normal;margin-block:0;margin-inline:0;max-height:11rem;max-width:11rem;min-height:11rem;min-width:11rem;padding-block:0;padding-inline:0;width:11rem;--fdGenericTileLineTileHeight:2rem;--fdGenericTileLineTileMaxHeight:3.25rem;--fdGenericTileLineHeight:1.625rem;--fdGenericTileTitleHorizontalSpacing:.625rem;background:var(--sapTile_Background);border:var(--fdTile_Border);border-radius:var(--sapElement_BorderCornerRadius);-webkit-box-shadow:var(--sapContent_Shadow0);box-shadow:var(--sapContent_Shadow0);cursor:pointer;padding-block:.9375rem;padding-inline:.9375rem;position:relative}.fd-tile:after,.fd-tile:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile[class*=-compact],.fd-tile[class*=-condensed],[class*=-compact] .fd-tile:not([class*=-cozy]),[class*=-condensed] .fd-tile:not([class*=-cozy]){--fdGenericTileLineTileHeight:1.625rem;--fdGenericTileLineTileMaxHeight:2.875rem;--fdGenericTileLineHeight:1.4375rem;--fdGenericTileTitleHorizontalSpacing:.5rem}.fd-tile.is-active,.fd-tile:active{background:var(--sapTile_Active_Background);border:.0625rem solid var(--sapTile_Interactive_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-tile.is-hover,.fd-tile:hover{background:var(--sapTile_Hover_Background);border:var(--fdTile_Hover_Border);-webkit-box-shadow:var(--fdTile_Hover_Box_Shadow);box-shadow:var(--fdTile_Hover_Box_Shadow)}.fd-tile__content,.fd-tile__footer,.fd-tile__header,.fd-tile__header-content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0}.fd-tile__content:after,.fd-tile__content:before,.fd-tile__footer:after,.fd-tile__footer:before,.fd-tile__header-content:after,.fd-tile__header-content:before,.fd-tile__header:after,.fd-tile__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile__content--2-col,.fd-tile__footer--2-col,.fd-tile__header--2-col,.fd-tile__header-content--2-col{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between}.fd-tile__header{height:3.625rem;max-height:3.625rem;min-height:3.625rem}.fd-tile__content,.fd-tile__header{-webkit-margin-after:.25rem;margin-block-end:.25rem}.fd-tile__content{height:3.875rem;max-height:3.875rem;min-height:3.875rem}.fd-tile__header-content{height:7.75rem;max-height:7.75rem;min-height:7.75rem;-webkit-margin-after:.25rem;margin-block-end:.25rem}.fd-tile__header-content .fd-tile__title{display:-webkit-box;-webkit-line-clamp:4;-webkit-box-orient:vertical;overflow:hidden}.fd-tile__footer{display:-webkit-box;display:-ms-flexbox;display:flex;height:1rem;max-height:1rem;min-height:1rem}.fd-tile__section{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:100%;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;width:calc(50% - .125rem)}.fd-tile__section:after,.fd-tile__section:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile__footer-text,.fd-tile__subtitle,.fd-tile__title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapTile_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-tile__footer-text:after,.fd-tile__footer-text:before,.fd-tile__subtitle:after,.fd-tile__subtitle:before,.fd-tile__title:after,.fd-tile__title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile__title{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;color:var(--sapTile_TitleTextColor);font-size:var(--fdTile_Title_Font_Size);font-weight:var(--fdTile_Title_Font_Weight);overflow:hidden}.fd-tile__footer-text,.fd-tile__subtitle{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-tile__refresh [class*=sap-icon],.fd-tile__refresh[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;display:-webkit-box;display:-ms-flexbox;display:flex;font-size:inherit;line-height:1;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-margin-end:.5rem;color:var(--sapButton_IconColor);font-size:var(--sapFontSize);line-height:normal;margin-inline-end:.5rem;min-width:.875rem;text-align:center}.fd-tile__profile-img{border:0;border-radius:50%;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:3.5rem;line-height:normal;margin-block:0;margin-inline:0;max-height:3.5rem;max-width:3.5rem;min-height:3.5rem;min-width:3.5rem;padding-block:0;padding-inline:0;width:3.5rem}.fd-tile__profile-img:after,.fd-tile__profile-img:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile__logo{height:1.75rem;max-height:1.75rem;max-width:3.625rem;min-height:1.75rem;min-width:3.625rem;width:3.625rem}.fd-tile__action-close,.fd-tile__action-indicator,.fd-tile__overlay{display:none}.fd-tile--double{max-width:22.5rem;min-width:22.5rem;width:22.5rem}.fd-tile--s{height:9.25rem;max-height:9.25rem;max-width:9.25rem;min-height:9.25rem;min-width:9.25rem;padding-block:.4375rem;padding-inline:.4375rem;width:9.25rem}.fd-tile--s.fd-tile--double{max-width:19rem;min-width:19rem;width:19rem}.fd-tile--s .fd-tile__header{height:3.25rem;max-height:3.25rem;min-height:3.25rem}.fd-tile--s .fd-tile__content{height:3.438rem;max-height:3.438rem;min-height:3.438rem}.fd-tile--s .fd-tile__header-content{height:6.938rem;max-height:6.938rem;min-height:6.938rem}.fd-tile--s .fd-tile__footer{height:1.063rem;max-height:1.063rem;min-height:1.063rem}.fd-tile--s .fd-tile__title{font-size:var(--sapFontHeader6Size)}.fd-tile--s .fd-tile__footer-text{font-size:var(--sapFontSmallSize)}.fd-tile--s .fd-tile__profile-img{height:3rem;max-height:3rem;max-width:3rem;min-height:3rem;min-width:3rem;width:3rem}.fd-tile--s .fd-tile__logo{height:1.438rem;max-height:1.438rem;max-width:3rem;min-height:1.438rem;min-width:3rem;width:3rem}.fd-tile--feed .fd-tile__content,.fd-tile--feed .fd-tile__content--2-col .fd-tile__section,.fd-tile--kpi .fd-tile__content,.fd-tile--kpi .fd-tile__content--2-col .fd-tile__section,.fd-tile--launch .fd-tile__content,.fd-tile--launch .fd-tile__content--2-col .fd-tile__section{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end}.fd-tile--feed .fd-tile__footer,.fd-tile--feed .fd-tile__footer--2-col .fd-tile__section,.fd-tile--kpi .fd-tile__footer,.fd-tile--kpi .fd-tile__footer--2-col .fd-tile__section,.fd-tile--launch .fd-tile__footer,.fd-tile--launch .fd-tile__footer--2-col .fd-tile__section{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-tile--feed .fd-tile__footer--2-col .fd-tile__section:last-child,.fd-tile--kpi .fd-tile__footer--2-col .fd-tile__section:last-child,.fd-tile--launch .fd-tile__footer--2-col .fd-tile__section:last-child{-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end}.fd-tile--feed .fd-tile__content .fd-tile__section{width:auto}.fd-tile--feed .fd-tile__content .fd-tile__section:first-child{-webkit-margin-end:.25rem;display:-webkit-box;display:-ms-flexbox;display:flex;margin-inline-end:.25rem;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-flex:1;-ms-flex:1;flex:1;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start;-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end;max-width:100%}.fd-tile--feed .fd-tile__content .fd-tile__section:nth-child(2){-webkit-padding-start:.5rem;max-width:10.25rem;padding-inline-start:.5rem}.fd-tile--feed .fd-tile__content-byline,.fd-tile--feed .fd-tile__content-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapTile_TitleTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:var(--sapFontSmallSize);font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1.063rem;margin-block:0;margin-inline:0;max-width:100%;padding-block:0;padding-inline:0}.fd-tile--feed .fd-tile__content-byline:after,.fd-tile--feed .fd-tile__content-byline:before,.fd-tile--feed .fd-tile__content-text:after,.fd-tile--feed .fd-tile__content-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--feed .fd-tile__content-text{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;max-height:2.125rem;overflow:hidden}.fd-tile--feed .fd-tile__content-byline{color:var(--sapTile_TextColor);overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-tile--feed.fd-tile--s .fd-tile__content .fd-tile__section:nth-child(2){max-width:8.25rem}.fd-tile--slide{display:-webkit-box;display:-ms-flexbox;display:flex;padding-block:0;padding-inline:0;-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end}.fd-tile--slide .fd-tile__background-img{background-size:cover;border:0;border-radius:var(--sapElement_BorderCornerRadius);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:100%;inset:0;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;position:absolute;width:100%}.fd-tile--slide .fd-tile__background-img:after,.fd-tile--slide .fd-tile__background-img:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--slide .fd-tile__background-img.is-hover,.fd-tile--slide .fd-tile__background-img:hover{opacity:.9}.fd-tile--slide .fd-tile__background-img.is-active,.fd-tile--slide .fd-tile__background-img:active{opacity:.8}.fd-tile--slide .fd-tile__toggle{background:transparent;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:none;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:3rem;line-height:normal;margin-block:0;margin-inline:0;max-height:3rem;max-width:3rem;min-height:3rem;min-width:3rem;padding-block:0;padding-block:.5rem;padding-inline:0;padding-inline:.5rem;position:absolute;right:-.0625rem;top:-.0625rem;width:3rem}.fd-tile--slide .fd-tile__toggle:after,.fd-tile--slide .fd-tile__toggle:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--slide .fd-tile__toggle[dir=rtl],[dir=rtl] .fd-tile--slide .fd-tile__toggle{left:-.0625rem;right:auto}.fd-tile--slide .fd-tile__toggle:before{display:-webkit-box;display:-ms-flexbox;display:flex;height:2rem;max-height:2rem;max-width:2rem;min-height:2rem;min-width:2rem;width:2rem;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--sapBlockLayer_Background);border-radius:50%;color:var(--sapButton_Emphasized_TextColor);content:\"\\e14b\";font-family:SAP-icons;font-size:1rem;opacity:.6;text-shadow:var(--sapButton_Emphasized_TextShadow)}.fd-tile--slide .fd-tile__toggle--pause:before{content:\"\\e14c\"}.fd-tile--slide .fd-tile__toggle.is-focus,.fd-tile--slide .fd-tile__toggle:focus{outline:none;z-index:5}.fd-tile--slide .fd-tile__toggle.is-hover:before,.fd-tile--slide .fd-tile__toggle:hover:before{opacity:.8}.fd-tile--slide .fd-tile__toggle.is-active:before,.fd-tile--slide .fd-tile__toggle:active:before{opacity:1}.fd-tile--slide .fd-tile__container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:6.125rem;line-height:normal;margin-block:0;margin-inline:0;max-height:6.125rem;min-height:6.125rem;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-pack:justify;-ms-flex-pack:justify;background-color:var(--fdSlide_Tile_Background_Color);justify-content:space-between;max-width:100%;opacity:var(--fdSlide_Tile_Background_Opacity);width:100%;z-index:2;-webkit-padding-before:.25rem;border-bottom-left-radius:var(--sapElement_BorderCornerRadius);border-bottom-right-radius:var(--sapElement_BorderCornerRadius);padding-block-start:.25rem;padding-inline:.9375rem}.fd-tile--slide .fd-tile__container:after,.fd-tile--slide .fd-tile__container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--slide .fd-tile__title{font-weight:var(--fdSlide_Tile_Title_Font_Weight);text-shadow:var(--fdSlide_Tile_Title_Text_Shadow)}.fd-tile--slide .fd-tile__footer-text,.fd-tile--slide .fd-tile__subtitle,.fd-tile--slide .fd-tile__title{color:var(--fdSlide_Tile_Title_Color);font-size:var(--sapFontSize);line-height:normal}.fd-tile--slide .fd-tile__page-indicator{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;height:.5rem;max-height:.5rem;min-height:.5rem;-webkit-margin-after:.125rem;margin-block-end:.125rem;margin-top:.375rem}.fd-tile--slide .fd-tile__page-indicator:after,.fd-tile--slide .fd-tile__page-indicator:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--slide .fd-tile__dot{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:var(--fdSlide_Tile_Indicator_Dot_Size);line-height:normal;margin-block:0;margin-inline:0;max-height:var(--fdSlide_Tile_Indicator_Dot_Size);max-width:var(--fdSlide_Tile_Indicator_Dot_Size);min-height:var(--fdSlide_Tile_Indicator_Dot_Size);min-width:var(--fdSlide_Tile_Indicator_Dot_Size);padding-block:0;padding-inline:0;width:var(--fdSlide_Tile_Indicator_Dot_Size);-webkit-margin-end:var(--fdSlide_Tile_Indicator_Dot_Spacing);background-color:var(--fdSlide_Tile_Indicator_Dot_Color);border:var(--fdSlide_Tile_Indicator_Dot_Border);border-radius:50%;-webkit-box-shadow:var(--fdSlide_Tile_Indicator_Dot_Shadow);box-shadow:var(--fdSlide_Tile_Indicator_Dot_Shadow);margin-inline-end:var(--fdSlide_Tile_Indicator_Dot_Spacing);opacity:var(--fdSlide_Tile_Indicator_Dot_Opacity)}.fd-tile--slide .fd-tile__dot:after,.fd-tile--slide .fd-tile__dot:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--slide .fd-tile__dot--active{background-color:var(--fdSlide_Tile_Indicator_Active_Dot_Color);border:var(--fdSlide_Tile_Indicator_Active_Dot_Border);height:var(--fdSlide_Tile_Indicator_Ative_Dot_Size);max-height:var(--fdSlide_Tile_Indicator_Ative_Dot_Size);max-width:var(--fdSlide_Tile_Indicator_Ative_Dot_Size);min-height:var(--fdSlide_Tile_Indicator_Ative_Dot_Size);min-width:var(--fdSlide_Tile_Indicator_Ative_Dot_Size);width:var(--fdSlide_Tile_Indicator_Ative_Dot_Size)}.fd-tile--slide .fd-tile__dot:last-child{margin-block:0;margin-inline:0}.fd-tile--slide.fd-tile--s .fd-tile__container{height:5.25rem;max-height:5.25rem;min-height:5.25rem;-webkit-padding-before:.1875rem;padding-block-start:.1875rem;padding-inline:.4375rem}.fd-tile--slide.fd-tile--s .fd-tile__footer-text,.fd-tile--slide.fd-tile--s .fd-tile__subtitle,.fd-tile--slide.fd-tile--s .fd-tile__title{font-size:var(--sapFontSmallSize)}.fd-tile--slide.fd-tile--s .fd-tile__page-indicator{margin-block:0}.fd-tile--action .fd-tile__action-close,.fd-tile--action .fd-tile__action-indicator,.fd-tile--action .fd-tile__overlay{display:block}.fd-tile--action .fd-tile__overlay{background:var(--sapTile_Background);border:0;border-radius:var(--sapElement_BorderCornerRadius);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:100%;inset:0;line-height:normal;margin-block:0;margin-inline:0;opacity:.7;padding-block:0;padding-inline:0;position:absolute;width:100%;z-index:4}.fd-tile--action .fd-tile__overlay:after,.fd-tile--action .fd-tile__overlay:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--action .fd-badge,.fd-tile--action .fd-tile__footer{display:none}.fd-tile--action .fd-tile__action-close{display:-webkit-box;display:-ms-flexbox;display:flex;height:auto;max-height:none;max-width:none;min-height:auto;min-width:auto;width:auto;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start;-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end;padding-block:0;padding-inline:0;position:absolute;right:-.375rem;top:-.375rem;z-index:5}.fd-tile--action .fd-tile__action-close[dir=rtl],[dir=rtl] .fd-tile--action .fd-tile__action-close{left:-.375rem;right:auto}.fd-tile--action .fd-tile__action-close [class*=sap-icon],.fd-tile--action .fd-tile__action-close[class*=sap-icon]{background:inherit;background:var(--sapButton_Background);border:.0625rem solid var(--sapButton_BorderColor);border-radius:inherit;border-radius:50%;-webkit-box-sizing:border-box;box-sizing:border-box;color:inherit;color:var(--sapButton_IconColor);font-size:inherit;font-size:.75rem;height:1.375rem;line-height:1;max-height:1.375rem;max-width:1.375rem;min-height:1.375rem;min-width:1.375rem;width:1.375rem}.fd-tile--action .fd-tile__action-close [class*=sap-icon]:before,.fd-tile--action .fd-tile__action-close[class*=sap-icon]:before{line-height:1.25rem}.fd-tile--action .fd-tile__action-close.is-focus,.fd-tile--action .fd-tile__action-close:focus{outline:none;z-index:5}.fd-tile--action .fd-tile__action-close.is-focus:after,.fd-tile--action .fd-tile__action-close:focus:after{border:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);border-radius:var(--fdButton_Focus_Border_Radius);content:\"\";display:block;inset:-.0625rem;position:absolute}.fd-tile--action .fd-tile__action-close.is-focus.fd-button--toggled:after,.fd-tile--action .fd-tile__action-close.is-focus.is-selected:after,.fd-tile--action .fd-tile__action-close:focus.fd-button--toggled:after,.fd-tile--action .fd-tile__action-close:focus.is-selected:after{border-color:var(--fdButton_Outline_Contrast)}.fd-tile--action .fd-tile__action-close::-moz-focus-inner{border:0}.fd-tile--action .fd-tile__action-indicator{bottom:0;position:absolute;right:0;-webkit-margin-after:.25rem;margin-block-end:.25rem;-webkit-margin-end:.25rem;margin-inline-end:.25rem;z-index:5}.fd-tile--action .fd-tile__action-indicator[dir=rtl],[dir=rtl] .fd-tile--action .fd-tile__action-indicator{left:0;right:auto}.fd-tile--action .fd-tile__action-indicator [class*=sap-icon],.fd-tile--action .fd-tile__action-indicator[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;display:-webkit-box;display:-ms-flexbox;display:flex;font-size:inherit;line-height:1;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapButton_IconColor);font-size:1rem}.fd-tile--action .fd-tile__action-close.is-active,.fd-tile--action .fd-tile__action-close.is-hover,.fd-tile--action .fd-tile__action-close:active,.fd-tile--action .fd-tile__action-close:hover,.fd-tile--action .fd-tile__action-indicator.is-active,.fd-tile--action .fd-tile__action-indicator.is-hover,.fd-tile--action .fd-tile__action-indicator:active,.fd-tile--action .fd-tile__action-indicator:hover{background:transparent;border-color:transparent}.fd-tile--action.fd-tile--slide .fd-tile__action-indicator [class*=sap-icon],.fd-tile--action.fd-tile--slide .fd-tile__action-indicator[class*=sap-icon]{color:var(--sapShell_Active_TextColor)}.fd-tile-container{background-color:var(--sapTile_Background);border:0;border:.0625rem solid var(--sapTile_BorderColor);border-radius:var(--sapElement_BorderCornerRadius);-webkit-box-shadow:var(--sapContent_Shadow0);box-shadow:var(--sapContent_Shadow0);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-block:.5rem;padding-inline:0;padding-inline:.5rem;width:100%}.fd-tile-container:after,.fd-tile-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile-container--list{-webkit-box-orient:vertical;-webkit-box-direction:normal;background-color:var(--sapGroup_ContentBackground);-ms-flex-direction:column;flex-direction:column}.fd-tile-container--list .fd-tile--line{-ms-flex-wrap:wrap;flex-wrap:wrap;margin-inline:0;max-height:var(--fdGenericTileLineTileMaxHeight)}.fd-tile-container--list .fd-tile--action .fd-tile__header{-webkit-mask-image:-webkit-gradient(linear,left top,left bottom,from(linear),color-stop(top,right),color-stop(top,left),color-stop(from(transparent)),color-stop(color-stop(7%,#000)),to(to(#000)));-webkit-mask-image:linear-gradient(linear,right top,left top,from(transparent),color-stop(7%,#000),to(#000));mask-image:-webkit-gradient(linear,left top,left bottom,from(linear),color-stop(top,right),color-stop(top,left),color-stop(from(transparent)),color-stop(color-stop(7%,#000)),to(to(#000)));mask-image:linear-gradient(linear,right top,left top,from(transparent),color-stop(7%,#000),to(#000));-webkit-mask-image:-webkit-gradient(linear,right top,left top,from(transparent),color-stop(7%,#000),to(#000));mask-image:-webkit-gradient(linear,right top,left top,from(transparent),color-stop(7%,#000),to(#000))}.fd-tile-container--list .fd-tile--action .fd-tile__header[dir=rtl],[dir=rtl] .fd-tile-container--list .fd-tile--action .fd-tile__header{-webkit-mask-image:-webkit-gradient(linear,left top,left bottom,from(linear),color-stop(top,left),color-stop(top,right),color-stop(from(transparent)),color-stop(color-stop(7%,#000)),to(to(#000)));-webkit-mask-image:linear-gradient(linear,left top,right top,from(transparent),color-stop(7%,#000),to(#000));mask-image:-webkit-gradient(linear,left top,left bottom,from(linear),color-stop(top,left),color-stop(top,right),color-stop(from(transparent)),color-stop(color-stop(7%,#000)),to(to(#000)));mask-image:linear-gradient(linear,left top,right top,from(transparent),color-stop(7%,#000),to(#000));-webkit-mask-image:-webkit-gradient(linear,left top,right top,from(transparent),color-stop(7%,#000),to(#000));mask-image:-webkit-gradient(linear,left top,right top,from(transparent),color-stop(7%,#000),to(#000))}.fd-tile-container--list .fd-tile__header{-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-box-flex:1;-ms-flex:1;flex:1}.fd-tile--line{display:-webkit-box;display:-ms-flexbox;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between;margin-block:.25rem;-webkit-margin-end:.5rem;background:var(--fdTile_Background,var(--sapTile_Background));border:.0625rem solid var(--fdTile_Border,var(--sapTile_BorderColor));border-radius:var(--sapTile_BorderCornerRadius);-webkit-box-shadow:var(--fdTile_Box_Shadow,var(--sapContent_Shadow0));box-shadow:var(--fdTile_Box_Shadow,var(--sapContent_Shadow0));display:flex;height:100%;margin-inline-end:.5rem;max-height:var(--fdGenericTileLineTileHeight);max-width:100%;min-height:var(--fdGenericTileLineTileHeight);min-width:2rem;padding-block:0;padding-inline:.5rem;width:auto;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;gap:.5rem}.fd-tile--line.is-hover,.fd-tile--line:hover{border-radius:var(--sapTile_BorderCornerRadius);--fdTile_Box_Shadow:var(--sapContent_Shadow2);--fdTile_Background:var(--sapTile_Hover_Background)}.fd-tile--line.is-active,.fd-tile--line:active{--fdTile_Background:var(--sapTile_Active_Background)}.fd-tile--line.is-focus,.fd-tile--line:focus{outline:.125rem solid var(--sapContent_FocusColor);outline-offset:-.125rem;z-index:5}.fd-tile--line.is-disabled,.fd-tile--line:disabled,.fd-tile--line[aria-disabled=true]{background:transparent;opacity:.5;pointer-events:none}.fd-tile--line:last-child{-webkit-margin-end:0;margin-inline-end:0}.fd-tile--line .fd-tile__header{height:100%;max-height:100%;min-height:100%}.fd-tile--line .fd-tile__header,.fd-tile--line .fd-tile__title-container{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;margin-block:0;margin-inline:0}.fd-tile--line .fd-tile__title-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;max-width:100%;padding-block:0;padding-inline:0}.fd-tile--line .fd-tile__title-container:after,.fd-tile--line .fd-tile__title-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--line .fd-tile__subtitle,.fd-tile--line .fd-tile__title{color:var(--sapTile_TitleTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);line-height:var(--fdGenericTileLineHeight);min-width:2rem;text-shadow:var(--sapContent_TextShadow)}.fd-tile--line .fd-tile__subtitle{color:var(--sapTile_TextColor);font-size:.875rem}.fd-tile--line .fd-tile__title{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;-webkit-margin-end:var(--fdGenericTileTitleHorizontalSpacing);color:var(--sapTile_TitleTextColor);display:inline;margin-inline-end:var(--fdGenericTileTitleHorizontalSpacing);-webkit-line-clamp:initial}.fd-tile--line.fd-tile--action{-webkit-padding-end:0;padding-inline-end:0}.fd-tile--line.fd-tile--action .fd-tile__action-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-margin-start:.25rem;margin-inline-start:.25rem}.fd-tile--line.fd-tile--action .fd-tile__action-container:after,.fd-tile--line.fd-tile--action .fd-tile__action-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--line.fd-tile--action .fd-tile__action-close{display:-webkit-box;display:-ms-flexbox;display:flex;height:1.375rem;min-width:1.375rem;width:1.375rem;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background:var(--sapButton_Background);border:var(--sapButton_BorderColor);border-radius:50%;cursor:pointer;font-size:.75rem;padding-block:0;padding-inline:.25rem;position:relative;top:-.625rem}.fd-tile--line.fd-tile--action .fd-tile__action-close:after{border-radius:50%}.fd-tile--line.fd-tile--action .fd-tile__action-indicator{height:1.625rem;line-height:1.625rem;margin-block:0;margin-inline:0;max-height:1.625rem;max-width:1.625rem;min-height:1.625rem;min-width:1.625rem;min-width:auto;position:relative;width:1.625rem}.fd-tile--line.fd-tile--action .fd-tile__action-indicator:after{content:\"\";height:2rem;left:60%;max-height:2rem;max-width:2rem;min-height:2rem;min-width:2rem;position:absolute;top:50%;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%);width:2rem}.fd-tile--line.fd-tile--action .fd-tile__action-indicator:after[dir=rtl],[dir=rtl] .fd-tile--line.fd-tile--action .fd-tile__action-indicator:after{left:auto;right:50%;-webkit-transform:translate(50%,-50%);transform:translate(50%,-50%)}.fd-tile--line .fd-badge{inset:0;position:relative;-webkit-margin-end:.375rem;margin-inline-end:.375rem;-ms-flex-negative:0;flex-shrink:0}.fd-tile--line .fd-badge[dir=rtl],[dir=rtl] .fd-tile--line .fd-badge{left:0;right:0}.fd-numeric-content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:3rem;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;width:100%}.fd-numeric-content:after,.fd-numeric-content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__kpi-container,.fd-numeric-content__launch-icon-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;height:100%;overflow:hidden;-webkit-padding-before:.125rem;padding-block-start:.125rem;-webkit-margin-end:.375rem;margin-inline-end:.375rem}.fd-numeric-content__kpi-container:after,.fd-numeric-content__kpi-container:before,.fd-numeric-content__launch-icon-container:after,.fd-numeric-content__launch-icon-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__kpi-container:first-child:last-child,.fd-numeric-content__launch-icon-container:first-child:last-child{margin-block:0;margin-inline:0}.fd-numeric-content__launch-icon-container{max-width:1.75rem;min-width:1.75rem;width:1.75rem}.fd-numeric-content__scale-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:100%;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-block:.5rem .375rem;padding-inline:0}.fd-numeric-content__scale-container:after,.fd-numeric-content__scale-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__scale-container:first-child:last-child{margin-block:0;margin-inline:0}.fd-numeric-content__launch-icon [class*=sap-icon],.fd-numeric-content__launch-icon[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;color:var(--sapTile_IconColor);font-size:inherit;font-size:1.75rem;line-height:1;line-height:normal}.fd-numeric-content__kpi{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapNeutralTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:2.25rem;font-weight:400;font-weight:lighter;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-numeric-content__kpi:after,.fd-numeric-content__kpi:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__kpi--positive{color:var(--sapPositiveTextColor)}.fd-numeric-content__kpi--critical{color:var(--sapCriticalTextColor)}.fd-numeric-content__kpi--negative{color:var(--sapNegativeTextColor)}.fd-numeric-content__kpi--informative{color:var(--sapInformativeTextColor)}.fd-numeric-content__scale{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between}.fd-numeric-content__scale:after,.fd-numeric-content__scale:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__scale-arrow [class*=sap-icon],.fd-numeric-content__scale-arrow[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;color:var(--sapNeutralTextColor);font-size:inherit;font-size:.875rem;line-height:1;line-height:normal}.fd-numeric-content__scale-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapNeutralTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:.875rem;font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-numeric-content__scale-text:after,.fd-numeric-content__scale-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__scale--positive .fd-numeric-content__scale-arrow [class*=sap-icon],.fd-numeric-content__scale--positive .fd-numeric-content__scale-arrow[class*=sap-icon],.fd-numeric-content__scale--positive .fd-numeric-content__scale-text{color:var(--sapPositiveTextColor)}.fd-numeric-content__scale--critical .fd-numeric-content__scale-arrow [class*=sap-icon],.fd-numeric-content__scale--critical .fd-numeric-content__scale-arrow[class*=sap-icon],.fd-numeric-content__scale--critical .fd-numeric-content__scale-text{color:var(--sapCriticalTextColor)}.fd-numeric-content__scale--negative .fd-numeric-content__scale-arrow [class*=sap-icon],.fd-numeric-content__scale--negative .fd-numeric-content__scale-arrow[class*=sap-icon],.fd-numeric-content__scale--negative .fd-numeric-content__scale-text{color:var(--sapNegativeTextColor)}.fd-numeric-content__scale--informative .fd-numeric-content__scale-arrow [class*=sap-icon],.fd-numeric-content__scale--informative .fd-numeric-content__scale-arrow[class*=sap-icon],.fd-numeric-content__scale--informative .fd-numeric-content__scale-text{color:var(--sapInformativeTextColor)}.fd-numeric-content--m{height:2.5rem}.fd-numeric-content--m .fd-numeric-content__kpi-container,.fd-numeric-content--m .fd-numeric-content__launch-icon-container{-webkit-padding-before:0;padding-block-start:0;-webkit-margin-end:.5rem;margin-inline-end:.5rem}.fd-numeric-content--m .fd-numeric-content__launch-icon-container{-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end}.fd-numeric-content--m .fd-numeric-content__scale-container{padding-block:.375rem .188rem}.fd-numeric-content--m .fd-numeric-content__kpi{font-size:2rem}.fd-numeric-content--s{height:2.25rem}.fd-numeric-content--s .fd-numeric-content__kpi-container,.fd-numeric-content--s .fd-numeric-content__launch-icon-container{-webkit-padding-before:0;padding-block-start:0;-webkit-margin-end:.5rem;margin-inline-end:.5rem}.fd-numeric-content--s .fd-numeric-content__scale-container{padding-block:0 .313rem}.fd-numeric-content--s .fd-numeric-content__kpi{font-size:1.75rem}.fd-numeric-content--small-tile{height:2.375rem}.fd-numeric-content--small-tile .fd-numeric-content__kpi-container,.fd-numeric-content--small-tile .fd-numeric-content__launch-icon-container{-webkit-padding-before:.5rem;padding-block-start:.5rem;-webkit-margin-end:.375rem;margin-inline-end:.375rem}.fd-numeric-content--small-tile .fd-numeric-content__launch-icon-container{max-width:1.5rem;min-width:1.5rem;width:1.5rem}.fd-numeric-content--small-tile .fd-numeric-content__scale-container{padding-block:.25rem}.fd-numeric-content--small-tile .fd-numeric-content__kpi,.fd-numeric-content--small-tile .fd-numeric-content__launch-icon [class*=sap-icon],.fd-numeric-content--small-tile .fd-numeric-content__launch-icon[class*=sap-icon]{font-size:1.5rem}.fd-numeric-content--small-tile .fd-numeric-content__kpi[dir=rtl],[dir=rtl] .fd-numeric-content--small-tile .fd-numeric-content__kpi{direction:ltr;text-align:right}.fd-numeric-content--small-tile.fd-numeric-content--m{height:2.375rem}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__kpi-container,.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__launch-icon-container{-webkit-padding-before:.5rem;padding-block-start:.5rem;-webkit-margin-end:.375rem;margin-inline-end:.375rem}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__launch-icon-container{max-width:1.5rem;min-width:1.5rem;width:1.5rem}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__scale-container{padding-block:.25rem}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__kpi,.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__launch-icon [class*=sap-icon],.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__launch-icon[class*=sap-icon]{font-size:1.5rem}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__kpi[dir=rtl],[dir=rtl] .fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__kpi{direction:ltr;text-align:right}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__launch-icon-container{-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end}.fd-numeric-content--small-tile.fd-numeric-content--s{height:2.375rem}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__kpi-container,.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__launch-icon-container{-webkit-padding-before:.5rem;padding-block-start:.5rem;-webkit-margin-end:.375rem;margin-inline-end:.375rem}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__launch-icon-container{max-width:1.5rem;min-width:1.5rem;width:1.5rem}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__scale-container{padding-block:.25rem}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__kpi,.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__launch-icon [class*=sap-icon],.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__launch-icon[class*=sap-icon]{font-size:1.5rem}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__kpi[dir=rtl],[dir=rtl] .fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__kpi{direction:ltr;text-align:right}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__scale-container{-webkit-padding-before:0;padding-block-start:0}.fd-badge{background:var(--sapHighlightColor);border:0;border:.0625rem solid var(--fdBadge_Border_Color);border-radius:.5rem;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_ContrastTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:var(--sapFontSmallSize);font-weight:400;font-weight:700;forced-color-adjust:none;height:1rem;line-height:normal;margin-block:0;margin-inline:0;max-width:calc(100% - 1rem);overflow:hidden;padding-block:0;padding-inline:0;padding-inline:.5rem;position:absolute;right:.5rem;text-overflow:ellipsis;top:-.55rem;white-space:nowrap;z-index:10}.fd-badge:after,.fd-badge:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-badge[dir=rtl],[dir=rtl] .fd-badge{left:.5rem;right:auto}.fd-badge--static{position:static}\n/*! Bundled license information:\n\nfundamental-styles/dist/badge.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], TileComponent.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-tile', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, imports: [], template: "<div\n    class=\"fd-tile\"\n    #container\n    [attr.tabindex]=\"clickable ? 0 : -1\"\n    (click)=\"clickable && tileClick.emit()\"\n    (keyup.enter)=\"clickable && tileClick.emit()\"\n    (keydown.space)=\"clickable && $event.preventDefault()\"\n    (keyup.space)=\"clickable && tileClick.emit()\"\n>\n    @if (action) {\n        <div class=\"fd-tile__overlay\"></div>\n    }\n    <ng-content select=\"[fd-tile-action-close]\"></ng-content>\n    <ng-content select=\"[fd-tile-action-indicator]\"></ng-content>\n    <ng-content select=\"[fd-badge]\"></ng-content>\n    <ng-content select=\"[fd-tile-header]\"></ng-content>\n    <ng-content select=\"[fd-tile-header-content]\"></ng-content>\n    <ng-content select=\"[fd-tile-content]\"></ng-content>\n    <ng-content select=\"[fd-tile-footer]\"></ng-content>\n    <ng-content select=\"[fd-tile-action-container]\"></ng-content>\n    <ng-content></ng-content>\n</div>\n", styles: [".fd-tile{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:11rem;line-height:normal;margin-block:0;margin-inline:0;max-height:11rem;max-width:11rem;min-height:11rem;min-width:11rem;padding-block:0;padding-inline:0;width:11rem;--fdGenericTileLineTileHeight:2rem;--fdGenericTileLineTileMaxHeight:3.25rem;--fdGenericTileLineHeight:1.625rem;--fdGenericTileTitleHorizontalSpacing:.625rem;background:var(--sapTile_Background);border:var(--fdTile_Border);border-radius:var(--sapElement_BorderCornerRadius);-webkit-box-shadow:var(--sapContent_Shadow0);box-shadow:var(--sapContent_Shadow0);cursor:pointer;padding-block:.9375rem;padding-inline:.9375rem;position:relative}.fd-tile:after,.fd-tile:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile[class*=-compact],.fd-tile[class*=-condensed],[class*=-compact] .fd-tile:not([class*=-cozy]),[class*=-condensed] .fd-tile:not([class*=-cozy]){--fdGenericTileLineTileHeight:1.625rem;--fdGenericTileLineTileMaxHeight:2.875rem;--fdGenericTileLineHeight:1.4375rem;--fdGenericTileTitleHorizontalSpacing:.5rem}.fd-tile.is-active,.fd-tile:active{background:var(--sapTile_Active_Background);border:.0625rem solid var(--sapTile_Interactive_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-tile.is-hover,.fd-tile:hover{background:var(--sapTile_Hover_Background);border:var(--fdTile_Hover_Border);-webkit-box-shadow:var(--fdTile_Hover_Box_Shadow);box-shadow:var(--fdTile_Hover_Box_Shadow)}.fd-tile__content,.fd-tile__footer,.fd-tile__header,.fd-tile__header-content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0}.fd-tile__content:after,.fd-tile__content:before,.fd-tile__footer:after,.fd-tile__footer:before,.fd-tile__header-content:after,.fd-tile__header-content:before,.fd-tile__header:after,.fd-tile__header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile__content--2-col,.fd-tile__footer--2-col,.fd-tile__header--2-col,.fd-tile__header-content--2-col{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between}.fd-tile__header{height:3.625rem;max-height:3.625rem;min-height:3.625rem}.fd-tile__content,.fd-tile__header{-webkit-margin-after:.25rem;margin-block-end:.25rem}.fd-tile__content{height:3.875rem;max-height:3.875rem;min-height:3.875rem}.fd-tile__header-content{height:7.75rem;max-height:7.75rem;min-height:7.75rem;-webkit-margin-after:.25rem;margin-block-end:.25rem}.fd-tile__header-content .fd-tile__title{display:-webkit-box;-webkit-line-clamp:4;-webkit-box-orient:vertical;overflow:hidden}.fd-tile__footer{display:-webkit-box;display:-ms-flexbox;display:flex;height:1rem;max-height:1rem;min-height:1rem}.fd-tile__section{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:100%;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;width:calc(50% - .125rem)}.fd-tile__section:after,.fd-tile__section:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile__footer-text,.fd-tile__subtitle,.fd-tile__title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapTile_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-tile__footer-text:after,.fd-tile__footer-text:before,.fd-tile__subtitle:after,.fd-tile__subtitle:before,.fd-tile__title:after,.fd-tile__title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile__title{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;color:var(--sapTile_TitleTextColor);font-size:var(--fdTile_Title_Font_Size);font-weight:var(--fdTile_Title_Font_Weight);overflow:hidden}.fd-tile__footer-text,.fd-tile__subtitle{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-tile__refresh [class*=sap-icon],.fd-tile__refresh[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;display:-webkit-box;display:-ms-flexbox;display:flex;font-size:inherit;line-height:1;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-margin-end:.5rem;color:var(--sapButton_IconColor);font-size:var(--sapFontSize);line-height:normal;margin-inline-end:.5rem;min-width:.875rem;text-align:center}.fd-tile__profile-img{border:0;border-radius:50%;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:3.5rem;line-height:normal;margin-block:0;margin-inline:0;max-height:3.5rem;max-width:3.5rem;min-height:3.5rem;min-width:3.5rem;padding-block:0;padding-inline:0;width:3.5rem}.fd-tile__profile-img:after,.fd-tile__profile-img:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile__logo{height:1.75rem;max-height:1.75rem;max-width:3.625rem;min-height:1.75rem;min-width:3.625rem;width:3.625rem}.fd-tile__action-close,.fd-tile__action-indicator,.fd-tile__overlay{display:none}.fd-tile--double{max-width:22.5rem;min-width:22.5rem;width:22.5rem}.fd-tile--s{height:9.25rem;max-height:9.25rem;max-width:9.25rem;min-height:9.25rem;min-width:9.25rem;padding-block:.4375rem;padding-inline:.4375rem;width:9.25rem}.fd-tile--s.fd-tile--double{max-width:19rem;min-width:19rem;width:19rem}.fd-tile--s .fd-tile__header{height:3.25rem;max-height:3.25rem;min-height:3.25rem}.fd-tile--s .fd-tile__content{height:3.438rem;max-height:3.438rem;min-height:3.438rem}.fd-tile--s .fd-tile__header-content{height:6.938rem;max-height:6.938rem;min-height:6.938rem}.fd-tile--s .fd-tile__footer{height:1.063rem;max-height:1.063rem;min-height:1.063rem}.fd-tile--s .fd-tile__title{font-size:var(--sapFontHeader6Size)}.fd-tile--s .fd-tile__footer-text{font-size:var(--sapFontSmallSize)}.fd-tile--s .fd-tile__profile-img{height:3rem;max-height:3rem;max-width:3rem;min-height:3rem;min-width:3rem;width:3rem}.fd-tile--s .fd-tile__logo{height:1.438rem;max-height:1.438rem;max-width:3rem;min-height:1.438rem;min-width:3rem;width:3rem}.fd-tile--feed .fd-tile__content,.fd-tile--feed .fd-tile__content--2-col .fd-tile__section,.fd-tile--kpi .fd-tile__content,.fd-tile--kpi .fd-tile__content--2-col .fd-tile__section,.fd-tile--launch .fd-tile__content,.fd-tile--launch .fd-tile__content--2-col .fd-tile__section{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end}.fd-tile--feed .fd-tile__footer,.fd-tile--feed .fd-tile__footer--2-col .fd-tile__section,.fd-tile--kpi .fd-tile__footer,.fd-tile--kpi .fd-tile__footer--2-col .fd-tile__section,.fd-tile--launch .fd-tile__footer,.fd-tile--launch .fd-tile__footer--2-col .fd-tile__section{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-tile--feed .fd-tile__footer--2-col .fd-tile__section:last-child,.fd-tile--kpi .fd-tile__footer--2-col .fd-tile__section:last-child,.fd-tile--launch .fd-tile__footer--2-col .fd-tile__section:last-child{-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end}.fd-tile--feed .fd-tile__content .fd-tile__section{width:auto}.fd-tile--feed .fd-tile__content .fd-tile__section:first-child{-webkit-margin-end:.25rem;display:-webkit-box;display:-ms-flexbox;display:flex;margin-inline-end:.25rem;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-flex:1;-ms-flex:1;flex:1;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start;-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end;max-width:100%}.fd-tile--feed .fd-tile__content .fd-tile__section:nth-child(2){-webkit-padding-start:.5rem;max-width:10.25rem;padding-inline-start:.5rem}.fd-tile--feed .fd-tile__content-byline,.fd-tile--feed .fd-tile__content-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapTile_TitleTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:var(--sapFontSmallSize);font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1.063rem;margin-block:0;margin-inline:0;max-width:100%;padding-block:0;padding-inline:0}.fd-tile--feed .fd-tile__content-byline:after,.fd-tile--feed .fd-tile__content-byline:before,.fd-tile--feed .fd-tile__content-text:after,.fd-tile--feed .fd-tile__content-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--feed .fd-tile__content-text{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;max-height:2.125rem;overflow:hidden}.fd-tile--feed .fd-tile__content-byline{color:var(--sapTile_TextColor);overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-tile--feed.fd-tile--s .fd-tile__content .fd-tile__section:nth-child(2){max-width:8.25rem}.fd-tile--slide{display:-webkit-box;display:-ms-flexbox;display:flex;padding-block:0;padding-inline:0;-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end}.fd-tile--slide .fd-tile__background-img{background-size:cover;border:0;border-radius:var(--sapElement_BorderCornerRadius);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:100%;inset:0;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;position:absolute;width:100%}.fd-tile--slide .fd-tile__background-img:after,.fd-tile--slide .fd-tile__background-img:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--slide .fd-tile__background-img.is-hover,.fd-tile--slide .fd-tile__background-img:hover{opacity:.9}.fd-tile--slide .fd-tile__background-img.is-active,.fd-tile--slide .fd-tile__background-img:active{opacity:.8}.fd-tile--slide .fd-tile__toggle{background:transparent;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:none;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:3rem;line-height:normal;margin-block:0;margin-inline:0;max-height:3rem;max-width:3rem;min-height:3rem;min-width:3rem;padding-block:0;padding-block:.5rem;padding-inline:0;padding-inline:.5rem;position:absolute;right:-.0625rem;top:-.0625rem;width:3rem}.fd-tile--slide .fd-tile__toggle:after,.fd-tile--slide .fd-tile__toggle:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--slide .fd-tile__toggle[dir=rtl],[dir=rtl] .fd-tile--slide .fd-tile__toggle{left:-.0625rem;right:auto}.fd-tile--slide .fd-tile__toggle:before{display:-webkit-box;display:-ms-flexbox;display:flex;height:2rem;max-height:2rem;max-width:2rem;min-height:2rem;min-width:2rem;width:2rem;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--sapBlockLayer_Background);border-radius:50%;color:var(--sapButton_Emphasized_TextColor);content:\"\\e14b\";font-family:SAP-icons;font-size:1rem;opacity:.6;text-shadow:var(--sapButton_Emphasized_TextShadow)}.fd-tile--slide .fd-tile__toggle--pause:before{content:\"\\e14c\"}.fd-tile--slide .fd-tile__toggle.is-focus,.fd-tile--slide .fd-tile__toggle:focus{outline:none;z-index:5}.fd-tile--slide .fd-tile__toggle.is-hover:before,.fd-tile--slide .fd-tile__toggle:hover:before{opacity:.8}.fd-tile--slide .fd-tile__toggle.is-active:before,.fd-tile--slide .fd-tile__toggle:active:before{opacity:1}.fd-tile--slide .fd-tile__container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:6.125rem;line-height:normal;margin-block:0;margin-inline:0;max-height:6.125rem;min-height:6.125rem;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-pack:justify;-ms-flex-pack:justify;background-color:var(--fdSlide_Tile_Background_Color);justify-content:space-between;max-width:100%;opacity:var(--fdSlide_Tile_Background_Opacity);width:100%;z-index:2;-webkit-padding-before:.25rem;border-bottom-left-radius:var(--sapElement_BorderCornerRadius);border-bottom-right-radius:var(--sapElement_BorderCornerRadius);padding-block-start:.25rem;padding-inline:.9375rem}.fd-tile--slide .fd-tile__container:after,.fd-tile--slide .fd-tile__container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--slide .fd-tile__title{font-weight:var(--fdSlide_Tile_Title_Font_Weight);text-shadow:var(--fdSlide_Tile_Title_Text_Shadow)}.fd-tile--slide .fd-tile__footer-text,.fd-tile--slide .fd-tile__subtitle,.fd-tile--slide .fd-tile__title{color:var(--fdSlide_Tile_Title_Color);font-size:var(--sapFontSize);line-height:normal}.fd-tile--slide .fd-tile__page-indicator{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;height:.5rem;max-height:.5rem;min-height:.5rem;-webkit-margin-after:.125rem;margin-block-end:.125rem;margin-top:.375rem}.fd-tile--slide .fd-tile__page-indicator:after,.fd-tile--slide .fd-tile__page-indicator:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--slide .fd-tile__dot{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:var(--fdSlide_Tile_Indicator_Dot_Size);line-height:normal;margin-block:0;margin-inline:0;max-height:var(--fdSlide_Tile_Indicator_Dot_Size);max-width:var(--fdSlide_Tile_Indicator_Dot_Size);min-height:var(--fdSlide_Tile_Indicator_Dot_Size);min-width:var(--fdSlide_Tile_Indicator_Dot_Size);padding-block:0;padding-inline:0;width:var(--fdSlide_Tile_Indicator_Dot_Size);-webkit-margin-end:var(--fdSlide_Tile_Indicator_Dot_Spacing);background-color:var(--fdSlide_Tile_Indicator_Dot_Color);border:var(--fdSlide_Tile_Indicator_Dot_Border);border-radius:50%;-webkit-box-shadow:var(--fdSlide_Tile_Indicator_Dot_Shadow);box-shadow:var(--fdSlide_Tile_Indicator_Dot_Shadow);margin-inline-end:var(--fdSlide_Tile_Indicator_Dot_Spacing);opacity:var(--fdSlide_Tile_Indicator_Dot_Opacity)}.fd-tile--slide .fd-tile__dot:after,.fd-tile--slide .fd-tile__dot:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--slide .fd-tile__dot--active{background-color:var(--fdSlide_Tile_Indicator_Active_Dot_Color);border:var(--fdSlide_Tile_Indicator_Active_Dot_Border);height:var(--fdSlide_Tile_Indicator_Ative_Dot_Size);max-height:var(--fdSlide_Tile_Indicator_Ative_Dot_Size);max-width:var(--fdSlide_Tile_Indicator_Ative_Dot_Size);min-height:var(--fdSlide_Tile_Indicator_Ative_Dot_Size);min-width:var(--fdSlide_Tile_Indicator_Ative_Dot_Size);width:var(--fdSlide_Tile_Indicator_Ative_Dot_Size)}.fd-tile--slide .fd-tile__dot:last-child{margin-block:0;margin-inline:0}.fd-tile--slide.fd-tile--s .fd-tile__container{height:5.25rem;max-height:5.25rem;min-height:5.25rem;-webkit-padding-before:.1875rem;padding-block-start:.1875rem;padding-inline:.4375rem}.fd-tile--slide.fd-tile--s .fd-tile__footer-text,.fd-tile--slide.fd-tile--s .fd-tile__subtitle,.fd-tile--slide.fd-tile--s .fd-tile__title{font-size:var(--sapFontSmallSize)}.fd-tile--slide.fd-tile--s .fd-tile__page-indicator{margin-block:0}.fd-tile--action .fd-tile__action-close,.fd-tile--action .fd-tile__action-indicator,.fd-tile--action .fd-tile__overlay{display:block}.fd-tile--action .fd-tile__overlay{background:var(--sapTile_Background);border:0;border-radius:var(--sapElement_BorderCornerRadius);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:100%;inset:0;line-height:normal;margin-block:0;margin-inline:0;opacity:.7;padding-block:0;padding-inline:0;position:absolute;width:100%;z-index:4}.fd-tile--action .fd-tile__overlay:after,.fd-tile--action .fd-tile__overlay:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--action .fd-badge,.fd-tile--action .fd-tile__footer{display:none}.fd-tile--action .fd-tile__action-close{display:-webkit-box;display:-ms-flexbox;display:flex;height:auto;max-height:none;max-width:none;min-height:auto;min-width:auto;width:auto;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start;-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end;padding-block:0;padding-inline:0;position:absolute;right:-.375rem;top:-.375rem;z-index:5}.fd-tile--action .fd-tile__action-close[dir=rtl],[dir=rtl] .fd-tile--action .fd-tile__action-close{left:-.375rem;right:auto}.fd-tile--action .fd-tile__action-close [class*=sap-icon],.fd-tile--action .fd-tile__action-close[class*=sap-icon]{background:inherit;background:var(--sapButton_Background);border:.0625rem solid var(--sapButton_BorderColor);border-radius:inherit;border-radius:50%;-webkit-box-sizing:border-box;box-sizing:border-box;color:inherit;color:var(--sapButton_IconColor);font-size:inherit;font-size:.75rem;height:1.375rem;line-height:1;max-height:1.375rem;max-width:1.375rem;min-height:1.375rem;min-width:1.375rem;width:1.375rem}.fd-tile--action .fd-tile__action-close [class*=sap-icon]:before,.fd-tile--action .fd-tile__action-close[class*=sap-icon]:before{line-height:1.25rem}.fd-tile--action .fd-tile__action-close.is-focus,.fd-tile--action .fd-tile__action-close:focus{outline:none;z-index:5}.fd-tile--action .fd-tile__action-close.is-focus:after,.fd-tile--action .fd-tile__action-close:focus:after{border:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);border-radius:var(--fdButton_Focus_Border_Radius);content:\"\";display:block;inset:-.0625rem;position:absolute}.fd-tile--action .fd-tile__action-close.is-focus.fd-button--toggled:after,.fd-tile--action .fd-tile__action-close.is-focus.is-selected:after,.fd-tile--action .fd-tile__action-close:focus.fd-button--toggled:after,.fd-tile--action .fd-tile__action-close:focus.is-selected:after{border-color:var(--fdButton_Outline_Contrast)}.fd-tile--action .fd-tile__action-close::-moz-focus-inner{border:0}.fd-tile--action .fd-tile__action-indicator{bottom:0;position:absolute;right:0;-webkit-margin-after:.25rem;margin-block-end:.25rem;-webkit-margin-end:.25rem;margin-inline-end:.25rem;z-index:5}.fd-tile--action .fd-tile__action-indicator[dir=rtl],[dir=rtl] .fd-tile--action .fd-tile__action-indicator{left:0;right:auto}.fd-tile--action .fd-tile__action-indicator [class*=sap-icon],.fd-tile--action .fd-tile__action-indicator[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;display:-webkit-box;display:-ms-flexbox;display:flex;font-size:inherit;line-height:1;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapButton_IconColor);font-size:1rem}.fd-tile--action .fd-tile__action-close.is-active,.fd-tile--action .fd-tile__action-close.is-hover,.fd-tile--action .fd-tile__action-close:active,.fd-tile--action .fd-tile__action-close:hover,.fd-tile--action .fd-tile__action-indicator.is-active,.fd-tile--action .fd-tile__action-indicator.is-hover,.fd-tile--action .fd-tile__action-indicator:active,.fd-tile--action .fd-tile__action-indicator:hover{background:transparent;border-color:transparent}.fd-tile--action.fd-tile--slide .fd-tile__action-indicator [class*=sap-icon],.fd-tile--action.fd-tile--slide .fd-tile__action-indicator[class*=sap-icon]{color:var(--sapShell_Active_TextColor)}.fd-tile-container{background-color:var(--sapTile_Background);border:0;border:.0625rem solid var(--sapTile_BorderColor);border-radius:var(--sapElement_BorderCornerRadius);-webkit-box-shadow:var(--sapContent_Shadow0);box-shadow:var(--sapContent_Shadow0);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-block:.5rem;padding-inline:0;padding-inline:.5rem;width:100%}.fd-tile-container:after,.fd-tile-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile-container--list{-webkit-box-orient:vertical;-webkit-box-direction:normal;background-color:var(--sapGroup_ContentBackground);-ms-flex-direction:column;flex-direction:column}.fd-tile-container--list .fd-tile--line{-ms-flex-wrap:wrap;flex-wrap:wrap;margin-inline:0;max-height:var(--fdGenericTileLineTileMaxHeight)}.fd-tile-container--list .fd-tile--action .fd-tile__header{-webkit-mask-image:-webkit-gradient(linear,left top,left bottom,from(linear),color-stop(top,right),color-stop(top,left),color-stop(from(transparent)),color-stop(color-stop(7%,#000)),to(to(#000)));-webkit-mask-image:linear-gradient(linear,right top,left top,from(transparent),color-stop(7%,#000),to(#000));mask-image:-webkit-gradient(linear,left top,left bottom,from(linear),color-stop(top,right),color-stop(top,left),color-stop(from(transparent)),color-stop(color-stop(7%,#000)),to(to(#000)));mask-image:linear-gradient(linear,right top,left top,from(transparent),color-stop(7%,#000),to(#000));-webkit-mask-image:-webkit-gradient(linear,right top,left top,from(transparent),color-stop(7%,#000),to(#000));mask-image:-webkit-gradient(linear,right top,left top,from(transparent),color-stop(7%,#000),to(#000))}.fd-tile-container--list .fd-tile--action .fd-tile__header[dir=rtl],[dir=rtl] .fd-tile-container--list .fd-tile--action .fd-tile__header{-webkit-mask-image:-webkit-gradient(linear,left top,left bottom,from(linear),color-stop(top,left),color-stop(top,right),color-stop(from(transparent)),color-stop(color-stop(7%,#000)),to(to(#000)));-webkit-mask-image:linear-gradient(linear,left top,right top,from(transparent),color-stop(7%,#000),to(#000));mask-image:-webkit-gradient(linear,left top,left bottom,from(linear),color-stop(top,left),color-stop(top,right),color-stop(from(transparent)),color-stop(color-stop(7%,#000)),to(to(#000)));mask-image:linear-gradient(linear,left top,right top,from(transparent),color-stop(7%,#000),to(#000));-webkit-mask-image:-webkit-gradient(linear,left top,right top,from(transparent),color-stop(7%,#000),to(#000));mask-image:-webkit-gradient(linear,left top,right top,from(transparent),color-stop(7%,#000),to(#000))}.fd-tile-container--list .fd-tile__header{-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-box-flex:1;-ms-flex:1;flex:1}.fd-tile--line{display:-webkit-box;display:-ms-flexbox;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between;margin-block:.25rem;-webkit-margin-end:.5rem;background:var(--fdTile_Background,var(--sapTile_Background));border:.0625rem solid var(--fdTile_Border,var(--sapTile_BorderColor));border-radius:var(--sapTile_BorderCornerRadius);-webkit-box-shadow:var(--fdTile_Box_Shadow,var(--sapContent_Shadow0));box-shadow:var(--fdTile_Box_Shadow,var(--sapContent_Shadow0));display:flex;height:100%;margin-inline-end:.5rem;max-height:var(--fdGenericTileLineTileHeight);max-width:100%;min-height:var(--fdGenericTileLineTileHeight);min-width:2rem;padding-block:0;padding-inline:.5rem;width:auto;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;gap:.5rem}.fd-tile--line.is-hover,.fd-tile--line:hover{border-radius:var(--sapTile_BorderCornerRadius);--fdTile_Box_Shadow:var(--sapContent_Shadow2);--fdTile_Background:var(--sapTile_Hover_Background)}.fd-tile--line.is-active,.fd-tile--line:active{--fdTile_Background:var(--sapTile_Active_Background)}.fd-tile--line.is-focus,.fd-tile--line:focus{outline:.125rem solid var(--sapContent_FocusColor);outline-offset:-.125rem;z-index:5}.fd-tile--line.is-disabled,.fd-tile--line:disabled,.fd-tile--line[aria-disabled=true]{background:transparent;opacity:.5;pointer-events:none}.fd-tile--line:last-child{-webkit-margin-end:0;margin-inline-end:0}.fd-tile--line .fd-tile__header{height:100%;max-height:100%;min-height:100%}.fd-tile--line .fd-tile__header,.fd-tile--line .fd-tile__title-container{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;margin-block:0;margin-inline:0}.fd-tile--line .fd-tile__title-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;max-width:100%;padding-block:0;padding-inline:0}.fd-tile--line .fd-tile__title-container:after,.fd-tile--line .fd-tile__title-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--line .fd-tile__subtitle,.fd-tile--line .fd-tile__title{color:var(--sapTile_TitleTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);line-height:var(--fdGenericTileLineHeight);min-width:2rem;text-shadow:var(--sapContent_TextShadow)}.fd-tile--line .fd-tile__subtitle{color:var(--sapTile_TextColor);font-size:.875rem}.fd-tile--line .fd-tile__title{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;-webkit-margin-end:var(--fdGenericTileTitleHorizontalSpacing);color:var(--sapTile_TitleTextColor);display:inline;margin-inline-end:var(--fdGenericTileTitleHorizontalSpacing);-webkit-line-clamp:initial}.fd-tile--line.fd-tile--action{-webkit-padding-end:0;padding-inline-end:0}.fd-tile--line.fd-tile--action .fd-tile__action-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-margin-start:.25rem;margin-inline-start:.25rem}.fd-tile--line.fd-tile--action .fd-tile__action-container:after,.fd-tile--line.fd-tile--action .fd-tile__action-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-tile--line.fd-tile--action .fd-tile__action-close{display:-webkit-box;display:-ms-flexbox;display:flex;height:1.375rem;min-width:1.375rem;width:1.375rem;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background:var(--sapButton_Background);border:var(--sapButton_BorderColor);border-radius:50%;cursor:pointer;font-size:.75rem;padding-block:0;padding-inline:.25rem;position:relative;top:-.625rem}.fd-tile--line.fd-tile--action .fd-tile__action-close:after{border-radius:50%}.fd-tile--line.fd-tile--action .fd-tile__action-indicator{height:1.625rem;line-height:1.625rem;margin-block:0;margin-inline:0;max-height:1.625rem;max-width:1.625rem;min-height:1.625rem;min-width:1.625rem;min-width:auto;position:relative;width:1.625rem}.fd-tile--line.fd-tile--action .fd-tile__action-indicator:after{content:\"\";height:2rem;left:60%;max-height:2rem;max-width:2rem;min-height:2rem;min-width:2rem;position:absolute;top:50%;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%);width:2rem}.fd-tile--line.fd-tile--action .fd-tile__action-indicator:after[dir=rtl],[dir=rtl] .fd-tile--line.fd-tile--action .fd-tile__action-indicator:after{left:auto;right:50%;-webkit-transform:translate(50%,-50%);transform:translate(50%,-50%)}.fd-tile--line .fd-badge{inset:0;position:relative;-webkit-margin-end:.375rem;margin-inline-end:.375rem;-ms-flex-negative:0;flex-shrink:0}.fd-tile--line .fd-badge[dir=rtl],[dir=rtl] .fd-tile--line .fd-badge{left:0;right:0}.fd-numeric-content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:3rem;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;width:100%}.fd-numeric-content:after,.fd-numeric-content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__kpi-container,.fd-numeric-content__launch-icon-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;height:100%;overflow:hidden;-webkit-padding-before:.125rem;padding-block-start:.125rem;-webkit-margin-end:.375rem;margin-inline-end:.375rem}.fd-numeric-content__kpi-container:after,.fd-numeric-content__kpi-container:before,.fd-numeric-content__launch-icon-container:after,.fd-numeric-content__launch-icon-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__kpi-container:first-child:last-child,.fd-numeric-content__launch-icon-container:first-child:last-child{margin-block:0;margin-inline:0}.fd-numeric-content__launch-icon-container{max-width:1.75rem;min-width:1.75rem;width:1.75rem}.fd-numeric-content__scale-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:100%;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-block:.5rem .375rem;padding-inline:0}.fd-numeric-content__scale-container:after,.fd-numeric-content__scale-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__scale-container:first-child:last-child{margin-block:0;margin-inline:0}.fd-numeric-content__launch-icon [class*=sap-icon],.fd-numeric-content__launch-icon[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;color:var(--sapTile_IconColor);font-size:inherit;font-size:1.75rem;line-height:1;line-height:normal}.fd-numeric-content__kpi{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapNeutralTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:2.25rem;font-weight:400;font-weight:lighter;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-numeric-content__kpi:after,.fd-numeric-content__kpi:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__kpi--positive{color:var(--sapPositiveTextColor)}.fd-numeric-content__kpi--critical{color:var(--sapCriticalTextColor)}.fd-numeric-content__kpi--negative{color:var(--sapNegativeTextColor)}.fd-numeric-content__kpi--informative{color:var(--sapInformativeTextColor)}.fd-numeric-content__scale{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between}.fd-numeric-content__scale:after,.fd-numeric-content__scale:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__scale-arrow [class*=sap-icon],.fd-numeric-content__scale-arrow[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;color:var(--sapNeutralTextColor);font-size:inherit;font-size:.875rem;line-height:1;line-height:normal}.fd-numeric-content__scale-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapNeutralTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:.875rem;font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-numeric-content__scale-text:after,.fd-numeric-content__scale-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-numeric-content__scale--positive .fd-numeric-content__scale-arrow [class*=sap-icon],.fd-numeric-content__scale--positive .fd-numeric-content__scale-arrow[class*=sap-icon],.fd-numeric-content__scale--positive .fd-numeric-content__scale-text{color:var(--sapPositiveTextColor)}.fd-numeric-content__scale--critical .fd-numeric-content__scale-arrow [class*=sap-icon],.fd-numeric-content__scale--critical .fd-numeric-content__scale-arrow[class*=sap-icon],.fd-numeric-content__scale--critical .fd-numeric-content__scale-text{color:var(--sapCriticalTextColor)}.fd-numeric-content__scale--negative .fd-numeric-content__scale-arrow [class*=sap-icon],.fd-numeric-content__scale--negative .fd-numeric-content__scale-arrow[class*=sap-icon],.fd-numeric-content__scale--negative .fd-numeric-content__scale-text{color:var(--sapNegativeTextColor)}.fd-numeric-content__scale--informative .fd-numeric-content__scale-arrow [class*=sap-icon],.fd-numeric-content__scale--informative .fd-numeric-content__scale-arrow[class*=sap-icon],.fd-numeric-content__scale--informative .fd-numeric-content__scale-text{color:var(--sapInformativeTextColor)}.fd-numeric-content--m{height:2.5rem}.fd-numeric-content--m .fd-numeric-content__kpi-container,.fd-numeric-content--m .fd-numeric-content__launch-icon-container{-webkit-padding-before:0;padding-block-start:0;-webkit-margin-end:.5rem;margin-inline-end:.5rem}.fd-numeric-content--m .fd-numeric-content__launch-icon-container{-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end}.fd-numeric-content--m .fd-numeric-content__scale-container{padding-block:.375rem .188rem}.fd-numeric-content--m .fd-numeric-content__kpi{font-size:2rem}.fd-numeric-content--s{height:2.25rem}.fd-numeric-content--s .fd-numeric-content__kpi-container,.fd-numeric-content--s .fd-numeric-content__launch-icon-container{-webkit-padding-before:0;padding-block-start:0;-webkit-margin-end:.5rem;margin-inline-end:.5rem}.fd-numeric-content--s .fd-numeric-content__scale-container{padding-block:0 .313rem}.fd-numeric-content--s .fd-numeric-content__kpi{font-size:1.75rem}.fd-numeric-content--small-tile{height:2.375rem}.fd-numeric-content--small-tile .fd-numeric-content__kpi-container,.fd-numeric-content--small-tile .fd-numeric-content__launch-icon-container{-webkit-padding-before:.5rem;padding-block-start:.5rem;-webkit-margin-end:.375rem;margin-inline-end:.375rem}.fd-numeric-content--small-tile .fd-numeric-content__launch-icon-container{max-width:1.5rem;min-width:1.5rem;width:1.5rem}.fd-numeric-content--small-tile .fd-numeric-content__scale-container{padding-block:.25rem}.fd-numeric-content--small-tile .fd-numeric-content__kpi,.fd-numeric-content--small-tile .fd-numeric-content__launch-icon [class*=sap-icon],.fd-numeric-content--small-tile .fd-numeric-content__launch-icon[class*=sap-icon]{font-size:1.5rem}.fd-numeric-content--small-tile .fd-numeric-content__kpi[dir=rtl],[dir=rtl] .fd-numeric-content--small-tile .fd-numeric-content__kpi{direction:ltr;text-align:right}.fd-numeric-content--small-tile.fd-numeric-content--m{height:2.375rem}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__kpi-container,.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__launch-icon-container{-webkit-padding-before:.5rem;padding-block-start:.5rem;-webkit-margin-end:.375rem;margin-inline-end:.375rem}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__launch-icon-container{max-width:1.5rem;min-width:1.5rem;width:1.5rem}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__scale-container{padding-block:.25rem}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__kpi,.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__launch-icon [class*=sap-icon],.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__launch-icon[class*=sap-icon]{font-size:1.5rem}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__kpi[dir=rtl],[dir=rtl] .fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__kpi{direction:ltr;text-align:right}.fd-numeric-content--small-tile.fd-numeric-content--m .fd-numeric-content__launch-icon-container{-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end}.fd-numeric-content--small-tile.fd-numeric-content--s{height:2.375rem}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__kpi-container,.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__launch-icon-container{-webkit-padding-before:.5rem;padding-block-start:.5rem;-webkit-margin-end:.375rem;margin-inline-end:.375rem}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__launch-icon-container{max-width:1.5rem;min-width:1.5rem;width:1.5rem}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__scale-container{padding-block:.25rem}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__kpi,.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__launch-icon [class*=sap-icon],.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__launch-icon[class*=sap-icon]{font-size:1.5rem}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__kpi[dir=rtl],[dir=rtl] .fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__kpi{direction:ltr;text-align:right}.fd-numeric-content--small-tile.fd-numeric-content--s .fd-numeric-content__scale-container{-webkit-padding-before:0;padding-block-start:0}.fd-badge{background:var(--sapHighlightColor);border:0;border:.0625rem solid var(--fdBadge_Border_Color);border-radius:.5rem;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_ContrastTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:var(--sapFontSmallSize);font-weight:400;font-weight:700;forced-color-adjust:none;height:1rem;line-height:normal;margin-block:0;margin-inline:0;max-width:calc(100% - 1rem);overflow:hidden;padding-block:0;padding-inline:0;padding-inline:.5rem;position:absolute;right:.5rem;text-overflow:ellipsis;top:-.55rem;white-space:nowrap;z-index:10}.fd-badge:after,.fd-badge:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-badge[dir=rtl],[dir=rtl] .fd-badge{left:.5rem;right:auto}.fd-badge--static{position:static}\n/*! Bundled license information:\n\nfundamental-styles/dist/badge.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], propDecorators: { class: [{
                type: Input
            }], size: [{
                type: Input
            }], double: [{
                type: Input
            }], type: [{
                type: Input
            }], action: [{
                type: Input
            }], clickable: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], tileClick: [{
                type: Output
            }], ref: [{
                type: ViewChild,
                args: ['container']
            }], buildComponentCssClass: [] } });

class TileModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: TileModule, imports: [TileComponent,
            TileHeaderDirective,
            TileContentDirective,
            TileFooterDirective,
            TileTitleDirective,
            TileSubtitleDirective,
            TileSectionDirective,
            TileRefreshDirective,
            TileFooterTextDirective,
            TileHeaderContentDirective,
            TileProfileImgDirective,
            TileLogoDirective,
            TileContentTextDirective,
            TileBackgroundImgDirective,
            TileToggleDirective,
            TileContainerDirective,
            TilePageIndicatorDirective,
            TileActionCloseDirective,
            TileActionIndicatorDirective,
            TileTitleContainerDirective,
            TileActionContainerDirective,
            NumericContentDirective,
            NumericContentScaleArrowDirective,
            NumericContentKpiContainerDirective,
            NumericContentKpiDirective,
            NumericContentLaunchIconContainerDirective,
            NumericContentLaunchIconDirective,
            NumericContentScaleContainerDirective,
            NumericContentScaleDirective,
            NumericContentScaleTextDirective], exports: [TileComponent,
            TileHeaderDirective,
            TileContentDirective,
            TileFooterDirective,
            TileTitleDirective,
            TileSubtitleDirective,
            TileSectionDirective,
            TileRefreshDirective,
            TileFooterTextDirective,
            TileHeaderContentDirective,
            TileProfileImgDirective,
            TileLogoDirective,
            TileContentTextDirective,
            TileBackgroundImgDirective,
            TileToggleDirective,
            TileContainerDirective,
            TilePageIndicatorDirective,
            TileActionCloseDirective,
            TileActionIndicatorDirective,
            TileTitleContainerDirective,
            TileActionContainerDirective,
            NumericContentDirective,
            NumericContentKpiContainerDirective,
            NumericContentKpiDirective,
            NumericContentLaunchIconContainerDirective,
            NumericContentLaunchIconDirective,
            NumericContentScaleArrowDirective,
            NumericContentScaleContainerDirective,
            NumericContentScaleDirective,
            NumericContentScaleTextDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: TileModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        TileComponent,
                        TileHeaderDirective,
                        TileContentDirective,
                        TileFooterDirective,
                        TileTitleDirective,
                        TileSubtitleDirective,
                        TileSectionDirective,
                        TileRefreshDirective,
                        TileFooterTextDirective,
                        TileHeaderContentDirective,
                        TileProfileImgDirective,
                        TileLogoDirective,
                        TileContentTextDirective,
                        TileBackgroundImgDirective,
                        TileToggleDirective,
                        TileContainerDirective,
                        TilePageIndicatorDirective,
                        TileActionCloseDirective,
                        TileActionIndicatorDirective,
                        TileTitleContainerDirective,
                        TileActionContainerDirective,
                        NumericContentDirective,
                        NumericContentScaleArrowDirective,
                        NumericContentKpiContainerDirective,
                        NumericContentKpiDirective,
                        NumericContentLaunchIconContainerDirective,
                        NumericContentLaunchIconDirective,
                        NumericContentScaleContainerDirective,
                        NumericContentScaleDirective,
                        NumericContentScaleTextDirective
                    ],
                    exports: [
                        TileComponent,
                        TileHeaderDirective,
                        TileContentDirective,
                        TileFooterDirective,
                        TileTitleDirective,
                        TileSubtitleDirective,
                        TileSectionDirective,
                        TileRefreshDirective,
                        TileFooterTextDirective,
                        TileHeaderContentDirective,
                        TileProfileImgDirective,
                        TileLogoDirective,
                        TileContentTextDirective,
                        TileBackgroundImgDirective,
                        TileToggleDirective,
                        TileContainerDirective,
                        TilePageIndicatorDirective,
                        TileActionCloseDirective,
                        TileActionIndicatorDirective,
                        TileTitleContainerDirective,
                        TileActionContainerDirective,
                        NumericContentDirective,
                        NumericContentKpiContainerDirective,
                        NumericContentKpiDirective,
                        NumericContentLaunchIconContainerDirective,
                        NumericContentLaunchIconDirective,
                        NumericContentScaleArrowDirective,
                        NumericContentScaleContainerDirective,
                        NumericContentScaleDirective,
                        NumericContentScaleTextDirective
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NumericContentDirective, NumericContentKpiContainerDirective, NumericContentKpiDirective, NumericContentLaunchIconContainerDirective, NumericContentLaunchIconDirective, NumericContentScaleArrowDirective, NumericContentScaleContainerDirective, NumericContentScaleDirective, NumericContentScaleTextDirective, TileActionCloseDirective, TileActionContainerDirective, TileActionIndicatorDirective, TileBackgroundImgDirective, TileComponent, TileContainerDirective, TileContentDirective, TileContentTextDirective, TileFooterDirective, TileFooterTextDirective, TileHeaderContentDirective, TileHeaderDirective, TileLogoDirective, TileModule, TilePageIndicatorDirective, TileProfileImgDirective, TileRefreshDirective, TileSectionDirective, TileSubtitleDirective, TileTitleContainerDirective, TileTitleDirective, TileToggleDirective };
//# sourceMappingURL=fundamental-ngx-core-tile.mjs.map
