import * as i0 from '@angular/core';
import { OnInit, OnChanges, SimpleChanges } from '@angular/core';
import { SafeHtml, DomSanitizer } from '@angular/platform-browser';

type LinkTargetType = '' | '_blank' | '_self' | '_top' | '_parent' | '_search';
/**
 * Formatted-text allowed tags, only this tags will render in component, other will skip;
 *
 * ``` selector: fd-formatted-text ```
 *
 * ```html
 * <fd-formatted-text [htmlText]="..."></fd-formatted-text>
 * ```
 */
declare class FormattedTextComponent implements OnInit, OnChanges {
    private readonly domSanitizer;
    /**
     * Text for formatted render.
     */
    htmlText: string;
    /**
     * Target attribute for included links.
     */
    convertedLinksDefaultTarget: LinkTargetType;
    /**
     * Height style for component.
     */
    height?: string;
    /**
     * Width style for component.
     */
    width?: string;
    /** @hidden */
    formattedText: SafeHtml;
    /** @hidden */
    private _htmlSanitizer;
    /** @hidden */
    constructor(domSanitizer: DomSanitizer);
    /** @hidden */
    ngOnInit(): void;
    /** @hidden */
    ngOnChanges(changes: SimpleChanges): void;
    /** @hidden */
    private render;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormattedTextComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FormattedTextComponent, "fd-formatted-text", ["fd-formatted-text"], { "htmlText": { "alias": "htmlText"; "required": false; }; "convertedLinksDefaultTarget": { "alias": "convertedLinksDefaultTarget"; "required": false; }; "height": { "alias": "height"; "required": false; }; "width": { "alias": "width"; "required": false; }; }, {}, never, never, true, never>;
}

/**
 * @deprecated
 * Import `FormattedTextComponent` directly as a standalone component.
 */
declare class FormattedTextModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<FormattedTextModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<FormattedTextModule, never, [typeof FormattedTextComponent], [typeof FormattedTextComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<FormattedTextModule>;
}

export { FormattedTextComponent, FormattedTextModule };
export type { LinkTargetType };
