import * as i0 from '@angular/core';
import { AfterContentInit, QueryList, ElementRef } from '@angular/core';
import { Nullable } from '@fundamental-ngx/cdk/utils';

declare class ObjectIdentifierComponent implements AfterContentInit {
    /** Description text */
    description: Nullable<string>;
    /** Whether the title should be bolded */
    bold: boolean;
    /** Whether the title is medium size */
    medium: boolean;
    /** @hidden */
    objectIdentifierClass: boolean;
    /** @hidden */
    linkComponents: QueryList<ElementRef>;
    /** An RxJS Subject that will kill the data stream upon component’s destruction (for unsubscribing)  */
    private readonly _destroyRef;
    /** @hidden */
    ngAfterContentInit(): void;
    /** @hidden */
    private _listenOnLinkQueryChange;
    /** @hidden */
    private _addIdentifierClass;
    static ɵfac: i0.ɵɵFactoryDeclaration<ObjectIdentifierComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ObjectIdentifierComponent, "fd-object-identifier", never, { "description": { "alias": "description"; "required": false; }; "bold": { "alias": "bold"; "required": false; }; "medium": { "alias": "medium"; "required": false; }; }, {}, ["linkComponents"], ["*"], true, never>;
}

/**
 * @deprecated
 * Use direct import of `ObjectIdentifierComponent`.
 */
declare class ObjectIdentifierModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<ObjectIdentifierModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<ObjectIdentifierModule, never, [typeof ObjectIdentifierComponent], [typeof ObjectIdentifierComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<ObjectIdentifierModule>;
}

export { ObjectIdentifierComponent, ObjectIdentifierModule };
