import * as i0 from '@angular/core';
import { OnChanges, OnInit, ElementRef } from '@angular/core';
import { CssClassBuilder } from '@fundamental-ngx/cdk/utils';
import { IconFont } from '@fundamental-ngx/core/icon';

declare class ObjectMarkerComponent implements OnChanges, OnInit, CssClassBuilder {
    readonly elementRef: ElementRef;
    /** User's custom classes */
    class: string;
    /** Glyph (icon) of the Object Status.*/
    glyph: string;
    /** Glyph font family */
    glyphFont: IconFont;
    /** Whether the Object Status is clickable. */
    clickable: boolean;
    /** Define the text content of the Object Status */
    label: string;
    /** @hidden */
    constructor(elementRef: ElementRef);
    /** @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass(): string[];
    /** @hidden */
    ngOnChanges(): void;
    /** @hidden */
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ObjectMarkerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ObjectMarkerComponent, "[fd-object-marker]", never, { "class": { "alias": "class"; "required": false; }; "glyph": { "alias": "glyph"; "required": false; }; "glyphFont": { "alias": "glyphFont"; "required": false; }; "clickable": { "alias": "clickable"; "required": false; }; "label": { "alias": "label"; "required": false; }; }, {}, never, ["*"], true, never>;
}

/**
 * @deprecated
 * Use direct import of `ObjectMarkerComponent`
 */
declare class ObjectMarkerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<ObjectMarkerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<ObjectMarkerModule, never, [typeof ObjectMarkerComponent], [typeof ObjectMarkerComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<ObjectMarkerModule>;
}

export { ObjectMarkerComponent, ObjectMarkerModule };
