import * as i0 from '@angular/core';
import { AfterViewInit, ElementRef } from '@angular/core';

declare class QuickViewGroupItemContentElementDirective {
    /** @hidden */
    static class: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewGroupItemContentElementDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<QuickViewGroupItemContentElementDirective, "[fd-quick-view-group-item-content-element]", never, {}, {}, never, never, true, never>;
}

declare class QuickViewGroupItemContentComponent implements AfterViewInit {
    private readonly _elRef;
    /** @hidden */
    constructor(_elRef: ElementRef<Element>);
    /** @hidden */
    ngAfterViewInit(): void;
    /** @hidden
     * Needed for binding the id of the element and id of the proper label to aria-labelledby. */
    private _bindElementAttributes;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewGroupItemContentComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuickViewGroupItemContentComponent, "fd-quick-view-group-item-content", never, {}, {}, never, ["*"], true, never>;
}

declare class QuickViewGroupItemLabelComponent implements AfterViewInit {
    private readonly _elRef;
    /** @hidden */
    constructor(_elRef: ElementRef<Element>);
    /** @hidden */
    ngAfterViewInit(): void;
    /** @hidden
     * Needed for binding the id to the label element (and this id needed for aria-labelledby of proper element). */
    private _bindElementAttributes;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewGroupItemLabelComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuickViewGroupItemLabelComponent, "fd-quick-view-group-item-label", never, {}, {}, never, ["*"], true, never>;
}

declare class QuickViewGroupItemComponent {
    /** Id of the quick view element. */
    id: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewGroupItemComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuickViewGroupItemComponent, "fd-quick-view-group-item", never, { "id": { "alias": "id"; "required": false; }; }, {}, never, ["*"], true, never>;
}

declare class QuickViewGroupTitleComponent {
    /** Id of the quick view group title. */
    id: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewGroupTitleComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuickViewGroupTitleComponent, "fd-quick-view-group-title", never, { "id": { "alias": "id"; "required": false; }; }, {}, never, ["*"], true, never>;
}

declare class QuickViewGroupComponent {
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuickViewGroupComponent, "fd-quick-view-group", never, {}, {}, never, ["*"], true, never>;
}

declare class QuickViewSubheaderSubtitleComponent {
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewSubheaderSubtitleComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuickViewSubheaderSubtitleComponent, "fd-quick-view-subheader-subtitle", never, {}, {}, never, ["*"], true, never>;
}

declare class QuickViewSubheaderTitleComponent {
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewSubheaderTitleComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuickViewSubheaderTitleComponent, "fd-quick-view-subheader-title", never, {}, {}, never, ["*"], true, never>;
}

declare class QuickViewSubheaderComponent {
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewSubheaderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuickViewSubheaderComponent, "fd-quick-view-subheader", never, {}, {}, never, ["fd-avatar", "fd-quick-view-subheader-title", "fd-quick-view-subheader-subtitle"], true, never>;
}

declare class QuickViewTitleComponent {
    /**
     * Alignment of title.
     * Options include 'left', 'right' and 'middle'. The default is set to 'middle'.
     * */
    align: 'left' | 'right' | 'middle';
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewTitleComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuickViewTitleComponent, "fd-quick-view-title", never, { "align": { "alias": "align"; "required": false; }; }, {}, never, ["*"], true, never>;
}

declare class QuickViewComponent {
    /** Id of the quick view element. */
    id: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuickViewComponent, "fd-quick-view", never, { "id": { "alias": "id"; "required": false; }; }, {}, never, ["fd-quick-view-title", "fd-quick-view-subheader", "fd-quick-view-group"], true, never>;
}

declare class QuickViewModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<QuickViewModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<QuickViewModule, never, [typeof QuickViewComponent, typeof QuickViewTitleComponent, typeof QuickViewSubheaderComponent, typeof QuickViewSubheaderTitleComponent, typeof QuickViewSubheaderSubtitleComponent, typeof QuickViewGroupComponent, typeof QuickViewGroupTitleComponent, typeof QuickViewGroupItemComponent, typeof QuickViewGroupItemLabelComponent, typeof QuickViewGroupItemContentComponent, typeof QuickViewGroupItemContentElementDirective], [typeof QuickViewComponent, typeof QuickViewTitleComponent, typeof QuickViewSubheaderComponent, typeof QuickViewSubheaderTitleComponent, typeof QuickViewSubheaderSubtitleComponent, typeof QuickViewGroupComponent, typeof QuickViewGroupTitleComponent, typeof QuickViewGroupItemComponent, typeof QuickViewGroupItemLabelComponent, typeof QuickViewGroupItemContentComponent, typeof QuickViewGroupItemContentElementDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<QuickViewModule>;
}

export { QuickViewComponent, QuickViewGroupComponent, QuickViewGroupItemComponent, QuickViewGroupItemContentComponent, QuickViewGroupItemContentElementDirective, QuickViewGroupItemLabelComponent, QuickViewGroupTitleComponent, QuickViewModule, QuickViewSubheaderComponent, QuickViewSubheaderSubtitleComponent, QuickViewSubheaderTitleComponent, QuickViewTitleComponent };
