import { Tree } from '@angular-devkit/schematics';
import * as ts from 'typescript';
export declare function callsProvidersFunction(tree: Tree, projectName: string, functionName: string): Promise<boolean>;
/**
 * Checks whether a providers function is being called in a `bootstrapApplication` call.
 * @param tree File tree of the project.
 * @param bootstrapCall Call to `bootstrapApplication`
 * @param filePath Path of the file in which to check.
 * @param functionName Name of the function to search for.
 */
export declare function callsProvidersFunctionStandalone(tree: Tree, bootstrapCall: ts.CallExpression, filePath: string, functionName: string): boolean;
