"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMainTsFilePath = getMainTsFilePath;
const schematics_1 = require("@angular-devkit/schematics");
const workspace_models_1 = require("@schematics/angular/utility/workspace-models");
const workspace_1 = require("./workspace");
function getMainTsFilePath(tree, projectName) {
    return __awaiter(this, void 0, void 0, function* () {
        const buildTarget = yield (0, workspace_1.getProjectBuildTarget)(tree, projectName);
        const options = buildTarget.options;
        const mainFilePath = buildTarget.builder === workspace_models_1.Builders.BuildApplication ? options.browser : options.main;
        if (!mainFilePath || !tree.exists(mainFilePath)) {
            throw new schematics_1.SchematicsException(`Could not find the main file of the project.`);
        }
        return mainFilePath;
    });
}
//# sourceMappingURL=main-ts-file-path.js.map