"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.installDependencies = installDependencies;
exports.addPackageDependency = addPackageDependency;
const tasks_1 = require("@angular-devkit/schematics/tasks");
const dependencies_1 = require("@schematics/angular/utility/dependencies");
/**
 * Add dependencies to the package.json
 */
function installDependencies() {
    return (tree, context) => {
        context.addTask(new tasks_1.NodePackageInstallTask());
        return tree;
    };
}
/**
 * Add dependencies to the package.json and log the changes
 */
function addPackageDependency(tree, dep, ctx) {
    (0, dependencies_1.addPackageJsonDependency)(tree, dep);
    if (ctx) {
        ctx.logger.info(`✅️ Added "${dep.name}" into ${dep.type}`);
    }
}
//# sourceMappingURL=package-utils.js.map