import { ProjectDefinition } from '@angular-devkit/core/src/workspace';
import { TargetDefinition } from '@angular-devkit/core/src/workspace/definitions';
import { Tree } from '@angular-devkit/schematics';
import { WorkspaceDefinition } from '@schematics/angular/utility';
/**
 * Clears the cached workspace.
 */
export declare function clearWorkspaceCache(): void;
/**
 * Gets the cached workspace definition.
 * @param tree
 */
export declare function getWorkspaceDefinition(tree: Tree): Promise<WorkspaceDefinition>;
/**
 * Gets the project definition for the given project name.
 * @param tree
 * @param projectName
 */
export declare function getProjectDefinition(tree: Tree, projectName: string): Promise<ProjectDefinition>;
/** Gets the build target name for the given project. */
export declare function getProjectBuildTargetName(tree: Tree, projectName: string): Promise<string>;
/**
 * Gets the build target for the given project name.
 * @param tree
 * @param projectName
 */
export declare function getProjectBuildTarget(tree: Tree, projectName: string): Promise<TargetDefinition>;
/**
 * Updates the project definition for the given project name.
 * @param tree
 * @param projectName
 * @param updatedProject
 */
export declare function updateProjectDefinition(tree: Tree, projectName: string, updatedProject: ProjectDefinition): Promise<void>;
/**
 * Updates the workspace definition.
 * @param tree
 * @param updatedWorkspace
 */
export declare function updateWorkspaceDefinition(tree: Tree, updatedWorkspace: WorkspaceDefinition): Promise<void>;
