import { NumberInput } from '@angular/cdk/coercion';
import * as i0 from '@angular/core';
import { OnChanges, SimpleChanges } from '@angular/core';

type SkeletonType = 'rectangle' | 'circle' | 'text';
declare class SkeletonComponent implements OnChanges {
    /** Whether the skeleton is animated. True by default. */
    animated: boolean;
    /** Type of the skeleton.
     * Can be one of the following: 'rectangle' | 'circle' | 'text'.
     * Default is not set, allowing to project any SVG elements to define own complex loading template.
     */
    type: SkeletonType;
    /** Number of lines when type is set to `text`. Default is 3. Last one is 60% in width if more than 1 line. */
    set textLines(value: NumberInput);
    get textLines(): number;
    /** Width of skeleton */
    set width(value: string);
    get width(): string;
    /** Height of skeleton */
    set height(value: string);
    get height(): string;
    /** @hidden */
    readonly _skeletonClass = true;
    /** @hidden */
    _width: string;
    /** @hidden */
    _height: string;
    /** @hidden */
    _id: string;
    /** @hidden */
    private _textLines;
    /** @hidden */
    ngOnChanges(changes: SimpleChanges): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkeletonComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SkeletonComponent, "fd-skeleton", never, { "animated": { "alias": "animated"; "required": false; }; "type": { "alias": "type"; "required": false; }; "textLines": { "alias": "textLines"; "required": false; }; "width": { "alias": "width"; "required": false; }; "height": { "alias": "height"; "required": false; }; }, {}, never, ["*"], true, never>;
}

/**
 * @deprecated
 * Use direct `SkeletonComponent` import.
 */
declare class SkeletonModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<SkeletonModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<SkeletonModule, never, [typeof SkeletonComponent], [typeof SkeletonComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<SkeletonModule>;
}

export { SkeletonComponent, SkeletonModule };
export type { SkeletonType };
