import * as i0 from '@angular/core';
import { EventEmitter, Output, ChangeDetectionStrategy, Component, Input, TemplateRef, ViewChild, Directive, signal, booleanAttribute, ContentChild, HostBinding, ViewEncapsulation, inject, DestroyRef, computed, ContentChildren, NgModule } from '@angular/core';
import { IconComponent } from '@fundamental-ngx/core/icon';
import { ToolbarComponent, ToolbarSpacerDirective, ToolbarLabelDirective, ToolbarModule } from '@fundamental-ngx/core/toolbar';
import { FdTranslatePipe } from '@fundamental-ngx/i18n';
import { ENTER, MAC_ENTER, F2, F7, ESCAPE, SPACE, UP_ARROW, DOWN_ARROW, LEFT_ARROW, RIGHT_ARROW, HOME, END, TAB } from '@angular/cdk/keycodes';
import { Subscription, BehaviorSubject, filter } from 'rxjs';
import * as i3 from '@fundamental-ngx/cdk/utils';
import { KeyUtil, RangeSelector, RtlService, KeyboardSupportService } from '@fundamental-ngx/cdk/utils';
import { NgTemplateOutlet } from '@angular/common';
import * as i4 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import { ButtonComponent, ButtonModule } from '@fundamental-ngx/core/button';
import * as i2 from '@fundamental-ngx/core/content-density';
import { ContentDensityModule, contentDensityObserverProviders } from '@fundamental-ngx/core/content-density';
import { ObjectStatusComponent } from '@fundamental-ngx/core/object-status';
import { takeUntilDestroyed } from '@angular/core/rxjs-interop';
import { startWith } from 'rxjs/operators';
import { AvatarModule } from '@fundamental-ngx/core/avatar';

class GridListFilterBarComponent {
    constructor() {
        /** Event is thrown, when the control button is clicked */
        // eslint-disable-next-line @angular-eslint/no-output-native
        this.close = new EventEmitter();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListFilterBarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: GridListFilterBarComponent, isStandalone: true, selector: "fd-grid-list-filter-bar", outputs: { close: "close" }, host: { classAttribute: "fd-col fd-col--12" }, ngImport: i0, template: "<fd-toolbar\n    fdType=\"info\"\n    [active]=\"true\"\n    [tabindex]=\"0\"\n    class=\"fd-grid-list__filter\"\n    [attr.aria-label]=\"'coreGridList.filterBarCancelButtonTitle' | fdTranslate\"\n    (click)=\"close.emit()\"\n    (keydown.space)=\"$event.preventDefault()\"\n    (keyup.space)=\"close.emit()\"\n    (keydown.enter)=\"close.emit()\"\n>\n    <ng-content></ng-content>\n\n    <fd-toolbar-spacer></fd-toolbar-spacer>\n\n    <fd-icon glyph=\"decline\"></fd-icon>\n</fd-toolbar>\n", dependencies: [{ kind: "component", type: ToolbarComponent, selector: "fd-toolbar", inputs: ["titleId", "class", "shouldOverflow", "fdType", "title", "active", "clearBorder", "forceOverflow", "tabindex", "headingLevel", "ariaLabel", "ariaLabelledBy"] }, { kind: "directive", type: ToolbarSpacerDirective, selector: "fd-toolbar-spacer", inputs: ["width", "class", "fixed"] }, { kind: "component", type: IconComponent, selector: "fd-icon", inputs: ["glyph", "font", "color", "background", "class", "ariaLabel", "ariaHidden"] }, { kind: "pipe", type: FdTranslatePipe, name: "fdTranslate" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListFilterBarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-grid-list-filter-bar', host: {
                        class: 'fd-col fd-col--12'
                    }, changeDetection: ChangeDetectionStrategy.OnPush, imports: [ToolbarComponent, ToolbarSpacerDirective, IconComponent, FdTranslatePipe], template: "<fd-toolbar\n    fdType=\"info\"\n    [active]=\"true\"\n    [tabindex]=\"0\"\n    class=\"fd-grid-list__filter\"\n    [attr.aria-label]=\"'coreGridList.filterBarCancelButtonTitle' | fdTranslate\"\n    (click)=\"close.emit()\"\n    (keydown.space)=\"$event.preventDefault()\"\n    (keyup.space)=\"close.emit()\"\n    (keydown.enter)=\"close.emit()\"\n>\n    <ng-content></ng-content>\n\n    <fd-toolbar-spacer></fd-toolbar-spacer>\n\n    <fd-icon glyph=\"decline\"></fd-icon>\n</fd-toolbar>\n" }]
        }], propDecorators: { close: [{
                type: Output
            }] } });

class GridListFooterComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListFooterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: GridListFooterComponent, isStandalone: true, selector: "fd-grid-list-footer", host: { classAttribute: "fd-col fd-col--12" }, ngImport: i0, template: "<div tabindex=\"0\" class=\"fd-grid-list__footer\">\n    <ng-content></ng-content>\n</div>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListFooterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-grid-list-footer', host: {
                        class: 'fd-col fd-col--12'
                    }, changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, template: "<div tabindex=\"0\" class=\"fd-grid-list__footer\">\n    <ng-content></ng-content>\n</div>\n" }]
        }] });

class GridListGroupHeaderComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListGroupHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: GridListGroupHeaderComponent, isStandalone: true, selector: "fd-grid-list-group-header", inputs: { ariaLabel: "ariaLabel" }, host: { classAttribute: "fd-col fd-col--12" }, ngImport: i0, template: "<div class=\"fd-grid-list__group-header fd-grid-list__group-header--no-margin\" [attr.aria-label]=\"ariaLabel\">\n    <ng-content></ng-content>\n</div>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListGroupHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-grid-list-group-header', changeDetection: ChangeDetectionStrategy.OnPush, host: {
                        class: 'fd-col fd-col--12'
                    }, standalone: true, template: "<div class=\"fd-grid-list__group-header fd-grid-list__group-header--no-margin\" [attr.aria-label]=\"ariaLabel\">\n    <ng-content></ng-content>\n</div>\n" }]
        }], propDecorators: { ariaLabel: [{
                type: Input
            }] } });

class GridListItemFooterBarComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListItemFooterBarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: GridListItemFooterBarComponent, isStandalone: true, selector: "fd-grid-list-item-footer-bar", viewQueries: [{ propertyName: "contentTemplateRef", first: true, predicate: TemplateRef, descendants: true }], ngImport: i0, template: "<ng-template>\n    <ng-content></ng-content>\n</ng-template>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListItemFooterBarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-grid-list-item-footer-bar', changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, template: "<ng-template>\n    <ng-content></ng-content>\n</ng-template>\n" }]
        }], propDecorators: { contentTemplateRef: [{
                type: ViewChild,
                args: [TemplateRef]
            }] } });

class GridListItemToolbarComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListItemToolbarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: GridListItemToolbarComponent, isStandalone: true, selector: "fd-grid-list-item-toolbar", viewQueries: [{ propertyName: "contentTemplateRef", first: true, predicate: TemplateRef, descendants: true }], ngImport: i0, template: "<ng-template>\n    <ng-content></ng-content>\n</ng-template>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListItemToolbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-grid-list-item-toolbar', changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, template: "<ng-template>\n    <ng-content></ng-content>\n</ng-template>\n" }]
        }], propDecorators: { contentTemplateRef: [{
                type: ViewChild,
                args: [TemplateRef]
            }] } });

class GridListItemBodyDirective {
    /** @hidden */
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListItemBodyDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: GridListItemBodyDirective, isStandalone: true, selector: "[fd-grid-list-item-body]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListItemBodyDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-grid-list-item-body]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }] });

/** Parse layout pattern */
function parseLayoutPattern(pattern, isBaseLayout = true) {
    const parseLayout = pattern && validateAndParseLayoutPattern(pattern, isBaseLayout);
    if (!parseLayout) {
        throw new Error('Invalid layoutPattern.');
    }
    return generateLayoutClasses(parseLayout);
}
function validateAndParseLayoutPattern(pattern, isBaseLayout) {
    const columnsNames = 'XL|L|M|S';
    const columnNumbers = isBaseLayout ? '12|6|4|3|2|1' : '12|11|10|9|8|7|6|5|4|3|2|1';
    const reg = new RegExp(`(?!-)((${columnsNames})(${columnNumbers}))`, 'gi');
    const match = pattern.match(reg);
    if (!match) {
        return;
    }
    return match.reduce((res, item) => {
        const size = item.replace(reg, '$2').toLocaleLowerCase();
        const num = +item.replace(reg, '$3');
        res[size] = {
            pattern: item,
            size,
            value: isBaseLayout ? 12 / num : num
        };
        return res;
    }, {});
}
function generateLayoutClasses({ xl, l, m, s }) {
    const classes = ['fd-col'];
    if (s) {
        classes.push(`fd-col--${s.value}`);
    }
    if (m) {
        classes.push(`fd-col-md--${m.value}`);
    }
    if (l) {
        classes.push(`fd-col-lg--${l.value}`);
    }
    if (xl) {
        classes.push(`fd-col-xl--${xl.value}`);
    }
    return classes;
}

var GridListSelectionActions;
(function (GridListSelectionActions) {
    GridListSelectionActions["ADD"] = "add";
    GridListSelectionActions["REMOVE"] = "remove";
})(GridListSelectionActions || (GridListSelectionActions = {}));
var GridListSelectionModeEnum;
(function (GridListSelectionModeEnum) {
    GridListSelectionModeEnum["NONE"] = "none";
    GridListSelectionModeEnum["DELETE"] = "delete";
    GridListSelectionModeEnum["SINGLE_SELECT"] = "singleSelect";
    GridListSelectionModeEnum["SINGLE_SELECT_LEFT"] = "singleSelectLeft";
    GridListSelectionModeEnum["SINGLE_SELECT_RIGHT"] = "singleSelectRight";
    GridListSelectionModeEnum["MULTI_SELECT"] = "multiSelect";
})(GridListSelectionModeEnum || (GridListSelectionModeEnum = {}));

class GridListTitleBarSpacerComponent extends ToolbarSpacerDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListTitleBarSpacerComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: GridListTitleBarSpacerComponent, isStandalone: true, selector: "fd-grid-list-title-bar-spacer", usesInheritance: true, ngImport: i0, template: '', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListTitleBarSpacerComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'fd-grid-list-title-bar-spacer',
                    template: '',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    standalone: true
                }]
        }] });

class GridList {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridList, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: GridList, isStandalone: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridList, decorators: [{
            type: Directive
        }] });

let gridListItemUniqueId = 0;
class GridListItemComponent {
    /**
     * specify the cell layout in the format `XLn-Ln-Mn-Sn` where n is
     * the number of occupied columns and n can be different for each size.
     */
    set layoutItemPattern(value) {
        this.gridLayoutClasses = value ? parseLayoutPattern(value, false) : [];
    }
    /**
     * Defines the type of Grid List Item
     * Types:
     * - active: indicates that the item is clickable via active feedback when item is pressed
     * - detail: enables detail button of the list item that fires event.
     * - detailsAndActive: enables "detail" and "active" enumerations together
     * - inactive: indicates the list item does not have any active feedback when item is pressed
     * - navigation: indicates the list item is navigable to show extra information about the item
     * Default: inactive
     */
    set type(value) {
        this._type = value ?? 'inactive';
    }
    get type() {
        return this._type;
    }
    /** @hidden */
    set gridLayoutClasses(value) {
        this._removeClassesNames(this._gridLayoutClasses);
        this._gridLayoutClasses = value;
        this._addClassesNames(this._gridLayoutClasses);
    }
    get gridLayoutClasses() {
        return this._gridLayoutClasses;
    }
    /** @hidden */
    set selectionMode(mode) {
        this._selectionMode = mode;
        if (mode !== GridListSelectionModeEnum.DELETE && mode !== GridListSelectionModeEnum.NONE && !this.value) {
            throw new Error('Grid List Item must have [value] attribute.');
        }
        if (this.selected && this.value && this._index != null) {
            const action = this.selectionMode !== GridListSelectionModeEnum.MULTI_SELECT ? null : GridListSelectionActions.ADD;
            this._gridList.setSelectedItem(this.value, this._index, action);
        }
        this._cd.detectChanges();
    }
    get selectionMode() {
        return this._selectionMode;
    }
    /** @hidden */
    constructor(_cd, _elementRef, _render, _gridList, _contentDensityObserver, _tabbableElementService) {
        this._cd = _cd;
        this._elementRef = _elementRef;
        this._render = _render;
        this._gridList = _gridList;
        this._contentDensityObserver = _contentDensityObserver;
        this._tabbableElementService = _tabbableElementService;
        /** id for the Element */
        this.id = `fd-grid-list-item-${gridListItemUniqueId++}`;
        /** Whether click on the custom toolbar is disabled */
        this.disableToolbarClick = false;
        /** Allows an item to be selected programmatically */
        this.selected = false;
        /** Remove the padding from the Item body */
        this.noPadding = false;
        /**
         * The navigated state of the list item.
         * If set to true, a navigation indicator is displayed at the end of the list item.
         */
        this.isNavigated = false;
        /**
         * Aria-level of the title
         * Available options: 1, 2, 3, 4, 5, 6
         * Default: 4
         */
        this.titleLevel = 4;
        /** When set to true the grid list item's height will be set to auto */
        this.autoHeight = false;
        /**
         * Event is thrown, when type is active
         * and item is pressed
         */
        this.press = new EventEmitter();
        /**
         * Event is thrown, when type is detail or detailsAndActive
         * and Detail button was pressed
         */
        this.detail = new EventEmitter();
        /**
         * Event is thrown, when mode delete
         * and Delete button was pressed
         */
        this.delete = new EventEmitter();
        /**
         * Event is thrown, when type is navigation
         * and Navigate button was pressed
         */
        this.navigate = new EventEmitter();
        /**
         * Event is thrown on grid list item click.
         */
        this.cardClick = new EventEmitter();
        /**
         * Event is thrown, when state is error, not used GridListItemFooterBarComponent
         * and Draft button was pressed
         */
        this.draft = new EventEmitter();
        /**
         * Event is thrown, when state is locked, not used GridListItemFooterBarComponent
         * and Locked button was pressed
         */
        this.locked = new EventEmitter();
        /** @hidden
         * The active state of the list item.
         * If set to true, the whole card has active state. Becomes false only when the Edit button is clicked.
         */
        this._isActive = true;
        /** tabIndex of the element */
        this.tabIndex = signal(-1);
        /** @hidden */
        this._type = 'inactive';
        /** @hidden */
        this._gridLayoutClasses = [];
        /** @hidden */
        this.subscription = new Subscription();
        /** @hidden */
        this._innerElementFocused = signal(false);
        const selectedItemsSub = this._gridList._selectedItems$.subscribe((items) => {
            this._selectedItem = items.selection.find((item) => item === this.value);
            this._cd.markForCheck();
        });
        this.subscription.add(selectedItemsSub);
    }
    /** @hidden */
    ngAfterViewInit() {
        this._cd.detectChanges();
    }
    /** @hidden */
    ngOnDestroy() {
        this.subscription.unsubscribe();
    }
    /** Focus grid list item programmatically */
    focus(options) {
        this._gridListItem?.nativeElement.focus(options);
    }
    /** @hidden */
    _setActive(event, isActive) {
        if (this._isElementCanBeClicked(event)) {
            return;
        }
        this._isActive = isActive;
    }
    /** @hidden */
    _singleSelect(event) {
        this._preventDefault(event);
        if (typeof this._selectedItem !== 'undefined' || !this.value || this._index == null) {
            return;
        }
        this._gridList.setSelectedItem(this.value, this._index);
    }
    /** @hidden */
    _checkboxClick(event) {
        const checked = event.target.checked;
        this._selectionItem(checked, event);
    }
    /** @hidden */
    _checkboxEscape() {
        this._gridListItem.nativeElement.focus();
    }
    /** @hidden */
    _selectionItem(value, event) {
        if (!this.value || this._index == null) {
            return;
        }
        const action = this.selectionMode !== GridListSelectionModeEnum.MULTI_SELECT
            ? null
            : value || value === 0
                ? GridListSelectionActions.ADD
                : GridListSelectionActions.REMOVE;
        this._gridList.setSelectedItem(this.value, this._index, action, event);
    }
    /** @hidden */
    _onDetail(event) {
        this._preventDefault(event);
        this.detail.emit(this._outputEventValue);
    }
    /** @hidden */
    _onNavigate(event) {
        this._preventDefault(event);
        this.navigate.emit(this._outputEventValue);
    }
    /** @hidden */
    _onDelete(event) {
        this._preventDefault(event);
        this.delete.emit(this._outputEventValue);
    }
    /** @hidden */
    _clickOnDraft(event) {
        this._preventDefault(event);
        this.draft.emit(this._outputEventValue);
    }
    /** @hidden */
    _clickOnLocked(event) {
        this._preventDefault(event);
        this.locked.emit(this._outputEventValue);
    }
    /** @hidden */
    _onClick(event) {
        if (!this._isElementCanBeClicked(event)) {
            return;
        }
        if (this.type !== 'active' && this.type !== 'detailsAndActive' && this.type !== 'navigation') {
            this.cardClick.emit(this._outputEventValue);
            return;
        }
        if (this.type === 'navigation') {
            this._onNavigate(event);
            return;
        }
        this.press.emit(this._outputEventValue);
        this.cardClick.emit(this._outputEventValue);
    }
    /** @hidden */
    _onKeyDown(event) {
        const activeElement = document.activeElement;
        const isFocused = activeElement === this._gridListItem.nativeElement;
        const shouldFocusChild = KeyUtil.isKeyCode(event, [ENTER, MAC_ENTER, F2, F7]) && !event.shiftKey && isFocused;
        if (shouldFocusChild) {
            event.stopPropagation();
            const interactiveElements = this._gridListItem.nativeElement.querySelectorAll('a, button, input, select, textarea');
            const firstInteractiveElement = interactiveElements[0];
            firstInteractiveElement.focus();
            interactiveElements.forEach((element) => {
                element.setAttribute('tabindex', '0');
            });
            this._innerElementFocused.set(true);
            return;
        }
        else if (this._innerElementFocused() && KeyUtil.isKeyCode(event, [F2, F7, ESCAPE])) {
            event.stopPropagation();
            this._gridListItem.nativeElement.focus();
            this._innerElementFocused.set(false);
            return;
        }
        const target = event.target;
        const isSelectionKeyDown = KeyUtil.isKeyCode(event, [ENTER, SPACE]);
        if (isSelectionKeyDown && this.selectionMode === GridListSelectionModeEnum.NONE) {
            this.press.emit(this._outputEventValue);
        }
        if (!isSelectionKeyDown ||
            this.selectionMode === GridListSelectionModeEnum.NONE ||
            !target.classList.contains('fd-grid-list__item')) {
            return;
        }
        this._preventDefault(event);
        if (this.selectionMode === GridListSelectionModeEnum.MULTI_SELECT) {
            this._selectionItem(!this._selectedItem);
            return;
        }
        if (typeof this._selectedItem === 'undefined') {
            this._singleSelect(event);
        }
    }
    /** @hidden */
    _isElementCanBeClicked(event) {
        if (!event?.target) {
            return false;
        }
        const element = event.target;
        const { classList } = element;
        return (!(this._isToolbarElement(element) && this.disableToolbarClick) &&
            !classList.contains('fd-grid-list__action-button') &&
            !classList.contains('fd-grid-list__radio-label') &&
            !classList.contains('fd-grid-list__radio-input') &&
            !classList.contains('fd-grid-list__checkbox-label') &&
            !classList.contains('fd-grid-list__checkbox-input') &&
            !classList.contains('fd-checkbox__checkmark'));
    }
    /** @hidden */
    _isToolbarElement(element) {
        if (!this.itemToolbarComponent) {
            return false;
        }
        while (element.parentElement && !element.parentElement.classList.contains('fd-grid-list__item')) {
            if (element.classList.contains('fd-toolbar--extra-content')) {
                return true;
            }
            element = element.parentElement;
        }
        return false;
    }
    /** @hidden */
    _preventDefault(event) {
        event.preventDefault();
        event.stopPropagation();
    }
    /** @hidden */
    get _outputEventValue() {
        return {
            value: this.value,
            index: this._index
        };
    }
    /** @hidden */
    _addClassesNames(classesNames) {
        for (const className of classesNames) {
            this._render.addClass(this._elementRef.nativeElement, className);
        }
    }
    /** @hidden */
    _removeClassesNames(classesNames) {
        for (const className of classesNames) {
            this._render.removeClass(this._elementRef.nativeElement, className);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListItemComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.Renderer2 }, { token: GridList }, { token: i2.ContentDensityObserver }, { token: i3.TabbableElementService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: GridListItemComponent, isStandalone: true, selector: "fd-grid-list-item", inputs: { id: "id", width: "width", layoutItemPattern: "layoutItemPattern", status: "status", counter: "counter", value: "value", disableToolbarClick: "disableToolbarClick", selected: ["selected", "selected", booleanAttribute], noPadding: "noPadding", ariaLabel: "ariaLabel", ariaLabelledBy: "ariaLabelledBy", type: "type", state: "state", isNavigated: "isNavigated", title: "title", titleLevel: "titleLevel", description: "description", autoHeight: "autoHeight" }, outputs: { press: "press", detail: "detail", delete: "delete", navigate: "navigate", cardClick: "cardClick", draft: "draft", locked: "locked" }, host: { properties: { "style.max-width": "this.width", "style.min-width": "this.width" } }, providers: [contentDensityObserverProviders()], queries: [{ propertyName: "footerBarComponent", first: true, predicate: GridListItemFooterBarComponent, descendants: true }, { propertyName: "itemToolbarComponent", first: true, predicate: GridListItemToolbarComponent, descendants: true }, { propertyName: "body", first: true, predicate: GridListItemBodyDirective, descendants: true }], viewQueries: [{ propertyName: "_gridListItem", first: true, predicate: ["gridListItem"], descendants: true }], ngImport: i0, template: "<div\n    #gridListItem\n    [id]=\"id\"\n    [tabindex]=\"tabIndex()\"\n    class=\"fd-grid-list__item\"\n    role=\"option\"\n    [class.is-navigated]=\"isNavigated\"\n    [class.is-selected]=\"!!_selectedItem\"\n    [class.fd-grid-list__item--link]=\"\n        _isActive && (type === 'active' || type === 'detailsAndActive' || type === 'navigation')\n    \"\n    [class.fd-grid-list__item--unread]=\"state === 'unread'\"\n    [class.fd-grid-list__item--locked]=\"state === 'locked'\"\n    [class.fd-grid-list__item--draft]=\"state === 'draft'\"\n    [class.fd-grid-list__item--error]=\"state === 'error'\"\n    [class.fd-grid-list__item--height-auto]=\"autoHeight\"\n    (keydown)=\"_onKeyDown($event)\"\n    (click)=\"selectionMode === 'singleSelect' && _singleSelect($event); _onClick($event)\"\n    [attr.aria-label]=\"ariaLabel\"\n    [attr.aria-labelledby]=\"ariaLabelledBy\"\n    (mouseover)=\"_setActive($event, false)\"\n    (mouseout)=\"_setActive($event, true)\"\n    [attr.aria-selected]=\"selectionMode === 'none' ? null : !!_selectedItem\"\n>\n    @if (status) {\n        <span\n            class=\"fd-grid-list__highlight\"\n            [class.fd-grid-list__highlight--positive]=\"status === 'success'\"\n            [class.fd-grid-list__highlight--critical]=\"status === 'warning'\"\n            [class.fd-grid-list__highlight--negative]=\"status === 'error'\"\n            [class.fd-grid-list__highlight--neutral]=\"status === 'neutral'\"\n            [attr.aria-label]=\"'coreGridList.listItemStatusAriaLabel' | fdTranslate: { status: status }\"\n        ></span>\n    }\n    @if (selectionMode === 'singleSelect') {\n        <ng-template [ngTemplateOutlet]=\"radio\"></ng-template>\n    }\n    @if (\n        counter ||\n        itemToolbarComponent?.contentTemplateRef ||\n        (type && type !== 'inactive' && type !== 'active') ||\n        (selectionMode !== 'none' && selectionMode !== 'singleSelect')\n    ) {\n        <div class=\"fd-toolbar fd-grid-list__item-toolbar\">\n            @if (selectionMode === 'singleSelectLeft') {\n                <ng-template [ngTemplateOutlet]=\"radio\"></ng-template>\n            }\n            @if (selectionMode === 'multiSelect') {\n                <ng-template [ngTemplateOutlet]=\"checkbox\"></ng-template>\n            }\n            @if (itemToolbarComponent?.contentTemplateRef) {\n                <div class=\"fd-toolbar--extra-content\">\n                    <ng-template [ngTemplateOutlet]=\"itemToolbarComponent!.contentTemplateRef\"></ng-template>\n                </div>\n            }\n            <fd-grid-list-title-bar-spacer></fd-grid-list-title-bar-spacer>\n            @if (counter) {\n                <span\n                    class=\"fd-grid-list__item-counter\"\n                    [attr.aria-label]=\"'coreGridList.listItemCounterAriaLabel' | fdTranslate: { count: counter }\"\n                    >{{ counter }}</span\n                >\n            }\n            @if (type === 'detail' || type === 'detailsAndActive') {\n                <button\n                    fd-button\n                    fdType=\"transparent\"\n                    glyph=\"edit\"\n                    class=\"fd-grid-list__action-button\"\n                    [attr.aria-label]=\"'coreGridList.listItemButtonDetailsTitle' | fdTranslate\"\n                    [title]=\"'coreGridList.listItemButtonDetailsTitle' | fdTranslate\"\n                    fdCompact\n                    (click)=\"_onDetail($event)\"\n                ></button>\n            }\n            @if (selectionMode === 'delete') {\n                <button\n                    fd-button\n                    fdType=\"transparent\"\n                    glyph=\"decline\"\n                    class=\"fd-grid-list__action-button\"\n                    [attr.aria-label]=\"'coreGridList.listItemButtonDeleteTitle' | fdTranslate\"\n                    [title]=\"'coreGridList.listItemButtonDeleteTitle' | fdTranslate\"\n                    title=\"Delete\"\n                    fdCompact\n                    (click)=\"_onDelete($event)\"\n                ></button>\n            }\n            @if (type === 'navigation') {\n                <span class=\"fd-grid-list__item-navigation-indicator\">\n                    <fd-icon glyph=\"navigation-right-arrow\"></fd-icon>\n                </span>\n            }\n            @if (selectionMode === 'singleSelectRight') {\n                <ng-template [ngTemplateOutlet]=\"radio\"></ng-template>\n            }\n        </div>\n    }\n    <div class=\"fd-grid-list__item-body\" [class.fd-grid-list__item-body--no-padding]=\"noPadding\">\n        <ng-content select=\"[fd-grid-list-item-image]\"></ng-content>\n        @if (title || description) {\n            <div class=\"fd-grid-list__item-header\">\n                @if (title) {\n                    <div\n                        role=\"heading\"\n                        [attr.aria-level]=\"titleLevel\"\n                        class=\"fd-title fd-title--h4 fd-grid-list__item-title\"\n                    >\n                        {{ title }}\n                    </div>\n                }\n                @if (description) {\n                    <span class=\"fd-grid-list__item-subtitle\">{{ description }}</span>\n                }\n            </div>\n        }\n        @if (body?.templateRef) {\n            <div class=\"fd-grid-list__item-content\">\n                <ng-template [ngTemplateOutlet]=\"body!.templateRef\"></ng-template>\n            </div>\n        }\n        @if (state || footerBarComponent?.contentTemplateRef) {\n            <ng-template [ngTemplateOutlet]=\"itemFooter\"></ng-template>\n        }\n    </div>\n</div>\n<ng-template #radio>\n    <input\n        [attr.tabindex]=\"selectionMode === 'singleSelect' ? -1 : 0\"\n        type=\"radio\"\n        class=\"fd-radio fd-grid-list__radio-input\"\n        [style.display]=\"selectionMode === 'singleSelect' ? 'none' : ''\"\n        [id]=\"id + '-radio'\"\n        [name]=\"'fd-grid-list-item-toolbar-' + selectionMode\"\n        [attr.aria-label]=\"ariaLabel\"\n        [attr.aria-labelledby]=\"ariaLabelledBy\"\n        [value]=\"value\"\n        [ngModel]=\"_selectedItem\"\n        (ngModelChange)=\"$event && _selectionItem($event)\"\n    />\n    <label\n        class=\"fd-radio__label fd-grid-list__radio-label\"\n        [for]=\"id + '-radio'\"\n        tabindex=\"-1\"\n        (mouseover)=\"_setActive($event, false)\"\n        (mouseout)=\"_setActive($event, true)\"\n    ></label>\n</ng-template>\n<ng-template #checkbox>\n    <input\n        type=\"checkbox\"\n        class=\"fd-checkbox fd-grid-list__checkbox-input\"\n        [id]=\"id + '-checkbox'\"\n        [attr.aria-label]=\"ariaLabel\"\n        [attr.aria-labelledby]=\"ariaLabelledBy\"\n        [ngModel]=\"_selectedItem\"\n        (click)=\"_checkboxClick($event)\"\n        (keydown.escape)=\"_checkboxEscape()\"\n        (keydown.shift)=\"_checkboxEscape()\"\n    />\n    <label class=\"fd-checkbox__label fd-grid-list__checkbox-label\" [for]=\"id + '-checkbox'\" tabindex=\"-1\">\n        <span class=\"fd-checkbox__checkmark\" aria-hidden=\"true\"></span>\n    </label>\n</ng-template>\n<ng-template #itemFooter>\n    @if (footerBarComponent || state) {\n        <div class=\"fd-grid-list__item-body-actions\">\n            @if (footerBarComponent?.contentTemplateRef) {\n                <ng-template [ngTemplateOutlet]=\"footerBarComponent!.contentTemplateRef\"></ng-template>\n            }\n            @if (!footerBarComponent?.contentTemplateRef && state) {\n                @if (state === 'error') {\n                    <span\n                        fd-object-status\n                        status=\"negative\"\n                        [label]=\"'coreGridList.listItemStatusContainsErrors' | fdTranslate\"\n                        [attr.aria-label]=\"'coreGridList.listItemStatusContainsErrors' | fdTranslate\"\n                    ></span>\n                }\n                @if (state === 'locked') {\n                    <button\n                        class=\"fd-grid-list__action-button\"\n                        fd-button\n                        fdType=\"transparent\"\n                        glyph=\"private\"\n                        [label]=\"'coreGridList.listItemStatusLocked' | fdTranslate\"\n                        [attr.aria-label]=\"'coreGridList.listItemStatusLocked' | fdTranslate\"\n                        [attr.data-test-id]=\"'coreGridList.listItemStatusLocked' | fdTranslate\"\n                        fdCompact\n                        (click)=\"_clickOnLocked($event)\"\n                    ></button>\n                }\n                @if (state === 'draft') {\n                    <button\n                        class=\"fd-grid-list__action-button\"\n                        fd-button\n                        fdType=\"transparent\"\n                        [attr.aria-label]=\"'coreGridList.listItemStatusDraft' | fdTranslate\"\n                        [label]=\"'coreGridList.listItemStatusDraft' | fdTranslate\"\n                        [attr.data-test-id]=\"'coreGridList.listItemStatusDraft' | fdTranslate\"\n                        fdCompact\n                        (click)=\"_clickOnDraft($event)\"\n                    ></button>\n                }\n            }\n        </div>\n    }\n</ng-template>\n", styles: [".fd-grid-list .fd-dnd-item.fd-dnd-on-drag{cursor:-webkit-grabbing;cursor:-moz-grabbing;cursor:-o-grabbing;cursor:-ms-grabbing;cursor:grabbing;background-color:transparent}.fd-grid-list .fd-dnd-item .fd-grid-list__item{overflow:visible}.fd-grid-list__item .drop-area__line--vertical{height:100%}.fd-grid-list__item .drop-area__line--vertical.before{left:-.55rem}.fd-grid-list__item .drop-area__line--vertical.after{right:-.55rem}.fd-grid-list__item .fd-checkbox__label{-webkit-user-select:none;user-select:none}\n"], dependencies: [{ kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: GridListTitleBarSpacerComponent, selector: "fd-grid-list-title-bar-spacer" }, { kind: "component", type: ButtonComponent, selector: "button[fd-button], a[fd-button], span[fd-button]", inputs: ["class"], exportAs: ["fd-button"] }, { kind: "component", type: IconComponent, selector: "fd-icon", inputs: ["glyph", "font", "color", "background", "class", "ariaLabel", "ariaHidden"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i4.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i4.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }, { kind: "directive", type: i4.RadioControlValueAccessor, selector: "input[type=radio][formControlName],input[type=radio][formControl],input[type=radio][ngModel]", inputs: ["name", "formControlName", "value"] }, { kind: "directive", type: i4.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i4.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: ObjectStatusComponent, selector: "[fd-object-status]", inputs: ["class", "status", "glyph", "glyphFont", "label", "glyphAriaLabel", "indicationColor", "clickable", "inverted", "large", "secondaryIndication", "textTemplate"] }, { kind: "pipe", type: FdTranslatePipe, name: "fdTranslate" }, { kind: "ngmodule", type: ContentDensityModule }, { kind: "directive", type: i2.ContentDensityDirective, selector: "[fdContentDensity]:not([fdCompact]):not([fdCondensed]):not([fdCozy]),                [fdCompact]:not([fdContentDensity]):not([fdCondensed]):not([fdCozy]),                [fdCondensed]:not([fdContentDensity]):not([fdCompact]):not([fdCozy]),                [fdCozy]:not([fdContentDensity]):not([fdCompact]):not([fdCondensed])", inputs: ["fdContentDensity", "fdCompact", "fdCondensed", "fdCozy"], exportAs: ["fdContentDensity"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-grid-list-item', changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, imports: [
                        NgTemplateOutlet,
                        GridListTitleBarSpacerComponent,
                        ButtonComponent,
                        IconComponent,
                        FormsModule,
                        ObjectStatusComponent,
                        FdTranslatePipe,
                        ContentDensityModule
                    ], providers: [contentDensityObserverProviders()], template: "<div\n    #gridListItem\n    [id]=\"id\"\n    [tabindex]=\"tabIndex()\"\n    class=\"fd-grid-list__item\"\n    role=\"option\"\n    [class.is-navigated]=\"isNavigated\"\n    [class.is-selected]=\"!!_selectedItem\"\n    [class.fd-grid-list__item--link]=\"\n        _isActive && (type === 'active' || type === 'detailsAndActive' || type === 'navigation')\n    \"\n    [class.fd-grid-list__item--unread]=\"state === 'unread'\"\n    [class.fd-grid-list__item--locked]=\"state === 'locked'\"\n    [class.fd-grid-list__item--draft]=\"state === 'draft'\"\n    [class.fd-grid-list__item--error]=\"state === 'error'\"\n    [class.fd-grid-list__item--height-auto]=\"autoHeight\"\n    (keydown)=\"_onKeyDown($event)\"\n    (click)=\"selectionMode === 'singleSelect' && _singleSelect($event); _onClick($event)\"\n    [attr.aria-label]=\"ariaLabel\"\n    [attr.aria-labelledby]=\"ariaLabelledBy\"\n    (mouseover)=\"_setActive($event, false)\"\n    (mouseout)=\"_setActive($event, true)\"\n    [attr.aria-selected]=\"selectionMode === 'none' ? null : !!_selectedItem\"\n>\n    @if (status) {\n        <span\n            class=\"fd-grid-list__highlight\"\n            [class.fd-grid-list__highlight--positive]=\"status === 'success'\"\n            [class.fd-grid-list__highlight--critical]=\"status === 'warning'\"\n            [class.fd-grid-list__highlight--negative]=\"status === 'error'\"\n            [class.fd-grid-list__highlight--neutral]=\"status === 'neutral'\"\n            [attr.aria-label]=\"'coreGridList.listItemStatusAriaLabel' | fdTranslate: { status: status }\"\n        ></span>\n    }\n    @if (selectionMode === 'singleSelect') {\n        <ng-template [ngTemplateOutlet]=\"radio\"></ng-template>\n    }\n    @if (\n        counter ||\n        itemToolbarComponent?.contentTemplateRef ||\n        (type && type !== 'inactive' && type !== 'active') ||\n        (selectionMode !== 'none' && selectionMode !== 'singleSelect')\n    ) {\n        <div class=\"fd-toolbar fd-grid-list__item-toolbar\">\n            @if (selectionMode === 'singleSelectLeft') {\n                <ng-template [ngTemplateOutlet]=\"radio\"></ng-template>\n            }\n            @if (selectionMode === 'multiSelect') {\n                <ng-template [ngTemplateOutlet]=\"checkbox\"></ng-template>\n            }\n            @if (itemToolbarComponent?.contentTemplateRef) {\n                <div class=\"fd-toolbar--extra-content\">\n                    <ng-template [ngTemplateOutlet]=\"itemToolbarComponent!.contentTemplateRef\"></ng-template>\n                </div>\n            }\n            <fd-grid-list-title-bar-spacer></fd-grid-list-title-bar-spacer>\n            @if (counter) {\n                <span\n                    class=\"fd-grid-list__item-counter\"\n                    [attr.aria-label]=\"'coreGridList.listItemCounterAriaLabel' | fdTranslate: { count: counter }\"\n                    >{{ counter }}</span\n                >\n            }\n            @if (type === 'detail' || type === 'detailsAndActive') {\n                <button\n                    fd-button\n                    fdType=\"transparent\"\n                    glyph=\"edit\"\n                    class=\"fd-grid-list__action-button\"\n                    [attr.aria-label]=\"'coreGridList.listItemButtonDetailsTitle' | fdTranslate\"\n                    [title]=\"'coreGridList.listItemButtonDetailsTitle' | fdTranslate\"\n                    fdCompact\n                    (click)=\"_onDetail($event)\"\n                ></button>\n            }\n            @if (selectionMode === 'delete') {\n                <button\n                    fd-button\n                    fdType=\"transparent\"\n                    glyph=\"decline\"\n                    class=\"fd-grid-list__action-button\"\n                    [attr.aria-label]=\"'coreGridList.listItemButtonDeleteTitle' | fdTranslate\"\n                    [title]=\"'coreGridList.listItemButtonDeleteTitle' | fdTranslate\"\n                    title=\"Delete\"\n                    fdCompact\n                    (click)=\"_onDelete($event)\"\n                ></button>\n            }\n            @if (type === 'navigation') {\n                <span class=\"fd-grid-list__item-navigation-indicator\">\n                    <fd-icon glyph=\"navigation-right-arrow\"></fd-icon>\n                </span>\n            }\n            @if (selectionMode === 'singleSelectRight') {\n                <ng-template [ngTemplateOutlet]=\"radio\"></ng-template>\n            }\n        </div>\n    }\n    <div class=\"fd-grid-list__item-body\" [class.fd-grid-list__item-body--no-padding]=\"noPadding\">\n        <ng-content select=\"[fd-grid-list-item-image]\"></ng-content>\n        @if (title || description) {\n            <div class=\"fd-grid-list__item-header\">\n                @if (title) {\n                    <div\n                        role=\"heading\"\n                        [attr.aria-level]=\"titleLevel\"\n                        class=\"fd-title fd-title--h4 fd-grid-list__item-title\"\n                    >\n                        {{ title }}\n                    </div>\n                }\n                @if (description) {\n                    <span class=\"fd-grid-list__item-subtitle\">{{ description }}</span>\n                }\n            </div>\n        }\n        @if (body?.templateRef) {\n            <div class=\"fd-grid-list__item-content\">\n                <ng-template [ngTemplateOutlet]=\"body!.templateRef\"></ng-template>\n            </div>\n        }\n        @if (state || footerBarComponent?.contentTemplateRef) {\n            <ng-template [ngTemplateOutlet]=\"itemFooter\"></ng-template>\n        }\n    </div>\n</div>\n<ng-template #radio>\n    <input\n        [attr.tabindex]=\"selectionMode === 'singleSelect' ? -1 : 0\"\n        type=\"radio\"\n        class=\"fd-radio fd-grid-list__radio-input\"\n        [style.display]=\"selectionMode === 'singleSelect' ? 'none' : ''\"\n        [id]=\"id + '-radio'\"\n        [name]=\"'fd-grid-list-item-toolbar-' + selectionMode\"\n        [attr.aria-label]=\"ariaLabel\"\n        [attr.aria-labelledby]=\"ariaLabelledBy\"\n        [value]=\"value\"\n        [ngModel]=\"_selectedItem\"\n        (ngModelChange)=\"$event && _selectionItem($event)\"\n    />\n    <label\n        class=\"fd-radio__label fd-grid-list__radio-label\"\n        [for]=\"id + '-radio'\"\n        tabindex=\"-1\"\n        (mouseover)=\"_setActive($event, false)\"\n        (mouseout)=\"_setActive($event, true)\"\n    ></label>\n</ng-template>\n<ng-template #checkbox>\n    <input\n        type=\"checkbox\"\n        class=\"fd-checkbox fd-grid-list__checkbox-input\"\n        [id]=\"id + '-checkbox'\"\n        [attr.aria-label]=\"ariaLabel\"\n        [attr.aria-labelledby]=\"ariaLabelledBy\"\n        [ngModel]=\"_selectedItem\"\n        (click)=\"_checkboxClick($event)\"\n        (keydown.escape)=\"_checkboxEscape()\"\n        (keydown.shift)=\"_checkboxEscape()\"\n    />\n    <label class=\"fd-checkbox__label fd-grid-list__checkbox-label\" [for]=\"id + '-checkbox'\" tabindex=\"-1\">\n        <span class=\"fd-checkbox__checkmark\" aria-hidden=\"true\"></span>\n    </label>\n</ng-template>\n<ng-template #itemFooter>\n    @if (footerBarComponent || state) {\n        <div class=\"fd-grid-list__item-body-actions\">\n            @if (footerBarComponent?.contentTemplateRef) {\n                <ng-template [ngTemplateOutlet]=\"footerBarComponent!.contentTemplateRef\"></ng-template>\n            }\n            @if (!footerBarComponent?.contentTemplateRef && state) {\n                @if (state === 'error') {\n                    <span\n                        fd-object-status\n                        status=\"negative\"\n                        [label]=\"'coreGridList.listItemStatusContainsErrors' | fdTranslate\"\n                        [attr.aria-label]=\"'coreGridList.listItemStatusContainsErrors' | fdTranslate\"\n                    ></span>\n                }\n                @if (state === 'locked') {\n                    <button\n                        class=\"fd-grid-list__action-button\"\n                        fd-button\n                        fdType=\"transparent\"\n                        glyph=\"private\"\n                        [label]=\"'coreGridList.listItemStatusLocked' | fdTranslate\"\n                        [attr.aria-label]=\"'coreGridList.listItemStatusLocked' | fdTranslate\"\n                        [attr.data-test-id]=\"'coreGridList.listItemStatusLocked' | fdTranslate\"\n                        fdCompact\n                        (click)=\"_clickOnLocked($event)\"\n                    ></button>\n                }\n                @if (state === 'draft') {\n                    <button\n                        class=\"fd-grid-list__action-button\"\n                        fd-button\n                        fdType=\"transparent\"\n                        [attr.aria-label]=\"'coreGridList.listItemStatusDraft' | fdTranslate\"\n                        [label]=\"'coreGridList.listItemStatusDraft' | fdTranslate\"\n                        [attr.data-test-id]=\"'coreGridList.listItemStatusDraft' | fdTranslate\"\n                        fdCompact\n                        (click)=\"_clickOnDraft($event)\"\n                    ></button>\n                }\n            }\n        </div>\n    }\n</ng-template>\n", styles: [".fd-grid-list .fd-dnd-item.fd-dnd-on-drag{cursor:-webkit-grabbing;cursor:-moz-grabbing;cursor:-o-grabbing;cursor:-ms-grabbing;cursor:grabbing;background-color:transparent}.fd-grid-list .fd-dnd-item .fd-grid-list__item{overflow:visible}.fd-grid-list__item .drop-area__line--vertical{height:100%}.fd-grid-list__item .drop-area__line--vertical.before{left:-.55rem}.fd-grid-list__item .drop-area__line--vertical.after{right:-.55rem}.fd-grid-list__item .fd-checkbox__label{-webkit-user-select:none;user-select:none}\n"] }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.Renderer2 }, { type: GridList }, { type: i2.ContentDensityObserver }, { type: i3.TabbableElementService }], propDecorators: { id: [{
                type: Input
            }], width: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.max-width']
            }, {
                type: HostBinding,
                args: ['style.min-width']
            }], layoutItemPattern: [{
                type: Input
            }], status: [{
                type: Input
            }], counter: [{
                type: Input
            }], value: [{
                type: Input
            }], disableToolbarClick: [{
                type: Input
            }], selected: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], noPadding: [{
                type: Input
            }], ariaLabel: [{
                type: Input
            }], ariaLabelledBy: [{
                type: Input
            }], type: [{
                type: Input
            }], state: [{
                type: Input
            }], isNavigated: [{
                type: Input
            }], title: [{
                type: Input
            }], titleLevel: [{
                type: Input
            }], description: [{
                type: Input
            }], autoHeight: [{
                type: Input
            }], press: [{
                type: Output
            }], detail: [{
                type: Output
            }], delete: [{
                type: Output
            }], navigate: [{
                type: Output
            }], cardClick: [{
                type: Output
            }], draft: [{
                type: Output
            }], locked: [{
                type: Output
            }], _gridListItem: [{
                type: ViewChild,
                args: ['gridListItem']
            }], footerBarComponent: [{
                type: ContentChild,
                args: [GridListItemFooterBarComponent]
            }], itemToolbarComponent: [{
                type: ContentChild,
                args: [GridListItemToolbarComponent]
            }], body: [{
                type: ContentChild,
                args: [GridListItemBodyDirective]
            }] } });

class GridListMoreBtnComponent {
    constructor() {
        /** Event is thrown, when the control button is clicked */
        this.showMore = new EventEmitter();
    }
    /** @hidden */
    _onKeyDown(event) {
        if (!KeyUtil.isKeyCode(event, [ENTER, SPACE])) {
            return;
        }
        event.preventDefault();
        this.showMore.emit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListMoreBtnComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: GridListMoreBtnComponent, isStandalone: true, selector: "fd-grid-list-more-btn", inputs: { title: "title", totalCount: "totalCount", displayCount: "displayCount" }, outputs: { showMore: "showMore" }, host: { classAttribute: "fd-col fd-col--12" }, ngImport: i0, template: "<div tabindex=\"0\" role=\"button\" class=\"fd-grid-list__more\" (keydown)=\"_onKeyDown($event)\" (click)=\"showMore.emit()\">\n    <h5 class=\"fd-title fd-title--h6 fd-grid-list__more-title\">{{ title }}</h5>\n    <p class=\"fd-grid-list__more-description\">{{ '[ ' + displayCount + ' / ' + totalCount + ' ]' }}</p>\n</div>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListMoreBtnComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-grid-list-more-btn', changeDetection: ChangeDetectionStrategy.OnPush, host: {
                        class: 'fd-col fd-col--12'
                    }, standalone: true, template: "<div tabindex=\"0\" role=\"button\" class=\"fd-grid-list__more\" (keydown)=\"_onKeyDown($event)\" (click)=\"showMore.emit()\">\n    <h5 class=\"fd-title fd-title--h6 fd-grid-list__more-title\">{{ title }}</h5>\n    <p class=\"fd-grid-list__more-description\">{{ '[ ' + displayCount + ' / ' + totalCount + ' ]' }}</p>\n</div>\n" }]
        }], propDecorators: { title: [{
                type: Input
            }], totalCount: [{
                type: Input
            }], displayCount: [{
                type: Input
            }], showMore: [{
                type: Output
            }] } });

class GridListTitleBarComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListTitleBarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: GridListTitleBarComponent, isStandalone: true, selector: "fd-grid-list-title-bar", inputs: { title: "title" }, host: { classAttribute: "fd-col fd-col--12" }, ngImport: i0, template: "<fd-toolbar fdType=\"solid\">\n    <label fd-toolbar-label>\n        {{ title }}\n        <ng-content select=\"[fd-grid-list-title-bar-additional-title-item]\"></ng-content>\n    </label>\n\n    <ng-content></ng-content>\n</fd-toolbar>\n", dependencies: [{ kind: "component", type: ToolbarComponent, selector: "fd-toolbar", inputs: ["titleId", "class", "shouldOverflow", "fdType", "title", "active", "clearBorder", "forceOverflow", "tabindex", "headingLevel", "ariaLabel", "ariaLabelledBy"] }, { kind: "directive", type: ToolbarLabelDirective, selector: "[fd-toolbar-label]" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListTitleBarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-grid-list-title-bar', host: {
                        class: 'fd-col fd-col--12'
                    }, changeDetection: ChangeDetectionStrategy.OnPush, imports: [ToolbarComponent, ToolbarLabelDirective], template: "<fd-toolbar fdType=\"solid\">\n    <label fd-toolbar-label>\n        {{ title }}\n        <ng-content select=\"[fd-grid-list-title-bar-additional-title-item]\"></ng-content>\n    </label>\n\n    <ng-content></ng-content>\n</fd-toolbar>\n" }]
        }], propDecorators: { title: [{
                type: Input
            }] } });

class GridListTitleBarAdditionalTitleItemDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListTitleBarAdditionalTitleItemDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: GridListTitleBarAdditionalTitleItemDirective, isStandalone: true, selector: "[fd-grid-list-title-bar-additional-title-item]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListTitleBarAdditionalTitleItemDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-grid-list-title-bar-additional-title-item]',
                    standalone: true
                }]
        }] });

let gridListUniqueId = 0;
class GridListComponent extends GridList {
    /** @hidden */
    set gridListItems(components) {
        this._gridListItems = components;
        this._updateGridListItemsProperties(components);
    }
    get gridListItems() {
        return this._gridListItems;
    }
    /** @hidden */
    constructor(_cd, _elRef) {
        super();
        this._cd = _cd;
        this._elRef = _elRef;
        /** id for the Element */
        this.id = `fd-grid-list-${gridListUniqueId++}`;
        /**
         * Defines the mode of Grid List
         * Modes:
         * - none: Default mode (no selection)
         * - delete: Delete mode (only one list item can be deleted via provided delete button)
         * - singleSelect: Selected item is highlighted but no selection control is visible (only one list item can be selected)
         * - singleSelectLeft: Left-positioned single selection mode (only one list item can be selected)
         * - singleSelectRight: Right-positioned single selection mode (only one list item can be selected)
         * - multiSelect: Multi-selection mode (more than one list item can be selected)
         *  */
        this.selectionMode = 'none';
        /** Event is thrown, when mode is singleSelect, singleSelectLeft, singleSelectRight or multiSelect and item was selected */
        this.selectionChange = new EventEmitter();
        /** @hidden */
        this._rangeSelector = new RangeSelector();
        /** @hidden */
        this._selectedItems = {
            added: [],
            index: [],
            removed: [],
            selection: []
        };
        /** @hidden */
        this._selectedItemsSubject$ = new BehaviorSubject(this._selectedItems);
        /** @hidden */
        this.subscription = new Subscription();
        /** An RxJS Subject that will kill the data stream upon component’s destruction (for unsubscribing)  */
        this._destroyRef = inject(DestroyRef);
        /** @hidden */
        this._rtlService = inject(RtlService, {
            optional: true
        });
        /** @hidden */
        this._rtl$ = computed(() => !!this._rtlService?.rtlSignal());
        this._selectedItems$ = this._selectedItemsSubject$.asObservable();
        const selectedItemsSub = this._selectedItems$
            .pipe(filter(() => !!this._gridListItems))
            .subscribe(this.selectionChange);
        this.subscription.add(selectedItemsSub);
    }
    /** @hidden */
    ngOnChanges(changes) {
        if (changes.layoutPattern &&
            !changes.layoutPattern.firstChange &&
            changes.layoutPattern.previousValue !== changes.layoutPattern.currentValue) {
            const baseLayoutItemPattern = parseLayoutPattern(this.layoutPattern);
            this._updateGridListItemsProperty('gridLayoutClasses', baseLayoutItemPattern);
        }
        if (changes.selectionMode &&
            !changes.selectionMode.firstChange &&
            changes.selectionMode.previousValue !== changes.selectionMode.currentValue) {
            this._updateGridListItemsProperty('selectionMode', this.selectionMode);
        }
    }
    /** @hidden */
    ngAfterContentInit() {
        this._setFirstFocusableItem();
        this._listenOnQueryChange();
        this._cd.detectChanges();
    }
    /** @hidden */
    ngOnDestroy() {
        this.subscription.unsubscribe();
    }
    /**
     * Clears previous selection of the items.
     */
    clearSelection() {
        this._selectedItems.added = [];
        this._selectedItems.index = [];
        this._selectedItems.removed = this._selectedItems.selection;
        this._selectedItems.selection = [];
        this._selectedItemsSubject$.next(this._selectedItems);
    }
    /** @hidden */
    setSelectedItem(item, componentIndex, action, event) {
        if (!action) {
            this._selectedItems.added = [item];
            const selectedItem = this._selectedItems.selection[0];
            if (selectedItem) {
                this._selectedItems.removed = [selectedItem];
            }
            this._selectedItems.selection = [item];
            this._selectedItems.index = [componentIndex];
            this._selectedItemsSubject$.next(this._selectedItems);
            return;
        }
        this._rangeSelector.onRangeElementToggled(componentIndex, event);
        const state = this._rangeSelector.lastRangeSelectionState;
        if (!state) {
            return;
        }
        const itemIndexes = new Array(state.to - state.from + 1).fill(null).map((e, i) => state.from + i);
        const selectedItems = itemIndexes.map((idx) => this.gridListItems.get(idx)?.value).filter((v) => !!v);
        const itemsSet = new Set(selectedItems);
        if (action === GridListSelectionActions.ADD) {
            this._selectedItems.added = [...itemsSet.values()];
            this._selectedItems.index = [...itemIndexes];
            this._selectedItems.removed = [];
            // remove "itemsSet" values from selection and add them back from "itemsSet"
            // this is needed to avoid duplicates as some of the items can be already selected
            this._selectedItems.selection = this._selectedItems.selection.filter((e) => !itemsSet.has(e));
            this._selectedItems.selection.push(...itemsSet.values());
        }
        if (action === GridListSelectionActions.REMOVE) {
            this._selectedItems.added = [];
            this._selectedItems.index = [...itemIndexes];
            this._selectedItems.removed = [...itemsSet.values()];
            this._selectedItems.selection = this._selectedItems.selection.filter((selectedItem) => !itemsSet.has(selectedItem));
        }
        this._selectedItemsSubject$.next(this._selectedItems);
    }
    /** @hidden */
    handleKeydown(event) {
        this._handleTabKeydown(event);
        if (KeyUtil.isKeyCode(event, [UP_ARROW, DOWN_ARROW, LEFT_ARROW, RIGHT_ARROW])) {
            if (event.shiftKey && this.selectionMode === 'multiSelect') {
                this._handleShiftArrowKeydown(event);
            }
            else {
                this._handleArrowKeydown(event);
            }
        }
        else if (event.shiftKey && this.selectionMode === 'multiSelect' && KeyUtil.isKeyCode(event, [HOME, END])) {
            this._handleHomeEndKeydown(event);
        }
    }
    /** @hidden */
    _handleHomeEndKeydown(event) {
        event.preventDefault();
        let shouldSelect = false;
        let selectionAction;
        const isEndKeydown = KeyUtil.isKeyCode(event, END);
        const loopStartingIndex = isEndKeydown ? 0 : this._gridListItems.length - 1;
        /**
         * Ternary loop - if isEndKeydown is true, loop iterates from zero to the end of the grid list items.
         * If isEndKeydown is false, loop iterates backwards
         **/
        for (let index = loopStartingIndex; isEndKeydown ? index < this._gridListItems.length : index >= 0; isEndKeydown ? index++ : index--) {
            const currentItem = this._gridListItems.toArray()[index];
            if (document.activeElement === currentItem._gridListItem.nativeElement) {
                shouldSelect = true;
                selectionAction = currentItem._selectedItem
                    ? GridListSelectionActions.ADD
                    : GridListSelectionActions.REMOVE;
            }
            if (shouldSelect) {
                this.setSelectedItem(currentItem, index, selectionAction);
            }
        }
        const itemToFocus = isEndKeydown
            ? this._gridListItems.last._gridListItem
            : this._gridListItems.first._gridListItem;
        itemToFocus.nativeElement.focus();
    }
    /** @hidden */
    _handleTabKeydown(event) {
        if (KeyUtil.isKeyCode(event, TAB) && !event.shiftKey) {
            const isFocused = this._gridListItems
                .toArray()
                .some((item) => item._gridListItem.nativeElement.contains(document.activeElement));
            const isChildFocused = this._gridListItems
                .toArray()
                .some((item) => item._gridListItem.nativeElement.querySelector(':focus'));
            if (isFocused && !isChildFocused) {
                this._gridListItems.forEach((item) => {
                    const interactiveElements = item._gridListItem.nativeElement.querySelectorAll('a, button, input, select, textarea');
                    // Set tabindex to -1 for all interactive elements in the grid
                    interactiveElements.forEach((element) => {
                        element.setAttribute('tabindex', '-1');
                    });
                });
                return;
            }
            else {
                this._gridListItems.forEach((item) => {
                    const interactiveElements = item._gridListItem.nativeElement.querySelectorAll('a, button, input, select, textarea');
                    interactiveElements.forEach((element) => {
                        element.setAttribute('tabindex', '0');
                    });
                });
                return;
            }
        }
    }
    /** @hidden */
    _handleShiftArrowKeydown(event) {
        event.preventDefault();
        const activeElement = document.activeElement;
        const currentItemIndex = this._getCurrentItemIndex(activeElement);
        if (currentItemIndex === -1) {
            return;
        }
        const indexToFocus = this._calculateIndexToFocus(event, currentItemIndex);
        if (indexToFocus === undefined) {
            return;
        }
        // Persist the selection state from the current item to the next item
        this._persistSelectionState(currentItemIndex, indexToFocus);
        // Focus the new item
        this._focusItemAtIndex(indexToFocus, activeElement);
    }
    /** @hidden */
    _handleArrowKeydown(event, isShiftPressed = false) {
        event.preventDefault();
        const activeElement = document.activeElement;
        const currentItemIndex = this._getCurrentItemIndex(activeElement);
        if (currentItemIndex === -1) {
            return;
        }
        const indexToFocus = this._calculateIndexToFocus(event, currentItemIndex);
        if (indexToFocus === undefined) {
            return;
        }
        if (isShiftPressed) {
            this._toggleSelection(indexToFocus);
        }
        this._focusItemAtIndex(indexToFocus, activeElement);
    }
    /** hidden */
    _calculateIndexToFocus(event, currentItemIndex) {
        const itemsPerRow = this._getItemsPerRow(this._gridListItems.toArray()[currentItemIndex]._gridListItem.nativeElement);
        if (KeyUtil.isKeyCode(event, LEFT_ARROW) || (this._rtl$() && KeyUtil.isKeyCode(event, [RIGHT_ARROW]))) {
            return currentItemIndex - 1;
        }
        else if (KeyUtil.isKeyCode(event, RIGHT_ARROW) || (this._rtl$() && KeyUtil.isKeyCode(event, [LEFT_ARROW]))) {
            return currentItemIndex + 1;
        }
        else if (KeyUtil.isKeyCode(event, UP_ARROW)) {
            return currentItemIndex - itemsPerRow;
        }
        else if (KeyUtil.isKeyCode(event, DOWN_ARROW)) {
            return currentItemIndex + itemsPerRow;
        }
        return undefined;
    }
    /** hidden */
    _persistSelectionState(currentIndex, indexToFocus) {
        const currentItem = this._gridListItems.toArray()[currentIndex];
        const nextItem = this._gridListItems.toArray()[indexToFocus];
        // Persist the selection state from the current item to the next item
        if (currentItem._selectedItem) {
            // If the current item is selected, ensure the next item is selected as well
            if (!nextItem._selectedItem) {
                this.setSelectedItem(nextItem, indexToFocus, GridListSelectionActions.ADD);
            }
        }
        else {
            // If the current item is not selected, ensure the next item remains not selected
            if (nextItem._selectedItem) {
                this.setSelectedItem(nextItem, indexToFocus, GridListSelectionActions.REMOVE);
            }
        }
    }
    /** hidden */
    _getCurrentItemIndex(activeElement) {
        return this._gridListItems
            .toArray()
            .findIndex((item) => item._gridListItem.nativeElement.contains(activeElement));
    }
    /** hidden */
    _focusItemAtIndex(indexToFocus, activeElement) {
        if (indexToFocus >= 0 && indexToFocus < this._gridListItems.length) {
            const itemToFocus = this._gridListItems.toArray()[indexToFocus];
            if (itemToFocus && itemToFocus._gridListItem) {
                const elementToFocus = itemToFocus._gridListItem.nativeElement?.parentElement?.querySelector(activeElement.tagName);
                if (elementToFocus) {
                    elementToFocus.focus();
                }
            }
        }
    }
    /** hidden */
    _toggleSelection(indexToFocus) {
        const currentItem = this._gridListItems.toArray()[indexToFocus];
        const selectionAction = currentItem._selectedItem
            ? GridListSelectionActions.REMOVE
            : GridListSelectionActions.ADD;
        this.setSelectedItem(currentItem, indexToFocus, selectionAction);
    }
    /** @hidden */
    _listenOnQueryChange() {
        this._gridListItems.changes.pipe(startWith(0), takeUntilDestroyed(this._destroyRef)).subscribe(() => {
            setTimeout(() => {
                this._setFirstFocusableItem();
            });
        });
    }
    /** @hidden */
    _setFirstFocusableItem() {
        this._gridListItems.toArray().forEach((item, index) => {
            item.tabIndex.set(index === 0 ? 0 : -1);
        });
    }
    /** @hidden */
    _getItemsPerRow(activeElement) {
        const itemWidth = activeElement.getBoundingClientRect().width;
        const containerWidth = this._elRef.nativeElement.getBoundingClientRect().width;
        return Math.floor(containerWidth / itemWidth);
    }
    /** @hidden */
    _updateGridListItemsProperties(components) {
        const layoutPattern = this.layoutPattern ? this.layoutPattern : 'XL4-L3-M2-S1';
        const baseLayoutItemPattern = parseLayoutPattern(layoutPattern);
        components.forEach((component, index) => {
            if (component._index !== index) {
                component._index = index;
            }
            if (!component.selectionMode) {
                component.selectionMode = this.selectionMode;
            }
            if (!component.layoutItemPattern) {
                component.gridLayoutClasses = baseLayoutItemPattern;
            }
        });
    }
    /** @hidden */
    _updateGridListItemsProperty(key, value) {
        this._gridListItems.forEach((componenet) => {
            componenet[key] = value;
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.2", type: GridListComponent, isStandalone: true, selector: "fd-grid-list", inputs: { id: "id", width: "width", ariaLabel: "ariaLabel", selectionMode: "selectionMode", layoutPattern: "layoutPattern" }, outputs: { selectionChange: "selectionChange" }, providers: [KeyboardSupportService, { provide: GridList, useExisting: GridListComponent }], queries: [{ propertyName: "gridListItems", predicate: GridListItemComponent, descendants: true }], usesInheritance: true, usesOnChanges: true, ngImport: i0, template: "<div\n    [id]=\"id\"\n    [style.width]=\"width\"\n    class=\"fd-grid-list\"\n    [attr.aria-label]=\"ariaLabel\"\n    [class.fd-grid-list--mode-delete]=\"selectionMode === 'delete'\"\n    [class.fd-grid-list--mode-single-select]=\"selectionMode === 'singleSelect'\"\n    [class.fd-grid-list--mode-single-select-left]=\"selectionMode === 'singleSelectLeft'\"\n    [class.fd-grid-list--mode-single-select-right]=\"selectionMode === 'singleSelectRight'\"\n    [class.fd-grid-list--mode-multi-select]=\"selectionMode === 'multiSelect'\"\n    (keydown)=\"handleKeydown($event)\"\n>\n    <div class=\"fd-container\" role=\"listbox\">\n        <div class=\"fd-row\">\n            <ng-content></ng-content>\n        </div>\n    </div>\n</div>\n", styles: [".fd-radio{-webkit-appearance:none;-moz-appearance:none;appearance:none;background-color:var(--sapField_Background);border:0;border-color:var(--sapField_BorderColor);border-radius:var(--sapField_BorderCornerRadius);border-style:solid;border-width:var(--sapField_BorderWidth);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapField_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;opacity:.0001;outline:none;overflow:hidden;padding-block:0;padding-inline:0;position:absolute;text-overflow:ellipsis;white-space:nowrap}.fd-radio:after,.fd-radio:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-radio::-webkit-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-radio::-moz-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-radio:-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-radio::-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-radio::placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-radio::-moz-selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-radio::selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-radio.is-success{background:var(--sapField_SuccessBackgroundStyle);background-color:var(--sapField_SuccessBackground);border:var(--sapField_SuccessColor) var(--sapField_SuccessBorderWidth) var(--sapField_SuccessBorderStyle);-webkit-box-shadow:var(--sapField_SuccessShadow);box-shadow:var(--sapField_SuccessShadow)}.fd-radio.is-success.is-hover,.fd-radio.is-success:hover{background-color:var(--fdInput_Success_Background_Color_Hover);border-color:var(--sapField_SuccessColor);-webkit-box-shadow:var(--fdInput_Success_Box_Shadow_Hover);box-shadow:var(--fdInput_Success_Box_Shadow_Hover)}.fd-radio.is-success.is-focus,.fd-radio.is-success:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Success_Outline_Color);z-index:5}.fd-radio.is-success.is-focus.is-hover,.fd-radio.is-success.is-focus:hover,.fd-radio.is-success:focus.is-hover,.fd-radio.is-success:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-success.is-expanded,.fd-radio.is-success[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Success_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-radio.is-error{background:var(--sapField_InvalidBackgroundStyle);background-color:var(--sapField_InvalidBackground);border:var(--sapField_InvalidColor) var(--sapField_InvalidBorderWidth) var(--sapField_InvalidBorderStyle);-webkit-box-shadow:var(--sapField_InvalidShadow);box-shadow:var(--sapField_InvalidShadow)}.fd-radio.is-error.is-hover,.fd-radio.is-error:hover{background-color:var(--fdInput_Error_Background_Color_Hover);border-color:var(--sapField_InvalidColor);-webkit-box-shadow:var(--fdInput_Error_Box_Shadow_Hover);box-shadow:var(--fdInput_Error_Box_Shadow_Hover)}.fd-radio.is-error.is-focus,.fd-radio.is-error:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Error_Outline_Color);z-index:5}.fd-radio.is-error.is-focus.is-hover,.fd-radio.is-error.is-focus:hover,.fd-radio.is-error:focus.is-hover,.fd-radio.is-error:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-error.is-expanded,.fd-radio.is-error[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Error_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-radio.is-warning{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle);-webkit-box-shadow:var(--sapField_WarningShadow);box-shadow:var(--sapField_WarningShadow)}.fd-radio.is-warning.is-hover,.fd-radio.is-warning:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-radio.is-warning.is-focus,.fd-radio.is-warning:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-radio.is-warning.is-focus.is-hover,.fd-radio.is-warning.is-focus:hover,.fd-radio.is-warning:focus.is-hover,.fd-radio.is-warning:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-warning.is-expanded,.fd-radio.is-warning[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-radio.is-alert{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle)}.fd-radio.is-alert.is-hover,.fd-radio.is-alert:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-radio.is-alert.is-focus,.fd-radio.is-alert:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-radio.is-alert.is-focus.is-hover,.fd-radio.is-alert.is-focus:hover,.fd-radio.is-alert:focus.is-hover,.fd-radio.is-alert:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-alert.is-expanded,.fd-radio.is-alert[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-radio.is-information{background:var(--sapField_InformationBackgroundStyle);background-color:var(--sapField_InformationBackground);border:var(--sapField_InformationColor) var(--sapField_InformationBorderWidth) var(--sapField_InformationBorderStyle);-webkit-box-shadow:var(--sapField_InformationShadow);box-shadow:var(--sapField_InformationShadow)}.fd-radio.is-information.is-hover,.fd-radio.is-information:hover{background-color:var(--fdInput_Information_Background_Color_Hover);border-color:var(--sapField_InformationColor);-webkit-box-shadow:var(--fdInput_Information_Box_Shadow_Hover);box-shadow:var(--fdInput_Information_Box_Shadow_Hover)}.fd-radio.is-information.is-focus,.fd-radio.is-information:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Information_Outline_Color);z-index:5}.fd-radio.is-information.is-focus.is-hover,.fd-radio.is-information.is-focus:hover,.fd-radio.is-information:focus.is-hover,.fd-radio.is-information:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-information.is-expanded,.fd-radio.is-information[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Information_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-radio.is-alert.is-focus,.fd-radio.is-alert:focus,.fd-radio.is-error.is-focus,.fd-radio.is-error:focus,.fd-radio.is-information.is-focus,.fd-radio.is-information:focus,.fd-radio.is-warning.is-focus,.fd-radio.is-warning:focus{outline-offset:var(--fdInput_Outline_Offset_States);z-index:5}.fd-radio.is-disabled,.fd-radio:disabled,.fd-radio[aria-disabled=true]{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-radio.is-readonly,.fd-radio.is-readonly.is-focus,.fd-radio.is-readonly.is-hover,.fd-radio.is-readonly:focus,.fd-radio.is-readonly:hover,.fd-radio[aria-readonly=true],.fd-radio[aria-readonly=true].is-focus,.fd-radio[aria-readonly=true].is-hover,.fd-radio[aria-readonly=true]:focus,.fd-radio[aria-readonly=true]:hover,.fd-radio[readonly],.fd-radio[readonly].is-focus,.fd-radio[readonly].is-hover,.fd-radio[readonly]:focus,.fd-radio[readonly]:hover{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-readonly.is-focus,.fd-radio.is-readonly:focus,.fd-radio[aria-readonly=true].is-focus,.fd-radio[aria-readonly=true]:focus,.fd-radio[readonly].is-focus,.fd-radio[readonly]:focus{z-index:5}.fd-radio__label{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;max-width:100%;padding-block:0;padding-inline:0;position:relative;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content;-webkit-margin-end:.5rem;cursor:text;margin-inline-end:.5rem;-ms-flex-item-align:start;align-self:flex-start;cursor:pointer;display:-webkit-box;display:-ms-flexbox;display:flex;line-height:1rem;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapField_TextColor);padding-block:var(--fdRadio_Outer_Circle_Padding);padding-inline:var(--fdRadio_Outer_Circle_Padding)}.fd-radio__label:after,.fd-radio__label:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-radio__label:before{content:\"\";display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;height:var(--fdRadio_Inner_Circle_Diameter);min-width:var(--fdRadio_Inner_Circle_Diameter);width:var(--fdRadio_Inner_Circle_Diameter);-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;border-radius:50%;-webkit-margin-end:var(--fdRadio_Outer_Circle_Padding);background-color:var(--fdRadio_Background_Color);border:var(--fdRadio_Inner_Border_Width) var(--fdRadio_Inner_Border_Style) var(--fdRadio_Inner_Border_Color);margin-inline-end:var(--fdRadio_Outer_Circle_Padding)}.fd-radio__label:after{height:var(--fdRadio_Inner_Content_Size);left:var(--fdRadio_Inner_Content_Padding);min-width:var(--fdRadio_Inner_Content_Size);width:var(--fdRadio_Inner_Content_Size)}.fd-radio__label.is-focus,.fd-radio__label:focus{outline:none;z-index:5}.fd-radio__label.is-hover:before,.fd-radio__label:hover:before{background-color:var(--fdRadio_Hover_Background_Color);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_Default_Hover);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_Default_Hover);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_Default_Hover);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_Default_Hover);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_Default_Hover)}.fd-radio__label[dir=rtl]:after,[dir=rtl] .fd-radio__label:after{right:var(--fdRadio_Inner_Content_Padding)}.fd-radio__label.is-empty,.fd-radio__label:empty{margin-block:0;margin-inline:0;padding-block:var(--fdRadio_Outer_Circle_Padding);padding-inline:var(--fdRadio_Outer_Circle_Padding)}.fd-radio__label.is-empty:after,.fd-radio__label.is-empty:before,.fd-radio__label:empty:after,.fd-radio__label:empty:before{margin-inline:0}.fd-radio__label--wrap .fd-radio__text{white-space:normal}.fd-radio__label--wrap-top-aligned{-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start}.fd-radio__label--wrap-top-aligned .fd-radio__text{white-space:normal}.fd-radio__label--wrap-top-aligned:after{top:var(--fdRadio_Inner_Content_Padding)}.fd-radio__text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-radio__text:after,.fd-radio__text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-radio:checked+.fd-radio__label:after{background:var(--fdRadio_Active_Dot_Color);border-radius:50%;content:\"\";position:absolute}.fd-radio.is-error+.fd-radio__label:before,.fd-radio.is-error:checked+.fd-radio__label:after{--fdRadio_Background_Color:var(--fdRadio_Background_Color_Error);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_Error);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_Error);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_Error);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_Error);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_Error_Hover)}.fd-radio.is-alert+.fd-radio__label:before,.fd-radio.is-alert:checked+.fd-radio__label:after,.fd-radio.is-warning+.fd-radio__label:before,.fd-radio.is-warning:checked+.fd-radio__label:after{--fdRadio_Background_Color:var(--fdRadio_Background_Color_Warning);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_Warning);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_Warning);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_Warning);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_Warning);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_Warning_Hover)}.fd-radio.is-success+.fd-radio__label:before,.fd-radio.is-success:checked+.fd-radio__label:after{--fdRadio_Background_Color:var(--fdRadio_Background_Color_Success);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_Success);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_Success);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_Success);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_Success);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_Success_Hover)}.fd-radio.is-information+.fd-radio__label:before,.fd-radio.is-information:checked+.fd-radio__label:after{--fdRadio_Background_Color:var(--fdRadio_Background_Color_Information);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_Information);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_Information);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_Information);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_Information);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_Information_Hover)}.fd-radio.is-readonly+.fd-radio__label:before,.fd-radio.is-readonly:checked+.fd-radio__label:after,.fd-radio[aria-readonly=true]+.fd-radio__label:before,.fd-radio[aria-readonly=true]:checked+.fd-radio__label:after,.fd-radio[readonly]+.fd-radio__label:before,.fd-radio[readonly]:checked+.fd-radio__label:after{--fdRadio_Background_Color:var(--fdRadio_Background_Color_ReadOnly);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_ReadOnly);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_ReadOnly);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_ReadOnly);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_ReadOnly);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_ReadOnly)}.fd-radio.is-focus,.fd-radio:focus{z-index:5}.fd-radio.is-focus+.fd-radio__label,.fd-radio:focus+.fd-radio__label{border-radius:var(--fdRadio_Outline_Border_Radius);outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);outline-offset:calc(var(--fdRadio_Focus_Outline_Offset) - var(--fdRadio_Outer_Circle_Padding))}.fd-radio.is-disabled,.fd-radio:disabled,.fd-radio[aria-disabled=true]{opacity:.0001}.fd-radio.is-disabled+.fd-radio__label,.fd-radio:disabled+.fd-radio__label,.fd-radio[aria-disabled=true]+.fd-radio__label{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-radio[class*=-compact]+.fd-radio__label,.fd-radio[class*=-condensed]+.fd-radio__label,[class*=-compact] .fd-radio:not([class*=-cozy])+.fd-radio__label,[class*=-condensed] .fd-radio:not([class*=-cozy])+.fd-radio__label{--fdRadio_Outer_Circle_Padding:var(--fdRadio_Compact_Outer_Circle_Padding);--fdRadio_Inner_Circle_Diameter:var(--fdRadio_Compact_Inner_Circle_Diameter);--fdRadio_Inner_Content_Size:var(--fdRadio_Inner_Content_Size_Compact);--fdRadio_Inner_Content_Padding:var(--fdRadio_Inner_Content_Padding_Compact)}.fd-radio[class*=-compact].is-focus,.fd-radio[class*=-compact]:focus,.fd-radio[class*=-condensed].is-focus,.fd-radio[class*=-condensed]:focus,[class*=-compact] .fd-radio:not([class*=-cozy]).is-focus,[class*=-compact] .fd-radio:not([class*=-cozy]):focus,[class*=-condensed] .fd-radio:not([class*=-cozy]).is-focus,[class*=-condensed] .fd-radio:not([class*=-cozy]):focus{z-index:5}.fd-radio[class*=-compact].is-focus+.fd-radio__label,.fd-radio[class*=-compact]:focus+.fd-radio__label,.fd-radio[class*=-condensed].is-focus+.fd-radio__label,.fd-radio[class*=-condensed]:focus+.fd-radio__label,[class*=-compact] .fd-radio:not([class*=-cozy]).is-focus+.fd-radio__label,[class*=-compact] .fd-radio:not([class*=-cozy]):focus+.fd-radio__label,[class*=-condensed] .fd-radio:not([class*=-cozy]).is-focus+.fd-radio__label,[class*=-condensed] .fd-radio:not([class*=-cozy]):focus+.fd-radio__label{--fdRadio_Outer_Circle_Padding:var(--fdRadio_Compact_Outer_Circle_Padding);--fdRadio_Outline_Border_Radius:var(--fdRadio_Compact_Outline_Border_radius)}.fd-checkbox{-webkit-appearance:none;-moz-appearance:none;appearance:none;background-color:var(--sapField_Background);border:0;border-color:var(--sapField_BorderColor);border-radius:var(--sapField_BorderCornerRadius);border-style:solid;border-width:var(--sapField_BorderWidth);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapField_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;opacity:.0001;outline:none;overflow:hidden;padding-block:0;padding-inline:0;position:absolute;text-overflow:ellipsis;white-space:nowrap}.fd-checkbox:after,.fd-checkbox:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-checkbox::-webkit-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-checkbox::-moz-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-checkbox:-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-checkbox::-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-checkbox::placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-checkbox::-moz-selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-checkbox::selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-checkbox.is-success{background:var(--sapField_SuccessBackgroundStyle);background-color:var(--sapField_SuccessBackground);border:var(--sapField_SuccessColor) var(--sapField_SuccessBorderWidth) var(--sapField_SuccessBorderStyle);-webkit-box-shadow:var(--sapField_SuccessShadow);box-shadow:var(--sapField_SuccessShadow)}.fd-checkbox.is-success.is-hover,.fd-checkbox.is-success:hover{background-color:var(--fdInput_Success_Background_Color_Hover);border-color:var(--sapField_SuccessColor);-webkit-box-shadow:var(--fdInput_Success_Box_Shadow_Hover);box-shadow:var(--fdInput_Success_Box_Shadow_Hover)}.fd-checkbox.is-success.is-focus,.fd-checkbox.is-success:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Success_Outline_Color);z-index:5}.fd-checkbox.is-success.is-focus.is-hover,.fd-checkbox.is-success.is-focus:hover,.fd-checkbox.is-success:focus.is-hover,.fd-checkbox.is-success:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-success.is-expanded,.fd-checkbox.is-success[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Success_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-checkbox.is-error{background:var(--sapField_InvalidBackgroundStyle);background-color:var(--sapField_InvalidBackground);border:var(--sapField_InvalidColor) var(--sapField_InvalidBorderWidth) var(--sapField_InvalidBorderStyle);-webkit-box-shadow:var(--sapField_InvalidShadow);box-shadow:var(--sapField_InvalidShadow)}.fd-checkbox.is-error.is-hover,.fd-checkbox.is-error:hover{background-color:var(--fdInput_Error_Background_Color_Hover);border-color:var(--sapField_InvalidColor);-webkit-box-shadow:var(--fdInput_Error_Box_Shadow_Hover);box-shadow:var(--fdInput_Error_Box_Shadow_Hover)}.fd-checkbox.is-error.is-focus,.fd-checkbox.is-error:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Error_Outline_Color);z-index:5}.fd-checkbox.is-error.is-focus.is-hover,.fd-checkbox.is-error.is-focus:hover,.fd-checkbox.is-error:focus.is-hover,.fd-checkbox.is-error:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-error.is-expanded,.fd-checkbox.is-error[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Error_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-checkbox.is-warning{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle);-webkit-box-shadow:var(--sapField_WarningShadow);box-shadow:var(--sapField_WarningShadow)}.fd-checkbox.is-warning.is-hover,.fd-checkbox.is-warning:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-checkbox.is-warning.is-focus,.fd-checkbox.is-warning:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-checkbox.is-warning.is-focus.is-hover,.fd-checkbox.is-warning.is-focus:hover,.fd-checkbox.is-warning:focus.is-hover,.fd-checkbox.is-warning:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-warning.is-expanded,.fd-checkbox.is-warning[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-checkbox.is-alert{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle)}.fd-checkbox.is-alert.is-hover,.fd-checkbox.is-alert:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-checkbox.is-alert.is-focus,.fd-checkbox.is-alert:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-checkbox.is-alert.is-focus.is-hover,.fd-checkbox.is-alert.is-focus:hover,.fd-checkbox.is-alert:focus.is-hover,.fd-checkbox.is-alert:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-alert.is-expanded,.fd-checkbox.is-alert[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-checkbox.is-information{background:var(--sapField_InformationBackgroundStyle);background-color:var(--sapField_InformationBackground);border:var(--sapField_InformationColor) var(--sapField_InformationBorderWidth) var(--sapField_InformationBorderStyle);-webkit-box-shadow:var(--sapField_InformationShadow);box-shadow:var(--sapField_InformationShadow)}.fd-checkbox.is-information.is-hover,.fd-checkbox.is-information:hover{background-color:var(--fdInput_Information_Background_Color_Hover);border-color:var(--sapField_InformationColor);-webkit-box-shadow:var(--fdInput_Information_Box_Shadow_Hover);box-shadow:var(--fdInput_Information_Box_Shadow_Hover)}.fd-checkbox.is-information.is-focus,.fd-checkbox.is-information:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Information_Outline_Color);z-index:5}.fd-checkbox.is-information.is-focus.is-hover,.fd-checkbox.is-information.is-focus:hover,.fd-checkbox.is-information:focus.is-hover,.fd-checkbox.is-information:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-information.is-expanded,.fd-checkbox.is-information[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Information_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-checkbox.is-alert.is-focus,.fd-checkbox.is-alert:focus,.fd-checkbox.is-error.is-focus,.fd-checkbox.is-error:focus,.fd-checkbox.is-information.is-focus,.fd-checkbox.is-information:focus,.fd-checkbox.is-warning.is-focus,.fd-checkbox.is-warning:focus{outline-offset:var(--fdInput_Outline_Offset_States);z-index:5}.fd-checkbox.is-disabled,.fd-checkbox:disabled,.fd-checkbox[aria-disabled=true]{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-checkbox.is-readonly,.fd-checkbox.is-readonly.is-focus,.fd-checkbox.is-readonly.is-hover,.fd-checkbox.is-readonly:focus,.fd-checkbox.is-readonly:hover,.fd-checkbox[aria-readonly=true],.fd-checkbox[aria-readonly=true].is-focus,.fd-checkbox[aria-readonly=true].is-hover,.fd-checkbox[aria-readonly=true]:focus,.fd-checkbox[aria-readonly=true]:hover,.fd-checkbox[readonly],.fd-checkbox[readonly].is-focus,.fd-checkbox[readonly].is-hover,.fd-checkbox[readonly]:focus,.fd-checkbox[readonly]:hover{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-readonly.is-focus,.fd-checkbox.is-readonly:focus,.fd-checkbox[aria-readonly=true].is-focus,.fd-checkbox[aria-readonly=true]:focus,.fd-checkbox[readonly].is-focus,.fd-checkbox[readonly]:focus{z-index:5}.fd-checkbox,.fd-checkbox.is-error,.fd-checkbox.is-information,.fd-checkbox.is-success,.fd-checkbox.is-warning{border-style:initial}.fd-checkbox__label{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;max-width:100%;overflow:hidden;padding-block:0;padding-inline:0;position:relative;text-overflow:ellipsis;white-space:nowrap;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content;-webkit-margin-end:.5rem;cursor:text;margin-inline-end:.5rem;-ms-flex-item-align:start;align-self:flex-start;cursor:pointer;display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;gap:var(--fdCheckbox_Padding);line-height:1rem;margin-block:0;margin-inline:0;padding-block:var(--fdCheckbox_Padding);padding-inline:var(--fdCheckbox_Padding)}.fd-checkbox__label:after,.fd-checkbox__label:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-checkbox__label.is-hover .fd-checkbox__checkmark,.fd-checkbox__label:hover .fd-checkbox__checkmark{background-color:var(--fdCheckbox_Hover_Background_Color);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_Default_Hover);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_Default_Hover);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_Default_Hover);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_Default_Hover);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_Default_Hover)}.fd-checkbox__label:focus{outline:none}.fd-checkbox__label--required .fd-checkbox__text,.fd-checkbox__label[aria-required=true] .fd-checkbox__text{-webkit-padding-end:.5rem;padding-inline-end:.5rem}.fd-checkbox__label--required .fd-checkbox__text:after,.fd-checkbox__label[aria-required=true] .fd-checkbox__text:after{color:var(--sapField_RequiredColor);content:\"*\"/\"\";font-size:var(--sapFontSize);font-weight:700;position:absolute;-webkit-padding-start:.125rem;padding-inline-start:.125rem}.fd-checkbox__label--wrap .fd-checkbox__label-container{height:auto;white-space:normal}.fd-checkbox__label--wrap .fd-checkbox__text{white-space:normal}.fd-checkbox__label--wrap-top-aligned{-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start}.fd-checkbox__label--wrap-top-aligned .fd-checkbox__label-container{height:auto;white-space:normal}.fd-checkbox__label--wrap-top-aligned .fd-checkbox__text{white-space:normal}.fd-checkbox__label-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;height:1rem;max-width:inherit;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-checkbox__label-container:after,.fd-checkbox__label-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-checkbox__text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;max-width:inherit;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-checkbox__text:after,.fd-checkbox__text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-checkbox__checkmark{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--fdCheckbox_Background_Color);border:var(--fdCheckbox_Inner_Border_Width) var(--fdCheckbox_Inner_Border_Style) var(--fdCheckbox_Inner_Border_Color);border-radius:var(--sapField_BorderCornerRadius);color:var(--fdCheckbox_Check_Mark_Color);font-family:SAP-icons;height:var(--fdCheckbox_Dimensions);min-width:var(--fdCheckbox_Dimensions);width:var(--fdCheckbox_Dimensions)}.fd-checkbox__checkmark:after,.fd-checkbox__checkmark:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-checkbox__checkmark:before{content:\"\"}.fd-checkbox:checked+.fd-checkbox__label .fd-checkbox__checkmark:before{content:\"\\e05b\"}.fd-checkbox:indeterminate+.fd-checkbox__label .fd-checkbox__checkmark:after{background-color:var(--fdCheckbox_Check_Mark_Color);content:\"\";height:var(--fdCheckbox_Tristate_Size);position:absolute;width:var(--fdCheckbox_Tristate_Size)}.fd-checkbox.is-alert+.fd-checkbox__label .fd-checkbox__checkmark,.fd-checkbox.is-warning+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:var(--fdCheckbox_Background_Color_Warning);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_Warning);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_Warning);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_Warning);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_Warning);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_Warning_Hover)}.fd-checkbox.is-error+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:var(--fdCheckbox_Background_Color_Error);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_Error);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_Error);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_Error);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_Error);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_Error_Hover)}.fd-checkbox.is-success+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:var(--fdCheckbox_Background_Color_Success);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_Success);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_Success);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_Success);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_Success);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_Success_Hover)}.fd-checkbox.is-information+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:var(--fdCheckbox_Background_Color_Information);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_Information);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_Information);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_Information);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_Information);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_Information_Hover)}.fd-checkbox.is-readonly+.fd-checkbox__label .fd-checkbox__checkmark,.fd-checkbox[readonly]+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:var(--fdCheckbox_Background_Color_ReadOnly);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_ReadOnly);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_ReadOnly);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_ReadOnly);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_ReadOnly);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_ReadOnly)}.fd-checkbox.is-display+.fd-checkbox__label{--fdCheckbox_Check_Mark_Color:var(--sapTextColor);gap:.5rem}.fd-checkbox.is-display+.fd-checkbox__label.is-hover .fd-checkbox__checkmark,.fd-checkbox.is-display+.fd-checkbox__label:hover .fd-checkbox__checkmark{--fdCheckbox_Check_Mark_Color:var(--sapTextColor);--fdCheckbox_Hover_Background_Color:transparent}.fd-checkbox.is-display+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:transparent;--fdCheckbox_Dimensions:1rem;border:none}.fd-checkbox.is-display+.fd-checkbox__label .fd-checkbox__checkmark:before{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;content:\"\\e19a\";font-size:1rem;height:1rem;max-height:1rem;max-width:1rem;min-height:1rem;min-width:1rem;width:1rem}.fd-checkbox.is-display:checked+.fd-checkbox__label .fd-checkbox__checkmark:before{content:\"\\e03f\";font-size:1rem}.fd-checkbox.is-display:indeterminate+.fd-checkbox__label .fd-checkbox__checkmark:before{content:\"\\e295\";font-size:1rem}.fd-checkbox.is-display:indeterminate+.fd-checkbox__label .fd-checkbox__checkmark:after{content:\"\";height:0;width:0}.fd-checkbox.is-focus,.fd-checkbox:focus{z-index:5}.fd-checkbox.is-focus+.fd-checkbox__label,.fd-checkbox:focus+.fd-checkbox__label{border-radius:var(--fdCheckbox_Outline_Border_Radius);outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);outline-offset:calc(var(--fdCheckbox_Focus_Outline_Offset) - var(--fdCheckbox_Padding))}.fd-checkbox.is-disabled,.fd-checkbox:disabled,.fd-checkbox[aria-disabled=true]{opacity:.0001}.fd-checkbox.is-disabled+.fd-checkbox__label,.fd-checkbox:disabled+.fd-checkbox__label,.fd-checkbox[aria-disabled=true]+.fd-checkbox__label{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-checkbox[class*=-compact]+.fd-checkbox__label,.fd-checkbox[class*=-condensed]+.fd-checkbox__label,[class*=-compact] .fd-checkbox:not([class*=-cozy])+.fd-checkbox__label,[class*=-condensed] .fd-checkbox:not([class*=-cozy])+.fd-checkbox__label{--fdCheckbox_Dimensions:var(--fdCheckbox_Compact_Dimensions);--fdCheckbox_Padding:var(--fdCheckbox_Compact_Padding)}.fd-checkbox[class*=-compact]:indeterminate+.fd-checkbox__label,.fd-checkbox[class*=-condensed]:indeterminate+.fd-checkbox__label,[class*=-compact] .fd-checkbox:not([class*=-cozy]):indeterminate+.fd-checkbox__label,[class*=-condensed] .fd-checkbox:not([class*=-cozy]):indeterminate+.fd-checkbox__label{--fdCheckbox_Tristate_Size:var(--fdCheckbox_Tristate_Compact_Size);--fdCheckbox_Tristate_Offset:var(--fdCheckbox_Tristate_Compact_Offset)}.fd-checkbox[class*=-compact].is-focus,.fd-checkbox[class*=-compact]:focus,.fd-checkbox[class*=-condensed].is-focus,.fd-checkbox[class*=-condensed]:focus,[class*=-compact] .fd-checkbox:not([class*=-cozy]).is-focus,[class*=-compact] .fd-checkbox:not([class*=-cozy]):focus,[class*=-condensed] .fd-checkbox:not([class*=-cozy]).is-focus,[class*=-condensed] .fd-checkbox:not([class*=-cozy]):focus{z-index:5}.fd-checkbox[class*=-compact].is-focus+.fd-checkbox__label,.fd-checkbox[class*=-compact]:focus+.fd-checkbox__label,.fd-checkbox[class*=-condensed].is-focus+.fd-checkbox__label,.fd-checkbox[class*=-condensed]:focus+.fd-checkbox__label,[class*=-compact] .fd-checkbox:not([class*=-cozy]).is-focus+.fd-checkbox__label,[class*=-compact] .fd-checkbox:not([class*=-cozy]):focus+.fd-checkbox__label,[class*=-condensed] .fd-checkbox:not([class*=-cozy]).is-focus+.fd-checkbox__label,[class*=-condensed] .fd-checkbox:not([class*=-cozy]):focus+.fd-checkbox__label{--fdCheckbox_Outline_Border_Radius:var(--fdCheckbox_Compact_Outline_Border_Radius)}.fd-col,.fd-container,.fd-row{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-col:after,.fd-col:before,.fd-container:after,.fd-container:before,.fd-row:after,.fd-row:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-container{display:-webkit-box;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-box-flex:0;-ms-flex:0 0 100%;flex:0 0 100%;padding-block:0;padding-inline:.25rem;position:relative}.fd-container .fd-row{margin-inline:-.25rem;min-width:calc(100% + .5rem)}.fd-container>.fd-row>.fd-col{padding-block:.25rem}.fd-container.fd-container--no-gap .fd-row,.fd-container.fd-container--no-horizontal-gap .fd-row{margin-inline:0}.fd-container.fd-container--no-gap .fd-row .fd-col,.fd-container.fd-container--no-horizontal-gap .fd-row .fd-col{padding-inline:0}.fd-container.fd-container--no-gap>.fd-row>.fd-col,.fd-container.fd-container--no-vertical-gap>.fd-row>.fd-col{padding-block:0}.fd-container[dir=rtl],[dir=rtl] .fd-container{direction:rtl}.fd-row{display:-webkit-box;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-box-flex:0;-ms-flex:0 0 100%;flex:0 0 100%;min-width:100%;position:relative}.fd-col{max-width:100%;min-width:100%;padding-inline:.25rem}.fd-col--0{max-width:0;min-width:0%}.fd-col--offset-0{-webkit-margin-start:0;margin-inline-start:0}.fd-col--offset-after-0{-webkit-margin-end:0;margin-inline-end:0}.fd-col--1{max-width:8.3333333333%;min-width:8.3333333333%}.fd-col--offset-1{-webkit-margin-start:8.3333333333%;margin-inline-start:8.3333333333%}.fd-col--offset-after-1{-webkit-margin-end:8.3333333333%;margin-inline-end:8.3333333333%}.fd-col--2{max-width:16.6666666667%;min-width:16.6666666667%}.fd-col--offset-2{-webkit-margin-start:16.6666666667%;margin-inline-start:16.6666666667%}.fd-col--offset-after-2{-webkit-margin-end:16.6666666667%;margin-inline-end:16.6666666667%}.fd-col--3{max-width:25%;min-width:25%}.fd-col--offset-3{-webkit-margin-start:25%;margin-inline-start:25%}.fd-col--offset-after-3{-webkit-margin-end:25%;margin-inline-end:25%}.fd-col--4{max-width:33.3333333333%;min-width:33.3333333333%}.fd-col--offset-4{-webkit-margin-start:33.3333333333%;margin-inline-start:33.3333333333%}.fd-col--offset-after-4{-webkit-margin-end:33.3333333333%;margin-inline-end:33.3333333333%}.fd-col--5{max-width:41.6666666667%;min-width:41.6666666667%}.fd-col--offset-5{-webkit-margin-start:41.6666666667%;margin-inline-start:41.6666666667%}.fd-col--offset-after-5{-webkit-margin-end:41.6666666667%;margin-inline-end:41.6666666667%}.fd-col--6{max-width:50%;min-width:50%}.fd-col--offset-6{-webkit-margin-start:50%;margin-inline-start:50%}.fd-col--offset-after-6{-webkit-margin-end:50%;margin-inline-end:50%}.fd-col--7{max-width:58.3333333333%;min-width:58.3333333333%}.fd-col--offset-7{-webkit-margin-start:58.3333333333%;margin-inline-start:58.3333333333%}.fd-col--offset-after-7{-webkit-margin-end:58.3333333333%;margin-inline-end:58.3333333333%}.fd-col--8{max-width:66.6666666667%;min-width:66.6666666667%}.fd-col--offset-8{-webkit-margin-start:66.6666666667%;margin-inline-start:66.6666666667%}.fd-col--offset-after-8{-webkit-margin-end:66.6666666667%;margin-inline-end:66.6666666667%}.fd-col--9{max-width:75%;min-width:75%}.fd-col--offset-9{-webkit-margin-start:75%;margin-inline-start:75%}.fd-col--offset-after-9{-webkit-margin-end:75%;margin-inline-end:75%}.fd-col--10{max-width:83.3333333333%;min-width:83.3333333333%}.fd-col--offset-10{-webkit-margin-start:83.3333333333%;margin-inline-start:83.3333333333%}.fd-col--offset-after-10{-webkit-margin-end:83.3333333333%;margin-inline-end:83.3333333333%}.fd-col--11{max-width:91.6666666667%;min-width:91.6666666667%}.fd-col--offset-11{-webkit-margin-start:91.6666666667%;margin-inline-start:91.6666666667%}.fd-col--offset-after-11{-webkit-margin-end:91.6666666667%;margin-inline-end:91.6666666667%}.fd-col--12{max-width:100%;min-width:100%}.fd-col--offset-12{-webkit-margin-start:100%;margin-inline-start:100%}.fd-col--offset-after-12{-webkit-margin-end:100%;margin-inline-end:100%}.fd-col--full{max-width:none;min-width:8.3333333333%;-webkit-box-flex:1;-ms-flex:1;flex:1}.fd-col--wrap{-ms-flex-wrap:wrap;flex-wrap:wrap}@media (width >= 600px){.fd-container{padding-block:0;padding-inline:.5rem}.fd-container .fd-row{margin-inline:-.5rem;min-width:calc(100% + 1rem)}.fd-container>.fd-row>.fd-col{padding-block:.5rem}.fd-col{padding-inline:.5rem}.fd-col-md--0{max-width:0;min-width:0%}.fd-col-md--offset-0{-webkit-margin-start:0;margin-inline-start:0}.fd-col-md--offset-after-0{-webkit-margin-end:0;margin-inline-end:0}.fd-col-md--1{max-width:8.3333333333%;min-width:8.3333333333%}.fd-col-md--offset-1{-webkit-margin-start:8.3333333333%;margin-inline-start:8.3333333333%}.fd-col-md--offset-after-1{-webkit-margin-end:8.3333333333%;margin-inline-end:8.3333333333%}.fd-col-md--2{max-width:16.6666666667%;min-width:16.6666666667%}.fd-col-md--offset-2{-webkit-margin-start:16.6666666667%;margin-inline-start:16.6666666667%}.fd-col-md--offset-after-2{-webkit-margin-end:16.6666666667%;margin-inline-end:16.6666666667%}.fd-col-md--3{max-width:25%;min-width:25%}.fd-col-md--offset-3{-webkit-margin-start:25%;margin-inline-start:25%}.fd-col-md--offset-after-3{-webkit-margin-end:25%;margin-inline-end:25%}.fd-col-md--4{max-width:33.3333333333%;min-width:33.3333333333%}.fd-col-md--offset-4{-webkit-margin-start:33.3333333333%;margin-inline-start:33.3333333333%}.fd-col-md--offset-after-4{-webkit-margin-end:33.3333333333%;margin-inline-end:33.3333333333%}.fd-col-md--5{max-width:41.6666666667%;min-width:41.6666666667%}.fd-col-md--offset-5{-webkit-margin-start:41.6666666667%;margin-inline-start:41.6666666667%}.fd-col-md--offset-after-5{-webkit-margin-end:41.6666666667%;margin-inline-end:41.6666666667%}.fd-col-md--6{max-width:50%;min-width:50%}.fd-col-md--offset-6{-webkit-margin-start:50%;margin-inline-start:50%}.fd-col-md--offset-after-6{-webkit-margin-end:50%;margin-inline-end:50%}.fd-col-md--7{max-width:58.3333333333%;min-width:58.3333333333%}.fd-col-md--offset-7{-webkit-margin-start:58.3333333333%;margin-inline-start:58.3333333333%}.fd-col-md--offset-after-7{-webkit-margin-end:58.3333333333%;margin-inline-end:58.3333333333%}.fd-col-md--8{max-width:66.6666666667%;min-width:66.6666666667%}.fd-col-md--offset-8{-webkit-margin-start:66.6666666667%;margin-inline-start:66.6666666667%}.fd-col-md--offset-after-8{-webkit-margin-end:66.6666666667%;margin-inline-end:66.6666666667%}.fd-col-md--9{max-width:75%;min-width:75%}.fd-col-md--offset-9{-webkit-margin-start:75%;margin-inline-start:75%}.fd-col-md--offset-after-9{-webkit-margin-end:75%;margin-inline-end:75%}.fd-col-md--10{max-width:83.3333333333%;min-width:83.3333333333%}.fd-col-md--offset-10{-webkit-margin-start:83.3333333333%;margin-inline-start:83.3333333333%}.fd-col-md--offset-after-10{-webkit-margin-end:83.3333333333%;margin-inline-end:83.3333333333%}.fd-col-md--11{max-width:91.6666666667%;min-width:91.6666666667%}.fd-col-md--offset-11{-webkit-margin-start:91.6666666667%;margin-inline-start:91.6666666667%}.fd-col-md--offset-after-11{-webkit-margin-end:91.6666666667%;margin-inline-end:91.6666666667%}.fd-col-md--12{max-width:100%;min-width:100%}.fd-col-md--offset-12{-webkit-margin-start:100%;margin-inline-start:100%}.fd-col-md--offset-after-12{-webkit-margin-end:100%;margin-inline-end:100%}}@media (width >= 1024px){.fd-col-lg--0{max-width:0;min-width:0%}.fd-col-lg--offset-0{-webkit-margin-start:0;margin-inline-start:0}.fd-col-lg--offset-after-0{-webkit-margin-end:0;margin-inline-end:0}.fd-col-lg--1{max-width:8.3333333333%;min-width:8.3333333333%}.fd-col-lg--offset-1{-webkit-margin-start:8.3333333333%;margin-inline-start:8.3333333333%}.fd-col-lg--offset-after-1{-webkit-margin-end:8.3333333333%;margin-inline-end:8.3333333333%}.fd-col-lg--2{max-width:16.6666666667%;min-width:16.6666666667%}.fd-col-lg--offset-2{-webkit-margin-start:16.6666666667%;margin-inline-start:16.6666666667%}.fd-col-lg--offset-after-2{-webkit-margin-end:16.6666666667%;margin-inline-end:16.6666666667%}.fd-col-lg--3{max-width:25%;min-width:25%}.fd-col-lg--offset-3{-webkit-margin-start:25%;margin-inline-start:25%}.fd-col-lg--offset-after-3{-webkit-margin-end:25%;margin-inline-end:25%}.fd-col-lg--4{max-width:33.3333333333%;min-width:33.3333333333%}.fd-col-lg--offset-4{-webkit-margin-start:33.3333333333%;margin-inline-start:33.3333333333%}.fd-col-lg--offset-after-4{-webkit-margin-end:33.3333333333%;margin-inline-end:33.3333333333%}.fd-col-lg--5{max-width:41.6666666667%;min-width:41.6666666667%}.fd-col-lg--offset-5{-webkit-margin-start:41.6666666667%;margin-inline-start:41.6666666667%}.fd-col-lg--offset-after-5{-webkit-margin-end:41.6666666667%;margin-inline-end:41.6666666667%}.fd-col-lg--6{max-width:50%;min-width:50%}.fd-col-lg--offset-6{-webkit-margin-start:50%;margin-inline-start:50%}.fd-col-lg--offset-after-6{-webkit-margin-end:50%;margin-inline-end:50%}.fd-col-lg--7{max-width:58.3333333333%;min-width:58.3333333333%}.fd-col-lg--offset-7{-webkit-margin-start:58.3333333333%;margin-inline-start:58.3333333333%}.fd-col-lg--offset-after-7{-webkit-margin-end:58.3333333333%;margin-inline-end:58.3333333333%}.fd-col-lg--8{max-width:66.6666666667%;min-width:66.6666666667%}.fd-col-lg--offset-8{-webkit-margin-start:66.6666666667%;margin-inline-start:66.6666666667%}.fd-col-lg--offset-after-8{-webkit-margin-end:66.6666666667%;margin-inline-end:66.6666666667%}.fd-col-lg--9{max-width:75%;min-width:75%}.fd-col-lg--offset-9{-webkit-margin-start:75%;margin-inline-start:75%}.fd-col-lg--offset-after-9{-webkit-margin-end:75%;margin-inline-end:75%}.fd-col-lg--10{max-width:83.3333333333%;min-width:83.3333333333%}.fd-col-lg--offset-10{-webkit-margin-start:83.3333333333%;margin-inline-start:83.3333333333%}.fd-col-lg--offset-after-10{-webkit-margin-end:83.3333333333%;margin-inline-end:83.3333333333%}.fd-col-lg--11{max-width:91.6666666667%;min-width:91.6666666667%}.fd-col-lg--offset-11{-webkit-margin-start:91.6666666667%;margin-inline-start:91.6666666667%}.fd-col-lg--offset-after-11{-webkit-margin-end:91.6666666667%;margin-inline-end:91.6666666667%}.fd-col-lg--12{max-width:100%;min-width:100%}.fd-col-lg--offset-12{-webkit-margin-start:100%;margin-inline-start:100%}.fd-col-lg--offset-after-12{-webkit-margin-end:100%;margin-inline-end:100%}}@media (width >= 1440px){.fd-col-xl--0{max-width:0;min-width:0%}.fd-col-xl--offset-0{-webkit-margin-start:0;margin-inline-start:0}.fd-col-xl--offset-after-0{-webkit-margin-end:0;margin-inline-end:0}.fd-col-xl--1{max-width:8.3333333333%;min-width:8.3333333333%}.fd-col-xl--offset-1{-webkit-margin-start:8.3333333333%;margin-inline-start:8.3333333333%}.fd-col-xl--offset-after-1{-webkit-margin-end:8.3333333333%;margin-inline-end:8.3333333333%}.fd-col-xl--2{max-width:16.6666666667%;min-width:16.6666666667%}.fd-col-xl--offset-2{-webkit-margin-start:16.6666666667%;margin-inline-start:16.6666666667%}.fd-col-xl--offset-after-2{-webkit-margin-end:16.6666666667%;margin-inline-end:16.6666666667%}.fd-col-xl--3{max-width:25%;min-width:25%}.fd-col-xl--offset-3{-webkit-margin-start:25%;margin-inline-start:25%}.fd-col-xl--offset-after-3{-webkit-margin-end:25%;margin-inline-end:25%}.fd-col-xl--4{max-width:33.3333333333%;min-width:33.3333333333%}.fd-col-xl--offset-4{-webkit-margin-start:33.3333333333%;margin-inline-start:33.3333333333%}.fd-col-xl--offset-after-4{-webkit-margin-end:33.3333333333%;margin-inline-end:33.3333333333%}.fd-col-xl--5{max-width:41.6666666667%;min-width:41.6666666667%}.fd-col-xl--offset-5{-webkit-margin-start:41.6666666667%;margin-inline-start:41.6666666667%}.fd-col-xl--offset-after-5{-webkit-margin-end:41.6666666667%;margin-inline-end:41.6666666667%}.fd-col-xl--6{max-width:50%;min-width:50%}.fd-col-xl--offset-6{-webkit-margin-start:50%;margin-inline-start:50%}.fd-col-xl--offset-after-6{-webkit-margin-end:50%;margin-inline-end:50%}.fd-col-xl--7{max-width:58.3333333333%;min-width:58.3333333333%}.fd-col-xl--offset-7{-webkit-margin-start:58.3333333333%;margin-inline-start:58.3333333333%}.fd-col-xl--offset-after-7{-webkit-margin-end:58.3333333333%;margin-inline-end:58.3333333333%}.fd-col-xl--8{max-width:66.6666666667%;min-width:66.6666666667%}.fd-col-xl--offset-8{-webkit-margin-start:66.6666666667%;margin-inline-start:66.6666666667%}.fd-col-xl--offset-after-8{-webkit-margin-end:66.6666666667%;margin-inline-end:66.6666666667%}.fd-col-xl--9{max-width:75%;min-width:75%}.fd-col-xl--offset-9{-webkit-margin-start:75%;margin-inline-start:75%}.fd-col-xl--offset-after-9{-webkit-margin-end:75%;margin-inline-end:75%}.fd-col-xl--10{max-width:83.3333333333%;min-width:83.3333333333%}.fd-col-xl--offset-10{-webkit-margin-start:83.3333333333%;margin-inline-start:83.3333333333%}.fd-col-xl--offset-after-10{-webkit-margin-end:83.3333333333%;margin-inline-end:83.3333333333%}.fd-col-xl--11{max-width:91.6666666667%;min-width:91.6666666667%}.fd-col-xl--offset-11{-webkit-margin-start:91.6666666667%;margin-inline-start:91.6666666667%}.fd-col-xl--offset-after-11{-webkit-margin-end:91.6666666667%;margin-inline-end:91.6666666667%}.fd-col-xl--12{max-width:100%;min-width:100%}.fd-col-xl--offset-12{-webkit-margin-start:100%;margin-inline-start:100%}.fd-col-xl--offset-after-12{-webkit-margin-end:100%;margin-inline-end:100%}}.fd-grid-list{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-grid-list:after,.fd-grid-list:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__radio-input{height:1rem;width:1rem}.fd-grid-list .fd-grid-list__radio-input+.fd-grid-list__radio-label.is-empty,.fd-grid-list .fd-grid-list__radio-input+.fd-grid-list__radio-label:empty{-ms-flex-item-align:center;align-self:center}.fd-grid-list .fd-grid-list__checkbox-input{height:1rem;width:1rem}.fd-grid-list .fd-grid-list__checkbox-input+.fd-grid-list__checkbox-label.is-empty,.fd-grid-list .fd-grid-list__checkbox-input+.fd-grid-list__checkbox-label:empty{-ms-flex-item-align:center;align-self:center}.fd-grid-list .fd-grid-list__item{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;background-color:var(--sapList_Background);border-radius:var(--fdGrid_List_Item_Border_Radius);-webkit-box-shadow:var(--sapContent_Shadow0);box-shadow:var(--sapContent_Shadow0);color:var(--sapList_TextColor);-ms-flex-direction:column;flex-direction:column;height:100%;outline:none;overflow:hidden;position:relative}.fd-grid-list .fd-grid-list__item:after,.fd-grid-list .fd-grid-list__item:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item.is-focus,.fd-grid-list .fd-grid-list__item:focus{z-index:5}.fd-grid-list .fd-grid-list__item.is-focus:before,.fd-grid-list .fd-grid-list__item:focus:before{border:var(--fdGrid_List_Item_Focus_Border);border-radius:var(--fdGrid_List_Item_Border_Radius);-webkit-box-shadow:var(--fdGrid_List_Item_Focus_Box_Shadow);box-shadow:var(--fdGrid_List_Item_Focus_Box_Shadow);content:\"\";display:block;inset:var(--fdGrid_List_Item_Focus_Outline_Offset);pointer-events:none;position:absolute;z-index:1}.fd-grid-list .fd-grid-list__item--height-auto{height:auto}.fd-grid-list .fd-grid-list__item--unread .fd-grid-list__item-body *{font-weight:700}.fd-grid-list .fd-grid-list__item--link{cursor:pointer}.fd-grid-list .fd-grid-list__item--link.is-hover,.fd-grid-list .fd-grid-list__item--link:hover{background-color:var(--sapList_Hover_Background);-webkit-box-shadow:0 0 0 .0625rem var(--fdGrid_List_Item_Hover_Border_Color),var(--sapContent_Shadow2);box-shadow:0 0 0 .0625rem var(--fdGrid_List_Item_Hover_Border_Color),var(--sapContent_Shadow2)}.fd-grid-list .fd-grid-list__item--link.is-active:not([aria-selected=true],.is-selected),.fd-grid-list .fd-grid-list__item--link:active:not([aria-selected=true],.is-selected){background-color:var(--sapList_Active_Background)}.fd-grid-list .fd-grid-list__item--link.is-active:not([aria-selected=true],.is-selected) *,.fd-grid-list .fd-grid-list__item--link:active:not([aria-selected=true],.is-selected) *{color:var(--sapList_Active_TextColor)!important;text-shadow:none!important}.fd-grid-list .fd-grid-list__item--link.is-selected,.fd-grid-list .fd-grid-list__item--link[aria-selected=true]{background-color:var(--sapList_SelectionBackgroundColor);-webkit-box-shadow:0 0 0 .125rem var(--sapList_SelectionBorderColor);box-shadow:0 0 0 .125rem var(--sapList_SelectionBorderColor)}.fd-grid-list .fd-grid-list__item--link.is-selected.is-hover,.fd-grid-list .fd-grid-list__item--link.is-selected:hover,.fd-grid-list .fd-grid-list__item--link[aria-selected=true].is-hover,.fd-grid-list .fd-grid-list__item--link[aria-selected=true]:hover{background-color:var(--sapList_Hover_SelectionBackground)}.fd-grid-list .fd-grid-list__item--link.is-navigated:after{background-color:var(--sapList_SelectionBorderColor);border-radius:0 var(--fdGrid_List_Item_Border_Radius) var(--fdGrid_List_Item_Border_Radius) 0;content:\"\";display:block;height:100%;position:absolute;right:0;top:0;width:.1875rem}.fd-grid-list .fd-grid-list__item--link.is-selected:before,.fd-grid-list .fd-grid-list__item--link[aria-selected=true]:before{border-color:var(--sapList_SelectionBackgroundColor)}.fd-grid-list .fd-grid-list__item-toolbar{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;--fdToolbar_Padding_Left:1rem;--fdToolbar_Padding_Right:1rem;--fdToolbar_Background:transparent;-ms-flex-negative:0;border:none;-webkit-box-shadow:var(--fdGrid_List_Item_Toolbar_Shadow);box-shadow:var(--fdGrid_List_Item_Toolbar_Shadow);flex-shrink:0}.fd-grid-list .fd-grid-list__item-body{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-ms-flex-wrap:wrap;flex-wrap:wrap;height:100%;padding-block:1rem;padding-inline:1rem;word-break:break-word}.fd-grid-list .fd-grid-list__item-body:after,.fd-grid-list .fd-grid-list__item-body:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-body--no-padding{padding-block:0;padding-inline:0}.fd-grid-list .fd-grid-list__item-body-actions{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-ms-flex-preferred-size:100%;flex-basis:100%;-webkit-margin-before:1rem;margin-block-start:1rem;-webkit-box-ordinal-group:2;-ms-flex-order:1;order:1}.fd-grid-list .fd-grid-list__item-body-actions:after,.fd-grid-list .fd-grid-list__item-body-actions:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-flex:0;-ms-flex:0 0 100%;flex:0 0 100%}.fd-grid-list .fd-grid-list__item-header:after,.fd-grid-list .fd-grid-list__item-header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-header+.fd-grid-list__item-content{-webkit-padding-before:1rem;padding-block-start:1rem}.fd-grid-list .fd-grid-list__item-image{-webkit-margin-end:.75rem;margin-inline-end:.75rem}.fd-grid-list .fd-grid-list__item-image+.fd-grid-list__item-content,.fd-grid-list .fd-grid-list__item-image+.fd-grid-list__item-header{max-width:calc(100% - 3.75rem)}.fd-grid-list .fd-grid-list__item-title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapList_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:var(--sapFontLargeSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;white-space:normal;-webkit-margin-before:.125rem;margin-block-start:.125rem}.fd-grid-list .fd-grid-list__item-title:after,.fd-grid-list .fd-grid-list__item-title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-subtitle{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);display:inline-block;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-block:.5rem .125rem;margin-inline:0;padding-block:0;padding-inline:0}.fd-grid-list .fd-grid-list__item-subtitle:after,.fd-grid-list .fd-grid-list__item-subtitle:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapList_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;width:100%}.fd-grid-list .fd-grid-list__item-content:after,.fd-grid-list .fd-grid-list__item-content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-counter{color:var(--sapContent_MarkerTextColor)}.fd-grid-list .fd-grid-list__item .fd-grid-list__item-navigation-indicator{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapContent_NonInteractiveIconColor);margin-inline:0 -1rem;width:2.5rem}.fd-grid-list .fd-grid-list__item .fd-grid-list__item-navigation-indicator[dir=rtl],[dir=rtl] .fd-grid-list .fd-grid-list__item .fd-grid-list__item-navigation-indicator{-webkit-transform:rotate(180deg);transform:rotate(180deg)}.fd-grid-list__group-header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;height:2rem;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;-webkit-margin-before:.75rem;color:var(--sapList_GroupHeaderTextColo);font-size:var(--sapFontHeader5Size);font-weight:700;line-height:2rem;margin-block-start:.75rem}.fd-grid-list__group-header:after,.fd-grid-list__group-header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__group-header.is-focus,.fd-grid-list__group-header:focus{outline:var(--sapContent_FocusColor) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:-.1875rem}.fd-grid-list__group-header--no-margin{-webkit-margin-before:0;margin-block-start:0}.fd-grid-list__more{background-color:var(--sapGroup_ContentBackground);border:0;border-radius:var(--fdGrid_List_Item_Border_Radius);-webkit-box-shadow:var(--sapContent_Shadow0);box-shadow:var(--sapContent_Shadow0);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);cursor:pointer;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-block:.813rem;padding-inline:0;padding-inline:.813rem;text-align:center}.fd-grid-list__more:after,.fd-grid-list__more:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__more.is-focus,.fd-grid-list__more:focus{outline:var(--sapContent_FocusColor) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:-.1875rem}.fd-grid-list__more-title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;font-weight:700;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-grid-list__more-title:after,.fd-grid-list__more-title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__more-description{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-block:.813rem 0;margin-inline:0;padding-block:0;padding-inline:0}.fd-grid-list__more-description:after,.fd-grid-list__more-description:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__more-description,.fd-grid-list__more-title{color:var(--sapLink_Visited_Color)}.fd-grid-list__more.is-hover,.fd-grid-list__more:hover{background-color:var(--sapList_Hover_Background)}.fd-grid-list__more.is-active,.fd-grid-list__more:active{background-color:var(--sapList_Active_Background)}.fd-grid-list__more.is-active-description,.fd-grid-list__more.is-active-title,.fd-grid-list__more:active-description,.fd-grid-list__more:active-title{color:var(--sapList_Active_TextColor)}.fd-grid-list__footer{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapList_FooterTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-grid-list__footer:after,.fd-grid-list__footer:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__footer.is-focus,.fd-grid-list__footer:focus{outline:var(--sapContent_FocusColor) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth)}.fd-grid-list__highlight{border:0;border-radius:var(--fdGrid_List_Item_Border_Radius) 0 0 var(--fdGrid_List_Item_Border_Radius);bottom:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:block;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;left:0;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;position:absolute;top:0;width:.375rem}.fd-grid-list__highlight:after,.fd-grid-list__highlight:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__highlight[dir=rtl],[dir=rtl] .fd-grid-list__highlight{right:0}.fd-grid-list__highlight--positive{background-color:var(--sapSuccessBorderColor)}.fd-grid-list__highlight--negative{background-color:var(--sapErrorBorderColor)}.fd-grid-list__highlight--critical{background-color:var(--sapWarningBorderColor)}.fd-grid-list__highlight--neutral{background-color:var(--sapNeutralBorderColor)}.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__checkbox-label,.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__radio-label,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__checkbox-label,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__radio-label,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__checkbox-label,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;color:var(--sapContent_LabelColor);-ms-flex-direction:row;flex-direction:row}.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__checkbox-label.is-empty,.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__checkbox-label:empty,.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__radio-label.is-empty,.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__radio-label:empty,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__checkbox-label.is-empty,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__checkbox-label:empty,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__radio-label.is-empty,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__radio-label:empty,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__checkbox-label.is-empty,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__checkbox-label:empty,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label.is-empty,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label:empty{-webkit-margin-start:-.5rem;margin-inline-start:-.5rem}.fd-grid-list--mode-single-select .fd-grid-list__item{cursor:pointer}.fd-grid-list--mode-single-select .fd-grid-list__item.is-hover,.fd-grid-list--mode-single-select .fd-grid-list__item:hover{background-color:var(--sapList_Hover_Background);-webkit-box-shadow:0 0 0 .0625rem var(--fdGrid_List_Item_Hover_Border_Color),var(--sapContent_Shadow2);box-shadow:0 0 0 .0625rem var(--fdGrid_List_Item_Hover_Border_Color),var(--sapContent_Shadow2)}.fd-grid-list--mode-single-select .fd-grid-list__item.is-selected,.fd-grid-list--mode-single-select .fd-grid-list__item[aria-selected=true]{background-color:var(--sapList_SelectionBackgroundColor);-webkit-box-shadow:0 0 0 .125rem var(--sapList_SelectionBorderColor);box-shadow:0 0 0 .125rem var(--sapList_SelectionBorderColor)}.fd-grid-list--mode-single-select .fd-grid-list__item.is-selected.is-hover,.fd-grid-list--mode-single-select .fd-grid-list__item.is-selected:hover,.fd-grid-list--mode-single-select .fd-grid-list__item[aria-selected=true].is-hover,.fd-grid-list--mode-single-select .fd-grid-list__item[aria-selected=true]:hover{background-color:var(--sapList_Hover_SelectionBackground)}.fd-grid-list--mode-single-select .fd-grid-list__item .fd-grid-list__radio-input{height:100%;width:100%;z-index:-1}.fd-grid-list--mode-single-select .fd-grid-list__item .fd-grid-list__radio-label{display:none}.fd-grid-list--mode-single-select .fd-grid-list__item.is-selected:before,.fd-grid-list--mode-single-select .fd-grid-list__item[aria-selected=true]:before{border-color:var(--sapList_SelectionBackgroundColor)}.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-input{right:1rem}.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label{-webkit-box-ordinal-group:2;-ms-flex-order:1;order:1}.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label.is-empty,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label:empty{margin-inline:.5rem -.5rem}.fd-grid-list--mode-multi-select .fd-toolbar.fd-grid-list__item-toolbar{padding-inline:.5rem 1rem}\n/*! Bundled license information:\n\nfundamental-styles/dist/grid-list.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n", ".cdk-drag-dragging{z-index:15;background-color:#fff;background-color:var(--sapList_Background, #fff);opacity:.8;transition:box-shadow .2s cubic-bezier(0,0,.2,1);box-shadow:0 3px 1px -2px #0003,0 2px 2px #00000024,0 1px 5px #0000001f}.fd-replace-indicator{position:absolute;width:100%;height:100%;top:0;left:0;pointer-events:none;border-width:.125rem;border-style:solid;background-color:transparent;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor)}.fd-replace-indicator:before{content:\"\";display:block;position:absolute;width:100%;height:100%;top:0;left:0;background-color:#0854a0;background-color:var(--sapContent_DragAndDropActiveColor, #0854a0);opacity:.5}.cdk-drag{cursor:grab}.cdk-drag.cdk-drag-dragging{cursor:grabbing}.cdk-drag-dragging{outline:none;cursor:grabbing;box-shadow:0 0 0 .0625rem #00000026,0 .625rem 1.875rem #0000004d}.cdk-drag-disabled{cursor:default}.fd-dnd-placeholder{top:0;left:0;position:absolute;opacity:.3;z-index:-1}.fd-dnd-item{position:relative;cursor:grab}.fd-dnd-item.fd-dnd-on-drag{background-color:#fff;background-color:var(--sapList_Background, #fff);z-index:15;cursor:grabbing}.drop-area__line{z-index:9999;position:absolute;background:#0854a0;background:var(--sapContent_DragAndDropActiveColor, #0854a0)}.drop-area__line--vertical{top:0;height:calc(100% - .5rem);width:2px}.drop-area__line--vertical.after{right:.2rem}.drop-area__line--vertical.before{left:-.3rem}.drop-area__line--vertical:before{background-color:#fff;background-color:var(--sapList_Background, #fff);content:\"\";position:absolute;left:-.2rem;top:-.5rem;border-radius:50%;width:.5rem;height:.5rem;border-width:.125rem;border-style:solid;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor, #0854a0)}.drop-area__line--horizontal{left:0;width:100%;height:2px}.drop-area__line--horizontal.before{top:0}.drop-area__line--horizontal.after{bottom:0}.drop-area__line--horizontal:before{background-color:#fff;background-color:var(--sapList_Background, #fff);content:\"\";position:absolute;left:0;top:-.2rem;border-radius:50%;width:.5rem;height:.5rem;border-width:.125rem;border-style:solid;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor, #0854a0)}.fd-dnd-list{position:relative}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fd-grid-list', encapsulation: ViewEncapsulation.None, providers: [KeyboardSupportService, { provide: GridList, useExisting: GridListComponent }], changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, template: "<div\n    [id]=\"id\"\n    [style.width]=\"width\"\n    class=\"fd-grid-list\"\n    [attr.aria-label]=\"ariaLabel\"\n    [class.fd-grid-list--mode-delete]=\"selectionMode === 'delete'\"\n    [class.fd-grid-list--mode-single-select]=\"selectionMode === 'singleSelect'\"\n    [class.fd-grid-list--mode-single-select-left]=\"selectionMode === 'singleSelectLeft'\"\n    [class.fd-grid-list--mode-single-select-right]=\"selectionMode === 'singleSelectRight'\"\n    [class.fd-grid-list--mode-multi-select]=\"selectionMode === 'multiSelect'\"\n    (keydown)=\"handleKeydown($event)\"\n>\n    <div class=\"fd-container\" role=\"listbox\">\n        <div class=\"fd-row\">\n            <ng-content></ng-content>\n        </div>\n    </div>\n</div>\n", styles: [".fd-radio{-webkit-appearance:none;-moz-appearance:none;appearance:none;background-color:var(--sapField_Background);border:0;border-color:var(--sapField_BorderColor);border-radius:var(--sapField_BorderCornerRadius);border-style:solid;border-width:var(--sapField_BorderWidth);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapField_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;opacity:.0001;outline:none;overflow:hidden;padding-block:0;padding-inline:0;position:absolute;text-overflow:ellipsis;white-space:nowrap}.fd-radio:after,.fd-radio:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-radio::-webkit-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-radio::-moz-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-radio:-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-radio::-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-radio::placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-radio::-moz-selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-radio::selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-radio.is-success{background:var(--sapField_SuccessBackgroundStyle);background-color:var(--sapField_SuccessBackground);border:var(--sapField_SuccessColor) var(--sapField_SuccessBorderWidth) var(--sapField_SuccessBorderStyle);-webkit-box-shadow:var(--sapField_SuccessShadow);box-shadow:var(--sapField_SuccessShadow)}.fd-radio.is-success.is-hover,.fd-radio.is-success:hover{background-color:var(--fdInput_Success_Background_Color_Hover);border-color:var(--sapField_SuccessColor);-webkit-box-shadow:var(--fdInput_Success_Box_Shadow_Hover);box-shadow:var(--fdInput_Success_Box_Shadow_Hover)}.fd-radio.is-success.is-focus,.fd-radio.is-success:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Success_Outline_Color);z-index:5}.fd-radio.is-success.is-focus.is-hover,.fd-radio.is-success.is-focus:hover,.fd-radio.is-success:focus.is-hover,.fd-radio.is-success:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-success.is-expanded,.fd-radio.is-success[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Success_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-radio.is-error{background:var(--sapField_InvalidBackgroundStyle);background-color:var(--sapField_InvalidBackground);border:var(--sapField_InvalidColor) var(--sapField_InvalidBorderWidth) var(--sapField_InvalidBorderStyle);-webkit-box-shadow:var(--sapField_InvalidShadow);box-shadow:var(--sapField_InvalidShadow)}.fd-radio.is-error.is-hover,.fd-radio.is-error:hover{background-color:var(--fdInput_Error_Background_Color_Hover);border-color:var(--sapField_InvalidColor);-webkit-box-shadow:var(--fdInput_Error_Box_Shadow_Hover);box-shadow:var(--fdInput_Error_Box_Shadow_Hover)}.fd-radio.is-error.is-focus,.fd-radio.is-error:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Error_Outline_Color);z-index:5}.fd-radio.is-error.is-focus.is-hover,.fd-radio.is-error.is-focus:hover,.fd-radio.is-error:focus.is-hover,.fd-radio.is-error:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-error.is-expanded,.fd-radio.is-error[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Error_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-radio.is-warning{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle);-webkit-box-shadow:var(--sapField_WarningShadow);box-shadow:var(--sapField_WarningShadow)}.fd-radio.is-warning.is-hover,.fd-radio.is-warning:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-radio.is-warning.is-focus,.fd-radio.is-warning:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-radio.is-warning.is-focus.is-hover,.fd-radio.is-warning.is-focus:hover,.fd-radio.is-warning:focus.is-hover,.fd-radio.is-warning:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-warning.is-expanded,.fd-radio.is-warning[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-radio.is-alert{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle)}.fd-radio.is-alert.is-hover,.fd-radio.is-alert:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-radio.is-alert.is-focus,.fd-radio.is-alert:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-radio.is-alert.is-focus.is-hover,.fd-radio.is-alert.is-focus:hover,.fd-radio.is-alert:focus.is-hover,.fd-radio.is-alert:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-alert.is-expanded,.fd-radio.is-alert[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-radio.is-information{background:var(--sapField_InformationBackgroundStyle);background-color:var(--sapField_InformationBackground);border:var(--sapField_InformationColor) var(--sapField_InformationBorderWidth) var(--sapField_InformationBorderStyle);-webkit-box-shadow:var(--sapField_InformationShadow);box-shadow:var(--sapField_InformationShadow)}.fd-radio.is-information.is-hover,.fd-radio.is-information:hover{background-color:var(--fdInput_Information_Background_Color_Hover);border-color:var(--sapField_InformationColor);-webkit-box-shadow:var(--fdInput_Information_Box_Shadow_Hover);box-shadow:var(--fdInput_Information_Box_Shadow_Hover)}.fd-radio.is-information.is-focus,.fd-radio.is-information:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Information_Outline_Color);z-index:5}.fd-radio.is-information.is-focus.is-hover,.fd-radio.is-information.is-focus:hover,.fd-radio.is-information:focus.is-hover,.fd-radio.is-information:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-information.is-expanded,.fd-radio.is-information[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Information_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-radio.is-alert.is-focus,.fd-radio.is-alert:focus,.fd-radio.is-error.is-focus,.fd-radio.is-error:focus,.fd-radio.is-information.is-focus,.fd-radio.is-information:focus,.fd-radio.is-warning.is-focus,.fd-radio.is-warning:focus{outline-offset:var(--fdInput_Outline_Offset_States);z-index:5}.fd-radio.is-disabled,.fd-radio:disabled,.fd-radio[aria-disabled=true]{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-radio.is-readonly,.fd-radio.is-readonly.is-focus,.fd-radio.is-readonly.is-hover,.fd-radio.is-readonly:focus,.fd-radio.is-readonly:hover,.fd-radio[aria-readonly=true],.fd-radio[aria-readonly=true].is-focus,.fd-radio[aria-readonly=true].is-hover,.fd-radio[aria-readonly=true]:focus,.fd-radio[aria-readonly=true]:hover,.fd-radio[readonly],.fd-radio[readonly].is-focus,.fd-radio[readonly].is-hover,.fd-radio[readonly]:focus,.fd-radio[readonly]:hover{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-radio.is-readonly.is-focus,.fd-radio.is-readonly:focus,.fd-radio[aria-readonly=true].is-focus,.fd-radio[aria-readonly=true]:focus,.fd-radio[readonly].is-focus,.fd-radio[readonly]:focus{z-index:5}.fd-radio__label{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;max-width:100%;padding-block:0;padding-inline:0;position:relative;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content;-webkit-margin-end:.5rem;cursor:text;margin-inline-end:.5rem;-ms-flex-item-align:start;align-self:flex-start;cursor:pointer;display:-webkit-box;display:-ms-flexbox;display:flex;line-height:1rem;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapField_TextColor);padding-block:var(--fdRadio_Outer_Circle_Padding);padding-inline:var(--fdRadio_Outer_Circle_Padding)}.fd-radio__label:after,.fd-radio__label:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-radio__label:before{content:\"\";display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;height:var(--fdRadio_Inner_Circle_Diameter);min-width:var(--fdRadio_Inner_Circle_Diameter);width:var(--fdRadio_Inner_Circle_Diameter);-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;border-radius:50%;-webkit-margin-end:var(--fdRadio_Outer_Circle_Padding);background-color:var(--fdRadio_Background_Color);border:var(--fdRadio_Inner_Border_Width) var(--fdRadio_Inner_Border_Style) var(--fdRadio_Inner_Border_Color);margin-inline-end:var(--fdRadio_Outer_Circle_Padding)}.fd-radio__label:after{height:var(--fdRadio_Inner_Content_Size);left:var(--fdRadio_Inner_Content_Padding);min-width:var(--fdRadio_Inner_Content_Size);width:var(--fdRadio_Inner_Content_Size)}.fd-radio__label.is-focus,.fd-radio__label:focus{outline:none;z-index:5}.fd-radio__label.is-hover:before,.fd-radio__label:hover:before{background-color:var(--fdRadio_Hover_Background_Color);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_Default_Hover);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_Default_Hover);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_Default_Hover);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_Default_Hover);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_Default_Hover)}.fd-radio__label[dir=rtl]:after,[dir=rtl] .fd-radio__label:after{right:var(--fdRadio_Inner_Content_Padding)}.fd-radio__label.is-empty,.fd-radio__label:empty{margin-block:0;margin-inline:0;padding-block:var(--fdRadio_Outer_Circle_Padding);padding-inline:var(--fdRadio_Outer_Circle_Padding)}.fd-radio__label.is-empty:after,.fd-radio__label.is-empty:before,.fd-radio__label:empty:after,.fd-radio__label:empty:before{margin-inline:0}.fd-radio__label--wrap .fd-radio__text{white-space:normal}.fd-radio__label--wrap-top-aligned{-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start}.fd-radio__label--wrap-top-aligned .fd-radio__text{white-space:normal}.fd-radio__label--wrap-top-aligned:after{top:var(--fdRadio_Inner_Content_Padding)}.fd-radio__text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-radio__text:after,.fd-radio__text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-radio:checked+.fd-radio__label:after{background:var(--fdRadio_Active_Dot_Color);border-radius:50%;content:\"\";position:absolute}.fd-radio.is-error+.fd-radio__label:before,.fd-radio.is-error:checked+.fd-radio__label:after{--fdRadio_Background_Color:var(--fdRadio_Background_Color_Error);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_Error);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_Error);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_Error);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_Error);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_Error_Hover)}.fd-radio.is-alert+.fd-radio__label:before,.fd-radio.is-alert:checked+.fd-radio__label:after,.fd-radio.is-warning+.fd-radio__label:before,.fd-radio.is-warning:checked+.fd-radio__label:after{--fdRadio_Background_Color:var(--fdRadio_Background_Color_Warning);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_Warning);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_Warning);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_Warning);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_Warning);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_Warning_Hover)}.fd-radio.is-success+.fd-radio__label:before,.fd-radio.is-success:checked+.fd-radio__label:after{--fdRadio_Background_Color:var(--fdRadio_Background_Color_Success);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_Success);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_Success);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_Success);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_Success);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_Success_Hover)}.fd-radio.is-information+.fd-radio__label:before,.fd-radio.is-information:checked+.fd-radio__label:after{--fdRadio_Background_Color:var(--fdRadio_Background_Color_Information);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_Information);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_Information);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_Information);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_Information);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_Information_Hover)}.fd-radio.is-readonly+.fd-radio__label:before,.fd-radio.is-readonly:checked+.fd-radio__label:after,.fd-radio[aria-readonly=true]+.fd-radio__label:before,.fd-radio[aria-readonly=true]:checked+.fd-radio__label:after,.fd-radio[readonly]+.fd-radio__label:before,.fd-radio[readonly]:checked+.fd-radio__label:after{--fdRadio_Background_Color:var(--fdRadio_Background_Color_ReadOnly);--fdRadio_Inner_Border_Width:var(--fdRadio_Inner_Border_Width_ReadOnly);--fdRadio_Inner_Border_Style:var(--fdRadio_Inner_Border_Style_ReadOnly);--fdRadio_Inner_Border_Color:var(--fdRadio_Inner_Border_Color_ReadOnly);--fdRadio_Active_Dot_Color:var(--fdRadio_Active_Dot_Color_ReadOnly);--fdRadio_Hover_Background_Color:var(--fdRadio_Background_Color_ReadOnly)}.fd-radio.is-focus,.fd-radio:focus{z-index:5}.fd-radio.is-focus+.fd-radio__label,.fd-radio:focus+.fd-radio__label{border-radius:var(--fdRadio_Outline_Border_Radius);outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);outline-offset:calc(var(--fdRadio_Focus_Outline_Offset) - var(--fdRadio_Outer_Circle_Padding))}.fd-radio.is-disabled,.fd-radio:disabled,.fd-radio[aria-disabled=true]{opacity:.0001}.fd-radio.is-disabled+.fd-radio__label,.fd-radio:disabled+.fd-radio__label,.fd-radio[aria-disabled=true]+.fd-radio__label{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-radio[class*=-compact]+.fd-radio__label,.fd-radio[class*=-condensed]+.fd-radio__label,[class*=-compact] .fd-radio:not([class*=-cozy])+.fd-radio__label,[class*=-condensed] .fd-radio:not([class*=-cozy])+.fd-radio__label{--fdRadio_Outer_Circle_Padding:var(--fdRadio_Compact_Outer_Circle_Padding);--fdRadio_Inner_Circle_Diameter:var(--fdRadio_Compact_Inner_Circle_Diameter);--fdRadio_Inner_Content_Size:var(--fdRadio_Inner_Content_Size_Compact);--fdRadio_Inner_Content_Padding:var(--fdRadio_Inner_Content_Padding_Compact)}.fd-radio[class*=-compact].is-focus,.fd-radio[class*=-compact]:focus,.fd-radio[class*=-condensed].is-focus,.fd-radio[class*=-condensed]:focus,[class*=-compact] .fd-radio:not([class*=-cozy]).is-focus,[class*=-compact] .fd-radio:not([class*=-cozy]):focus,[class*=-condensed] .fd-radio:not([class*=-cozy]).is-focus,[class*=-condensed] .fd-radio:not([class*=-cozy]):focus{z-index:5}.fd-radio[class*=-compact].is-focus+.fd-radio__label,.fd-radio[class*=-compact]:focus+.fd-radio__label,.fd-radio[class*=-condensed].is-focus+.fd-radio__label,.fd-radio[class*=-condensed]:focus+.fd-radio__label,[class*=-compact] .fd-radio:not([class*=-cozy]).is-focus+.fd-radio__label,[class*=-compact] .fd-radio:not([class*=-cozy]):focus+.fd-radio__label,[class*=-condensed] .fd-radio:not([class*=-cozy]).is-focus+.fd-radio__label,[class*=-condensed] .fd-radio:not([class*=-cozy]):focus+.fd-radio__label{--fdRadio_Outer_Circle_Padding:var(--fdRadio_Compact_Outer_Circle_Padding);--fdRadio_Outline_Border_Radius:var(--fdRadio_Compact_Outline_Border_radius)}.fd-checkbox{-webkit-appearance:none;-moz-appearance:none;appearance:none;background-color:var(--sapField_Background);border:0;border-color:var(--sapField_BorderColor);border-radius:var(--sapField_BorderCornerRadius);border-style:solid;border-width:var(--sapField_BorderWidth);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapField_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;opacity:.0001;outline:none;overflow:hidden;padding-block:0;padding-inline:0;position:absolute;text-overflow:ellipsis;white-space:nowrap}.fd-checkbox:after,.fd-checkbox:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-checkbox::-webkit-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-checkbox::-moz-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-checkbox:-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-checkbox::-ms-input-placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-checkbox::placeholder{color:var(--sapField_PlaceholderTextColor);font-style:italic}.fd-checkbox::-moz-selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-checkbox::selection{background-color:var(--sapSelectedColor);color:var(--sapContent_ContrastTextColor)}.fd-checkbox.is-success{background:var(--sapField_SuccessBackgroundStyle);background-color:var(--sapField_SuccessBackground);border:var(--sapField_SuccessColor) var(--sapField_SuccessBorderWidth) var(--sapField_SuccessBorderStyle);-webkit-box-shadow:var(--sapField_SuccessShadow);box-shadow:var(--sapField_SuccessShadow)}.fd-checkbox.is-success.is-hover,.fd-checkbox.is-success:hover{background-color:var(--fdInput_Success_Background_Color_Hover);border-color:var(--sapField_SuccessColor);-webkit-box-shadow:var(--fdInput_Success_Box_Shadow_Hover);box-shadow:var(--fdInput_Success_Box_Shadow_Hover)}.fd-checkbox.is-success.is-focus,.fd-checkbox.is-success:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Success_Outline_Color);z-index:5}.fd-checkbox.is-success.is-focus.is-hover,.fd-checkbox.is-success.is-focus:hover,.fd-checkbox.is-success:focus.is-hover,.fd-checkbox.is-success:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-success.is-expanded,.fd-checkbox.is-success[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Success_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-checkbox.is-error{background:var(--sapField_InvalidBackgroundStyle);background-color:var(--sapField_InvalidBackground);border:var(--sapField_InvalidColor) var(--sapField_InvalidBorderWidth) var(--sapField_InvalidBorderStyle);-webkit-box-shadow:var(--sapField_InvalidShadow);box-shadow:var(--sapField_InvalidShadow)}.fd-checkbox.is-error.is-hover,.fd-checkbox.is-error:hover{background-color:var(--fdInput_Error_Background_Color_Hover);border-color:var(--sapField_InvalidColor);-webkit-box-shadow:var(--fdInput_Error_Box_Shadow_Hover);box-shadow:var(--fdInput_Error_Box_Shadow_Hover)}.fd-checkbox.is-error.is-focus,.fd-checkbox.is-error:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Error_Outline_Color);z-index:5}.fd-checkbox.is-error.is-focus.is-hover,.fd-checkbox.is-error.is-focus:hover,.fd-checkbox.is-error:focus.is-hover,.fd-checkbox.is-error:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-error.is-expanded,.fd-checkbox.is-error[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Error_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-checkbox.is-warning{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle);-webkit-box-shadow:var(--sapField_WarningShadow);box-shadow:var(--sapField_WarningShadow)}.fd-checkbox.is-warning.is-hover,.fd-checkbox.is-warning:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-checkbox.is-warning.is-focus,.fd-checkbox.is-warning:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-checkbox.is-warning.is-focus.is-hover,.fd-checkbox.is-warning.is-focus:hover,.fd-checkbox.is-warning:focus.is-hover,.fd-checkbox.is-warning:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-warning.is-expanded,.fd-checkbox.is-warning[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-checkbox.is-alert{background:var(--sapField_WarningBackgroundStyle);background-color:var(--sapField_WarningBackground);border:var(--sapField_WarningColor) var(--sapField_WarningBorderWidth) var(--sapField_WarningBorderStyle)}.fd-checkbox.is-alert.is-hover,.fd-checkbox.is-alert:hover{background-color:var(--fdInput_Warning_Background_Color_Hover);border-color:var(--sapField_WarningColor);-webkit-box-shadow:var(--fdInput_Warning_Box_Shadow_Hover);box-shadow:var(--fdInput_Warning_Box_Shadow_Hover)}.fd-checkbox.is-alert.is-focus,.fd-checkbox.is-alert:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Warning_Outline_Color);z-index:5}.fd-checkbox.is-alert.is-focus.is-hover,.fd-checkbox.is-alert.is-focus:hover,.fd-checkbox.is-alert:focus.is-hover,.fd-checkbox.is-alert:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-alert.is-expanded,.fd-checkbox.is-alert[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Warning_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-checkbox.is-information{background:var(--sapField_InformationBackgroundStyle);background-color:var(--sapField_InformationBackground);border:var(--sapField_InformationColor) var(--sapField_InformationBorderWidth) var(--sapField_InformationBorderStyle);-webkit-box-shadow:var(--sapField_InformationShadow);box-shadow:var(--sapField_InformationShadow)}.fd-checkbox.is-information.is-hover,.fd-checkbox.is-information:hover{background-color:var(--fdInput_Information_Background_Color_Hover);border-color:var(--sapField_InformationColor);-webkit-box-shadow:var(--fdInput_Information_Box_Shadow_Hover);box-shadow:var(--fdInput_Information_Box_Shadow_Hover)}.fd-checkbox.is-information.is-focus,.fd-checkbox.is-information:focus{background:var(--sapField_Focus_Background);outline-color:var(--fdInput_Information_Outline_Color);z-index:5}.fd-checkbox.is-information.is-focus.is-hover,.fd-checkbox.is-information.is-focus:hover,.fd-checkbox.is-information:focus.is-hover,.fd-checkbox.is-information:focus:hover{-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-information.is-expanded,.fd-checkbox.is-information[aria-expanded=true]{background:var(--sapField_Focus_Background);-webkit-box-shadow:none;box-shadow:none;outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdInput_Information_Outline_Color);outline-offset:var(--fdInput_Outline_Offset)}.fd-checkbox.is-alert.is-focus,.fd-checkbox.is-alert:focus,.fd-checkbox.is-error.is-focus,.fd-checkbox.is-error:focus,.fd-checkbox.is-information.is-focus,.fd-checkbox.is-information:focus,.fd-checkbox.is-warning.is-focus,.fd-checkbox.is-warning:focus{outline-offset:var(--fdInput_Outline_Offset_States);z-index:5}.fd-checkbox.is-disabled,.fd-checkbox:disabled,.fd-checkbox[aria-disabled=true]{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-checkbox.is-readonly,.fd-checkbox.is-readonly.is-focus,.fd-checkbox.is-readonly.is-hover,.fd-checkbox.is-readonly:focus,.fd-checkbox.is-readonly:hover,.fd-checkbox[aria-readonly=true],.fd-checkbox[aria-readonly=true].is-focus,.fd-checkbox[aria-readonly=true].is-hover,.fd-checkbox[aria-readonly=true]:focus,.fd-checkbox[aria-readonly=true]:hover,.fd-checkbox[readonly],.fd-checkbox[readonly].is-focus,.fd-checkbox[readonly].is-hover,.fd-checkbox[readonly]:focus,.fd-checkbox[readonly]:hover{--fdInput_Outline_Offset:-.25rem;background:var(--sapField_ReadOnly_BackgroundStyle);background-color:var(--sapField_ReadOnly_Background);border-color:var(--sapField_ReadOnly_BorderColor);-webkit-box-shadow:none;box-shadow:none}.fd-checkbox.is-readonly.is-focus,.fd-checkbox.is-readonly:focus,.fd-checkbox[aria-readonly=true].is-focus,.fd-checkbox[aria-readonly=true]:focus,.fd-checkbox[readonly].is-focus,.fd-checkbox[readonly]:focus{z-index:5}.fd-checkbox,.fd-checkbox.is-error,.fd-checkbox.is-information,.fd-checkbox.is-success,.fd-checkbox.is-warning{border-style:initial}.fd-checkbox__label{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;max-width:100%;overflow:hidden;padding-block:0;padding-inline:0;position:relative;text-overflow:ellipsis;white-space:nowrap;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content;-webkit-margin-end:.5rem;cursor:text;margin-inline-end:.5rem;-ms-flex-item-align:start;align-self:flex-start;cursor:pointer;display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;gap:var(--fdCheckbox_Padding);line-height:1rem;margin-block:0;margin-inline:0;padding-block:var(--fdCheckbox_Padding);padding-inline:var(--fdCheckbox_Padding)}.fd-checkbox__label:after,.fd-checkbox__label:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-checkbox__label.is-hover .fd-checkbox__checkmark,.fd-checkbox__label:hover .fd-checkbox__checkmark{background-color:var(--fdCheckbox_Hover_Background_Color);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_Default_Hover);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_Default_Hover);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_Default_Hover);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_Default_Hover);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_Default_Hover)}.fd-checkbox__label:focus{outline:none}.fd-checkbox__label--required .fd-checkbox__text,.fd-checkbox__label[aria-required=true] .fd-checkbox__text{-webkit-padding-end:.5rem;padding-inline-end:.5rem}.fd-checkbox__label--required .fd-checkbox__text:after,.fd-checkbox__label[aria-required=true] .fd-checkbox__text:after{color:var(--sapField_RequiredColor);content:\"*\"/\"\";font-size:var(--sapFontSize);font-weight:700;position:absolute;-webkit-padding-start:.125rem;padding-inline-start:.125rem}.fd-checkbox__label--wrap .fd-checkbox__label-container{height:auto;white-space:normal}.fd-checkbox__label--wrap .fd-checkbox__text{white-space:normal}.fd-checkbox__label--wrap-top-aligned{-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start}.fd-checkbox__label--wrap-top-aligned .fd-checkbox__label-container{height:auto;white-space:normal}.fd-checkbox__label--wrap-top-aligned .fd-checkbox__text{white-space:normal}.fd-checkbox__label-container{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;height:1rem;max-width:inherit;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-checkbox__label-container:after,.fd-checkbox__label-container:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-checkbox__text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;max-width:inherit;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap}.fd-checkbox__text:after,.fd-checkbox__text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-checkbox__checkmark{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:var(--fdCheckbox_Background_Color);border:var(--fdCheckbox_Inner_Border_Width) var(--fdCheckbox_Inner_Border_Style) var(--fdCheckbox_Inner_Border_Color);border-radius:var(--sapField_BorderCornerRadius);color:var(--fdCheckbox_Check_Mark_Color);font-family:SAP-icons;height:var(--fdCheckbox_Dimensions);min-width:var(--fdCheckbox_Dimensions);width:var(--fdCheckbox_Dimensions)}.fd-checkbox__checkmark:after,.fd-checkbox__checkmark:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-checkbox__checkmark:before{content:\"\"}.fd-checkbox:checked+.fd-checkbox__label .fd-checkbox__checkmark:before{content:\"\\e05b\"}.fd-checkbox:indeterminate+.fd-checkbox__label .fd-checkbox__checkmark:after{background-color:var(--fdCheckbox_Check_Mark_Color);content:\"\";height:var(--fdCheckbox_Tristate_Size);position:absolute;width:var(--fdCheckbox_Tristate_Size)}.fd-checkbox.is-alert+.fd-checkbox__label .fd-checkbox__checkmark,.fd-checkbox.is-warning+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:var(--fdCheckbox_Background_Color_Warning);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_Warning);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_Warning);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_Warning);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_Warning);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_Warning_Hover)}.fd-checkbox.is-error+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:var(--fdCheckbox_Background_Color_Error);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_Error);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_Error);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_Error);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_Error);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_Error_Hover)}.fd-checkbox.is-success+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:var(--fdCheckbox_Background_Color_Success);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_Success);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_Success);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_Success);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_Success);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_Success_Hover)}.fd-checkbox.is-information+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:var(--fdCheckbox_Background_Color_Information);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_Information);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_Information);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_Information);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_Information);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_Information_Hover)}.fd-checkbox.is-readonly+.fd-checkbox__label .fd-checkbox__checkmark,.fd-checkbox[readonly]+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:var(--fdCheckbox_Background_Color_ReadOnly);--fdCheckbox_Inner_Border_Width:var(--fdCheckbox_Inner_Border_Width_ReadOnly);--fdCheckbox_Inner_Border_Style:var(--fdCheckbox_Inner_Border_Style_ReadOnly);--fdCheckbox_Inner_Border_Color:var(--fdCheckbox_Inner_Border_Color_ReadOnly);--fdCheckbox_Check_Mark_Color:var(--fdCheckbox_Check_Mark_Color_ReadOnly);--fdCheckbox_Hover_Background_Color:var(--fdCheckbox_Background_Color_ReadOnly)}.fd-checkbox.is-display+.fd-checkbox__label{--fdCheckbox_Check_Mark_Color:var(--sapTextColor);gap:.5rem}.fd-checkbox.is-display+.fd-checkbox__label.is-hover .fd-checkbox__checkmark,.fd-checkbox.is-display+.fd-checkbox__label:hover .fd-checkbox__checkmark{--fdCheckbox_Check_Mark_Color:var(--sapTextColor);--fdCheckbox_Hover_Background_Color:transparent}.fd-checkbox.is-display+.fd-checkbox__label .fd-checkbox__checkmark{--fdCheckbox_Background_Color:transparent;--fdCheckbox_Dimensions:1rem;border:none}.fd-checkbox.is-display+.fd-checkbox__label .fd-checkbox__checkmark:before{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;content:\"\\e19a\";font-size:1rem;height:1rem;max-height:1rem;max-width:1rem;min-height:1rem;min-width:1rem;width:1rem}.fd-checkbox.is-display:checked+.fd-checkbox__label .fd-checkbox__checkmark:before{content:\"\\e03f\";font-size:1rem}.fd-checkbox.is-display:indeterminate+.fd-checkbox__label .fd-checkbox__checkmark:before{content:\"\\e295\";font-size:1rem}.fd-checkbox.is-display:indeterminate+.fd-checkbox__label .fd-checkbox__checkmark:after{content:\"\";height:0;width:0}.fd-checkbox.is-focus,.fd-checkbox:focus{z-index:5}.fd-checkbox.is-focus+.fd-checkbox__label,.fd-checkbox:focus+.fd-checkbox__label{border-radius:var(--fdCheckbox_Outline_Border_Radius);outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);outline-offset:calc(var(--fdCheckbox_Focus_Outline_Offset) - var(--fdCheckbox_Padding))}.fd-checkbox.is-disabled,.fd-checkbox:disabled,.fd-checkbox[aria-disabled=true]{opacity:.0001}.fd-checkbox.is-disabled+.fd-checkbox__label,.fd-checkbox:disabled+.fd-checkbox__label,.fd-checkbox[aria-disabled=true]+.fd-checkbox__label{opacity:var(--sapContent_DisabledOpacity);pointer-events:none}.fd-checkbox[class*=-compact]+.fd-checkbox__label,.fd-checkbox[class*=-condensed]+.fd-checkbox__label,[class*=-compact] .fd-checkbox:not([class*=-cozy])+.fd-checkbox__label,[class*=-condensed] .fd-checkbox:not([class*=-cozy])+.fd-checkbox__label{--fdCheckbox_Dimensions:var(--fdCheckbox_Compact_Dimensions);--fdCheckbox_Padding:var(--fdCheckbox_Compact_Padding)}.fd-checkbox[class*=-compact]:indeterminate+.fd-checkbox__label,.fd-checkbox[class*=-condensed]:indeterminate+.fd-checkbox__label,[class*=-compact] .fd-checkbox:not([class*=-cozy]):indeterminate+.fd-checkbox__label,[class*=-condensed] .fd-checkbox:not([class*=-cozy]):indeterminate+.fd-checkbox__label{--fdCheckbox_Tristate_Size:var(--fdCheckbox_Tristate_Compact_Size);--fdCheckbox_Tristate_Offset:var(--fdCheckbox_Tristate_Compact_Offset)}.fd-checkbox[class*=-compact].is-focus,.fd-checkbox[class*=-compact]:focus,.fd-checkbox[class*=-condensed].is-focus,.fd-checkbox[class*=-condensed]:focus,[class*=-compact] .fd-checkbox:not([class*=-cozy]).is-focus,[class*=-compact] .fd-checkbox:not([class*=-cozy]):focus,[class*=-condensed] .fd-checkbox:not([class*=-cozy]).is-focus,[class*=-condensed] .fd-checkbox:not([class*=-cozy]):focus{z-index:5}.fd-checkbox[class*=-compact].is-focus+.fd-checkbox__label,.fd-checkbox[class*=-compact]:focus+.fd-checkbox__label,.fd-checkbox[class*=-condensed].is-focus+.fd-checkbox__label,.fd-checkbox[class*=-condensed]:focus+.fd-checkbox__label,[class*=-compact] .fd-checkbox:not([class*=-cozy]).is-focus+.fd-checkbox__label,[class*=-compact] .fd-checkbox:not([class*=-cozy]):focus+.fd-checkbox__label,[class*=-condensed] .fd-checkbox:not([class*=-cozy]).is-focus+.fd-checkbox__label,[class*=-condensed] .fd-checkbox:not([class*=-cozy]):focus+.fd-checkbox__label{--fdCheckbox_Outline_Border_Radius:var(--fdCheckbox_Compact_Outline_Border_Radius)}.fd-col,.fd-container,.fd-row{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-col:after,.fd-col:before,.fd-container:after,.fd-container:before,.fd-row:after,.fd-row:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-container{display:-webkit-box;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-box-flex:0;-ms-flex:0 0 100%;flex:0 0 100%;padding-block:0;padding-inline:.25rem;position:relative}.fd-container .fd-row{margin-inline:-.25rem;min-width:calc(100% + .5rem)}.fd-container>.fd-row>.fd-col{padding-block:.25rem}.fd-container.fd-container--no-gap .fd-row,.fd-container.fd-container--no-horizontal-gap .fd-row{margin-inline:0}.fd-container.fd-container--no-gap .fd-row .fd-col,.fd-container.fd-container--no-horizontal-gap .fd-row .fd-col{padding-inline:0}.fd-container.fd-container--no-gap>.fd-row>.fd-col,.fd-container.fd-container--no-vertical-gap>.fd-row>.fd-col{padding-block:0}.fd-container[dir=rtl],[dir=rtl] .fd-container{direction:rtl}.fd-row{display:-webkit-box;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-box-flex:0;-ms-flex:0 0 100%;flex:0 0 100%;min-width:100%;position:relative}.fd-col{max-width:100%;min-width:100%;padding-inline:.25rem}.fd-col--0{max-width:0;min-width:0%}.fd-col--offset-0{-webkit-margin-start:0;margin-inline-start:0}.fd-col--offset-after-0{-webkit-margin-end:0;margin-inline-end:0}.fd-col--1{max-width:8.3333333333%;min-width:8.3333333333%}.fd-col--offset-1{-webkit-margin-start:8.3333333333%;margin-inline-start:8.3333333333%}.fd-col--offset-after-1{-webkit-margin-end:8.3333333333%;margin-inline-end:8.3333333333%}.fd-col--2{max-width:16.6666666667%;min-width:16.6666666667%}.fd-col--offset-2{-webkit-margin-start:16.6666666667%;margin-inline-start:16.6666666667%}.fd-col--offset-after-2{-webkit-margin-end:16.6666666667%;margin-inline-end:16.6666666667%}.fd-col--3{max-width:25%;min-width:25%}.fd-col--offset-3{-webkit-margin-start:25%;margin-inline-start:25%}.fd-col--offset-after-3{-webkit-margin-end:25%;margin-inline-end:25%}.fd-col--4{max-width:33.3333333333%;min-width:33.3333333333%}.fd-col--offset-4{-webkit-margin-start:33.3333333333%;margin-inline-start:33.3333333333%}.fd-col--offset-after-4{-webkit-margin-end:33.3333333333%;margin-inline-end:33.3333333333%}.fd-col--5{max-width:41.6666666667%;min-width:41.6666666667%}.fd-col--offset-5{-webkit-margin-start:41.6666666667%;margin-inline-start:41.6666666667%}.fd-col--offset-after-5{-webkit-margin-end:41.6666666667%;margin-inline-end:41.6666666667%}.fd-col--6{max-width:50%;min-width:50%}.fd-col--offset-6{-webkit-margin-start:50%;margin-inline-start:50%}.fd-col--offset-after-6{-webkit-margin-end:50%;margin-inline-end:50%}.fd-col--7{max-width:58.3333333333%;min-width:58.3333333333%}.fd-col--offset-7{-webkit-margin-start:58.3333333333%;margin-inline-start:58.3333333333%}.fd-col--offset-after-7{-webkit-margin-end:58.3333333333%;margin-inline-end:58.3333333333%}.fd-col--8{max-width:66.6666666667%;min-width:66.6666666667%}.fd-col--offset-8{-webkit-margin-start:66.6666666667%;margin-inline-start:66.6666666667%}.fd-col--offset-after-8{-webkit-margin-end:66.6666666667%;margin-inline-end:66.6666666667%}.fd-col--9{max-width:75%;min-width:75%}.fd-col--offset-9{-webkit-margin-start:75%;margin-inline-start:75%}.fd-col--offset-after-9{-webkit-margin-end:75%;margin-inline-end:75%}.fd-col--10{max-width:83.3333333333%;min-width:83.3333333333%}.fd-col--offset-10{-webkit-margin-start:83.3333333333%;margin-inline-start:83.3333333333%}.fd-col--offset-after-10{-webkit-margin-end:83.3333333333%;margin-inline-end:83.3333333333%}.fd-col--11{max-width:91.6666666667%;min-width:91.6666666667%}.fd-col--offset-11{-webkit-margin-start:91.6666666667%;margin-inline-start:91.6666666667%}.fd-col--offset-after-11{-webkit-margin-end:91.6666666667%;margin-inline-end:91.6666666667%}.fd-col--12{max-width:100%;min-width:100%}.fd-col--offset-12{-webkit-margin-start:100%;margin-inline-start:100%}.fd-col--offset-after-12{-webkit-margin-end:100%;margin-inline-end:100%}.fd-col--full{max-width:none;min-width:8.3333333333%;-webkit-box-flex:1;-ms-flex:1;flex:1}.fd-col--wrap{-ms-flex-wrap:wrap;flex-wrap:wrap}@media (width >= 600px){.fd-container{padding-block:0;padding-inline:.5rem}.fd-container .fd-row{margin-inline:-.5rem;min-width:calc(100% + 1rem)}.fd-container>.fd-row>.fd-col{padding-block:.5rem}.fd-col{padding-inline:.5rem}.fd-col-md--0{max-width:0;min-width:0%}.fd-col-md--offset-0{-webkit-margin-start:0;margin-inline-start:0}.fd-col-md--offset-after-0{-webkit-margin-end:0;margin-inline-end:0}.fd-col-md--1{max-width:8.3333333333%;min-width:8.3333333333%}.fd-col-md--offset-1{-webkit-margin-start:8.3333333333%;margin-inline-start:8.3333333333%}.fd-col-md--offset-after-1{-webkit-margin-end:8.3333333333%;margin-inline-end:8.3333333333%}.fd-col-md--2{max-width:16.6666666667%;min-width:16.6666666667%}.fd-col-md--offset-2{-webkit-margin-start:16.6666666667%;margin-inline-start:16.6666666667%}.fd-col-md--offset-after-2{-webkit-margin-end:16.6666666667%;margin-inline-end:16.6666666667%}.fd-col-md--3{max-width:25%;min-width:25%}.fd-col-md--offset-3{-webkit-margin-start:25%;margin-inline-start:25%}.fd-col-md--offset-after-3{-webkit-margin-end:25%;margin-inline-end:25%}.fd-col-md--4{max-width:33.3333333333%;min-width:33.3333333333%}.fd-col-md--offset-4{-webkit-margin-start:33.3333333333%;margin-inline-start:33.3333333333%}.fd-col-md--offset-after-4{-webkit-margin-end:33.3333333333%;margin-inline-end:33.3333333333%}.fd-col-md--5{max-width:41.6666666667%;min-width:41.6666666667%}.fd-col-md--offset-5{-webkit-margin-start:41.6666666667%;margin-inline-start:41.6666666667%}.fd-col-md--offset-after-5{-webkit-margin-end:41.6666666667%;margin-inline-end:41.6666666667%}.fd-col-md--6{max-width:50%;min-width:50%}.fd-col-md--offset-6{-webkit-margin-start:50%;margin-inline-start:50%}.fd-col-md--offset-after-6{-webkit-margin-end:50%;margin-inline-end:50%}.fd-col-md--7{max-width:58.3333333333%;min-width:58.3333333333%}.fd-col-md--offset-7{-webkit-margin-start:58.3333333333%;margin-inline-start:58.3333333333%}.fd-col-md--offset-after-7{-webkit-margin-end:58.3333333333%;margin-inline-end:58.3333333333%}.fd-col-md--8{max-width:66.6666666667%;min-width:66.6666666667%}.fd-col-md--offset-8{-webkit-margin-start:66.6666666667%;margin-inline-start:66.6666666667%}.fd-col-md--offset-after-8{-webkit-margin-end:66.6666666667%;margin-inline-end:66.6666666667%}.fd-col-md--9{max-width:75%;min-width:75%}.fd-col-md--offset-9{-webkit-margin-start:75%;margin-inline-start:75%}.fd-col-md--offset-after-9{-webkit-margin-end:75%;margin-inline-end:75%}.fd-col-md--10{max-width:83.3333333333%;min-width:83.3333333333%}.fd-col-md--offset-10{-webkit-margin-start:83.3333333333%;margin-inline-start:83.3333333333%}.fd-col-md--offset-after-10{-webkit-margin-end:83.3333333333%;margin-inline-end:83.3333333333%}.fd-col-md--11{max-width:91.6666666667%;min-width:91.6666666667%}.fd-col-md--offset-11{-webkit-margin-start:91.6666666667%;margin-inline-start:91.6666666667%}.fd-col-md--offset-after-11{-webkit-margin-end:91.6666666667%;margin-inline-end:91.6666666667%}.fd-col-md--12{max-width:100%;min-width:100%}.fd-col-md--offset-12{-webkit-margin-start:100%;margin-inline-start:100%}.fd-col-md--offset-after-12{-webkit-margin-end:100%;margin-inline-end:100%}}@media (width >= 1024px){.fd-col-lg--0{max-width:0;min-width:0%}.fd-col-lg--offset-0{-webkit-margin-start:0;margin-inline-start:0}.fd-col-lg--offset-after-0{-webkit-margin-end:0;margin-inline-end:0}.fd-col-lg--1{max-width:8.3333333333%;min-width:8.3333333333%}.fd-col-lg--offset-1{-webkit-margin-start:8.3333333333%;margin-inline-start:8.3333333333%}.fd-col-lg--offset-after-1{-webkit-margin-end:8.3333333333%;margin-inline-end:8.3333333333%}.fd-col-lg--2{max-width:16.6666666667%;min-width:16.6666666667%}.fd-col-lg--offset-2{-webkit-margin-start:16.6666666667%;margin-inline-start:16.6666666667%}.fd-col-lg--offset-after-2{-webkit-margin-end:16.6666666667%;margin-inline-end:16.6666666667%}.fd-col-lg--3{max-width:25%;min-width:25%}.fd-col-lg--offset-3{-webkit-margin-start:25%;margin-inline-start:25%}.fd-col-lg--offset-after-3{-webkit-margin-end:25%;margin-inline-end:25%}.fd-col-lg--4{max-width:33.3333333333%;min-width:33.3333333333%}.fd-col-lg--offset-4{-webkit-margin-start:33.3333333333%;margin-inline-start:33.3333333333%}.fd-col-lg--offset-after-4{-webkit-margin-end:33.3333333333%;margin-inline-end:33.3333333333%}.fd-col-lg--5{max-width:41.6666666667%;min-width:41.6666666667%}.fd-col-lg--offset-5{-webkit-margin-start:41.6666666667%;margin-inline-start:41.6666666667%}.fd-col-lg--offset-after-5{-webkit-margin-end:41.6666666667%;margin-inline-end:41.6666666667%}.fd-col-lg--6{max-width:50%;min-width:50%}.fd-col-lg--offset-6{-webkit-margin-start:50%;margin-inline-start:50%}.fd-col-lg--offset-after-6{-webkit-margin-end:50%;margin-inline-end:50%}.fd-col-lg--7{max-width:58.3333333333%;min-width:58.3333333333%}.fd-col-lg--offset-7{-webkit-margin-start:58.3333333333%;margin-inline-start:58.3333333333%}.fd-col-lg--offset-after-7{-webkit-margin-end:58.3333333333%;margin-inline-end:58.3333333333%}.fd-col-lg--8{max-width:66.6666666667%;min-width:66.6666666667%}.fd-col-lg--offset-8{-webkit-margin-start:66.6666666667%;margin-inline-start:66.6666666667%}.fd-col-lg--offset-after-8{-webkit-margin-end:66.6666666667%;margin-inline-end:66.6666666667%}.fd-col-lg--9{max-width:75%;min-width:75%}.fd-col-lg--offset-9{-webkit-margin-start:75%;margin-inline-start:75%}.fd-col-lg--offset-after-9{-webkit-margin-end:75%;margin-inline-end:75%}.fd-col-lg--10{max-width:83.3333333333%;min-width:83.3333333333%}.fd-col-lg--offset-10{-webkit-margin-start:83.3333333333%;margin-inline-start:83.3333333333%}.fd-col-lg--offset-after-10{-webkit-margin-end:83.3333333333%;margin-inline-end:83.3333333333%}.fd-col-lg--11{max-width:91.6666666667%;min-width:91.6666666667%}.fd-col-lg--offset-11{-webkit-margin-start:91.6666666667%;margin-inline-start:91.6666666667%}.fd-col-lg--offset-after-11{-webkit-margin-end:91.6666666667%;margin-inline-end:91.6666666667%}.fd-col-lg--12{max-width:100%;min-width:100%}.fd-col-lg--offset-12{-webkit-margin-start:100%;margin-inline-start:100%}.fd-col-lg--offset-after-12{-webkit-margin-end:100%;margin-inline-end:100%}}@media (width >= 1440px){.fd-col-xl--0{max-width:0;min-width:0%}.fd-col-xl--offset-0{-webkit-margin-start:0;margin-inline-start:0}.fd-col-xl--offset-after-0{-webkit-margin-end:0;margin-inline-end:0}.fd-col-xl--1{max-width:8.3333333333%;min-width:8.3333333333%}.fd-col-xl--offset-1{-webkit-margin-start:8.3333333333%;margin-inline-start:8.3333333333%}.fd-col-xl--offset-after-1{-webkit-margin-end:8.3333333333%;margin-inline-end:8.3333333333%}.fd-col-xl--2{max-width:16.6666666667%;min-width:16.6666666667%}.fd-col-xl--offset-2{-webkit-margin-start:16.6666666667%;margin-inline-start:16.6666666667%}.fd-col-xl--offset-after-2{-webkit-margin-end:16.6666666667%;margin-inline-end:16.6666666667%}.fd-col-xl--3{max-width:25%;min-width:25%}.fd-col-xl--offset-3{-webkit-margin-start:25%;margin-inline-start:25%}.fd-col-xl--offset-after-3{-webkit-margin-end:25%;margin-inline-end:25%}.fd-col-xl--4{max-width:33.3333333333%;min-width:33.3333333333%}.fd-col-xl--offset-4{-webkit-margin-start:33.3333333333%;margin-inline-start:33.3333333333%}.fd-col-xl--offset-after-4{-webkit-margin-end:33.3333333333%;margin-inline-end:33.3333333333%}.fd-col-xl--5{max-width:41.6666666667%;min-width:41.6666666667%}.fd-col-xl--offset-5{-webkit-margin-start:41.6666666667%;margin-inline-start:41.6666666667%}.fd-col-xl--offset-after-5{-webkit-margin-end:41.6666666667%;margin-inline-end:41.6666666667%}.fd-col-xl--6{max-width:50%;min-width:50%}.fd-col-xl--offset-6{-webkit-margin-start:50%;margin-inline-start:50%}.fd-col-xl--offset-after-6{-webkit-margin-end:50%;margin-inline-end:50%}.fd-col-xl--7{max-width:58.3333333333%;min-width:58.3333333333%}.fd-col-xl--offset-7{-webkit-margin-start:58.3333333333%;margin-inline-start:58.3333333333%}.fd-col-xl--offset-after-7{-webkit-margin-end:58.3333333333%;margin-inline-end:58.3333333333%}.fd-col-xl--8{max-width:66.6666666667%;min-width:66.6666666667%}.fd-col-xl--offset-8{-webkit-margin-start:66.6666666667%;margin-inline-start:66.6666666667%}.fd-col-xl--offset-after-8{-webkit-margin-end:66.6666666667%;margin-inline-end:66.6666666667%}.fd-col-xl--9{max-width:75%;min-width:75%}.fd-col-xl--offset-9{-webkit-margin-start:75%;margin-inline-start:75%}.fd-col-xl--offset-after-9{-webkit-margin-end:75%;margin-inline-end:75%}.fd-col-xl--10{max-width:83.3333333333%;min-width:83.3333333333%}.fd-col-xl--offset-10{-webkit-margin-start:83.3333333333%;margin-inline-start:83.3333333333%}.fd-col-xl--offset-after-10{-webkit-margin-end:83.3333333333%;margin-inline-end:83.3333333333%}.fd-col-xl--11{max-width:91.6666666667%;min-width:91.6666666667%}.fd-col-xl--offset-11{-webkit-margin-start:91.6666666667%;margin-inline-start:91.6666666667%}.fd-col-xl--offset-after-11{-webkit-margin-end:91.6666666667%;margin-inline-end:91.6666666667%}.fd-col-xl--12{max-width:100%;min-width:100%}.fd-col-xl--offset-12{-webkit-margin-start:100%;margin-inline-start:100%}.fd-col-xl--offset-after-12{-webkit-margin-end:100%;margin-inline-end:100%}}.fd-grid-list{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-grid-list:after,.fd-grid-list:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__radio-input{height:1rem;width:1rem}.fd-grid-list .fd-grid-list__radio-input+.fd-grid-list__radio-label.is-empty,.fd-grid-list .fd-grid-list__radio-input+.fd-grid-list__radio-label:empty{-ms-flex-item-align:center;align-self:center}.fd-grid-list .fd-grid-list__checkbox-input{height:1rem;width:1rem}.fd-grid-list .fd-grid-list__checkbox-input+.fd-grid-list__checkbox-label.is-empty,.fd-grid-list .fd-grid-list__checkbox-input+.fd-grid-list__checkbox-label:empty{-ms-flex-item-align:center;align-self:center}.fd-grid-list .fd-grid-list__item{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;background-color:var(--sapList_Background);border-radius:var(--fdGrid_List_Item_Border_Radius);-webkit-box-shadow:var(--sapContent_Shadow0);box-shadow:var(--sapContent_Shadow0);color:var(--sapList_TextColor);-ms-flex-direction:column;flex-direction:column;height:100%;outline:none;overflow:hidden;position:relative}.fd-grid-list .fd-grid-list__item:after,.fd-grid-list .fd-grid-list__item:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item.is-focus,.fd-grid-list .fd-grid-list__item:focus{z-index:5}.fd-grid-list .fd-grid-list__item.is-focus:before,.fd-grid-list .fd-grid-list__item:focus:before{border:var(--fdGrid_List_Item_Focus_Border);border-radius:var(--fdGrid_List_Item_Border_Radius);-webkit-box-shadow:var(--fdGrid_List_Item_Focus_Box_Shadow);box-shadow:var(--fdGrid_List_Item_Focus_Box_Shadow);content:\"\";display:block;inset:var(--fdGrid_List_Item_Focus_Outline_Offset);pointer-events:none;position:absolute;z-index:1}.fd-grid-list .fd-grid-list__item--height-auto{height:auto}.fd-grid-list .fd-grid-list__item--unread .fd-grid-list__item-body *{font-weight:700}.fd-grid-list .fd-grid-list__item--link{cursor:pointer}.fd-grid-list .fd-grid-list__item--link.is-hover,.fd-grid-list .fd-grid-list__item--link:hover{background-color:var(--sapList_Hover_Background);-webkit-box-shadow:0 0 0 .0625rem var(--fdGrid_List_Item_Hover_Border_Color),var(--sapContent_Shadow2);box-shadow:0 0 0 .0625rem var(--fdGrid_List_Item_Hover_Border_Color),var(--sapContent_Shadow2)}.fd-grid-list .fd-grid-list__item--link.is-active:not([aria-selected=true],.is-selected),.fd-grid-list .fd-grid-list__item--link:active:not([aria-selected=true],.is-selected){background-color:var(--sapList_Active_Background)}.fd-grid-list .fd-grid-list__item--link.is-active:not([aria-selected=true],.is-selected) *,.fd-grid-list .fd-grid-list__item--link:active:not([aria-selected=true],.is-selected) *{color:var(--sapList_Active_TextColor)!important;text-shadow:none!important}.fd-grid-list .fd-grid-list__item--link.is-selected,.fd-grid-list .fd-grid-list__item--link[aria-selected=true]{background-color:var(--sapList_SelectionBackgroundColor);-webkit-box-shadow:0 0 0 .125rem var(--sapList_SelectionBorderColor);box-shadow:0 0 0 .125rem var(--sapList_SelectionBorderColor)}.fd-grid-list .fd-grid-list__item--link.is-selected.is-hover,.fd-grid-list .fd-grid-list__item--link.is-selected:hover,.fd-grid-list .fd-grid-list__item--link[aria-selected=true].is-hover,.fd-grid-list .fd-grid-list__item--link[aria-selected=true]:hover{background-color:var(--sapList_Hover_SelectionBackground)}.fd-grid-list .fd-grid-list__item--link.is-navigated:after{background-color:var(--sapList_SelectionBorderColor);border-radius:0 var(--fdGrid_List_Item_Border_Radius) var(--fdGrid_List_Item_Border_Radius) 0;content:\"\";display:block;height:100%;position:absolute;right:0;top:0;width:.1875rem}.fd-grid-list .fd-grid-list__item--link.is-selected:before,.fd-grid-list .fd-grid-list__item--link[aria-selected=true]:before{border-color:var(--sapList_SelectionBackgroundColor)}.fd-grid-list .fd-grid-list__item-toolbar{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;--fdToolbar_Padding_Left:1rem;--fdToolbar_Padding_Right:1rem;--fdToolbar_Background:transparent;-ms-flex-negative:0;border:none;-webkit-box-shadow:var(--fdGrid_List_Item_Toolbar_Shadow);box-shadow:var(--fdGrid_List_Item_Toolbar_Shadow);flex-shrink:0}.fd-grid-list .fd-grid-list__item-body{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-ms-flex-wrap:wrap;flex-wrap:wrap;height:100%;padding-block:1rem;padding-inline:1rem;word-break:break-word}.fd-grid-list .fd-grid-list__item-body:after,.fd-grid-list .fd-grid-list__item-body:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-body--no-padding{padding-block:0;padding-inline:0}.fd-grid-list .fd-grid-list__item-body-actions{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-ms-flex-preferred-size:100%;flex-basis:100%;-webkit-margin-before:1rem;margin-block-start:1rem;-webkit-box-ordinal-group:2;-ms-flex-order:1;order:1}.fd-grid-list .fd-grid-list__item-body-actions:after,.fd-grid-list .fd-grid-list__item-body-actions:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-flex:0;-ms-flex:0 0 100%;flex:0 0 100%}.fd-grid-list .fd-grid-list__item-header:after,.fd-grid-list .fd-grid-list__item-header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-header+.fd-grid-list__item-content{-webkit-padding-before:1rem;padding-block-start:1rem}.fd-grid-list .fd-grid-list__item-image{-webkit-margin-end:.75rem;margin-inline-end:.75rem}.fd-grid-list .fd-grid-list__item-image+.fd-grid-list__item-content,.fd-grid-list .fd-grid-list__item-image+.fd-grid-list__item-header{max-width:calc(100% - 3.75rem)}.fd-grid-list .fd-grid-list__item-title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapList_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-size:var(--sapFontLargeSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;white-space:normal;-webkit-margin-before:.125rem;margin-block-start:.125rem}.fd-grid-list .fd-grid-list__item-title:after,.fd-grid-list .fd-grid-list__item-title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-subtitle{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);display:inline-block;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-block:.5rem .125rem;margin-inline:0;padding-block:0;padding-inline:0}.fd-grid-list .fd-grid-list__item-subtitle:after,.fd-grid-list .fd-grid-list__item-subtitle:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapList_TextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;width:100%}.fd-grid-list .fd-grid-list__item-content:after,.fd-grid-list .fd-grid-list__item-content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list .fd-grid-list__item-counter{color:var(--sapContent_MarkerTextColor)}.fd-grid-list .fd-grid-list__item .fd-grid-list__item-navigation-indicator{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapContent_NonInteractiveIconColor);margin-inline:0 -1rem;width:2.5rem}.fd-grid-list .fd-grid-list__item .fd-grid-list__item-navigation-indicator[dir=rtl],[dir=rtl] .fd-grid-list .fd-grid-list__item .fd-grid-list__item-navigation-indicator{-webkit-transform:rotate(180deg);transform:rotate(180deg)}.fd-grid-list__group-header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;height:2rem;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;-webkit-margin-before:.75rem;color:var(--sapList_GroupHeaderTextColo);font-size:var(--sapFontHeader5Size);font-weight:700;line-height:2rem;margin-block-start:.75rem}.fd-grid-list__group-header:after,.fd-grid-list__group-header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__group-header.is-focus,.fd-grid-list__group-header:focus{outline:var(--sapContent_FocusColor) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:-.1875rem}.fd-grid-list__group-header--no-margin{-webkit-margin-before:0;margin-block-start:0}.fd-grid-list__more{background-color:var(--sapGroup_ContentBackground);border:0;border-radius:var(--fdGrid_List_Item_Border_Radius);-webkit-box-shadow:var(--sapContent_Shadow0);box-shadow:var(--sapContent_Shadow0);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);cursor:pointer;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-block:.813rem;padding-inline:0;padding-inline:.813rem;text-align:center}.fd-grid-list__more:after,.fd-grid-list__more:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__more.is-focus,.fd-grid-list__more:focus{outline:var(--sapContent_FocusColor) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:-.1875rem}.fd-grid-list__more-title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;font-weight:700;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-grid-list__more-title:after,.fd-grid-list__more-title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__more-description{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-block:.813rem 0;margin-inline:0;padding-block:0;padding-inline:0}.fd-grid-list__more-description:after,.fd-grid-list__more-description:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__more-description,.fd-grid-list__more-title{color:var(--sapLink_Visited_Color)}.fd-grid-list__more.is-hover,.fd-grid-list__more:hover{background-color:var(--sapList_Hover_Background)}.fd-grid-list__more.is-active,.fd-grid-list__more:active{background-color:var(--sapList_Active_Background)}.fd-grid-list__more.is-active-description,.fd-grid-list__more.is-active-title,.fd-grid-list__more:active-description,.fd-grid-list__more:active-title{color:var(--sapList_Active_TextColor)}.fd-grid-list__footer{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapList_FooterTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-grid-list__footer:after,.fd-grid-list__footer:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__footer.is-focus,.fd-grid-list__footer:focus{outline:var(--sapContent_FocusColor) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth)}.fd-grid-list__highlight{border:0;border-radius:var(--fdGrid_List_Item_Border_Radius) 0 0 var(--fdGrid_List_Item_Border_Radius);bottom:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:block;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;left:0;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;position:absolute;top:0;width:.375rem}.fd-grid-list__highlight:after,.fd-grid-list__highlight:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-grid-list__highlight[dir=rtl],[dir=rtl] .fd-grid-list__highlight{right:0}.fd-grid-list__highlight--positive{background-color:var(--sapSuccessBorderColor)}.fd-grid-list__highlight--negative{background-color:var(--sapErrorBorderColor)}.fd-grid-list__highlight--critical{background-color:var(--sapWarningBorderColor)}.fd-grid-list__highlight--neutral{background-color:var(--sapNeutralBorderColor)}.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__checkbox-label,.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__radio-label,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__checkbox-label,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__radio-label,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__checkbox-label,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;color:var(--sapContent_LabelColor);-ms-flex-direction:row;flex-direction:row}.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__checkbox-label.is-empty,.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__checkbox-label:empty,.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__radio-label.is-empty,.fd-grid-list--mode-multi-select .fd-grid-list__item .fd-grid-list__radio-label:empty,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__checkbox-label.is-empty,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__checkbox-label:empty,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__radio-label.is-empty,.fd-grid-list--mode-single-select-left .fd-grid-list__item .fd-grid-list__radio-label:empty,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__checkbox-label.is-empty,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__checkbox-label:empty,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label.is-empty,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label:empty{-webkit-margin-start:-.5rem;margin-inline-start:-.5rem}.fd-grid-list--mode-single-select .fd-grid-list__item{cursor:pointer}.fd-grid-list--mode-single-select .fd-grid-list__item.is-hover,.fd-grid-list--mode-single-select .fd-grid-list__item:hover{background-color:var(--sapList_Hover_Background);-webkit-box-shadow:0 0 0 .0625rem var(--fdGrid_List_Item_Hover_Border_Color),var(--sapContent_Shadow2);box-shadow:0 0 0 .0625rem var(--fdGrid_List_Item_Hover_Border_Color),var(--sapContent_Shadow2)}.fd-grid-list--mode-single-select .fd-grid-list__item.is-selected,.fd-grid-list--mode-single-select .fd-grid-list__item[aria-selected=true]{background-color:var(--sapList_SelectionBackgroundColor);-webkit-box-shadow:0 0 0 .125rem var(--sapList_SelectionBorderColor);box-shadow:0 0 0 .125rem var(--sapList_SelectionBorderColor)}.fd-grid-list--mode-single-select .fd-grid-list__item.is-selected.is-hover,.fd-grid-list--mode-single-select .fd-grid-list__item.is-selected:hover,.fd-grid-list--mode-single-select .fd-grid-list__item[aria-selected=true].is-hover,.fd-grid-list--mode-single-select .fd-grid-list__item[aria-selected=true]:hover{background-color:var(--sapList_Hover_SelectionBackground)}.fd-grid-list--mode-single-select .fd-grid-list__item .fd-grid-list__radio-input{height:100%;width:100%;z-index:-1}.fd-grid-list--mode-single-select .fd-grid-list__item .fd-grid-list__radio-label{display:none}.fd-grid-list--mode-single-select .fd-grid-list__item.is-selected:before,.fd-grid-list--mode-single-select .fd-grid-list__item[aria-selected=true]:before{border-color:var(--sapList_SelectionBackgroundColor)}.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-input{right:1rem}.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label{-webkit-box-ordinal-group:2;-ms-flex-order:1;order:1}.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label.is-empty,.fd-grid-list--mode-single-select-right .fd-grid-list__item .fd-grid-list__radio-label:empty{margin-inline:.5rem -.5rem}.fd-grid-list--mode-multi-select .fd-toolbar.fd-grid-list__item-toolbar{padding-inline:.5rem 1rem}\n/*! Bundled license information:\n\nfundamental-styles/dist/grid-list.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n", ".cdk-drag-dragging{z-index:15;background-color:#fff;background-color:var(--sapList_Background, #fff);opacity:.8;transition:box-shadow .2s cubic-bezier(0,0,.2,1);box-shadow:0 3px 1px -2px #0003,0 2px 2px #00000024,0 1px 5px #0000001f}.fd-replace-indicator{position:absolute;width:100%;height:100%;top:0;left:0;pointer-events:none;border-width:.125rem;border-style:solid;background-color:transparent;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor)}.fd-replace-indicator:before{content:\"\";display:block;position:absolute;width:100%;height:100%;top:0;left:0;background-color:#0854a0;background-color:var(--sapContent_DragAndDropActiveColor, #0854a0);opacity:.5}.cdk-drag{cursor:grab}.cdk-drag.cdk-drag-dragging{cursor:grabbing}.cdk-drag-dragging{outline:none;cursor:grabbing;box-shadow:0 0 0 .0625rem #00000026,0 .625rem 1.875rem #0000004d}.cdk-drag-disabled{cursor:default}.fd-dnd-placeholder{top:0;left:0;position:absolute;opacity:.3;z-index:-1}.fd-dnd-item{position:relative;cursor:grab}.fd-dnd-item.fd-dnd-on-drag{background-color:#fff;background-color:var(--sapList_Background, #fff);z-index:15;cursor:grabbing}.drop-area__line{z-index:9999;position:absolute;background:#0854a0;background:var(--sapContent_DragAndDropActiveColor, #0854a0)}.drop-area__line--vertical{top:0;height:calc(100% - .5rem);width:2px}.drop-area__line--vertical.after{right:.2rem}.drop-area__line--vertical.before{left:-.3rem}.drop-area__line--vertical:before{background-color:#fff;background-color:var(--sapList_Background, #fff);content:\"\";position:absolute;left:-.2rem;top:-.5rem;border-radius:50%;width:.5rem;height:.5rem;border-width:.125rem;border-style:solid;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor, #0854a0)}.drop-area__line--horizontal{left:0;width:100%;height:2px}.drop-area__line--horizontal.before{top:0}.drop-area__line--horizontal.after{bottom:0}.drop-area__line--horizontal:before{background-color:#fff;background-color:var(--sapList_Background, #fff);content:\"\";position:absolute;left:0;top:-.2rem;border-radius:50%;width:.5rem;height:.5rem;border-width:.125rem;border-style:solid;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor, #0854a0)}.fd-dnd-list{position:relative}\n"] }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }], propDecorators: { id: [{
                type: Input
            }], width: [{
                type: Input
            }], ariaLabel: [{
                type: Input
            }], selectionMode: [{
                type: Input
            }], layoutPattern: [{
                type: Input
            }], selectionChange: [{
                type: Output
            }], gridListItems: [{
                type: ContentChildren,
                args: [GridListItemComponent, { descendants: true }]
            }] } });

class GridListItemImageDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListItemImageDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: GridListItemImageDirective, isStandalone: true, selector: "[fd-grid-list-item-image]", host: { classAttribute: "fd-grid-list__item-image" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListItemImageDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[fd-grid-list-item-image]',
                    host: {
                        class: 'fd-grid-list__item-image'
                    },
                    standalone: true
                }]
        }] });

class GridListModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: GridListModule, imports: [ToolbarModule,
            ButtonModule,
            AvatarModule,
            GridListComponent,
            GridListItemComponent,
            GridListTitleBarComponent,
            GridListFilterBarComponent,
            GridListMoreBtnComponent,
            GridListFooterComponent,
            GridListItemFooterBarComponent,
            GridListItemToolbarComponent,
            GridListGroupHeaderComponent,
            GridListTitleBarSpacerComponent,
            GridListTitleBarAdditionalTitleItemDirective,
            GridListItemImageDirective,
            GridListItemBodyDirective], exports: [GridListComponent,
            GridListItemComponent,
            GridListTitleBarComponent,
            GridListFilterBarComponent,
            GridListMoreBtnComponent,
            GridListFooterComponent,
            GridListItemFooterBarComponent,
            GridListItemToolbarComponent,
            GridListGroupHeaderComponent,
            GridListTitleBarSpacerComponent,
            GridListTitleBarAdditionalTitleItemDirective,
            GridListItemImageDirective,
            GridListItemBodyDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListModule, imports: [ToolbarModule,
            ButtonModule,
            AvatarModule,
            GridListItemComponent,
            GridListTitleBarComponent,
            GridListFilterBarComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: GridListModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        ToolbarModule,
                        ButtonModule,
                        AvatarModule,
                        GridListComponent,
                        GridListItemComponent,
                        GridListTitleBarComponent,
                        GridListFilterBarComponent,
                        GridListMoreBtnComponent,
                        GridListFooterComponent,
                        GridListItemFooterBarComponent,
                        GridListItemToolbarComponent,
                        GridListGroupHeaderComponent,
                        GridListTitleBarSpacerComponent,
                        GridListTitleBarAdditionalTitleItemDirective,
                        GridListItemImageDirective,
                        GridListItemBodyDirective
                    ],
                    exports: [
                        GridListComponent,
                        GridListItemComponent,
                        GridListTitleBarComponent,
                        GridListFilterBarComponent,
                        GridListMoreBtnComponent,
                        GridListFooterComponent,
                        GridListItemFooterBarComponent,
                        GridListItemToolbarComponent,
                        GridListGroupHeaderComponent,
                        GridListTitleBarSpacerComponent,
                        GridListTitleBarAdditionalTitleItemDirective,
                        GridListItemImageDirective,
                        GridListItemBodyDirective
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { GridListComponent, GridListFilterBarComponent, GridListFooterComponent, GridListGroupHeaderComponent, GridListItemBodyDirective, GridListItemComponent, GridListItemFooterBarComponent, GridListItemImageDirective, GridListItemToolbarComponent, GridListModule, GridListMoreBtnComponent, GridListSelectionActions, GridListSelectionModeEnum, GridListTitleBarAdditionalTitleItemDirective, GridListTitleBarComponent, GridListTitleBarSpacerComponent };
//# sourceMappingURL=fundamental-ngx-core-grid-list.mjs.map
