import * as i0 from '@angular/core';
import { Input, HostBinding, Directive, EventEmitter, HostListener, Output, inject, ElementRef, InjectionToken, isDevMode, signal, computed, input, DestroyRef, forwardRef, ContentChildren, ContentChild, ViewEncapsulation, ChangeDetectionStrategy, Component, Renderer2, effect, Optional, booleanAttribute, NgModule } from '@angular/core';
import { __decorate, __metadata } from 'tslib';
import * as i1$1 from '@fundamental-ngx/cdk/utils';
import { applyCssClass, KeyUtil, LIST_ITEM_COMPONENT, destroyObservable, KeyboardSupportService } from '@fundamental-ngx/cdk/utils';
import { FD_DEFAULT_ICON_FONT_FAMILY, fdBuildIconClass, IconComponent, FD_ICON_COMPONENT } from '@fundamental-ngx/core/icon';
import { Subject, merge } from 'rxjs';
import * as i1 from '@angular/common';
import { NgClass, DecimalPipe, NgTemplateOutlet } from '@angular/common';
import { coerceNumberProperty } from '@angular/cdk/coercion';
import { ENTER, SPACE, RIGHT_ARROW, LEFT_ARROW } from '@angular/cdk/keycodes';
import { takeUntilDestroyed } from '@angular/core/rxjs-interop';
import { FD_BUTTON_COMPONENT } from '@fundamental-ngx/core/button';
import { FD_CHECKBOX_COMPONENT } from '@fundamental-ngx/core/checkbox';
import { FormItemComponent } from '@fundamental-ngx/core/form';
import { FD_RADIO_BUTTON_COMPONENT } from '@fundamental-ngx/core/radio';
import { startWith, map, takeUntil } from 'rxjs/operators';
import * as i2 from '@fundamental-ngx/core/content-density';
import { contentDensityObserverProviders } from '@fundamental-ngx/core/content-density';

class ListBylineLeftDirective {
    constructor() {
        /** @hidden */
        this.fdListBylineLeftClass = true;
        /** Whether or not this should be wrapped, when too much text. */
        this.wrap = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListBylineLeftDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListBylineLeftDirective, isStandalone: true, selector: "[fdListBylineLeft], [fd-list-byline-left]", inputs: { wrap: "wrap" }, host: { properties: { "class.fd-list__byline-left": "this.fdListBylineLeftClass", "class.fd-list__byline-left--wrap": "this.wrap" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListBylineLeftDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdListBylineLeft], [fd-list-byline-left]',
                    standalone: true
                }]
        }], propDecorators: { fdListBylineLeftClass: [{
                type: HostBinding,
                args: ['class.fd-list__byline-left']
            }], wrap: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__byline-left--wrap']
            }] } });

class ListBylineRightDirective {
    constructor() {
        /** Whether or not this should be wrapped, when too much text. */
        this.wrap = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListBylineRightDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListBylineRightDirective, isStandalone: true, selector: "[fdListBylineRight], [fd-list-byline-right]", inputs: { status: "status", wrap: "wrap" }, host: { properties: { "class.fd-list__byline-right--neutral": "status === \"neutral\"", "class.fd-list__byline-right--positive": "status === \"positive\"", "class.fd-list__byline-right--negative": "status === \"negative\"", "class.fd-list__byline-right--critical": "status === \"critical\"", "class.fd-list__byline-right--informative": "status === \"informative\"", "class.fd-list__byline-right--wrap": "wrap" }, classAttribute: "fd-list__byline-right" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListBylineRightDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdListBylineRight], [fd-list-byline-right]',
                    host: {
                        class: 'fd-list__byline-right',
                        '[class.fd-list__byline-right--neutral]': 'status === "neutral"',
                        '[class.fd-list__byline-right--positive]': 'status === "positive"',
                        '[class.fd-list__byline-right--negative]': 'status === "negative"',
                        '[class.fd-list__byline-right--critical]': 'status === "critical"',
                        '[class.fd-list__byline-right--informative]': 'status === "informative"',
                        '[class.fd-list__byline-right--wrap]': 'wrap'
                    },
                    standalone: true
                }]
        }], propDecorators: { status: [{
                type: Input
            }], wrap: [{
                type: Input
            }] } });

class ListBylineDirective {
    constructor() {
        /** Whether or not this is a 2-column byline. */
        this.twoCol = false;
        /** Whether or not this should be wrapped, when too much text. */
        this.wrap = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListBylineDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListBylineDirective, isStandalone: true, selector: "[fdListByline], [fd-list-byline]", inputs: { twoCol: "twoCol", wrap: "wrap" }, host: { properties: { "class.fd-list__byline--2-col": "twoCol", "class.fd-list__byline--wrap": "wrap" }, classAttribute: "fd-list__byline" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListBylineDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdListByline], [fd-list-byline]',
                    host: {
                        class: 'fd-list__byline',
                        '[class.fd-list__byline--2-col]': 'twoCol',
                        '[class.fd-list__byline--wrap]': 'wrap'
                    },
                    standalone: true
                }]
        }], propDecorators: { twoCol: [{
                type: Input
            }], wrap: [{
                type: Input
            }] } });

class ListContentDirective {
    constructor() {
        /** @hidden */
        this.fdListContentClass = true;
        /** Whether or not this is a 2-column content. */
        this.twoCol = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListContentDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListContentDirective, isStandalone: true, selector: "[fdListContent], [fd-list-content]", inputs: { twoCol: "twoCol" }, host: { properties: { "class.fd-list__content": "this.fdListContentClass", "class.fd-list__content--2-col": "this.twoCol" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListContentDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdListContent], [fd-list-content]',
                    standalone: true
                }]
        }], propDecorators: { fdListContentClass: [{
                type: HostBinding,
                args: ['class.fd-list__content']
            }], twoCol: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__content--2-col']
            }] } });

class ListThumbnailDirective {
    constructor() {
        /** @hidden */
        this.fdListThumbnailClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListThumbnailDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListThumbnailDirective, isStandalone: true, selector: "[fdListThumbnail], [fd-list-thumbnail]", host: { properties: { "class.fd-list__thumbnail": "this.fdListThumbnailClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListThumbnailDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdListThumbnail], [fd-list-thumbnail]',
                    standalone: true
                }]
        }], propDecorators: { fdListThumbnailClass: [{
                type: HostBinding,
                args: ['class.fd-list__thumbnail']
            }] } });

class ListFooterDirective {
    constructor() {
        /** @hidden */
        this.fdListFooterClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListFooterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListFooterDirective, isStandalone: true, selector: "[fdListFooter], [fd-list-footer]", host: { properties: { "class.fd-list__footer": "this.fdListFooterClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListFooterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdListFooter], [fd-list-footer]',
                    standalone: true
                }]
        }], propDecorators: { fdListFooterClass: [{
                type: HostBinding,
                args: ['class.fd-list__footer']
            }] } });

let uniqueId = 0;
class ListGroupHeaderDirective {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
        /** id of an element to be applied */
        this.nativeElementId = `fd-list-group-header-${++uniqueId}`;
        /** @hidden Implementation of KeyboardSupportItemInterface */
        this.keyDown = new EventEmitter();
    }
    /** @hidden */
    keydownHandler(event) {
        this.keyDown.emit(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListGroupHeaderDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListGroupHeaderDirective, isStandalone: true, selector: "[fdListGroupHeader], [fd-list-group-header]", inputs: { nativeElementId: "nativeElementId" }, outputs: { keyDown: "keyDown" }, host: { listeners: { "keydown": "keydownHandler($event)" }, properties: { "style.outline": "\"none\"", "class.fd-list__item": "true", "class.fd-list__group-header": "true", "attr.id": "this.nativeElementId" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListGroupHeaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdListGroupHeader], [fd-list-group-header]',
                    host: {
                        '[style.outline]': '"none"',
                        '[class.fd-list__item]': 'true',
                        '[class.fd-list__group-header]': 'true'
                    },
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { nativeElementId: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['attr.id']
            }], keyDown: [{
                type: Output
            }], keydownHandler: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }] } });

class ListIconDirective {
    constructor() {
        /** Glyph font family */
        this.glyphFont = FD_DEFAULT_ICON_FONT_FAMILY;
        /** Role attribute for list icon */
        this.role = 'presentation';
        /** Aria hidden attribute for list icon */
        this.ariaHidden = true;
        /** @hidden */
        this.elementRef = inject(ElementRef);
    }
    /** @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return ['fd-list__icon', this.glyph ? fdBuildIconClass(this.glyphFont, this.glyph) : '', this.class];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListIconDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListIconDirective, isStandalone: true, selector: "[fdListIcon], [fd-list-icon]", inputs: { glyph: "glyph", glyphFont: "glyphFont", class: "class", role: "role", ariaHidden: "ariaHidden" }, host: { properties: { "attr.role": "this.role", "attr.aria-hidden": "this.ariaHidden" } }, usesOnChanges: true, ngImport: i0 }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], ListIconDirective.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListIconDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdListIcon], [fd-list-icon]',
                    standalone: true
                }]
        }], propDecorators: { glyph: [{
                type: Input
            }], glyphFont: [{
                type: Input
            }], class: [{
                type: Input
            }], role: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['attr.role']
            }], ariaHidden: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['attr.aria-hidden']
            }], buildComponentCssClass: [] } });

const FD_LIST_MESSAGE_DIRECTIVE = new InjectionToken('FdListMessageDirective');
const FD_LIST_LINK_DIRECTIVE = new InjectionToken('FdListLinkDirective');
const FD_LIST_COMPONENT = new InjectionToken('ListComponent');
const FD_LIST_UNREAD_INDICATOR = new InjectionToken('ListUnreadIndicator');

class ListLinkDirective {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
        /** Defines if navigation indicator arrow should be included inside list item */
        this.navigationIndicator = false;
        /** Defines if link should be treated as a navigated */
        this.navigated = false;
        /** Whether to mark link as focusable. If true, list item will shift focus from itself to the link. */
        this.focusable = false;
        /** @hidden */
        this.fdListLinkClass = true;
        /** Emits when some of the properties, that should be read by screenreader, are changed */
        this._onReadablePropertyChanged$ = new Subject();
    }
    /** @hidden */
    ngOnChanges(changes) {
        if (changes.navigationIndicator || changes.navigated) {
            this._onReadablePropertyChanged$.next();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListLinkDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListLinkDirective, isStandalone: true, selector: "[fd-list-link], [fdListLink]", inputs: { navigationIndicator: "navigationIndicator", navigated: "navigated", focusable: "focusable" }, host: { properties: { "attr.tabindex": "-1", "class.fd-list__link--navigation-indicator": "this.navigationIndicator", "class.is-navigated": "this.navigated", "class.fd-list__link--focusable": "this.focusable", "class.fd-list__link": "this.fdListLinkClass" } }, providers: [
            {
                provide: FD_LIST_LINK_DIRECTIVE,
                useExisting: ListLinkDirective
            }
        ], usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListLinkDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fd-list-link], [fdListLink]',
                    host: {
                        '[attr.tabindex]': '-1'
                    },
                    providers: [
                        {
                            provide: FD_LIST_LINK_DIRECTIVE,
                            useExisting: ListLinkDirective
                        }
                    ],
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { navigationIndicator: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__link--navigation-indicator']
            }], navigated: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.is-navigated']
            }], focusable: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__link--focusable']
            }], fdListLinkClass: [{
                type: HostBinding,
                args: ['class.fd-list__link']
            }] } });

class ListNavigationItemArrowDirective {
    constructor() {
        /** @hidden */
        this.navigationItemArrowClass = true;
        /** @hidden */
        this.rightArrowClass = true;
        /** @hidden */
        this.downArrowClass = false;
        /** @hidden */
        this.expanded = false;
        /** Aria-hidden attribute value. */
        this.ariaHidden = true;
    }
    /** @hidden */
    _setExpanded(expanded) {
        if (this.expanded !== expanded) {
            this.rightArrowClass = !this.rightArrowClass;
            this.downArrowClass = !this.downArrowClass;
        }
        this.expanded = expanded;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListNavigationItemArrowDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListNavigationItemArrowDirective, isStandalone: true, selector: "[fd-list-navigation-item-arrow], [fdListNavigaitonItemArrow]", inputs: { ariaHidden: "ariaHidden" }, host: { attributes: { "tabindex": "-1", "role": "presentation" }, properties: { "class.fd-list__navigation-item-arrow": "this.navigationItemArrowClass", "class.sap-icon--navigation-right-arrow": "this.rightArrowClass", "class.sap-icon--navigation-down-arrow": "this.downArrowClass", "class.is-expanded": "this.expanded", "attr.aria-hidden": "this.ariaHidden" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListNavigationItemArrowDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fd-list-navigation-item-arrow], [fdListNavigaitonItemArrow]',
                    host: {
                        tabindex: '-1',
                        role: 'presentation'
                    },
                    standalone: true
                }]
        }], propDecorators: { navigationItemArrowClass: [{
                type: HostBinding,
                args: ['class.fd-list__navigation-item-arrow']
            }], rightArrowClass: [{
                type: HostBinding,
                args: ['class.sap-icon--navigation-right-arrow']
            }], downArrowClass: [{
                type: HostBinding,
                args: ['class.sap-icon--navigation-down-arrow']
            }], expanded: [{
                type: HostBinding,
                args: ['class.is-expanded']
            }], ariaHidden: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['attr.aria-hidden']
            }] } });

class ListNavigationItemTextDirective {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
        /** @hidden */
        this.navigationItemTextClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListNavigationItemTextDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListNavigationItemTextDirective, isStandalone: true, selector: "[fd-list-navigation-item-text], [fdListNavigaitonItemText]", host: { properties: { "class.fd-list__navigation-item-text": "this.navigationItemTextClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListNavigationItemTextDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fd-list-navigation-item-text], [fdListNavigaitonItemText]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { navigationItemTextClass: [{
                type: HostBinding,
                args: ['class.fd-list__navigation-item-text']
            }] } });

const _secondaryListItemTypes = ['positive', 'critical', 'negative', 'informative'];
class ListSecondaryDirective {
    /** @hidden */
    constructor() {
        /** @hidden */
        this.ngClass = inject(NgClass);
        this.ngClass.ngClass = ['fd-list__secondary'];
    }
    /** @hidden */
    ngOnChanges() {
        if (this.type && !_secondaryListItemTypes.includes(this.type) && isDevMode()) {
            console.warn(`Unknown type of the secondary list item: ${this.type}. Allowed types are: ${JSON.stringify(_secondaryListItemTypes)}`);
        }
        this.ngClass.ngClass = ['fd-list__secondary', `fd-list__secondary--${this.type}`];
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListSecondaryDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListSecondaryDirective, isStandalone: true, selector: "[fd-list-secondary], [fdListSecondary]", inputs: { type: "type" }, usesOnChanges: true, hostDirectives: [{ directive: i1.NgClass }], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListSecondaryDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fd-list-secondary], [fdListSecondary]',
                    standalone: true,
                    hostDirectives: [NgClass]
                }]
        }], ctorParameters: () => [], propDecorators: { type: [{
                type: Input
            }] } });

class ListTitleTextDirective {
    constructor() {
        /** @hidden */
        this.fdListTitleText = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListTitleTextDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListTitleTextDirective, isStandalone: true, selector: "[fd-list-title-text], [fdListTitleText]", host: { properties: { "class.fd-list__title-text": "this.fdListTitleText" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListTitleTextDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fd-list-title-text], [fdListTitleText]',
                    standalone: true
                }]
        }], propDecorators: { fdListTitleText: [{
                type: HostBinding,
                args: ['class.fd-list__title-text']
            }] } });

class ListTitleDirective {
    /** @hidden */
    constructor(elRef) {
        this.elRef = elRef;
        /** @hidden */
        this.fdListTitleClass = true;
        /** Whether or not this should be wrapped, when too much text. */
        this.wrap = false;
    }
    /** @hidden */
    ngOnInit() {
        const nativeEl = this.elRef.nativeElement;
        if (nativeEl.tagName === 'A') {
            nativeEl.setAttribute('tabIndex', '-1');
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListTitleDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListTitleDirective, isStandalone: true, selector: "[fd-list-title], [fdListTitle]", inputs: { wrap: "wrap" }, host: { properties: { "class.fd-list__title": "this.fdListTitleClass", "class.fd-list__title--wrap": "this.wrap" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListTitleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fd-list-title], [fdListTitle]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { fdListTitleClass: [{
                type: HostBinding,
                args: ['class.fd-list__title']
            }], wrap: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__title--wrap']
            }] } });

class ListSublineDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListSublineDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListSublineDirective, isStandalone: true, selector: "[fdListSubline], [fd-list-subline]", host: { classAttribute: "fd-list__subline" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListSublineDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fdListSubline], [fd-list-subline]',
                    host: {
                        class: 'fd-list__subline'
                    },
                    standalone: true
                }]
        }] });

class ListFocusItem {
    constructor() {
        /** @hidden Implementation of KeyboardSupportItemInterface */
        this.keyDown = new EventEmitter();
        /** @hidden */
        this.elementRef = inject(ElementRef);
        /** @hidden */
        this._focused$ = new Subject();
        /** @hidden */
        this._clicked$ = new Subject();
        /** @hidden */
        this._isFirstItem$ = signal(false);
        /** @hidden */
        this._tabIndex$ = signal(undefined);
        /** @hidden */
        this._normalizedTabIndex$ = computed(() => {
            if (this._isFirstItem$() && isNaN(this._tabIndex$())) {
                return 0;
            }
            return this._tabIndex$() ?? -1;
        });
    }
    /** tab index attribute */
    set tabindex(value) {
        this._tabIndex$.set(coerceNumberProperty(value, -1));
    }
    get tabindex() {
        return this._normalizedTabIndex$();
    }
    /** @hidden */
    onFocus(event) {
        this._focused$.next({
            focusedWithin: event.target !== this.elementRef?.nativeElement
        });
    }
    /** @hidden */
    click() {
        this.elementRef?.nativeElement?.click();
    }
    /** @hidden */
    focus() {
        this.elementRef?.nativeElement?.focus();
    }
    /** @hidden */
    setIsFirst(value) {
        this._isFirstItem$.set(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListFocusItem, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListFocusItem, isStandalone: true, inputs: { tabindex: "tabindex", value: "value" }, host: { listeners: { "focusin": "onFocus($event)" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListFocusItem, decorators: [{
            type: Directive
        }], propDecorators: { tabindex: [{
                type: Input
            }], value: [{
                type: Input
            }], onFocus: [{
                type: HostListener,
                args: ['focusin', ['$event']]
            }] } });

let listItemUniqueId = 0;
/**
 * The component that represents a list item.
 * The list item can contain plain text, links or actions.
 */
class ListItemComponent extends ListFocusItem {
    /** @hidden */
    set radio(value) {
        this._radio = value;
        if (this._radio && this._radio.tabIndex == null) {
            this._radio.tabIndex = -1;
        }
        if (value) {
            this._role = 'option';
        }
    }
    get radio() {
        return this._radio;
    }
    /** @hidden */
    set checkbox(value) {
        this._checkbox = value;
        if (this._checkbox && this._checkbox.tabIndexValue == null) {
            this._checkbox.tabIndexValue = -1;
        }
        if (value) {
            this._role = 'option';
        }
    }
    get checkbox() {
        return this._checkbox;
    }
    /** @hidden */
    constructor(_changeDetectorRef) {
        super();
        this._changeDetectorRef = _changeDetectorRef;
        /** Whether there is no data inside list item */
        this.noData = false;
        /** Whether there is item performs some action */
        this.action = false;
        /** Whether there is item performs some action */
        this.interactive = false;
        /** Whether list item contains busy indicator */
        this.growing = false;
        /** Whether list item shows active indicator. Used only in List with Subline. */
        this.active = false;
        /** Whether list item should contain additional unRead styles */
        this.unread = false;
        /**
         * Whether the list item is byline
         */
        this.byline = false;
        /** The ID of the list item element */
        this.id = 'fd-list-item-' + ++listItemUniqueId;
        /** Whether to prevent built-in click event logic on the list item.
         * Helpful when using lists with checkboxes or radio buttons when the list item should be clickable, but should not select/deselect the list item. */
        this.preventClick = false;
        /** @hidden Implementation of KeyboardSupportItemInterface | TODO Revisit KeyboardSupportItemInterface*/
        this.keyDown = new EventEmitter();
        /** Whether list item contains link */
        this.link = false;
        /** @hidden */
        this._list = inject(FD_LIST_UNREAD_INDICATOR, {
            optional: true
        });
        /** Template ref for Settings list item */
        this.settingsListTpl = input();
        /** @hidden */
        this._role = 'listitem'; // default for li elements
        /** @hidden An RxJS Subject that will kill the data stream upon component’s destruction (for unsubscribing)  */
        this._destroyRef = inject(DestroyRef);
        /** @hidden */
        this._onLinkListChanged$ = new Subject();
    }
    /** @hidden */
    get roleAttr() {
        return this.ariaRole || this._role;
    }
    /** @hidden */
    keydownHandler(event) {
        if (KeyUtil.isKeyCode(event, [ENTER, SPACE])) {
            if (this.checkbox) {
                this.checkbox.nextValue();
                this._muteEvent(event);
            }
            else if (this.radio) {
                this.radio.labelClicked(event, false);
                this._muteEvent(event);
            }
            else if (this.interactive) {
                this.selected = !this.selected;
                this._muteEvent(event);
                return;
            }
            else if (this.link) {
                this.linkDirectives.first.elementRef.nativeElement.classList.add('is-active');
                this._muteEvent(event);
            }
        }
        this.keyDown.emit(event);
    }
    /** @hidden */
    keyupHandler(event) {
        if (KeyUtil.isKeyCode(event, [ENTER, SPACE]) && this.link) {
            const _anchorElement = this.linkDirectives.first.elementRef.nativeElement;
            _anchorElement.classList.remove('is-active');
            _anchorElement.click();
            this._muteEvent(event);
        }
    }
    /** Handler for mouse events */
    onClick(event) {
        if (!this.preventClick) {
            this._clicked$.next(event);
            if (this.checkbox && !this.link) {
                if (!this.checkbox.elementRef.nativeElement.contains(event.target)) {
                    // clicking on the checkbox is not suppressed
                    // so we should only process clicks if clicked on the list-item, not checkbox itself
                    this.checkbox.nextValue();
                }
            }
            if (this.radio && !this.link) {
                this.radio.labelClicked(event, false);
            }
        }
    }
    /** @hidden */
    _onFocus() {
        // Try to find inner focusable link
        const tabbableLink = this.elementRef.nativeElement.querySelector('.fd-list__link.fd-list__link--focusable');
        tabbableLink?.focus();
    }
    /** @hidden */
    ngAfterContentInit() {
        this._listenOnLinkQueryChange();
        this._listenOnButtonQueryChange();
    }
    /** @hidden */
    _listenOnLinkQueryChange() {
        this.linkDirectives.changes
            .pipe(startWith(this.linkDirectives), takeUntilDestroyed(this._destroyRef))
            .subscribe(() => {
            this._onLinkListChanged$.next();
            this.link = this.linkDirectives.length > 0;
            this._changeDetectorRef.detectChanges();
        });
    }
    /** @hidden */
    _listenOnButtonQueryChange() {
        this.buttons.changes.pipe(startWith(0), takeUntilDestroyed(this._destroyRef)).subscribe(() => {
            this.buttons.forEach(this._addClassToButtons);
        });
    }
    /** @hidden */
    _addClassToButtons(button) {
        button.class += ' fd-list__button';
        button.buildComponentCssClass();
        button.detectChanges();
    }
    /** @hidden */
    _muteEvent(event) {
        event.stopPropagation();
        event.preventDefault();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListItemComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: ListItemComponent, isStandalone: true, selector: "[fdListItem] ,[fd-list-item]", inputs: { selected: { classPropertyName: "selected", publicName: "selected", isSignal: false, isRequired: false, transformFunction: null }, noData: { classPropertyName: "noData", publicName: "noData", isSignal: false, isRequired: false, transformFunction: null }, action: { classPropertyName: "action", publicName: "action", isSignal: false, isRequired: false, transformFunction: null }, interactive: { classPropertyName: "interactive", publicName: "interactive", isSignal: false, isRequired: false, transformFunction: null }, growing: { classPropertyName: "growing", publicName: "growing", isSignal: false, isRequired: false, transformFunction: null }, counter: { classPropertyName: "counter", publicName: "counter", isSignal: false, isRequired: false, transformFunction: null }, active: { classPropertyName: "active", publicName: "active", isSignal: false, isRequired: false, transformFunction: null }, unread: { classPropertyName: "unread", publicName: "unread", isSignal: false, isRequired: false, transformFunction: null }, byline: { classPropertyName: "byline", publicName: "byline", isSignal: false, isRequired: false, transformFunction: null }, ariaRole: { classPropertyName: "ariaRole", publicName: "ariaRole", isSignal: false, isRequired: false, transformFunction: null }, id: { classPropertyName: "id", publicName: "id", isSignal: false, isRequired: false, transformFunction: null }, preventClick: { classPropertyName: "preventClick", publicName: "preventClick", isSignal: false, isRequired: false, transformFunction: null }, settingsListTpl: { classPropertyName: "settingsListTpl", publicName: "settingsListTpl", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { keyDown: "keyDown" }, host: { listeners: { "keydown": "keydownHandler($event)", "keyup": "keyupHandler($event)", "click": "onClick($event)", "focus": "_onFocus()" }, properties: { "attr.tabindex": "_normalizedTabIndex$()", "attr.id": "id", "class.is-selected": "this.selected", "attr.aria-selected": "this.selected", "class.fd-list__item--no-data": "this.noData", "class.fd-list__item--action": "this.action", "class.fd-list__item--interractive": "this.interactive", "class.fd-list__item--growing": "this.growing", "class.fd-list__item--unread": "this.unread", "class.fd-list__item--byline": "this.byline", "class.fd-list__item--link": "this.link", "attr.role": "this.roleAttr" }, classAttribute: "fd-list__item" }, providers: [
            {
                provide: LIST_ITEM_COMPONENT,
                useExisting: forwardRef(() => ListItemComponent)
            },
            {
                provide: ListFocusItem,
                useExisting: forwardRef(() => ListItemComponent)
            }
        ], queries: [{ propertyName: "radio", first: true, predicate: FD_RADIO_BUTTON_COMPONENT, descendants: true }, { propertyName: "checkbox", first: true, predicate: FD_CHECKBOX_COMPONENT, descendants: true }, { propertyName: "linkDirectives", predicate: FD_LIST_LINK_DIRECTIVE }, { propertyName: "buttons", predicate: FD_BUTTON_COMPONENT, descendants: true }], usesInheritance: true, ngImport: i0, template: "@if (checkbox || radio) {\n    <div fd-form-item class=\"fd-list__form-item\">\n        <ng-content select=\"fd-checkbox\"></ng-content>\n        <ng-content select=\"fd-radio-button\"></ng-content>\n    </div>\n}\n@if (unread && (!_list || _list.byline)) {\n    <fd-icon class=\"fd-list__notification\" glyph=\"circle-task-2\"></fd-icon>\n}\n<ng-content></ng-content>\n@if (counter || counter === 0) {\n    <span class=\"fd-list__item-counter\">\n        {{ counter | number: '1.0-2' }}\n    </span>\n}\n@if (active) {\n    <span class=\"fd-list__active-indicator sap-icon--sys-enter-2\"></span>\n}\n", dependencies: [{ kind: "component", type: FormItemComponent, selector: "[fd-form-item]", inputs: ["isInline", "horizontal"] }, { kind: "pipe", type: DecimalPipe, name: "number" }, { kind: "component", type: IconComponent, selector: "fd-icon", inputs: ["glyph", "font", "color", "background", "class", "ariaLabel", "ariaHidden"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: '[fdListItem] ,[fd-list-item]', host: {
                        class: 'fd-list__item',
                        '[attr.tabindex]': '_normalizedTabIndex$()',
                        '[attr.id]': 'id'
                    }, providers: [
                        {
                            provide: LIST_ITEM_COMPONENT,
                            useExisting: forwardRef(() => ListItemComponent)
                        },
                        {
                            provide: ListFocusItem,
                            useExisting: forwardRef(() => ListItemComponent)
                        }
                    ], changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, imports: [FormItemComponent, DecimalPipe, IconComponent], template: "@if (checkbox || radio) {\n    <div fd-form-item class=\"fd-list__form-item\">\n        <ng-content select=\"fd-checkbox\"></ng-content>\n        <ng-content select=\"fd-radio-button\"></ng-content>\n    </div>\n}\n@if (unread && (!_list || _list.byline)) {\n    <fd-icon class=\"fd-list__notification\" glyph=\"circle-task-2\"></fd-icon>\n}\n<ng-content></ng-content>\n@if (counter || counter === 0) {\n    <span class=\"fd-list__item-counter\">\n        {{ counter | number: '1.0-2' }}\n    </span>\n}\n@if (active) {\n    <span class=\"fd-list__active-indicator sap-icon--sys-enter-2\"></span>\n}\n" }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }], propDecorators: { selected: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.is-selected']
            }, {
                type: HostBinding,
                args: ['attr.aria-selected']
            }], noData: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__item--no-data']
            }], action: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__item--action']
            }], interactive: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__item--interractive']
            }], growing: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__item--growing']
            }], counter: [{
                type: Input
            }], active: [{
                type: Input
            }], unread: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__item--unread']
            }], byline: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list__item--byline']
            }], ariaRole: [{
                type: Input
            }], id: [{
                type: Input
            }], preventClick: [{
                type: Input
            }], keyDown: [{
                type: Output
            }], link: [{
                type: HostBinding,
                args: ['class.fd-list__item--link']
            }], radio: [{
                type: ContentChild,
                args: [FD_RADIO_BUTTON_COMPONENT]
            }], checkbox: [{
                type: ContentChild,
                args: [FD_CHECKBOX_COMPONENT]
            }], linkDirectives: [{
                type: ContentChildren,
                args: [FD_LIST_LINK_DIRECTIVE]
            }], buttons: [{
                type: ContentChildren,
                args: [FD_BUTTON_COMPONENT, { descendants: true }]
            }], roleAttr: [{
                type: HostBinding,
                args: ['attr.role']
            }], keydownHandler: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }], keyupHandler: [{
                type: HostListener,
                args: ['keyup', ['$event']]
            }], onClick: [{
                type: HostListener,
                args: ['click', ['$event']]
            }], _onFocus: [{
                type: HostListener,
                args: ['focus']
            }] } });

class ListMessageDirective {
    /** @hidden */
    constructor(elementRef) {
        this.elementRef = elementRef;
    }
    /** @hidden
     * CssClassBuilder interface implementation
     * function must return single string
     * function is responsible for order which css classes are applied
     */
    buildComponentCssClass() {
        return ['fd-list__message', this.type ? 'fd-list__message--' + this.type : '', this.class];
    }
    /** @hidden */
    ngOnChanges() {
        this.buildComponentCssClass();
    }
    /** @hidden */
    ngOnInit() {
        this.buildComponentCssClass();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListMessageDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.2", type: ListMessageDirective, isStandalone: true, selector: "[fd-list-message], [fdListMessage]", inputs: { type: "type", class: "class" }, providers: [
            {
                provide: FD_LIST_MESSAGE_DIRECTIVE,
                useExisting: ListMessageDirective
            }
        ], usesOnChanges: true, ngImport: i0 }); }
}
__decorate([
    applyCssClass,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], ListMessageDirective.prototype, "buildComponentCssClass", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListMessageDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fd-list-message], [fdListMessage]',
                    providers: [
                        {
                            provide: FD_LIST_MESSAGE_DIRECTIVE,
                            useExisting: ListMessageDirective
                        }
                    ],
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { type: [{
                type: Input
            }], class: [{
                type: Input
            }], buildComponentCssClass: [] } });

class ListNavigationItemComponent {
    /** @hidden */
    get _ariaExpanded() {
        return this._isExpandable ? this._expanded : null;
    }
    /** @hidden */
    constructor(_elementRef, _rtlService) {
        this._elementRef = _elementRef;
        this._rtlService = _rtlService;
        /** Whether or not the list item is expanded. */
        this.expanded = false;
        /** Whether or not this list item is indicated for navigation. */
        this.indicated = false;
        /** @hidden */
        this._navigationItemClass = true;
        /** @hidden */
        this._isExpandable = false;
        /** @hidden */
        this._condensed = signal(false);
        /** @hidden */
        this._expanded = false;
        /** @hidden */
        this._focused$ = new Subject();
        /** @hidden */
        this._clicked$ = new Subject();
        /**
         * @hidden
         * false if list-item is within unexpanded list (not visible to user until list expanded). default is true
         */
        this._isItemVisible = true;
        /** @hidden handles rtl service */
        this._rtl$ = computed(() => !!this._rtlService?.rtlSignal());
        /** @hidden */
        this._renderer2 = inject(Renderer2);
        effect(() => {
            if (this._condensed()) {
                this._renderer2.addClass(this._elementRef.nativeElement, 'fd-list__navigation-item--condensed');
            }
            else {
                this._renderer2.removeClass(this._elementRef.nativeElement, 'fd-list__navigation-item--condensed');
            }
        });
    }
    /** @hidden */
    onItemClick(event) {
        event.stopPropagation();
        this._handleExpandedChanges(!this.expanded);
    }
    /** @hidden */
    keyDownHandler(event) {
        if (KeyUtil.isKeyCode(event, [RIGHT_ARROW])) {
            event.preventDefault();
            this._handleExpandedChanges(!this._rtl$());
        }
        if (KeyUtil.isKeyCode(event, [LEFT_ARROW])) {
            event.preventDefault();
            this._handleExpandedChanges(this._rtl$());
        }
        if (KeyUtil.isKeyCode(event, [SPACE, ENTER])) {
            event.preventDefault();
            event.stopPropagation();
            this._handleExpandedChanges(!this.expanded);
        }
    }
    /** @hidden */
    onFocus(event) {
        this._focused$.next(event.target !== this._elementRef?.nativeElement);
    }
    /** @hidden */
    ngAfterContentInit() {
        if (this._listComponent) {
            this._isExpandable = true;
            this._listComponent.role = 'group';
        }
        else {
            this._tabIndex = 0;
        }
        if (this._iconComponent) {
            this._iconComponent._navigationItemIcon = true;
            this._iconComponent.ariaHidden = true;
        }
        this._innerText = this._text.elementRef.nativeElement.textContent ?? '';
        this._ariaLevel = 1;
        this._childItems?.forEach((item) => {
            item._ariaLevel = 2;
        });
    }
    /** @hidden */
    ngAfterViewInit() {
        if (this._isExpandable) {
            this._expanded = false;
        }
        this._setIsItemVisible(this.expanded);
    }
    /** @hidden
     * set the _isItemVisible of sublist items to true if this(containing) list is expanded.
     */
    _setIsItemVisible(value) {
        if (this._isExpandable) {
            this._listComponent?._navItems?.forEach((item) => {
                item._isItemVisible = value;
            });
        }
    }
    /** @hidden */
    _childIndicatedAndCollapsed() {
        let retVal = false;
        this._listComponent?._navItems?.forEach((navItem) => {
            if (navItem.indicated && !navItem.expanded) {
                retVal = true;
            }
        });
        return retVal;
    }
    /** support for FocusKeyManager for arrow key navigation */
    focus() {
        this._elementRef.nativeElement.focus();
    }
    /** support for FocusKeyManager for arrow key navigation */
    click() {
        this._elementRef?.nativeElement?.click();
    }
    /** @hidden */
    _handleExpandedChanges(expanded) {
        if (this._isExpandable) {
            if (this.expanded === expanded) {
                return;
            }
            this.expanded = expanded;
            this._expanded = expanded;
            this._setIsItemVisible(expanded);
            this._listNavigationItemArrow._setExpanded(this.expanded);
            if (expanded) {
                setTimeout(() => {
                    this._listComponent._navItems.first.focus();
                });
            }
            else {
                setTimeout(() => {
                    this.focus();
                });
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListNavigationItemComponent, deps: [{ token: i0.ElementRef }, { token: i1$1.RtlService, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.2", type: ListNavigationItemComponent, isStandalone: true, selector: "[fd-list-navigation-item], [fdListNavigaitonItem]", inputs: { expanded: "expanded", indicated: "indicated" }, host: { attributes: { "role": "treeitem" }, listeners: { "click": "onItemClick($event)", "keydown": "keyDownHandler($event)", "focus": "onFocus($event)" }, properties: { "class.is-expanded": "this.expanded", "attr.aria-selected": "this.indicated", "class.fd-list__navigation-item--indicated": "this.indicated", "class.fd-list__navigation-item": "this._navigationItemClass", "class.fd-list__navigation-item--expandable": "this._isExpandable", "attr.tabindex": "this._tabIndex", "attr.aria-level": "this._ariaLevel", "attr.aria-expanded": "this._ariaExpanded" } }, queries: [{ propertyName: "_listComponent", first: true, predicate: FD_LIST_COMPONENT, descendants: true }, { propertyName: "_listNavigationItemArrow", first: true, predicate: ListNavigationItemArrowDirective, descendants: true }, { propertyName: "_iconComponent", first: true, predicate: FD_ICON_COMPONENT, descendants: true }, { propertyName: "_text", first: true, predicate: ListNavigationItemTextDirective, descendants: true }, { propertyName: "_childItems", predicate: i0.forwardRef(() => ListNavigationItemComponent), descendants: true }], ngImport: i0, template: "@if (!expanded || !_isExpandable || !_condensed() || !_listComponent) {\n    <ng-content></ng-content> <ng-template [ngTemplateOutlet]=\"subListTemplate\"></ng-template>\n    @if (indicated || _childIndicatedAndCollapsed()) {\n        <span class=\"fd-list__navigation-item-indicator\"></span>\n    }\n}\n@if (expanded && _isExpandable && _condensed() && _listComponent) {\n    <div\n        class=\"fd-popover__body fd-popover__body--no-arrow fd-list__navigation-item-popover--first-level\"\n        aria-hidden=\"false\"\n    >\n        <ul class=\"fd-list\">\n            <li class=\"fd-list__navigation-item fd-list__navigation-item--condensed\">\n                <fd-icon\n                    role=\"presentation\"\n                    class=\"fd-list__navigation-item-icon\"\n                    [glyph]=\"_iconComponent.glyph\"\n                ></fd-icon>\n                <span class=\"fd-list__navigation-item-text\">{{ _innerText }}</span>\n            </li>\n        </ul>\n    </div>\n    <div\n        class=\"fd-popover__body fd-popover__body--no-arrow fd-list__navigation-item-popover--second-level\"\n        aria-hidden=\"false\"\n    >\n        <ng-template [ngTemplateOutlet]=\"subListTemplate\"></ng-template>\n    </div>\n}\n<ng-template #subListTemplate>\n    <ng-content select=\"[fd-list]\"></ng-content>\n</ng-template>\n", styles: ["body.fd-overlay-active:before{background:var(--fdModal_BackgroundColor);content:\"\";height:100vh;left:0;pointer-events:all;position:fixed;top:0;width:100vw;z-index:999}.fd-popover{--fdPopover_Display:inline-block;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:var(--fdPopover_Display);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;max-width:100%;padding-block:0;padding-inline:0;position:relative}.fd-popover:after,.fd-popover:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover__modal{position:relative;z-index:1000}.fd-popover__control{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);cursor:pointer;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;position:relative}.fd-popover__control:after,.fd-popover__control:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover__control:focus-visible{outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor)}.fd-popover__control.is-expanded>*,.fd-popover__control[aria-expanded=true]>*{-webkit-margin-after:0;margin-block-end:0}.fd-popover__control.is-expanded+.fd-popover__body--input-message-group,.fd-popover__control[aria-expanded=true]+.fd-popover__body--input-message-group{margin-top:0}.fd-popover__control.is-disabled,.fd-popover__control:disabled,.fd-popover__control[aria-disabled=true]{pointer-events:none}.fd-popover__wrapper{border-radius:var(--fdPopover_Body_Border_Radius);overflow:auto;position:relative;scrollbar-color:var(--fdScrollbar_Thumb_Color) var(--fdScrollbar_Track_Color)}.fd-popover__wrapper.is-focus,.fd-popover__wrapper:focus{outline:none;z-index:5}.fd-popover__wrapper::-webkit-scrollbar{height:var(--fdScrollbar_Dimension);width:var(--fdScrollbar_Dimension)}.fd-popover__wrapper::-webkit-scrollbar-corner,.fd-popover__wrapper::-webkit-scrollbar-track{background-color:var(--fdScrollbar_Track_Color)}.fd-popover__wrapper::-webkit-scrollbar-thumb{background-color:transparent;border:var(--fdScrollbar_Thumb_Offset) solid transparent;border-radius:calc(var(--fdScrollbar_Thumb_Border_Radius) - var(--fdScrollbar_Thumb_Offset));-webkit-box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Color);box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Color)}.fd-popover__wrapper::-webkit-scrollbar-thumb:active,.fd-popover__wrapper::-webkit-scrollbar-thumb:hover{-webkit-box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Hover_Color);box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Hover_Color)}.fd-popover__wrapper::-webkit-scrollbar-corner,.fd-popover__wrapper::-webkit-scrollbar-track{border-radius:0 var(--fdScrollbar_Border_Radius) var(--fdScrollbar_Border_Radius) 0}.fd-popover__wrapper[dir=rtl]::-webkit-scrollbar-corner,.fd-popover__wrapper[dir=rtl]::-webkit-scrollbar-track,[dir=rtl] .fd-popover__wrapper::-webkit-scrollbar-corner,[dir=rtl] .fd-popover__wrapper::-webkit-scrollbar-track{border-radius:var(--fdScrollbar_Border_Radius) 0 0 var(--fdScrollbar_Border_Radius)}.fd-popover__wrapper--visible{overflow:visible!important}.fd-popover__body{--fdPopover_Offset:100%;--fdPopover_Center_Offset:50%;--fdPopover_Arrow_Size:.5rem;--fdPopover_Body_Border_Radius:var(--fdPopover_Border_Radius);--fdPopover_Body_Box_Shadow:var(--sapContent_Shadow2);--fdPopover_Body_Box_Shadow_No_Arrow:var(--sapContent_Shadow1);--fdIcon_Button_Height:2.25rem;--fdIcon_Button_Width:2.25rem;--fdPopover_Resize_Handle_Offset:-.5rem;--fdPopover_Resize_Handle_Position_Top:auto;--fdPopover_Resize_Handle_Position_Right:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Bottom:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Rotate_Angle:0;--fdPopover_Resize_Handle_Cursor:se-resize;--fdPopover_Resize_Handle_Justify:center;--fdPopover_Resize_Handle_Transform_Scale:1;background:var(--sapGroup_ContentBackground);border:0;border-radius:var(--fdPopover_Body_Border_Radius);-webkit-box-shadow:var(--fdPopover_Body_Box_Shadow);box-shadow:var(--fdPopover_Body_Box_Shadow);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;opacity:1;padding-block:0;padding-inline:0;position:absolute;top:calc(var(--fdPopover_Offset) + var(--fdPopover_Arrow_Size));-webkit-transition:all .125s;transition:all .125s;visibility:visible;white-space:nowrap;z-index:1000}.fd-popover__body:after,.fd-popover__body:before{-webkit-box-sizing:inherit;box-sizing:inherit;content:\"\";font-size:inherit;position:absolute}.fd-popover__body:before{border-bottom:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid var(--sapGroup_ContentBackground);border-left:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;border-right:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;top:calc(var(--fdPopover_Arrow_Size)*-1 + var(--fdPopover_Border_Width));z-index:1002}.fd-popover__body:after,.fd-popover__body:before{border-top:none;display:inline-block;height:0;width:0}.fd-popover__body:after{border-bottom:var(--fdPopover_Arrow_Size) solid var(--fdPopover_Border_Color);border-left:var(--fdPopover_Arrow_Size) solid transparent;border-right:var(--fdPopover_Arrow_Size) solid transparent;top:calc(var(--fdPopover_Arrow_Size)*-1);z-index:1001}.fd-popover__body>:not(.fd-popover__wrapper){overflow:hidden}.fd-popover__body-header>:first-child,.fd-popover__body>:first-child{border-top-left-radius:var(--fdPopover_Border_Radius);border-top-right-radius:var(--fdPopover_Border_Radius)}.fd-popover__body-footer>:last-child,.fd-popover__body>:last-child:not(.fd-popover__resize-handle){border-bottom-left-radius:var(--fdPopover_Border_Radius);border-bottom-right-radius:var(--fdPopover_Border_Radius)}.fd-popover__body .fd-menu{width:100%}.fd-popover__body[class*=-compact],.fd-popover__body[class*=-condensed],[class*=-compact] .fd-popover__body:not([class*=-cozy]),[class*=-condensed] .fd-popover__body:not([class*=-cozy]){--fdIcon_Button_Height:1.625rem;--fdIcon_Button_Width:2rem}.fd-popover__body--no-arrow{-webkit-box-shadow:var(--fdPopover_Body_Box_Shadow_No_Arrow);box-shadow:var(--fdPopover_Body_Box_Shadow_No_Arrow);top:var(--fdPopover_Offset)}.fd-popover__body--no-arrow:after,.fd-popover__body--no-arrow:before{display:none}.fd-popover__body,.fd-popover__body--left{left:0}.fd-popover__body--left[dir=rtl],.fd-popover__body[dir=rtl],[dir=rtl] .fd-popover__body,[dir=rtl] .fd-popover__body--left{left:auto;right:0}.fd-popover__body--left:before,.fd-popover__body:before{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--left:after,.fd-popover__body:after{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--left[dir=rtl]:before,.fd-popover__body[dir=rtl]:before,[dir=rtl] .fd-popover__body--left:before,[dir=rtl] .fd-popover__body:before{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--left[dir=rtl]:after,.fd-popover__body[dir=rtl]:after,[dir=rtl] .fd-popover__body--left:after,[dir=rtl] .fd-popover__body:after{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--center{left:var(--fdPopover_Center_Offset);-webkit-transform:translateX(calc(var(--fdPopover_Center_Offset)*-1));transform:translate(calc(var(--fdPopover_Center_Offset)*-1))}.fd-popover__body--center[dir=rtl],[dir=rtl] .fd-popover__body--center{left:auto;right:var(--fdPopover_Center_Offset);-webkit-transform:translateX(var(--fdPopover_Center_Offset));transform:translate(var(--fdPopover_Center_Offset))}.fd-popover__body--right{left:auto;right:0}.fd-popover__body--right[dir=rtl],[dir=rtl] .fd-popover__body--right{left:0;right:auto}.fd-popover__body--right:before{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--right:after{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--right[dir=rtl]:before,[dir=rtl] .fd-popover__body--right:before{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width));right:auto}.fd-popover__body--right[dir=rtl]:after,[dir=rtl] .fd-popover__body--right:after{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width));right:auto}.fd-popover__body--before{left:auto!important;right:var(--fdPopover_Offset)!important;top:0}.fd-popover__body--after{left:var(--fdPopover_Offset)!important;right:auto!important;top:0}.fd-popover__body--middle{top:var(--fdPopover_Center_Offset);-webkit-transform:translateY(calc(var(--fdPopover_Center_Offset)*-1));transform:translateY(calc(var(--fdPopover_Center_Offset)*-1))}.fd-popover__body--bottom{bottom:0;top:auto}.fd-popover__body--above{bottom:var(--fdPopover_Offset);top:auto}.fd-popover__body--arrow-bottom{bottom:calc(var(--fdPopover_Offset) + var(--fdPopover_Arrow_Size))!important}.fd-popover__body--arrow-bottom:before{border-bottom:none;border-left:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;border-right:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;border-top:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid var(--sapGroup_ContentBackground);display:inline-block;height:0;top:100%;width:0}.fd-popover__body--arrow-bottom:after{border-bottom:none;border-left:var(--fdPopover_Arrow_Size) solid transparent;border-right:var(--fdPopover_Arrow_Size) solid transparent;border-top:var(--fdPopover_Arrow_Size) solid var(--fdPopover_Border_Color);display:inline-block;height:0;top:100%;width:0}.fd-popover__body--arrow-left{left:calc(var(--fdPopover_Offset) + var(--fdPopover_Arrow_Size))!important}.fd-popover__body--arrow-left:before{border-bottom:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;border-right:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid var(--sapGroup_ContentBackground);border-top:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;top:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--arrow-left:after,.fd-popover__body--arrow-left:before{border-left:none;display:inline-block;height:0;left:auto!important;right:100%!important;width:0}.fd-popover__body--arrow-left:after{border-bottom:var(--fdPopover_Arrow_Size) solid transparent;border-right:var(--fdPopover_Arrow_Size) solid var(--fdPopover_Border_Color);border-top:var(--fdPopover_Arrow_Size) solid transparent;top:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--arrow-right{right:calc(var(--fdPopover_Offset) + var(--fdPopover_Arrow_Size))!important}.fd-popover__body--arrow-right:before{border-bottom:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;border-left:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid var(--sapGroup_ContentBackground);border-top:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;top:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--arrow-right:after,.fd-popover__body--arrow-right:before{border-right:none;display:inline-block;height:0;left:100%!important;right:auto!important;width:0}.fd-popover__body--arrow-right:after{border-bottom:var(--fdPopover_Arrow_Size) solid transparent;border-left:var(--fdPopover_Arrow_Size) solid var(--fdPopover_Border_Color);border-top:var(--fdPopover_Arrow_Size) solid transparent;top:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--arrow-x-center:after,.fd-popover__body--arrow-x-center:before{left:50%;-webkit-transform:translateX(-50%);transform:translate(-50%)}.fd-popover__body--arrow-x-center[dir=rtl]:after,.fd-popover__body--arrow-x-center[dir=rtl]:before,[dir=rtl] .fd-popover__body--arrow-x-center:after,[dir=rtl] .fd-popover__body--arrow-x-center:before{left:auto;right:50%;-webkit-transform:translateX(50%);transform:translate(50%)}.fd-popover__body--arrow-x-end:before{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--arrow-x-end:after{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--arrow-x-end[dir=rtl]:before,[dir=rtl] .fd-popover__body--arrow-x-end:before{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width));right:auto}.fd-popover__body--arrow-x-end[dir=rtl]:after,[dir=rtl] .fd-popover__body--arrow-x-end:after{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width));right:auto}.fd-popover__body--arrow-y-center:after,.fd-popover__body--arrow-y-center:before{top:50%;-webkit-transform:translateY(-50%);transform:translateY(-50%)}.fd-popover__body--arrow-y-bottom:before,.fd-popover__body--arrow-y-end:before{bottom:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width));top:auto}.fd-popover__body--arrow-y-bottom:after,.fd-popover__body--arrow-y-end:after{bottom:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width));top:auto}.fd-popover__body--dropdown{width:-webkit-max-content;width:-moz-max-content;width:max-content}.fd-popover__body--dropdown-fill{display:block;max-width:40rem;width:calc(100% - var(--sapGroup_BorderWidth)*2)}.fd-popover__body--static{position:relative;--fdPopover_Offset:0%;--fdPopover_Center_Offset:0%}.fd-popover__body.is-hidden,.fd-popover__body[aria-hidden=true]{opacity:0;visibility:hidden;z-index:-1}.fd-popover__body .fd-popover__body--hidden{display:none}.fd-popover__body--input-message-group{border:none;-webkit-box-shadow:none;box-shadow:none}.fd-popover__body--inline-help{font-size:var(--sapFontSmallSize);padding-block:.75rem;padding-inline:.75rem}.fd-popover__body--inline-help-icon{--fdIcon_Button_Height:1.375rem;--fdIcon_Button_Width:1.375rem}.fd-popover__body.fd-popover__body--resizable[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable{--fdPopover_Resize_Handle_Position_Right:auto;--fdPopover_Resize_Handle_Position_Left:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Cursor:sw-resize;--fdPopover_Resize_Handle_Transform_Scale:-1}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--right{--fdPopover_Resize_Handle_Position_Left:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Right:auto;--fdPopover_Resize_Handle_Cursor:sw-resize;--fdPopover_Resize_Handle_Transform_Scale:-1;--fdPopover_Resize_Handle_Container_Justify:flex-end}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--right[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--right{--fdPopover_Resize_Handle_Position_Right:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Cursor:se-resize;--fdPopover_Resize_Handle_Transform_Scale:1}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--above{--fdPopover_Resize_Handle_Position_Top:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Bottom:auto;--fdPopover_Resize_Handle_Position_Right:-.5rem;--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Cursor:ne-resize;--fdPopover_Resize_Handle_Rotate_Angle:-90deg;--fdPopover_Resize_Handle_Transform_Scale:1}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--above[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--above{--fdPopover_Resize_Handle_Position_Right:auto;--fdPopover_Resize_Handle_Position_Left:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Cursor:nw-resize;--fdPopover_Resize_Handle_Transform_Scale:1;--fdPopover_Resize_Handle_Rotate_Angle:180deg;--fdPopover_Resize_Handle_Container_Justify:flex-end}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--above.fd-popover__body--right{--fdPopover_Resize_Handle_Position_Right:auto;--fdPopover_Resize_Handle_Position_Left:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Rotate_Angle:180deg;--fdPopover_Resize_Handle_Cursor:nw-resize;--fdPopover_Resize_Handle_Transform_Scale:1;--fdPopover_Resize_Handle_Container_Justify:flex-start}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--above.fd-popover__body--right[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--above.fd-popover__body--right{--fdPopover_Resize_Handle_Position_Right:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Rotate_Angle:-90deg;--fdPopover_Resize_Handle_Cursor:ne-resize;--fdPopover_Resize_Handle_Container_Justify:flex-end}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--after{--fdPopover_Resize_Handle_Position_Top:auto;--fdPopover_Resize_Handle_Position_Bottom:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Right:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Cursor:se-resize}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--after[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--after{--fdPopover_Resize_Handle_Rotate_Angle:-90deg}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--after.fd-popover__body--bottom{--fdPopover_Resize_Handle_Position_Top:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Bottom:auto;--fdPopover_Resize_Handle_Position_Right:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Cursor:ne-resize;--fdPopover_Resize_Handle_Rotate_Angle:-90deg;--fdPopover_Resize_Handle_Transform_Scale:1}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--after.fd-popover__body--bottom[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--after.fd-popover__body--bottom{--fdPopover_Resize_Handle_Container_Justify:flex-end}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--before{--fdPopover_Resize_Handle_Position_Top:auto;--fdPopover_Resize_Handle_Position_Bottom:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Right:auto;--fdPopover_Resize_Handle_Position_Left:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Cursor:sw-resize;--fdPopover_Resize_Handle_Rotate_Angle:0;--fdPopover_Resize_Handle_Transform_Scale:-1;--fdPopover_Resize_Handle_Container_Justify:flex-end}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--before[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--before{--fdPopover_Resize_Handle_Container_Justify:flex-start}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--before.fd-popover__body--bottom,.fd-popover__body.fd-popover__body--resizable.fd-popover__body--before.fd-popover__body--middle{--fdPopover_Resize_Handle_Position_Top:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Bottom:auto;--fdPopover_Resize_Handle_Rotate_Angle:90deg;--fdPopover_Resize_Handle_Cursor:nw-resize}.fd-popover__resize-handle{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:1.5rem;line-height:normal;margin-block:0;margin-inline:0;min-width:1.5rem;padding-block:0;padding-inline:0;width:1.5rem;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start;-webkit-box-pack:var(--fdPopover_Resize_Handle_Container_Justify,flex-start);-ms-flex-pack:var(--fdPopover_Resize_Handle_Container_Justify,flex-start);color:var(--sapButton_Lite_TextColor);cursor:var(--fdPopover_Resize_Handle_Cursor);font-size:1rem;inset:var(--fdPopover_Resize_Handle_Position_Top) var(--fdPopover_Resize_Handle_Position_Right) var(--fdPopover_Resize_Handle_Position_Bottom) var(--fdPopover_Resize_Handle_Position_Left);justify-content:var(--fdPopover_Resize_Handle_Container_Justify,flex-start);line-height:1rem;overflow:hidden;position:absolute;-webkit-transform:rotate(var(--fdPopover_Resize_Handle_Rotate_Angle));transform:rotate(var(--fdPopover_Resize_Handle_Rotate_Angle))}.fd-popover__resize-handle:after,.fd-popover__resize-handle:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover__resize-handle:after{content:\"\\e24f\";display:-webkit-box;display:-ms-flexbox;display:flex;font-family:SAP-icons;height:1rem;min-width:1rem;text-align:center;text-decoration:inherit;text-rendering:optimizeLegibility;text-transform:none;width:1rem;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-pack:var(--fdPopover_Resize_Handle_Justify);-ms-flex-pack:var(--fdPopover_Resize_Handle_Justify);color:inherit;justify-content:var(--fdPopover_Resize_Handle_Justify);-webkit-transform:scaleX(var(--fdPopover_Resize_Handle_Transform_Scale));transform:scaleX(var(--fdPopover_Resize_Handle_Transform_Scale))}.fd-popover--slider{--fdPopover_Display:block}.fd-popover--input-message-group .fd-popover__body,.fd-popover--input-message-group .fd-popover__body--no-arrow{border:none;-webkit-box-shadow:none;box-shadow:none}.fd-popover--full-width{width:100%}.fd-popover--btp .fd-popover__body{--fdPopover_Arrow_Size:.375rem;--fdPopover_Body_Border_Radius:.75rem;--fdPopover_Body_Box_Shadow:var(--sapMenu_Shadow2);border:none;top:calc(var(--fdPopover_Offset) + var(--fdPopover_Arrow_Size) - .1875rem)}.fd-popover--btp .fd-popover__body--padding{padding-block:.75rem;padding-inline:.75rem}.fd-popover--btp .fd-popover__body-header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-popover--btp .fd-popover__body-header:after,.fd-popover--btp .fd-popover__body-header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover--btp .fd-popover__body-content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-block:.75rem;margin-inline:0;padding-block:0;padding-inline:0}.fd-popover--btp .fd-popover__body-content:after,.fd-popover--btp .fd-popover__body-content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover--btp .fd-popover__body-content:only-child{margin-block:0;margin-inline:0}.fd-popover--btp .fd-popover__body-footer{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;gap:.1875rem;-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end;padding-block:.375rem;padding-inline:0}.fd-popover--btp .fd-popover__body-footer:after,.fd-popover--btp .fd-popover__body-footer:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover--btp .fd-popover__body-footer--center{-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center}\n/*! Bundled license information:\n\nfundamental-styles/dist/popover.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"], dependencies: [{ kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: IconComponent, selector: "fd-icon", inputs: ["glyph", "font", "color", "background", "class", "ariaLabel", "ariaHidden"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListNavigationItemComponent, decorators: [{
            type: Component,
            args: [{ selector: '[fd-list-navigation-item], [fdListNavigaitonItem]', host: {
                        role: 'treeitem'
                    }, imports: [NgTemplateOutlet, IconComponent], template: "@if (!expanded || !_isExpandable || !_condensed() || !_listComponent) {\n    <ng-content></ng-content> <ng-template [ngTemplateOutlet]=\"subListTemplate\"></ng-template>\n    @if (indicated || _childIndicatedAndCollapsed()) {\n        <span class=\"fd-list__navigation-item-indicator\"></span>\n    }\n}\n@if (expanded && _isExpandable && _condensed() && _listComponent) {\n    <div\n        class=\"fd-popover__body fd-popover__body--no-arrow fd-list__navigation-item-popover--first-level\"\n        aria-hidden=\"false\"\n    >\n        <ul class=\"fd-list\">\n            <li class=\"fd-list__navigation-item fd-list__navigation-item--condensed\">\n                <fd-icon\n                    role=\"presentation\"\n                    class=\"fd-list__navigation-item-icon\"\n                    [glyph]=\"_iconComponent.glyph\"\n                ></fd-icon>\n                <span class=\"fd-list__navigation-item-text\">{{ _innerText }}</span>\n            </li>\n        </ul>\n    </div>\n    <div\n        class=\"fd-popover__body fd-popover__body--no-arrow fd-list__navigation-item-popover--second-level\"\n        aria-hidden=\"false\"\n    >\n        <ng-template [ngTemplateOutlet]=\"subListTemplate\"></ng-template>\n    </div>\n}\n<ng-template #subListTemplate>\n    <ng-content select=\"[fd-list]\"></ng-content>\n</ng-template>\n", styles: ["body.fd-overlay-active:before{background:var(--fdModal_BackgroundColor);content:\"\";height:100vh;left:0;pointer-events:all;position:fixed;top:0;width:100vw;z-index:999}.fd-popover{--fdPopover_Display:inline-block;border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:var(--fdPopover_Display);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;max-width:100%;padding-block:0;padding-inline:0;position:relative}.fd-popover:after,.fd-popover:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover__modal{position:relative;z-index:1000}.fd-popover__control{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);cursor:pointer;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;position:relative}.fd-popover__control:after,.fd-popover__control:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover__control:focus-visible{outline:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor)}.fd-popover__control.is-expanded>*,.fd-popover__control[aria-expanded=true]>*{-webkit-margin-after:0;margin-block-end:0}.fd-popover__control.is-expanded+.fd-popover__body--input-message-group,.fd-popover__control[aria-expanded=true]+.fd-popover__body--input-message-group{margin-top:0}.fd-popover__control.is-disabled,.fd-popover__control:disabled,.fd-popover__control[aria-disabled=true]{pointer-events:none}.fd-popover__wrapper{border-radius:var(--fdPopover_Body_Border_Radius);overflow:auto;position:relative;scrollbar-color:var(--fdScrollbar_Thumb_Color) var(--fdScrollbar_Track_Color)}.fd-popover__wrapper.is-focus,.fd-popover__wrapper:focus{outline:none;z-index:5}.fd-popover__wrapper::-webkit-scrollbar{height:var(--fdScrollbar_Dimension);width:var(--fdScrollbar_Dimension)}.fd-popover__wrapper::-webkit-scrollbar-corner,.fd-popover__wrapper::-webkit-scrollbar-track{background-color:var(--fdScrollbar_Track_Color)}.fd-popover__wrapper::-webkit-scrollbar-thumb{background-color:transparent;border:var(--fdScrollbar_Thumb_Offset) solid transparent;border-radius:calc(var(--fdScrollbar_Thumb_Border_Radius) - var(--fdScrollbar_Thumb_Offset));-webkit-box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Color);box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Color)}.fd-popover__wrapper::-webkit-scrollbar-thumb:active,.fd-popover__wrapper::-webkit-scrollbar-thumb:hover{-webkit-box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Hover_Color);box-shadow:inset 0 0 0 var(--fdScrollbar_Dimension) var(--fdScrollbar_Thumb_Hover_Color)}.fd-popover__wrapper::-webkit-scrollbar-corner,.fd-popover__wrapper::-webkit-scrollbar-track{border-radius:0 var(--fdScrollbar_Border_Radius) var(--fdScrollbar_Border_Radius) 0}.fd-popover__wrapper[dir=rtl]::-webkit-scrollbar-corner,.fd-popover__wrapper[dir=rtl]::-webkit-scrollbar-track,[dir=rtl] .fd-popover__wrapper::-webkit-scrollbar-corner,[dir=rtl] .fd-popover__wrapper::-webkit-scrollbar-track{border-radius:var(--fdScrollbar_Border_Radius) 0 0 var(--fdScrollbar_Border_Radius)}.fd-popover__wrapper--visible{overflow:visible!important}.fd-popover__body{--fdPopover_Offset:100%;--fdPopover_Center_Offset:50%;--fdPopover_Arrow_Size:.5rem;--fdPopover_Body_Border_Radius:var(--fdPopover_Border_Radius);--fdPopover_Body_Box_Shadow:var(--sapContent_Shadow2);--fdPopover_Body_Box_Shadow_No_Arrow:var(--sapContent_Shadow1);--fdIcon_Button_Height:2.25rem;--fdIcon_Button_Width:2.25rem;--fdPopover_Resize_Handle_Offset:-.5rem;--fdPopover_Resize_Handle_Position_Top:auto;--fdPopover_Resize_Handle_Position_Right:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Bottom:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Rotate_Angle:0;--fdPopover_Resize_Handle_Cursor:se-resize;--fdPopover_Resize_Handle_Justify:center;--fdPopover_Resize_Handle_Transform_Scale:1;background:var(--sapGroup_ContentBackground);border:0;border-radius:var(--fdPopover_Body_Border_Radius);-webkit-box-shadow:var(--fdPopover_Body_Box_Shadow);box-shadow:var(--fdPopover_Body_Box_Shadow);-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;opacity:1;padding-block:0;padding-inline:0;position:absolute;top:calc(var(--fdPopover_Offset) + var(--fdPopover_Arrow_Size));-webkit-transition:all .125s;transition:all .125s;visibility:visible;white-space:nowrap;z-index:1000}.fd-popover__body:after,.fd-popover__body:before{-webkit-box-sizing:inherit;box-sizing:inherit;content:\"\";font-size:inherit;position:absolute}.fd-popover__body:before{border-bottom:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid var(--sapGroup_ContentBackground);border-left:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;border-right:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;top:calc(var(--fdPopover_Arrow_Size)*-1 + var(--fdPopover_Border_Width));z-index:1002}.fd-popover__body:after,.fd-popover__body:before{border-top:none;display:inline-block;height:0;width:0}.fd-popover__body:after{border-bottom:var(--fdPopover_Arrow_Size) solid var(--fdPopover_Border_Color);border-left:var(--fdPopover_Arrow_Size) solid transparent;border-right:var(--fdPopover_Arrow_Size) solid transparent;top:calc(var(--fdPopover_Arrow_Size)*-1);z-index:1001}.fd-popover__body>:not(.fd-popover__wrapper){overflow:hidden}.fd-popover__body-header>:first-child,.fd-popover__body>:first-child{border-top-left-radius:var(--fdPopover_Border_Radius);border-top-right-radius:var(--fdPopover_Border_Radius)}.fd-popover__body-footer>:last-child,.fd-popover__body>:last-child:not(.fd-popover__resize-handle){border-bottom-left-radius:var(--fdPopover_Border_Radius);border-bottom-right-radius:var(--fdPopover_Border_Radius)}.fd-popover__body .fd-menu{width:100%}.fd-popover__body[class*=-compact],.fd-popover__body[class*=-condensed],[class*=-compact] .fd-popover__body:not([class*=-cozy]),[class*=-condensed] .fd-popover__body:not([class*=-cozy]){--fdIcon_Button_Height:1.625rem;--fdIcon_Button_Width:2rem}.fd-popover__body--no-arrow{-webkit-box-shadow:var(--fdPopover_Body_Box_Shadow_No_Arrow);box-shadow:var(--fdPopover_Body_Box_Shadow_No_Arrow);top:var(--fdPopover_Offset)}.fd-popover__body--no-arrow:after,.fd-popover__body--no-arrow:before{display:none}.fd-popover__body,.fd-popover__body--left{left:0}.fd-popover__body--left[dir=rtl],.fd-popover__body[dir=rtl],[dir=rtl] .fd-popover__body,[dir=rtl] .fd-popover__body--left{left:auto;right:0}.fd-popover__body--left:before,.fd-popover__body:before{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--left:after,.fd-popover__body:after{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--left[dir=rtl]:before,.fd-popover__body[dir=rtl]:before,[dir=rtl] .fd-popover__body--left:before,[dir=rtl] .fd-popover__body:before{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--left[dir=rtl]:after,.fd-popover__body[dir=rtl]:after,[dir=rtl] .fd-popover__body--left:after,[dir=rtl] .fd-popover__body:after{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--center{left:var(--fdPopover_Center_Offset);-webkit-transform:translateX(calc(var(--fdPopover_Center_Offset)*-1));transform:translate(calc(var(--fdPopover_Center_Offset)*-1))}.fd-popover__body--center[dir=rtl],[dir=rtl] .fd-popover__body--center{left:auto;right:var(--fdPopover_Center_Offset);-webkit-transform:translateX(var(--fdPopover_Center_Offset));transform:translate(var(--fdPopover_Center_Offset))}.fd-popover__body--right{left:auto;right:0}.fd-popover__body--right[dir=rtl],[dir=rtl] .fd-popover__body--right{left:0;right:auto}.fd-popover__body--right:before{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--right:after{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--right[dir=rtl]:before,[dir=rtl] .fd-popover__body--right:before{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width));right:auto}.fd-popover__body--right[dir=rtl]:after,[dir=rtl] .fd-popover__body--right:after{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width));right:auto}.fd-popover__body--before{left:auto!important;right:var(--fdPopover_Offset)!important;top:0}.fd-popover__body--after{left:var(--fdPopover_Offset)!important;right:auto!important;top:0}.fd-popover__body--middle{top:var(--fdPopover_Center_Offset);-webkit-transform:translateY(calc(var(--fdPopover_Center_Offset)*-1));transform:translateY(calc(var(--fdPopover_Center_Offset)*-1))}.fd-popover__body--bottom{bottom:0;top:auto}.fd-popover__body--above{bottom:var(--fdPopover_Offset);top:auto}.fd-popover__body--arrow-bottom{bottom:calc(var(--fdPopover_Offset) + var(--fdPopover_Arrow_Size))!important}.fd-popover__body--arrow-bottom:before{border-bottom:none;border-left:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;border-right:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;border-top:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid var(--sapGroup_ContentBackground);display:inline-block;height:0;top:100%;width:0}.fd-popover__body--arrow-bottom:after{border-bottom:none;border-left:var(--fdPopover_Arrow_Size) solid transparent;border-right:var(--fdPopover_Arrow_Size) solid transparent;border-top:var(--fdPopover_Arrow_Size) solid var(--fdPopover_Border_Color);display:inline-block;height:0;top:100%;width:0}.fd-popover__body--arrow-left{left:calc(var(--fdPopover_Offset) + var(--fdPopover_Arrow_Size))!important}.fd-popover__body--arrow-left:before{border-bottom:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;border-right:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid var(--sapGroup_ContentBackground);border-top:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;top:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--arrow-left:after,.fd-popover__body--arrow-left:before{border-left:none;display:inline-block;height:0;left:auto!important;right:100%!important;width:0}.fd-popover__body--arrow-left:after{border-bottom:var(--fdPopover_Arrow_Size) solid transparent;border-right:var(--fdPopover_Arrow_Size) solid var(--fdPopover_Border_Color);border-top:var(--fdPopover_Arrow_Size) solid transparent;top:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--arrow-right{right:calc(var(--fdPopover_Offset) + var(--fdPopover_Arrow_Size))!important}.fd-popover__body--arrow-right:before{border-bottom:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;border-left:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid var(--sapGroup_ContentBackground);border-top:calc(var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width)) solid transparent;top:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--arrow-right:after,.fd-popover__body--arrow-right:before{border-right:none;display:inline-block;height:0;left:100%!important;right:auto!important;width:0}.fd-popover__body--arrow-right:after{border-bottom:var(--fdPopover_Arrow_Size) solid transparent;border-left:var(--fdPopover_Arrow_Size) solid var(--fdPopover_Border_Color);border-top:var(--fdPopover_Arrow_Size) solid transparent;top:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--arrow-x-center:after,.fd-popover__body--arrow-x-center:before{left:50%;-webkit-transform:translateX(-50%);transform:translate(-50%)}.fd-popover__body--arrow-x-center[dir=rtl]:after,.fd-popover__body--arrow-x-center[dir=rtl]:before,[dir=rtl] .fd-popover__body--arrow-x-center:after,[dir=rtl] .fd-popover__body--arrow-x-center:before{left:auto;right:50%;-webkit-transform:translateX(50%);transform:translate(50%)}.fd-popover__body--arrow-x-end:before{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width))}.fd-popover__body--arrow-x-end:after{left:auto;right:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width))}.fd-popover__body--arrow-x-end[dir=rtl]:before,[dir=rtl] .fd-popover__body--arrow-x-end:before{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width));right:auto}.fd-popover__body--arrow-x-end[dir=rtl]:after,[dir=rtl] .fd-popover__body--arrow-x-end:after{left:calc(var(--fdIcon_Button_Width)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width));right:auto}.fd-popover__body--arrow-y-center:after,.fd-popover__body--arrow-y-center:before{top:50%;-webkit-transform:translateY(-50%);transform:translateY(-50%)}.fd-popover__body--arrow-y-bottom:before,.fd-popover__body--arrow-y-end:before{bottom:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width) + var(--fdPopover_Border_Width));top:auto}.fd-popover__body--arrow-y-bottom:after,.fd-popover__body--arrow-y-end:after{bottom:calc(var(--fdIcon_Button_Height)*.5 - var(--fdPopover_Arrow_Size) - var(--fdPopover_Border_Width));top:auto}.fd-popover__body--dropdown{width:-webkit-max-content;width:-moz-max-content;width:max-content}.fd-popover__body--dropdown-fill{display:block;max-width:40rem;width:calc(100% - var(--sapGroup_BorderWidth)*2)}.fd-popover__body--static{position:relative;--fdPopover_Offset:0%;--fdPopover_Center_Offset:0%}.fd-popover__body.is-hidden,.fd-popover__body[aria-hidden=true]{opacity:0;visibility:hidden;z-index:-1}.fd-popover__body .fd-popover__body--hidden{display:none}.fd-popover__body--input-message-group{border:none;-webkit-box-shadow:none;box-shadow:none}.fd-popover__body--inline-help{font-size:var(--sapFontSmallSize);padding-block:.75rem;padding-inline:.75rem}.fd-popover__body--inline-help-icon{--fdIcon_Button_Height:1.375rem;--fdIcon_Button_Width:1.375rem}.fd-popover__body.fd-popover__body--resizable[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable{--fdPopover_Resize_Handle_Position_Right:auto;--fdPopover_Resize_Handle_Position_Left:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Cursor:sw-resize;--fdPopover_Resize_Handle_Transform_Scale:-1}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--right{--fdPopover_Resize_Handle_Position_Left:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Right:auto;--fdPopover_Resize_Handle_Cursor:sw-resize;--fdPopover_Resize_Handle_Transform_Scale:-1;--fdPopover_Resize_Handle_Container_Justify:flex-end}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--right[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--right{--fdPopover_Resize_Handle_Position_Right:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Cursor:se-resize;--fdPopover_Resize_Handle_Transform_Scale:1}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--above{--fdPopover_Resize_Handle_Position_Top:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Bottom:auto;--fdPopover_Resize_Handle_Position_Right:-.5rem;--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Cursor:ne-resize;--fdPopover_Resize_Handle_Rotate_Angle:-90deg;--fdPopover_Resize_Handle_Transform_Scale:1}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--above[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--above{--fdPopover_Resize_Handle_Position_Right:auto;--fdPopover_Resize_Handle_Position_Left:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Cursor:nw-resize;--fdPopover_Resize_Handle_Transform_Scale:1;--fdPopover_Resize_Handle_Rotate_Angle:180deg;--fdPopover_Resize_Handle_Container_Justify:flex-end}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--above.fd-popover__body--right{--fdPopover_Resize_Handle_Position_Right:auto;--fdPopover_Resize_Handle_Position_Left:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Rotate_Angle:180deg;--fdPopover_Resize_Handle_Cursor:nw-resize;--fdPopover_Resize_Handle_Transform_Scale:1;--fdPopover_Resize_Handle_Container_Justify:flex-start}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--above.fd-popover__body--right[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--above.fd-popover__body--right{--fdPopover_Resize_Handle_Position_Right:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Rotate_Angle:-90deg;--fdPopover_Resize_Handle_Cursor:ne-resize;--fdPopover_Resize_Handle_Container_Justify:flex-end}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--after{--fdPopover_Resize_Handle_Position_Top:auto;--fdPopover_Resize_Handle_Position_Bottom:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Right:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Cursor:se-resize}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--after[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--after{--fdPopover_Resize_Handle_Rotate_Angle:-90deg}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--after.fd-popover__body--bottom{--fdPopover_Resize_Handle_Position_Top:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Bottom:auto;--fdPopover_Resize_Handle_Position_Right:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Left:auto;--fdPopover_Resize_Handle_Cursor:ne-resize;--fdPopover_Resize_Handle_Rotate_Angle:-90deg;--fdPopover_Resize_Handle_Transform_Scale:1}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--after.fd-popover__body--bottom[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--after.fd-popover__body--bottom{--fdPopover_Resize_Handle_Container_Justify:flex-end}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--before{--fdPopover_Resize_Handle_Position_Top:auto;--fdPopover_Resize_Handle_Position_Bottom:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Right:auto;--fdPopover_Resize_Handle_Position_Left:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Cursor:sw-resize;--fdPopover_Resize_Handle_Rotate_Angle:0;--fdPopover_Resize_Handle_Transform_Scale:-1;--fdPopover_Resize_Handle_Container_Justify:flex-end}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--before[dir=rtl],[dir=rtl] .fd-popover__body.fd-popover__body--resizable.fd-popover__body--before{--fdPopover_Resize_Handle_Container_Justify:flex-start}.fd-popover__body.fd-popover__body--resizable.fd-popover__body--before.fd-popover__body--bottom,.fd-popover__body.fd-popover__body--resizable.fd-popover__body--before.fd-popover__body--middle{--fdPopover_Resize_Handle_Position_Top:var(--fdPopover_Resize_Handle_Offset);--fdPopover_Resize_Handle_Position_Bottom:auto;--fdPopover_Resize_Handle_Rotate_Angle:90deg;--fdPopover_Resize_Handle_Cursor:nw-resize}.fd-popover__resize-handle{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:1.5rem;line-height:normal;margin-block:0;margin-inline:0;min-width:1.5rem;padding-block:0;padding-inline:0;width:1.5rem;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start;-webkit-box-pack:var(--fdPopover_Resize_Handle_Container_Justify,flex-start);-ms-flex-pack:var(--fdPopover_Resize_Handle_Container_Justify,flex-start);color:var(--sapButton_Lite_TextColor);cursor:var(--fdPopover_Resize_Handle_Cursor);font-size:1rem;inset:var(--fdPopover_Resize_Handle_Position_Top) var(--fdPopover_Resize_Handle_Position_Right) var(--fdPopover_Resize_Handle_Position_Bottom) var(--fdPopover_Resize_Handle_Position_Left);justify-content:var(--fdPopover_Resize_Handle_Container_Justify,flex-start);line-height:1rem;overflow:hidden;position:absolute;-webkit-transform:rotate(var(--fdPopover_Resize_Handle_Rotate_Angle));transform:rotate(var(--fdPopover_Resize_Handle_Rotate_Angle))}.fd-popover__resize-handle:after,.fd-popover__resize-handle:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover__resize-handle:after{content:\"\\e24f\";display:-webkit-box;display:-ms-flexbox;display:flex;font-family:SAP-icons;height:1rem;min-width:1rem;text-align:center;text-decoration:inherit;text-rendering:optimizeLegibility;text-transform:none;width:1rem;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-pack:var(--fdPopover_Resize_Handle_Justify);-ms-flex-pack:var(--fdPopover_Resize_Handle_Justify);color:inherit;justify-content:var(--fdPopover_Resize_Handle_Justify);-webkit-transform:scaleX(var(--fdPopover_Resize_Handle_Transform_Scale));transform:scaleX(var(--fdPopover_Resize_Handle_Transform_Scale))}.fd-popover--slider{--fdPopover_Display:block}.fd-popover--input-message-group .fd-popover__body,.fd-popover--input-message-group .fd-popover__body--no-arrow{border:none;-webkit-box-shadow:none;box-shadow:none}.fd-popover--full-width{width:100%}.fd-popover--btp .fd-popover__body{--fdPopover_Arrow_Size:.375rem;--fdPopover_Body_Border_Radius:.75rem;--fdPopover_Body_Box_Shadow:var(--sapMenu_Shadow2);border:none;top:calc(var(--fdPopover_Offset) + var(--fdPopover_Arrow_Size) - .1875rem)}.fd-popover--btp .fd-popover__body--padding{padding-block:.75rem;padding-inline:.75rem}.fd-popover--btp .fd-popover__body-header{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-popover--btp .fd-popover__body-header:after,.fd-popover--btp .fd-popover__body-header:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover--btp .fd-popover__body-content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-block:.75rem;margin-inline:0;padding-block:0;padding-inline:0}.fd-popover--btp .fd-popover__body-content:after,.fd-popover--btp .fd-popover__body-content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover--btp .fd-popover__body-content:only-child{margin-block:0;margin-inline:0}.fd-popover--btp .fd-popover__body-footer{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;gap:.1875rem;-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end;padding-block:.375rem;padding-inline:0}.fd-popover--btp .fd-popover__body-footer:after,.fd-popover--btp .fd-popover__body-footer:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-popover--btp .fd-popover__body-footer--center{-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center}\n/*! Bundled license information:\n\nfundamental-styles/dist/popover.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1$1.RtlService, decorators: [{
                    type: Optional
                }] }], propDecorators: { expanded: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.is-expanded']
            }], indicated: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['attr.aria-selected']
            }, {
                type: HostBinding,
                args: ['class.fd-list__navigation-item--indicated']
            }], _navigationItemClass: [{
                type: HostBinding,
                args: ['class.fd-list__navigation-item']
            }], _isExpandable: [{
                type: HostBinding,
                args: ['class.fd-list__navigation-item--expandable']
            }], _tabIndex: [{
                type: HostBinding,
                args: ['attr.tabindex']
            }], _ariaLevel: [{
                type: HostBinding,
                args: ['attr.aria-level']
            }], _listComponent: [{
                type: ContentChild,
                args: [FD_LIST_COMPONENT]
            }], _listNavigationItemArrow: [{
                type: ContentChild,
                args: [ListNavigationItemArrowDirective]
            }], _iconComponent: [{
                type: ContentChild,
                args: [FD_ICON_COMPONENT]
            }], _text: [{
                type: ContentChild,
                args: [ListNavigationItemTextDirective]
            }], _childItems: [{
                type: ContentChildren,
                args: [forwardRef(() => ListNavigationItemComponent), { descendants: true }]
            }], _ariaExpanded: [{
                type: HostBinding,
                args: ['attr.aria-expanded']
            }], onItemClick: [{
                type: HostListener,
                args: ['click', ['$event']]
            }], keyDownHandler: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }], onFocus: [{
                type: HostListener,
                args: ['focus', ['$event']]
            }] } });

/**
 * The directive that represents a list.
 * It is used to display a list of items with simple information such as scopes, names, etc.
 */
class ListComponent {
    /** @hidden */
    get _ariaRole() {
        return this.role || this._defaultRole;
    }
    /** @hidden */
    constructor(_keyboardSupportService, _contentDensityObserver) {
        this._keyboardSupportService = _keyboardSupportService;
        /** Whether dropdown mode is included to component, used for Select and Combobox */
        this.dropdownMode = false;
        /** Whether multi mode is included to component, used for MultiInput */
        this.multiInputMode = false;
        /** Whether list is used in mobile mode*/
        this.mobileMode = false;
        /** Whether list component contains message */
        this.hasMessage = false;
        /** Whether list component has removed borders */
        this.noBorder = false;
        /** Whether list component has navigation indicators */
        this.navigationIndicator = false;
        /** Whether list component has checkboxes or radio buttons included */
        this.selection = false;
        /** Whether internal keyboard support should be enabled. It's enabled by default */
        this.keyboardSupport = true;
        /** Whether list should have a byline */
        this.byline = false;
        /** Whether list should have a subline */
        this.subline = false;
        /** Whether to display unread notification indicator. */
        this.unreadIndicator = false;
        /** Event thrown, when focus escapes the list */
        this.focusEscapeList = new EventEmitter();
        /** Whether list component includes links */
        this.hasNavigation = false;
        /** Whether the list is used inside Settings Dialog */
        this.settingsList = input(false, { transform: booleanAttribute });
        /** Whether the list is used inside Settings Dialog Footer */
        this.settingsListFooter = input(false, { transform: booleanAttribute });
        /**
         * @hidden
         * Default role for lists
         */
        this._defaultRole = 'list';
        /** An RxJS Subject that will kill the data stream upon queryList changes (for unsubscribing)  */
        this._onRefresh$ = new Subject();
        /** An RxJS Subject that will kill the data stream upon component’s destruction (for unsubscribing)  */
        this._destroyRef = inject(DestroyRef);
        _contentDensityObserver.subscribe();
    }
    /** @hidden */
    keyDownHandler(event) {
        if (this.keyboardSupport) {
            this._keyboardSupportService.onKeyDown(event);
        }
    }
    /** @hidden */
    ngOnInit() {
        this._listenOnListFocusEscape();
    }
    /** @hidden */
    ngAfterContentInit() {
        this._keyboardSupportService.setKeyboardService(this._focusItems, false, false);
        this._listenOnQueryChange();
    }
    /** @hidden */
    ngOnDestroy() {
        this._onRefresh$.next();
        this._onRefresh$.complete();
    }
    /** Set fake focus on element with passed index */
    setItemActive(index, updateOnly = false) {
        if (updateOnly) {
            this._keyboardSupportService.keyManager.updateActiveItem(index);
        }
        else {
            this._keyboardSupportService.keyManager.setActiveItem(index);
        }
    }
    /**
     * @returns Currently active list item.
     */
    getActiveItem() {
        return this._keyboardSupportService.keyManager.activeItem;
    }
    /** @hidden */
    _listenOnQueryChange() {
        this._focusItems.changes.pipe(startWith(0), takeUntilDestroyed(this._destroyRef)).subscribe(() => {
            this._recheckLinks();
            this._listenOnItemsClick();
            setTimeout(() => {
                // using setTimeout to avoid ExpressionChangedAfterItHasBeenCheckedError
                this.updateItemsProperties();
            });
        });
    }
    /** @hidden */
    _listenOnItemsClick() {
        /** Finish all the streams, from before */
        this._onRefresh$.next();
        if (!this.keyboardSupport) {
            return;
        }
        /** Merge refresh/destroy observables */
        const completion$ = merge(this._onRefresh$, destroyObservable(this._destroyRef));
        const interactionChangesIndexes = this._focusItems.map((item, index) => merge(item._clicked$.pipe(map(() => ({ index, updateOnly: false }))), item._focused$.pipe(map(({ focusedWithin }) => ({ index, updateOnly: focusedWithin })))));
        merge(...interactionChangesIndexes)
            .pipe(takeUntil(completion$))
            .subscribe(({ index, updateOnly }) => this.setItemActive(index, updateOnly));
    }
    /** @hidden */
    updateItemsProperties() {
        let closestListHeader = null;
        this._focusItems.forEach((item, index) => {
            if (item instanceof ListGroupHeaderDirective) {
                closestListHeader = item;
            }
            else if (item instanceof ListItemComponent && closestListHeader) {
                item._relatedGroupHeaderId = closestListHeader.nativeElementId;
            }
            item.setIsFirst(index === 0);
        });
    }
    /** @hidden */
    _recheckLinks() {
        const items = this.items.filter((item) => item.link);
        this.hasNavigation = items.length > 0;
        if (this.selection) {
            this._defaultRole = 'listbox';
        }
    }
    /** @hidden */
    _listenOnListFocusEscape() {
        this._keyboardSupportService.focusEscapeList
            .pipe(takeUntilDestroyed(this._destroyRef))
            .subscribe((direction) => this.focusEscapeList.emit(direction));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListComponent, deps: [{ token: i1$1.KeyboardSupportService }, { token: i2.ContentDensityObserver }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "20.0.2", type: ListComponent, isStandalone: true, selector: "[fd-list], [fdList]", inputs: { dropdownMode: { classPropertyName: "dropdownMode", publicName: "dropdownMode", isSignal: false, isRequired: false, transformFunction: null }, multiInputMode: { classPropertyName: "multiInputMode", publicName: "multiInputMode", isSignal: false, isRequired: false, transformFunction: null }, mobileMode: { classPropertyName: "mobileMode", publicName: "mobileMode", isSignal: false, isRequired: false, transformFunction: null }, hasMessage: { classPropertyName: "hasMessage", publicName: "hasMessage", isSignal: false, isRequired: false, transformFunction: null }, noBorder: { classPropertyName: "noBorder", publicName: "noBorder", isSignal: false, isRequired: false, transformFunction: null }, navigationIndicator: { classPropertyName: "navigationIndicator", publicName: "navigationIndicator", isSignal: false, isRequired: false, transformFunction: null }, selection: { classPropertyName: "selection", publicName: "selection", isSignal: false, isRequired: false, transformFunction: null }, keyboardSupport: { classPropertyName: "keyboardSupport", publicName: "keyboardSupport", isSignal: false, isRequired: false, transformFunction: null }, byline: { classPropertyName: "byline", publicName: "byline", isSignal: false, isRequired: false, transformFunction: null }, subline: { classPropertyName: "subline", publicName: "subline", isSignal: false, isRequired: false, transformFunction: null }, unreadIndicator: { classPropertyName: "unreadIndicator", publicName: "unreadIndicator", isSignal: false, isRequired: false, transformFunction: null }, role: { classPropertyName: "role", publicName: "role", isSignal: false, isRequired: false, transformFunction: null }, settingsList: { classPropertyName: "settingsList", publicName: "settingsList", isSignal: true, isRequired: false, transformFunction: null }, settingsListFooter: { classPropertyName: "settingsListFooter", publicName: "settingsListFooter", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { focusEscapeList: "focusEscapeList" }, host: { listeners: { "keydown": "keyDownHandler($event)" }, properties: { "class.fd-settings__list": "settingsList() || settingsListFooter()", "class.fd-settings__list--footer": "settingsListFooter()", "class.fd-list--dropdown": "this.dropdownMode", "class.fd-list--multi-input": "this.multiInputMode", "class.fd-list--mobile": "this.mobileMode", "class.fd-list--has-message": "this.hasMessage", "class.fd-list--no-border": "this.noBorder", "class.fd-list--navigation-indication": "this.navigationIndicator", "class.fd-list--selection": "this.selection", "class.fd-list--byline": "this.byline", "class.fd-list--subline": "this.subline", "class.fd-list--unread-indicator": "this.unreadIndicator", "class.fd-list--navigation": "this.hasNavigation", "attr.role": "this._ariaRole" }, classAttribute: "fd-list" }, providers: [
            KeyboardSupportService,
            contentDensityObserverProviders(),
            {
                provide: FD_LIST_COMPONENT,
                useExisting: ListComponent
            },
            {
                provide: FD_LIST_UNREAD_INDICATOR,
                useExisting: ListComponent
            }
        ], queries: [{ propertyName: "items", predicate: LIST_ITEM_COMPONENT }, { propertyName: "_navItems", predicate: ListNavigationItemComponent }, { propertyName: "_focusItems", predicate: ListFocusItem }], ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, styles: [".fd-list{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;list-style:none;margin-block:0;margin-inline:0;max-width:100%!important;padding-block:0;padding-inline:0;position:relative;width:100%}.fd-list:after,.fd-list:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__footer,.fd-list__group-header,.fd-list__item{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;padding-block:0;padding-inline:.9375rem}.fd-list__footer:after,.fd-list__footer:before,.fd-list__group-header:after,.fd-list__group-header:before,.fd-list__item:after,.fd-list__item:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__item{background:var(--fdList_Item_Background_Color);border-bottom:var(--sapList_BorderWidth) solid var(--fdList_Item_Border_Color);height:var(--fdList_Item_Height);position:relative}.fd-list__item.is-focus,.fd-list__item:focus{outline:none;pointer-events:all}.fd-list__item.is-focus:before,.fd-list__item:focus:before{border:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);content:\"\";display:block;inset:.125rem .125rem .0625rem;pointer-events:none;position:absolute}.fd-list__item.is-focus.is-active:before,.fd-list__item.is-focus:active:before,.fd-list__item:focus.is-active:before,.fd-list__item:focus:active:before{border:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdList_Active_Outline_Color)}.fd-list__item .fd-avatar:first-child{-webkit-margin-end:.75rem;margin-inline-end:.75rem}.fd-list__item--unread .fd-list__title{font-weight:700}.fd-list__item--no-data .fd-list__title{text-align:center}.fd-list__item--interactive,.fd-list__item--interractive{cursor:pointer}.fd-list__item--interactive.is-hover,.fd-list__item--interactive:hover,.fd-list__item--interractive.is-hover,.fd-list__item--interractive:hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor)}.fd-list__item--interactive.is-selected,.fd-list__item--interactive[aria-selected=true],.fd-list__item--interractive.is-selected,.fd-list__item--interractive[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list__item--interactive.is-selected .fd-list__link,.fd-list__item--interactive[aria-selected=true] .fd-list__link,.fd-list__item--interractive.is-selected .fd-list__link,.fd-list__item--interractive[aria-selected=true] .fd-list__link{background:inherit}.fd-list__item--interactive.is-selected .fd-list__link.is-active,.fd-list__item--interactive.is-selected .fd-list__link:active,.fd-list__item--interactive[aria-selected=true] .fd-list__link.is-active,.fd-list__item--interactive[aria-selected=true] .fd-list__link:active,.fd-list__item--interractive.is-selected .fd-list__link.is-active,.fd-list__item--interractive.is-selected .fd-list__link:active,.fd-list__item--interractive[aria-selected=true] .fd-list__link.is-active,.fd-list__item--interractive[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list__item--interactive.is-selected.is-hover,.fd-list__item--interactive.is-selected:hover,.fd-list__item--interactive[aria-selected=true].is-hover,.fd-list__item--interactive[aria-selected=true]:hover,.fd-list__item--interractive.is-selected.is-hover,.fd-list__item--interractive.is-selected:hover,.fd-list__item--interractive[aria-selected=true].is-hover,.fd-list__item--interractive[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list__item--interactive.is-active,.fd-list__item--interactive.is-active.is-hover,.fd-list__item--interactive.is-active.is-selected,.fd-list__item--interactive.is-active.is-selected.is-hover,.fd-list__item--interactive.is-active.is-selected:hover,.fd-list__item--interactive.is-active:hover,.fd-list__item--interactive.is-active[aria-selected=true],.fd-list__item--interactive.is-active[aria-selected=true].is-hover,.fd-list__item--interactive.is-active[aria-selected=true]:hover,.fd-list__item--interactive:active,.fd-list__item--interactive:active.is-hover,.fd-list__item--interactive:active.is-selected,.fd-list__item--interactive:active.is-selected.is-hover,.fd-list__item--interactive:active.is-selected:hover,.fd-list__item--interactive:active:hover,.fd-list__item--interactive:active[aria-selected=true],.fd-list__item--interactive:active[aria-selected=true].is-hover,.fd-list__item--interactive:active[aria-selected=true]:hover,.fd-list__item--interractive.is-active,.fd-list__item--interractive.is-active.is-hover,.fd-list__item--interractive.is-active.is-selected,.fd-list__item--interractive.is-active.is-selected.is-hover,.fd-list__item--interractive.is-active.is-selected:hover,.fd-list__item--interractive.is-active:hover,.fd-list__item--interractive.is-active[aria-selected=true],.fd-list__item--interractive.is-active[aria-selected=true].is-hover,.fd-list__item--interractive.is-active[aria-selected=true]:hover,.fd-list__item--interractive:active,.fd-list__item--interractive:active.is-hover,.fd-list__item--interractive:active.is-selected,.fd-list__item--interractive:active.is-selected.is-hover,.fd-list__item--interractive:active.is-selected:hover,.fd-list__item--interractive:active:hover,.fd-list__item--interractive:active[aria-selected=true],.fd-list__item--interractive:active[aria-selected=true].is-hover,.fd-list__item--interractive:active[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Active_Background);--fdList_Item_Text_Color:var(--sapList_Active_TextColor);--fdList_Item_Border_Color:var(--sapList_Active_Background)}.fd-list__item--interactive.is-active,.fd-list__item--interactive.is-active .fd-list__byline,.fd-list__item--interactive.is-active .fd-list__byline-left,.fd-list__item--interactive.is-active .fd-list__byline-right,.fd-list__item--interactive.is-active .fd-list__byline-right--critical,.fd-list__item--interactive.is-active .fd-list__byline-right--informative,.fd-list__item--interactive.is-active .fd-list__byline-right--negative,.fd-list__item--interactive.is-active .fd-list__byline-right--neutral,.fd-list__item--interactive.is-active .fd-list__byline-right--positive,.fd-list__item--interactive.is-active .fd-list__content,.fd-list__item--interactive.is-active .fd-list__icon,.fd-list__item--interactive.is-active .fd-list__secondary,.fd-list__item--interactive.is-active .fd-list__thumbnail,.fd-list__item--interactive.is-active .fd-list__title,.fd-list__item--interactive.is-active.fd-list__link--navigation-indicator:after,.fd-list__item--interactive:active,.fd-list__item--interactive:active .fd-list__byline,.fd-list__item--interactive:active .fd-list__byline-left,.fd-list__item--interactive:active .fd-list__byline-right,.fd-list__item--interactive:active .fd-list__byline-right--critical,.fd-list__item--interactive:active .fd-list__byline-right--informative,.fd-list__item--interactive:active .fd-list__byline-right--negative,.fd-list__item--interactive:active .fd-list__byline-right--neutral,.fd-list__item--interactive:active .fd-list__byline-right--positive,.fd-list__item--interactive:active .fd-list__content,.fd-list__item--interactive:active .fd-list__icon,.fd-list__item--interactive:active .fd-list__secondary,.fd-list__item--interactive:active .fd-list__thumbnail,.fd-list__item--interactive:active .fd-list__title,.fd-list__item--interactive:active.fd-list__link--navigation-indicator:after,.fd-list__item--interractive.is-active,.fd-list__item--interractive.is-active .fd-list__byline,.fd-list__item--interractive.is-active .fd-list__byline-left,.fd-list__item--interractive.is-active .fd-list__byline-right,.fd-list__item--interractive.is-active .fd-list__byline-right--critical,.fd-list__item--interractive.is-active .fd-list__byline-right--informative,.fd-list__item--interractive.is-active .fd-list__byline-right--negative,.fd-list__item--interractive.is-active .fd-list__byline-right--neutral,.fd-list__item--interractive.is-active .fd-list__byline-right--positive,.fd-list__item--interractive.is-active .fd-list__content,.fd-list__item--interractive.is-active .fd-list__icon,.fd-list__item--interractive.is-active .fd-list__secondary,.fd-list__item--interractive.is-active .fd-list__thumbnail,.fd-list__item--interractive.is-active .fd-list__title,.fd-list__item--interractive.is-active.fd-list__link--navigation-indicator:after,.fd-list__item--interractive:active,.fd-list__item--interractive:active .fd-list__byline,.fd-list__item--interractive:active .fd-list__byline-left,.fd-list__item--interractive:active .fd-list__byline-right,.fd-list__item--interractive:active .fd-list__byline-right--critical,.fd-list__item--interractive:active .fd-list__byline-right--informative,.fd-list__item--interractive:active .fd-list__byline-right--negative,.fd-list__item--interractive:active .fd-list__byline-right--neutral,.fd-list__item--interractive:active .fd-list__byline-right--positive,.fd-list__item--interractive:active .fd-list__content,.fd-list__item--interractive:active .fd-list__icon,.fd-list__item--interractive:active .fd-list__secondary,.fd-list__item--interractive:active .fd-list__thumbnail,.fd-list__item--interractive:active .fd-list__title,.fd-list__item--interractive:active.fd-list__link--navigation-indicator:after{text-shadow:none}.fd-list__item--action{border-bottom:var(--fdList_Item_Action_Border);font-size:var(--sapFontSize);padding-block:0;padding-inline:0;text-align:center;--fdList_Item_Height:var(--sapElement_LineHeight)}.fd-list__item--action:first-child{border-top:var(--fdList_Item_Action_Border)}.fd-list__item--action .fd-list__title{background:transparent;border:var(--fdList_Item_Action_Button_Border);border-radius:var(--fdList_Item_Action_Button_Border_Radius);color:var(--sapButton_TextColor);cursor:pointer;height:var(--fdList_Item_Action_Button_Size);margin-block:var(--fdList_Item_Action_Button_Spacing);margin-inline:var(--fdList_Item_Action_Button_Spacing);padding-block:0;padding-inline:.9375rem;pointer-events:all;width:100%}.fd-list__item--action .fd-list__title.is-hover,.fd-list__item--action .fd-list__title:hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor)}.fd-list__item--action .fd-list__title.is-selected,.fd-list__item--action .fd-list__title[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list__item--action .fd-list__title.is-selected .fd-list__link,.fd-list__item--action .fd-list__title[aria-selected=true] .fd-list__link{background:inherit}.fd-list__item--action .fd-list__title.is-selected .fd-list__link.is-active,.fd-list__item--action .fd-list__title.is-selected .fd-list__link:active,.fd-list__item--action .fd-list__title[aria-selected=true] .fd-list__link.is-active,.fd-list__item--action .fd-list__title[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list__item--action .fd-list__title.is-selected.is-hover,.fd-list__item--action .fd-list__title.is-selected:hover,.fd-list__item--action .fd-list__title[aria-selected=true].is-hover,.fd-list__item--action .fd-list__title[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list__item--action .fd-list__title.is-active,.fd-list__item--action .fd-list__title.is-active.is-hover,.fd-list__item--action .fd-list__title.is-active.is-selected,.fd-list__item--action .fd-list__title.is-active.is-selected.is-hover,.fd-list__item--action .fd-list__title.is-active.is-selected:hover,.fd-list__item--action .fd-list__title.is-active:hover,.fd-list__item--action .fd-list__title.is-active[aria-selected=true],.fd-list__item--action .fd-list__title.is-active[aria-selected=true].is-hover,.fd-list__item--action .fd-list__title.is-active[aria-selected=true]:hover,.fd-list__item--action .fd-list__title:active,.fd-list__item--action .fd-list__title:active.is-hover,.fd-list__item--action .fd-list__title:active.is-selected,.fd-list__item--action .fd-list__title:active.is-selected.is-hover,.fd-list__item--action .fd-list__title:active.is-selected:hover,.fd-list__item--action .fd-list__title:active:hover,.fd-list__item--action .fd-list__title:active[aria-selected=true],.fd-list__item--action .fd-list__title:active[aria-selected=true].is-hover,.fd-list__item--action .fd-list__title:active[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Active_Background);--fdList_Item_Text_Color:var(--sapList_Active_TextColor);--fdList_Item_Border_Color:var(--sapList_Active_Background)}.fd-list__item--action .fd-list__title.is-active,.fd-list__item--action .fd-list__title.is-active .fd-list__byline,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-left,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right--critical,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right--informative,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right--negative,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right--neutral,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right--positive,.fd-list__item--action .fd-list__title.is-active .fd-list__content,.fd-list__item--action .fd-list__title.is-active .fd-list__icon,.fd-list__item--action .fd-list__title.is-active .fd-list__secondary,.fd-list__item--action .fd-list__title.is-active .fd-list__thumbnail,.fd-list__item--action .fd-list__title.is-active .fd-list__title,.fd-list__item--action .fd-list__title.is-active.fd-list__link--navigation-indicator:after,.fd-list__item--action .fd-list__title:active,.fd-list__item--action .fd-list__title:active .fd-list__byline,.fd-list__item--action .fd-list__title:active .fd-list__byline-left,.fd-list__item--action .fd-list__title:active .fd-list__byline-right,.fd-list__item--action .fd-list__title:active .fd-list__byline-right--critical,.fd-list__item--action .fd-list__title:active .fd-list__byline-right--informative,.fd-list__item--action .fd-list__title:active .fd-list__byline-right--negative,.fd-list__item--action .fd-list__title:active .fd-list__byline-right--neutral,.fd-list__item--action .fd-list__title:active .fd-list__byline-right--positive,.fd-list__item--action .fd-list__title:active .fd-list__content,.fd-list__item--action .fd-list__title:active .fd-list__icon,.fd-list__item--action .fd-list__title:active .fd-list__secondary,.fd-list__item--action .fd-list__title:active .fd-list__thumbnail,.fd-list__item--action .fd-list__title:active .fd-list__title,.fd-list__item--action .fd-list__title:active.fd-list__link--navigation-indicator:after{text-shadow:none}.fd-list__item--action .fd-list__title.is-focus,.fd-list__item--action .fd-list__title:focus{outline:var(--sapContent_FocusColor) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:-.125rem}.fd-list__item--action .fd-list__title.is-focus.is-active,.fd-list__item--action .fd-list__title.is-focus:active,.fd-list__item--action .fd-list__title:focus.is-active,.fd-list__item--action .fd-list__title:focus:active{outline-color:var(--fdList_Active_Outline_Color)}.fd-list__item--action .fd-list__title::-moz-focus-inner{border:0}.fd-list__item--growing{--fdList_Item_Height:var(--sapElement_LineHeight)}.fd-list__item--growing .fd-list__title{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;gap:.5rem}.fd-list__item--growing .fd-list__title-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:inherit;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;font-weight:var(--fdList_Growing_Font_Weight);forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;text-shadow:inherit;white-space:nowrap}.fd-list__item--growing .fd-list__title-text:after,.fd-list__item--growing .fd-list__title-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__item--inactive,.fd-list__item--inactive .fd-list__secondary,.fd-list__item--inactive .fd-list__title{pointer-events:none}.fd-list__item.is-selected,.fd-list__item[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list__item.is-selected .fd-list__link,.fd-list__item[aria-selected=true] .fd-list__link{background:inherit}.fd-list__item.is-selected .fd-list__link.is-active,.fd-list__item.is-selected .fd-list__link:active,.fd-list__item[aria-selected=true] .fd-list__link.is-active,.fd-list__item[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list__item.is-selected.is-hover,.fd-list__item.is-selected:hover,.fd-list__item[aria-selected=true].is-hover,.fd-list__item[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list__secondary,.fd-list__title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--fdList_Item_Text_Color);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;pointer-events:none;pointer-events:all;text-overflow:ellipsis;white-space:nowrap}.fd-list__secondary:after,.fd-list__secondary:before,.fd-list__title:after,.fd-list__title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__title{-webkit-box-flex:3;-ms-flex:3 3 10%;flex:3 3 10%;font-size:var(--fdList_Item_Text_Font_Size);min-height:var(--fdList_Item_Text_Font_Size)}.fd-list__title:last-child:first-child{-ms-flex-preferred-size:auto;flex-basis:auto}.fd-list__title .fd-list__title-text{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-list__title~.fd-list__icon{-webkit-margin-end:-1rem;margin-inline-end:-1rem}.fd-list__secondary{color:var(--fdList_Status_Text_Color);font-size:var(--sapFontSize);max-width:40%;text-align:right;-webkit-padding-start:1rem;padding-inline-start:1rem}.fd-list__secondary--positive{--fdList_Status_Text_Color:var(--sapPositiveTextColor)}.fd-list__secondary--critical{--fdList_Status_Text_Color:var(--sapCriticalTextColor)}.fd-list__secondary--negative{--fdList_Status_Text_Color:var(--sapNegativeTextColor)}.fd-list__secondary--informative{--fdList_Status_Text_Color:var(--sapInformativeTextColor)}.fd-list__secondary[dir=rtl],[dir=rtl] .fd-list__secondary{text-align:left}.fd-list__icon [class*=sap-icon],.fd-list__icon[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;display:-webkit-box;display:-ms-flexbox;display:flex;font-size:inherit;line-height:1;pointer-events:none;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapContent_NonInteractiveIconColor);font-size:var(--fdList_Item_Icon_Font_Size);width:2.75rem;-webkit-box-flex:0;-ms-flex:0 0 auto;flex:0 0 auto}.fd-list__icon [class*=sap-icon]:first-child,.fd-list__icon[class*=sap-icon]:first-child{-webkit-margin-start:-1rem;margin-inline-start:-1rem}.fd-list__link{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;--fdList_Item_Border_Color:transparent;background:var(--fdList_Item_Background_Color);border-bottom:var(--sapList_BorderWidth) solid var(--fdList_Item_Border_Color);cursor:pointer;height:100%;padding-block:0;padding-inline:.9375rem;text-decoration:none;width:100%}.fd-list__link:after,.fd-list__link:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__link.is-focus,.fd-list__link:focus{outline:none;pointer-events:all}.fd-list__link.is-focus:before,.fd-list__link:focus:before{border:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);content:\"\";display:block;inset:.125rem;pointer-events:none;position:absolute}.fd-list__link.is-focus.is-active:before,.fd-list__link.is-focus:active:before,.fd-list__link:focus.is-active:before,.fd-list__link:focus:active:before{border:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdList_Active_Outline_Color)}.fd-list__link.is-hover,.fd-list__link:hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor)}.fd-list__link.is-selected,.fd-list__link[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list__link.is-selected .fd-list__link,.fd-list__link[aria-selected=true] .fd-list__link{background:inherit}.fd-list__link.is-selected .fd-list__link.is-active,.fd-list__link.is-selected .fd-list__link:active,.fd-list__link[aria-selected=true] .fd-list__link.is-active,.fd-list__link[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list__link.is-selected.is-hover,.fd-list__link.is-selected:hover,.fd-list__link[aria-selected=true].is-hover,.fd-list__link[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list__link.is-active,.fd-list__link.is-active.is-hover,.fd-list__link.is-active.is-selected,.fd-list__link.is-active.is-selected.is-hover,.fd-list__link.is-active.is-selected:hover,.fd-list__link.is-active:hover,.fd-list__link.is-active[aria-selected=true],.fd-list__link.is-active[aria-selected=true].is-hover,.fd-list__link.is-active[aria-selected=true]:hover,.fd-list__link:active,.fd-list__link:active.is-hover,.fd-list__link:active.is-selected,.fd-list__link:active.is-selected.is-hover,.fd-list__link:active.is-selected:hover,.fd-list__link:active:hover,.fd-list__link:active[aria-selected=true],.fd-list__link:active[aria-selected=true].is-hover,.fd-list__link:active[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Active_Background);--fdList_Item_Text_Color:var(--sapList_Active_TextColor);--fdList_Item_Border_Color:var(--sapList_Active_Background)}.fd-list__link.is-active,.fd-list__link.is-active .fd-list__byline,.fd-list__link.is-active .fd-list__byline-left,.fd-list__link.is-active .fd-list__byline-right,.fd-list__link.is-active .fd-list__byline-right--critical,.fd-list__link.is-active .fd-list__byline-right--informative,.fd-list__link.is-active .fd-list__byline-right--negative,.fd-list__link.is-active .fd-list__byline-right--neutral,.fd-list__link.is-active .fd-list__byline-right--positive,.fd-list__link.is-active .fd-list__content,.fd-list__link.is-active .fd-list__icon,.fd-list__link.is-active .fd-list__secondary,.fd-list__link.is-active .fd-list__thumbnail,.fd-list__link.is-active .fd-list__title,.fd-list__link.is-active.fd-list__link--navigation-indicator:after,.fd-list__link:active,.fd-list__link:active .fd-list__byline,.fd-list__link:active .fd-list__byline-left,.fd-list__link:active .fd-list__byline-right,.fd-list__link:active .fd-list__byline-right--critical,.fd-list__link:active .fd-list__byline-right--informative,.fd-list__link:active .fd-list__byline-right--negative,.fd-list__link:active .fd-list__byline-right--neutral,.fd-list__link:active .fd-list__byline-right--positive,.fd-list__link:active .fd-list__content,.fd-list__link:active .fd-list__icon,.fd-list__link:active .fd-list__secondary,.fd-list__link:active .fd-list__thumbnail,.fd-list__link:active .fd-list__title,.fd-list__link:active.fd-list__link--navigation-indicator:after{text-shadow:none}.fd-list__group-header{background:var(--sapList_GroupHeaderBackground);border-bottom:var(--sapList_BorderWidth) solid var(--sapList_GroupHeaderBorderColor);height:var(--sapElement_LineHeight);-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end}.fd-list__group-header .fd-list__title{color:var(--sapList_TableGroupHeaderTextColor);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontHeader6Size);font-weight:700;line-height:2rem;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-list__footer{background:var(--sapList_FooterBackground);color:var(--sapList_FooterTextColor);font-size:var(--sapFontSize);height:2rem}.fd-list__footer--right{-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end}.fd-list__footer--left{-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start}.fd-list__bold{font-weight:700}.fd-list__message{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:2rem;left:0;line-height:normal;line-height:2rem;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;position:absolute;text-overflow:ellipsis;top:0;white-space:nowrap;width:100%;-webkit-padding-start:.5rem;background-color:var(--fdList_Message_Background_Color);font-size:var(--sapFontSmallSize);padding-inline-start:.5rem}.fd-list__message:after,.fd-list__message:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__message--error{--fdList_Message_Background_Color:var(--sapErrorBackground)}.fd-list__message--warning{--fdList_Message_Background_Color:var(--sapWarningBackground)}.fd-list__message--success{--fdList_Message_Background_Color:var(--sapSuccessBackground)}.fd-list__message--information{--fdList_Message_Background_Color:var(--sapInformationBackground)}.fd-list .fd-list__button{-webkit-margin-start:var(--fdList_Button_Spacing);margin-inline-start:var(--fdList_Button_Spacing);-ms-flex-item-align:center;align-self:center}.fd-list[class*=-compact]:not(.fd-object-list):not(.fd-list--message-view),.fd-list[class*=-condensed]:not(.fd-object-list):not(.fd-list--message-view),[class*=-compact] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view),[class*=-condensed] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view){--fdList_Item_Icon_Font_Size:1rem;--fdList_Item_Text_Font_Size:var(--sapFontSize);--fdList_Item_Height:var(--sapElement_Compact_LineHeight)}.fd-list[class*=-compact]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item--growing,.fd-list[class*=-condensed]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item--growing,[class*=-compact] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item--growing,[class*=-condensed] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item--growing{--fdList_Item_Height:var(--sapElement_LineHeight)}.fd-list[class*=-compact]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action,.fd-list[class*=-condensed]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action,[class*=-compact] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action,[class*=-condensed] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action{--fdList_Item_Height:var(--sapElement_Compact_LineHeight)}.fd-list[class*=-compact]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action .fd-list__title,.fd-list[class*=-condensed]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action .fd-list__title,[class*=-compact] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action .fd-list__title,[class*=-condensed] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action .fd-list__title{height:var(--fdList_Item_Action_Button_Size_Compact)}.fd-list--no-border .fd-list__group-header,.fd-list--no-border .fd-list__item{border-bottom:0;border-top:0}.fd-list--no-border .fd-list__item.is-selected,.fd-list--no-border .fd-list__item[aria-selected=true]{border-bottom:var(--sapList_BorderWidth) solid var(--sapList_SelectionBorderColor)}.fd-list--has-message{-webkit-padding-before:2rem;padding-block-start:2rem}.fd-list__infinite-scroll{outline:none;overflow:scroll}.fd-list--dropdown.is-focus,.fd-list--dropdown:focus{outline:none;z-index:5}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header){display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;cursor:pointer;height:auto;min-height:2.5rem;padding-block:0;padding-inline:.9375rem}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor)}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected .fd-list__link,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true] .fd-list__link{background:inherit}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected .fd-list__link.is-active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected .fd-list__link:active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true] .fd-list__link.is-active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected.is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true].is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active.is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active.is-selected,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active.is-selected.is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active.is-selected:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active[aria-selected=true],.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active[aria-selected=true].is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active[aria-selected=true]:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active.is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active.is-selected,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active.is-selected.is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active.is-selected:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active[aria-selected=true],.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active[aria-selected=true].is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Active_Background);--fdList_Item_Text_Color:var(--sapList_Active_TextColor);--fdList_Item_Border_Color:var(--sapList_Active_Background)}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-left,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right--critical,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right--informative,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right--negative,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right--neutral,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right--positive,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__content,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__icon,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__secondary,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__thumbnail,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__title,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active.fd-list__link--navigation-indicator:after,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-left,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right--critical,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right--informative,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right--negative,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right--neutral,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right--positive,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__content,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__icon,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__secondary,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__thumbnail,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__title,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active.fd-list__link--navigation-indicator:after{text-shadow:none}.fd-list--dropdown[class*=-compact] .fd-list__item:not(.fd-list__group-header),.fd-list--dropdown[class*=-condensed] .fd-list__item:not(.fd-list__group-header),[class*=-compact] .fd-list--dropdown:not([class*=-cozy]) .fd-list__item:not(.fd-list__group-header),[class*=-condensed] .fd-list--dropdown:not([class*=-cozy]) .fd-list__item:not(.fd-list__group-header){height:auto;min-height:2rem;padding-block:0;padding-inline:.9375rem}.fd-list--multi-input .fd-list__item{cursor:pointer;height:auto;padding-block:0;padding-inline:0 1rem}.fd-list--multi-input .fd-list__item.is-hover,.fd-list--multi-input .fd-list__item:hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor)}.fd-list--multi-input .fd-list__item.is-selected,.fd-list--multi-input .fd-list__item[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list--multi-input .fd-list__item.is-selected .fd-list__link,.fd-list--multi-input .fd-list__item[aria-selected=true] .fd-list__link{background:inherit}.fd-list--multi-input .fd-list__item.is-selected .fd-list__link.is-active,.fd-list--multi-input .fd-list__item.is-selected .fd-list__link:active,.fd-list--multi-input .fd-list__item[aria-selected=true] .fd-list__link.is-active,.fd-list--multi-input .fd-list__item[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list--multi-input .fd-list__item.is-selected.is-hover,.fd-list--multi-input .fd-list__item.is-selected:hover,.fd-list--multi-input .fd-list__item[aria-selected=true].is-hover,.fd-list--multi-input .fd-list__item[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list--multi-input .fd-list__item.is-active,.fd-list--multi-input .fd-list__item.is-active.is-hover,.fd-list--multi-input .fd-list__item.is-active.is-selected,.fd-list--multi-input .fd-list__item.is-active.is-selected.is-hover,.fd-list--multi-input .fd-list__item.is-active.is-selected:hover,.fd-list--multi-input .fd-list__item.is-active:hover,.fd-list--multi-input .fd-list__item.is-active[aria-selected=true],.fd-list--multi-input .fd-list__item.is-active[aria-selected=true].is-hover,.fd-list--multi-input .fd-list__item.is-active[aria-selected=true]:hover,.fd-list--multi-input .fd-list__item:active,.fd-list--multi-input .fd-list__item:active.is-hover,.fd-list--multi-input .fd-list__item:active.is-selected,.fd-list--multi-input .fd-list__item:active.is-selected.is-hover,.fd-list--multi-input .fd-list__item:active.is-selected:hover,.fd-list--multi-input .fd-list__item:active:hover,.fd-list--multi-input .fd-list__item:active[aria-selected=true],.fd-list--multi-input .fd-list__item:active[aria-selected=true].is-hover,.fd-list--multi-input .fd-list__item:active[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Active_Background);--fdList_Item_Text_Color:var(--sapList_Active_TextColor);--fdList_Item_Border_Color:var(--sapList_Active_Background)}.fd-list--multi-input .fd-list__item.is-active,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-left,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right--critical,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right--informative,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right--negative,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right--neutral,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right--positive,.fd-list--multi-input .fd-list__item.is-active .fd-list__content,.fd-list--multi-input .fd-list__item.is-active .fd-list__icon,.fd-list--multi-input .fd-list__item.is-active .fd-list__secondary,.fd-list--multi-input .fd-list__item.is-active .fd-list__thumbnail,.fd-list--multi-input .fd-list__item.is-active .fd-list__title,.fd-list--multi-input .fd-list__item.is-active.fd-list__link--navigation-indicator:after,.fd-list--multi-input .fd-list__item:active,.fd-list--multi-input .fd-list__item:active .fd-list__byline,.fd-list--multi-input .fd-list__item:active .fd-list__byline-left,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right--critical,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right--informative,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right--negative,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right--neutral,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right--positive,.fd-list--multi-input .fd-list__item:active .fd-list__content,.fd-list--multi-input .fd-list__item:active .fd-list__icon,.fd-list--multi-input .fd-list__item:active .fd-list__secondary,.fd-list--multi-input .fd-list__item:active .fd-list__thumbnail,.fd-list--multi-input .fd-list__item:active .fd-list__title,.fd-list--multi-input .fd-list__item:active.fd-list__link--navigation-indicator:after{text-shadow:none}.fd-list--multi-input .fd-list__label{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:inherit;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;position:relative;text-overflow:ellipsis;width:100%;-webkit-margin-end:0;margin-inline-end:0}.fd-list--multi-input .fd-list__label:after,.fd-list--multi-input .fd-list__label:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--multi-input .fd-list__label:before{margin-block:-.1875rem -.1875rem}.fd-list--multi-input .fd-list__input.is-focus,.fd-list--multi-input .fd-list__input:focus{-webkit-box-shadow:none;box-shadow:none;z-index:5}.fd-list--multi-input .fd-list__input.is-focus+.fd-list__label:after,.fd-list--multi-input .fd-list__input:focus+.fd-list__label:after{inset:.0625rem}.fd-list--multi-input .fd-list__footer{height:auto;text-align:right;-webkit-box-pack:end;-ms-flex-pack:end;background-color:var(--sapList_Background);justify-content:flex-end;line-height:1rem}.fd-list--multi-input .fd-list__footer,.fd-list--multi-input .fd-list__label{padding-block:.75rem;padding-inline:.9375rem}.fd-list--multi-input[class*=-compact] .fd-list__item,.fd-list--multi-input[class*=-condensed] .fd-list__item,[class*=-compact] .fd-list--multi-input:not([class*=-cozy]) .fd-list__item,[class*=-condensed] .fd-list--multi-input:not([class*=-cozy]) .fd-list__item{height:auto;padding-block:0;padding-inline:0}.fd-list--multi-input[class*=-compact] .fd-list__label:before,.fd-list--multi-input[class*=-condensed] .fd-list__label:before,[class*=-compact] .fd-list--multi-input:not([class*=-cozy]) .fd-list__label:before,[class*=-condensed] .fd-list--multi-input:not([class*=-cozy]) .fd-list__label:before{-webkit-margin-start:0;margin-inline-start:0;margin-top:0;-webkit-margin-after:0;margin-block-end:0}.fd-list--multi-input[class*=-compact] .fd-list__footer,.fd-list--multi-input[class*=-compact] .fd-list__label,.fd-list--multi-input[class*=-condensed] .fd-list__footer,.fd-list--multi-input[class*=-condensed] .fd-list__label,[class*=-compact] .fd-list--multi-input:not([class*=-cozy]) .fd-list__footer,[class*=-compact] .fd-list--multi-input:not([class*=-cozy]) .fd-list__label,[class*=-condensed] .fd-list--multi-input:not([class*=-cozy]) .fd-list__footer,[class*=-condensed] .fd-list--multi-input:not([class*=-cozy]) .fd-list__label{padding-block:.5rem;padding-inline:.9375rem}.fd-list--dropdown,.fd-list--multi-input{display:block;max-width:40rem;min-width:5rem}.fd-list--dropdown .fd-list__item,.fd-list--multi-input .fd-list__item{border:none;cursor:pointer}.fd-list--dropdown .fd-list__item.is-selected,.fd-list--dropdown .fd-list__item[aria-selected=true],.fd-list--multi-input .fd-list__item.is-selected,.fd-list--multi-input .fd-list__item[aria-selected=true]{border-bottom:var(--sapList_BorderWidth) solid var(--sapList_SelectionBorderColor)}.fd-list--dropdown .fd-list__secondary,.fd-list--dropdown .fd-list__title,.fd-list--multi-input .fd-list__secondary,.fd-list--multi-input .fd-list__title{font-size:var(--sapFontSize);white-space:normal;-webkit-box-flex:1;-ms-flex:auto;flex:auto;width:auto}.fd-list--dropdown .fd-list__secondary--no-wrap,.fd-list--dropdown .fd-list__title--no-wrap,.fd-list--multi-input .fd-list__secondary--no-wrap,.fd-list--multi-input .fd-list__title--no-wrap{white-space:nowrap}.fd-list--dropdown .fd-list__secondary,.fd-list--multi-input .fd-list__secondary{display:block}.fd-list--dropdown .fd-list__title,.fd-list--multi-input .fd-list__title{max-width:24rem}.fd-list--dropdown .fd-list__title:first-child:last-child,.fd-list--multi-input .fd-list__title:first-child:last-child{max-width:40rem}.fd-list--dropdown .fd-list__secondary,.fd-list--multi-input .fd-list__secondary{max-width:16rem}.fd-list--dropdown.fd-list--mobile,.fd-list--multi-input.fd-list--mobile{max-width:100%}.fd-list--dropdown .fd-list__icon,.fd-list--multi-input .fd-list__icon{line-height:1rem}.fd-list--dropdown.fd-list--large-dropdown,.fd-list--multi-input.fd-list--large-dropdown{max-width:62rem}.fd-list--dropdown.fd-list--large-dropdown .fd-list__title,.fd-list--multi-input.fd-list--large-dropdown .fd-list__title{max-width:37.2rem}.fd-list--dropdown.fd-list--large-dropdown .fd-list__title:first-child:last-child,.fd-list--multi-input.fd-list--large-dropdown .fd-list__title:first-child:last-child{max-width:62rem}.fd-list--dropdown.fd-list--large-dropdown .fd-list__secondary,.fd-list--multi-input.fd-list--large-dropdown .fd-list__secondary{max-width:24.8rem}.fd-list--dropdown.fd-list--large-dropdown.fd-list--mobile,.fd-list--multi-input.fd-list--large-dropdown.fd-list--mobile{max-width:100%}.fd-list--byline .fd-list__item{height:auto;min-height:5rem;padding-block:.9375rem;padding-inline:1rem;width:100%;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start}.fd-list--byline .fd-list__item.is-focus,.fd-list--byline .fd-list__item:focus{pointer-events:all;z-index:5}.fd-list--byline .fd-list__item .fd-list__item-counter{-ms-flex-align:center;-ms-flex-item-align:center;align-self:center;-webkit-box-pack:end;-ms-flex-pack:end;height:100%;justify-content:flex-end;min-width:2rem}.fd-list--byline .fd-list__item .fd-list__item-counter,.fd-list--byline .fd-list__thumbnail{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;align-items:center}.fd-list--byline .fd-list__thumbnail{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;pointer-events:none;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-ms-flex-align:center;-webkit-margin-end:.75rem;border-radius:.25rem;color:var(--sapContent_NonInteractiveIconColor);font-size:2rem;height:3rem;margin-inline-end:.75rem;max-height:3rem;max-width:3rem;min-height:3rem;min-width:3rem;width:3rem}.fd-list--byline .fd-list__thumbnail:after,.fd-list--byline .fd-list__thumbnail:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--byline .fd-list__thumbnail [class*=sap-icon],.fd-list--byline .fd-list__thumbnail[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;font-size:inherit;line-height:1}.fd-list--byline .fd-list__thumbnail>svg{height:100%}.fd-list--byline .fd-list__notification{color:var(--sapAccentColor6);font-size:.375rem;left:1rem;position:absolute;top:50%;-webkit-transform:translateY(-50%);transform:translateY(-50%)}.fd-list--byline .fd-list__notification[dir=rtl],[dir=rtl] .fd-list--byline .fd-list__notification{left:auto;right:1rem}.fd-list--byline .fd-list__notification+.fd-list__link .fd-list__content .fd-list__title,.fd-list--byline .fd-list__notification~.fd-list__content .fd-list__title{font-weight:700}.fd-list--byline .fd-list__content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;pointer-events:none;-ms-flex-line-pack:justify;align-content:space-between;height:100%;min-height:3rem;min-width:3rem;-webkit-box-flex:1;-ms-flex:1 1 auto;flex:1 1 auto;padding-block:.125rem;padding-inline:0}.fd-list--byline .fd-list__content:after,.fd-list--byline .fd-list__content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--byline .fd-list__title{font-size:var(--sapFontLargeSize);min-height:1rem;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-list--byline .fd-list__byline{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1rem;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap;-webkit-padding-before:.5rem;padding-block-start:.5rem}.fd-list--byline .fd-list__byline:after,.fd-list--byline .fd-list__byline:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--byline .fd-list__byline--2-col{display:-webkit-box;display:-ms-flexbox;display:flex;pointer-events:all}.fd-list--byline .fd-list__byline--wrap .fd-list__byline-left,.fd-list--byline .fd-list__byline--wrap .fd-list__byline-right{display:inline;padding-block:0;padding-inline:0;white-space:normal;width:100%}.fd-list--byline .fd-list__byline--wrap .fd-list__byline-right{float:right;width:auto}.fd-list--byline .fd-list__link--more{pointer-events:all;text-transform:capitalize}.fd-list--byline .fd-list__byline--wrap,.fd-list--byline .fd-list__title--wrap{white-space:normal}.fd-list--byline .fd-list__byline-left{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1rem;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap;width:60%;-ms-flex-item-align:end;align-self:flex-end;-webkit-padding-end:.5rem;padding-inline-end:.5rem}.fd-list--byline .fd-list__byline-left:after,.fd-list--byline .fd-list__byline-left:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--byline .fd-list__byline-right{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1rem;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-align:right;text-overflow:ellipsis;white-space:nowrap;width:40%;-ms-flex-item-align:end;align-self:flex-end;-webkit-padding-start:.5rem;padding-inline-start:.5rem}.fd-list--byline .fd-list__byline-right:after,.fd-list--byline .fd-list__byline-right:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--byline .fd-list__byline-right[dir=rtl],[dir=rtl] .fd-list--byline .fd-list__byline-right{text-align:left}.fd-list--byline .fd-list__byline-right--neutral{color:var(--sapNeutralTextColor)}.fd-list--byline .fd-list__byline-right--positive{color:var(--sapPositiveTextColor)}.fd-list--byline .fd-list__byline-right--critical{color:var(--sapCriticalTextColor)}.fd-list--byline .fd-list__byline-right--negative{color:var(--sapNegativeTextColor)}.fd-list--byline .fd-list__byline-right--informative{color:var(--sapInformativeTextColor)}.fd-list--byline .fd-list__group-header{height:var(--sapElement_LineHeight);max-height:var(--sapElement_LineHeight);min-height:var(--sapElement_LineHeight)}.fd-list--byline.fd-list--unread-indicator .fd-list__item{padding-inline:2.125rem 1rem}.fd-list--byline[class*=-compact] .fd-list__title,.fd-list--byline[class*=-condensed] .fd-list__title,[class*=-compact] .fd-list--byline:not([class*=-cozy]) .fd-list__title,[class*=-condensed] .fd-list--byline:not([class*=-cozy]) .fd-list__title{font-size:var(--sapFontSize)}.fd-list--byline.fd-list--no-border .fd-list__item{height:100%;max-height:5rem;padding-block:.5rem}.fd-list--byline.fd-list--no-border .fd-list__item:first-child{-webkit-padding-before:.9375rem;padding-block-start:.9375rem}.fd-list--byline.fd-list--no-border .fd-list__item:last-child{-webkit-padding-after:.9375rem;padding-block-end:.9375rem}.fd-list--subline .fd-list__item{-webkit-box-orient:horizontal;-ms-flex-direction:row;flex-direction:row;gap:.75rem;-webkit-box-align:center;-ms-flex-align:center;align-items:center;min-height:4.5rem;padding-block:.5rem;padding-inline:1rem}.fd-list--subline .fd-list__content,.fd-list--subline .fd-list__item{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-direction:normal}.fd-list--subline .fd-list__content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-ms-flex-direction:column;flex-direction:column;-webkit-box-flex:1;-ms-flex:1;flex:1;gap:.25rem;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start;overflow:hidden}.fd-list--subline .fd-list__content:after,.fd-list--subline .fd-list__content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--subline .fd-list__title{color:var(--sapList_TextColor);font-family:var(--sapFontBoldFamily)}.fd-list--subline .fd-list__subline,.fd-list--subline .fd-list__title{font-size:var(--sapFontSize);font-style:normal;line-height:normal;max-width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;width:100%}.fd-list--subline .fd-list__subline{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-weight:400;forced-color-adjust:none;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-list--subline .fd-list__subline:after,.fd-list--subline .fd-list__subline:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--subline .fd-list__active-indicator{color:var(--sapContent_NonInteractiveIconColor)}.fd-list--subline .fd-avatar:first-child{margin-inline:0}.fd-list--message-view{--fdListNavigationIndicatorFontSize:.75rem;--fdList_Item_Height:calc(2.75rem + var(--sapList_BorderWidth));--fdList_Message_View_Item_Byline_Height:calc(3.325rem + var(--sapList_BorderWidth));--fdList_Message_View_Title_Size:var(--sapFontHeader5Size)}.fd-list--message-view .fd-list__item{height:auto}.fd-list--message-view .fd-list__item--byline{--fdList_Item_Height:var(--fdList_Message_View_Item_Byline_Height)}.fd-list--message-view .fd-list__content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-flex:1;-ms-flex:1 1 auto;flex:1 1 auto;overflow:hidden;pointer-events:none;text-overflow:ellipsis;white-space:nowrap}.fd-list--message-view .fd-list__content:after,.fd-list--message-view .fd-list__content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--message-view .fd-list__title{color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontHeaderFamily);font-size:var(--fdList_Message_View_Title_Size);font-weight:var(--sapFontHeaderWeight,normal);overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-list--message-view .fd-list__subtitle{-webkit-padding-before:.25rem;color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);overflow:hidden;padding-block-start:.25rem;text-overflow:ellipsis;white-space:nowrap}.fd-list--message-view .fd-list__link{padding-block:.5rem}.fd-list--message-view .fd-list__link.is-active .fd-list__subtitle,.fd-list--message-view .fd-list__link.is-active .fd-list__title,.fd-list--message-view .fd-list__link.is-active .fd-object-status .fd-object-status__icon,.fd-list--message-view .fd-list__link:active .fd-list__subtitle,.fd-list--message-view .fd-list__link:active .fd-list__title,.fd-list--message-view .fd-list__link:active .fd-object-status .fd-object-status__icon{color:var(--sapList_Active_TextColor)}.fd-list--message-view[class*=-compact],.fd-list--message-view[class*=-condensed],[class*=-compact] .fd-list--message-view:not([class*=-cozy]),[class*=-condensed] .fd-list--message-view:not([class*=-cozy]){--fdList_Message_View_Item_Height:calc(2rem + var(--sapList_BorderWidth));--fdList_Message_View_Title_Size:var(--sapFontHeader6Size);--fdList_Message_View_Item_Byline_Height:calc(3.25rem + var(--sapList_BorderWidth))}.fd-list--navigation .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-icon-tab-bar__list .fd-list__link{gap:.25rem}.fd-list--navigation .fd-list__link{padding-inline:var(--fdList_Navigation_Link_Padding_Left,.9375rem) var(--fdList_Navigation_Link_Padding_Right,.9375rem)}.fd-list--navigation.fd-list--unread-indicator{--fdList_Navigation_Link_Padding_Left:2.125rem;--fdList_Navigation_Link_Padding_Right:.9375rem}.fd-list--navigation.fd-list--navigation-indication{--fdList_Navigation_Link_Padding_Left:.9375rem;--fdList_Navigation_Link_Padding_Right:0}.fd-list--navigation.fd-list--selection{--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:.9375rem}.fd-list--navigation.fd-list--selection .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--selection.fd-list--navigation-indication{--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:0}.fd-list--navigation.fd-list--selection.fd-list--navigation-indication .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--byline,.fd-list--navigation.fd-list--byline.fd-list--compact{--fdList_Navigation_Link_Padding_Left:1rem;--fdList_Navigation_Link_Padding_Right:1rem}.fd-list--navigation.fd-list--byline .fd-list__item--link,.fd-list--navigation.fd-list--byline.fd-list--compact .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--byline .fd-list__link,.fd-list--navigation.fd-list--byline.fd-list--compact .fd-list__link{padding-block:.9375rem}.fd-list--navigation.fd-list--byline.fd-list--compact.fd-list--unread-indicator,.fd-list--navigation.fd-list--byline.fd-list--unread-indicator{--fdList_Navigation_Link_Padding_Left:2.125rem;--fdList_Navigation_Link_Padding_Right:1rem}.fd-list--navigation.fd-list--byline.fd-list--navigation-indication{--fdList_Navigation_Link_Padding_Left:.9375rem;--fdList_Navigation_Link_Padding_Right:0}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link .fd-list__link{padding-block:.5rem}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:first-child{-webkit-padding-before:0;padding-block-start:0}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:first-child .fd-list__link{-webkit-padding-before:1rem;padding-block-start:1rem}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:first-child .fd-list__link--navigation-indicator:after{-webkit-margin-after:.5rem;margin-block-end:.5rem}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:last-child{-webkit-padding-after:0;padding-block-end:0}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:last-child .fd-list__link{-webkit-padding-after:1rem;padding-block-end:1rem}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:last-child .fd-list__link--navigation-indicator:after{margin-top:.25rem}.fd-list--navigation.fd-list--byline.fd-list--selection{--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--byline.fd-list--selection[class*=-compact],.fd-list--navigation.fd-list--byline.fd-list--selection[class*=-condensed],[class*=-compact] .fd-list--navigation.fd-list--byline.fd-list--selection:not([class*=-cozy]),[class*=-condensed] .fd-list--navigation.fd-list--byline.fd-list--selection:not([class*=-cozy]){--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link,.fd-list--navigation.fd-list--byline.fd-list--selection[class*=-compact] .fd-list__item--link,.fd-list--navigation.fd-list--byline.fd-list--selection[class*=-condensed] .fd-list__item--link,[class*=-compact] .fd-list--navigation.fd-list--byline.fd-list--selection:not([class*=-cozy]) .fd-list__item--link,[class*=-condensed] .fd-list--navigation.fd-list--byline.fd-list--selection:not([class*=-cozy]) .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link .fd-list__link{padding-block:.5rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:first-child{-webkit-padding-before:0;padding-block-start:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:first-child .fd-list__link{-webkit-padding-before:1rem;padding-block-start:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:first-child .fd-list__link--navigation-indicator:after{-webkit-margin-after:.5rem;margin-block-end:.5rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:last-child{-webkit-padding-after:0;padding-block-end:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:last-child .fd-list__link{-webkit-padding-after:1rem;padding-block-end:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:last-child .fd-list__link--navigation-indicator:after{margin-top:.25rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication{--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication[class*=-compact],.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication[class*=-condensed],[class*=-compact] .fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication:not([class*=-cozy]),[class*=-condensed] .fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication:not([class*=-cozy]){--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link .fd-list__link{padding-block:.5rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:first-child{-webkit-padding-before:0;padding-block-start:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:first-child .fd-list__link{-webkit-padding-before:1rem;padding-block-start:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:first-child .fd-list__link--navigation-indicator:after{-webkit-margin-after:.5rem;margin-block-end:.5rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:last-child{-webkit-padding-after:0;padding-block-end:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:last-child .fd-list__link{-webkit-padding-after:1rem;padding-block-end:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:last-child .fd-list__link--navigation-indicator:after{margin-top:.25rem}.fd-list--navigation.fd-list--navigation-object{--fdList_Navigation_Link_Padding_Left:1rem;--fdList_Navigation_Link_Padding_Right:1rem}.fd-list--navigation.fd-list--navigation-object .fd-list__item--link,.fd-list--navigation.fd-list--navigation-object[dir=rtl] .fd-list__item--link,[dir=rtl] .fd-list--navigation.fd-list--navigation-object .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--navigation-object .fd-list__link{padding-block:1rem}.fd-list--navigation-indication .fd-list:after{content:\"\";min-width:1.5rem}.fd-list--navigation-indication fd-list__item.fd-list__item--link{-webkit-padding-end:0;padding-inline-end:0}.fd-list--navigation-indication fd-list__item.fd-list__item--link:after{content:none}.fd-list--navigation-indication .fd-list__link:after{content:\"\";min-width:2.5rem}.fd-list--navigation-indication .fd-list__link--navigation-indicator:after{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapContent_NonInteractiveIconColor);content:\"\\e1ed\";font-family:SAP-icons;font-size:var(--fdListNavigationIndicatorFontSize,var(--sapFontLargeSize));height:100%;text-decoration:none;text-transform:none}.fd-list--navigation-indication .fd-list__link--navigation-indicator[dir=rtl]:after,[dir=rtl] .fd-list--navigation-indication .fd-list__link--navigation-indicator:after{content:\"\\e1ee\"}.fd-list--navigation-indication .fd-list__icon:last-child,.fd-list--navigation-indication .fd-list__icon[dir=rtl]:last-child,[dir=rtl] .fd-list--navigation-indication .fd-list__icon:last-child{margin-block:0;margin-inline:0}.fd-list--navigation-indication .is-navigated{-webkit-box-shadow:inset -.1875rem 0 0 0 var(--sapList_SelectionBorderColor);box-shadow:inset -.1875rem 0 0 0 var(--sapList_SelectionBorderColor)}.fd-list--navigation-indication .is-navigated[dir=rtl],[dir=rtl] .fd-list--navigation-indication .is-navigated{-webkit-box-shadow:inset .1875rem 0 0 0 var(--sapList_SelectionBorderColor);box-shadow:inset .1875rem 0 0 0 var(--sapList_SelectionBorderColor)}.fd-list--selection .fd-list__item{cursor:pointer;padding-inline:2.75rem .9375rem}.fd-list--selection .fd-list__item.is-hover,.fd-list--selection .fd-list__item:hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background)}.fd-list--selection .fd-list__item.is-selected,.fd-list--selection .fd-list__item[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list--selection .fd-list__item.is-selected .fd-list__link,.fd-list--selection .fd-list__item[aria-selected=true] .fd-list__link{background:inherit}.fd-list--selection .fd-list__item.is-selected .fd-list__link.is-active,.fd-list--selection .fd-list__item.is-selected .fd-list__link:active,.fd-list--selection .fd-list__item[aria-selected=true] .fd-list__link.is-active,.fd-list--selection .fd-list__item[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list--selection .fd-list__item.is-selected.is-hover,.fd-list--selection .fd-list__item.is-selected:hover,.fd-list--selection .fd-list__item[aria-selected=true].is-hover,.fd-list--selection .fd-list__item[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list--selection .fd-list__form-item{left:0;position:absolute;top:0;z-index:5}.fd-list--selection .fd-list__form-item[dir=rtl],[dir=rtl] .fd-list--selection .fd-list__form-item{left:auto;right:0}.fd-list--selection[class*=-compact] .fd-list__form-item,.fd-list--selection[class*=-condensed] .fd-list__form-item,[class*=-compact] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item,[class*=-condensed] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item{left:.375rem}.fd-list--selection[class*=-compact] .fd-list__form-item[dir=rtl],.fd-list--selection[class*=-condensed] .fd-list__form-item[dir=rtl],[class*=-compact] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item[dir=rtl],[class*=-condensed] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item[dir=rtl],[dir=rtl] .fd-list--selection[class*=-compact] .fd-list__form-item,[dir=rtl] .fd-list--selection[class*=-condensed] .fd-list__form-item,[dir=rtl] [class*=-compact] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item,[dir=rtl] [class*=-condensed] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item{left:auto;right:.375rem}.fd-list--selection.fd-list--byline .fd-list__item{padding-inline:2.75rem 1rem}.fd-list--selection.fd-list--byline .fd-list__form-item{top:.3125rem}.fd-list--selection.fd-list--byline[class*=-compact] .fd-list__item,.fd-list--selection.fd-list--byline[class*=-condensed] .fd-list__item,[class*=-compact] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__item,[class*=-condensed] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__item{padding-inline:2.75rem 1rem}.fd-list--selection.fd-list--byline[class*=-compact] .fd-list__form-item,.fd-list--selection.fd-list--byline[class*=-condensed] .fd-list__form-item,[class*=-compact] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item,[class*=-condensed] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item{left:.375rem;top:.5rem}.fd-list--selection.fd-list--byline[class*=-compact] .fd-list__form-item[dir=rtl],.fd-list--selection.fd-list--byline[class*=-condensed] .fd-list__form-item[dir=rtl],[class*=-compact] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item[dir=rtl],[class*=-condensed] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item[dir=rtl],[dir=rtl] .fd-list--selection.fd-list--byline[class*=-compact] .fd-list__form-item,[dir=rtl] .fd-list--selection.fd-list--byline[class*=-condensed] .fd-list__form-item,[dir=rtl] [class*=-compact] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item,[dir=rtl] [class*=-condensed] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item{left:auto;right:.375rem}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item{padding-block:.5rem;padding-inline:2.75rem 1rem}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:first-child{-webkit-padding-before:.9375rem;padding-block-start:.9375rem}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:last-child{-webkit-padding-after:.9375rem;padding-block-end:.9375rem}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item,.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item.fd-form-item{top:0}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item label,.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item.fd-form-item label{-webkit-padding-before:.5rem;padding-block-start:.5rem}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item label:after,.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item.fd-form-item label:after{top:.375rem}.fd-list--selection.fd-list--selection-row .fd-list__item{-webkit-padding-start:1rem;padding-inline-start:1rem}:root{--fdList_Item_Background_Color:var(--sapList_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor);--fdList_Item_Text_Font_Size:var(--sapFontLargeSize);--fdList_Item_Icon_Font_Size:1.125rem;--fdList_Item_Height:var(--sapElement_LineHeight);--fdList_Status_Text_Color:var(--sapNeutralTextColor);--fdList_Message_Background_Color:var(--sapNeutralBackground)}.fd-list__item-counter{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap;-webkit-margin-start:1rem;color:var(--sapContent_MarkerTextColor);margin-inline-start:1rem}.fd-list__item-counter:after,.fd-list__item-counter:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list{max-width:100%!important}.fd-settings__list.fd-list.fd-list--byline .fd-list__content{height:auto}.fd-list--byline .fd-list__group-header{min-height:var(--sapElement_LineHeight);height:var(--sapElement_LineHeight);max-height:var(--sapElement_LineHeight)}\n/*! Bundled license information:\n\nfundamental-styles/dist/list.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n", ".cdk-drag-dragging{z-index:15;background-color:#fff;background-color:var(--sapList_Background, #fff);opacity:.8;transition:box-shadow .2s cubic-bezier(0,0,.2,1);box-shadow:0 3px 1px -2px #0003,0 2px 2px #00000024,0 1px 5px #0000001f}.fd-replace-indicator{position:absolute;width:100%;height:100%;top:0;left:0;pointer-events:none;border-width:.125rem;border-style:solid;background-color:transparent;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor)}.fd-replace-indicator:before{content:\"\";display:block;position:absolute;width:100%;height:100%;top:0;left:0;background-color:#0854a0;background-color:var(--sapContent_DragAndDropActiveColor, #0854a0);opacity:.5}.cdk-drag{cursor:grab}.cdk-drag.cdk-drag-dragging{cursor:grabbing}.cdk-drag-dragging{outline:none;cursor:grabbing;box-shadow:0 0 0 .0625rem #00000026,0 .625rem 1.875rem #0000004d}.cdk-drag-disabled{cursor:default}.fd-dnd-placeholder{top:0;left:0;position:absolute;opacity:.3;z-index:-1}.fd-dnd-item{position:relative;cursor:grab}.fd-dnd-item.fd-dnd-on-drag{background-color:#fff;background-color:var(--sapList_Background, #fff);z-index:15;cursor:grabbing}.drop-area__line{z-index:9999;position:absolute;background:#0854a0;background:var(--sapContent_DragAndDropActiveColor, #0854a0)}.drop-area__line--vertical{top:0;height:calc(100% - .5rem);width:2px}.drop-area__line--vertical.after{right:.2rem}.drop-area__line--vertical.before{left:-.3rem}.drop-area__line--vertical:before{background-color:#fff;background-color:var(--sapList_Background, #fff);content:\"\";position:absolute;left:-.2rem;top:-.5rem;border-radius:50%;width:.5rem;height:.5rem;border-width:.125rem;border-style:solid;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor, #0854a0)}.drop-area__line--horizontal{left:0;width:100%;height:2px}.drop-area__line--horizontal.before{top:0}.drop-area__line--horizontal.after{bottom:0}.drop-area__line--horizontal:before{background-color:#fff;background-color:var(--sapList_Background, #fff);content:\"\";position:absolute;left:0;top:-.2rem;border-radius:50%;width:.5rem;height:.5rem;border-width:.125rem;border-style:solid;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor, #0854a0)}.fd-dnd-list{position:relative}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListComponent, decorators: [{
            type: Component,
            args: [{ selector: '[fd-list], [fdList]', template: `<ng-content></ng-content>`, host: {
                        class: 'fd-list',
                        '[class.fd-settings__list]': 'settingsList() || settingsListFooter()',
                        '[class.fd-settings__list--footer]': 'settingsListFooter()'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        KeyboardSupportService,
                        contentDensityObserverProviders(),
                        {
                            provide: FD_LIST_COMPONENT,
                            useExisting: ListComponent
                        },
                        {
                            provide: FD_LIST_UNREAD_INDICATOR,
                            useExisting: ListComponent
                        }
                    ], standalone: true, styles: [".fd-list{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;list-style:none;margin-block:0;margin-inline:0;max-width:100%!important;padding-block:0;padding-inline:0;position:relative;width:100%}.fd-list:after,.fd-list:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__footer,.fd-list__group-header,.fd-list__item{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;padding-block:0;padding-inline:.9375rem}.fd-list__footer:after,.fd-list__footer:before,.fd-list__group-header:after,.fd-list__group-header:before,.fd-list__item:after,.fd-list__item:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__item{background:var(--fdList_Item_Background_Color);border-bottom:var(--sapList_BorderWidth) solid var(--fdList_Item_Border_Color);height:var(--fdList_Item_Height);position:relative}.fd-list__item.is-focus,.fd-list__item:focus{outline:none;pointer-events:all}.fd-list__item.is-focus:before,.fd-list__item:focus:before{border:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);content:\"\";display:block;inset:.125rem .125rem .0625rem;pointer-events:none;position:absolute}.fd-list__item.is-focus.is-active:before,.fd-list__item.is-focus:active:before,.fd-list__item:focus.is-active:before,.fd-list__item:focus:active:before{border:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdList_Active_Outline_Color)}.fd-list__item .fd-avatar:first-child{-webkit-margin-end:.75rem;margin-inline-end:.75rem}.fd-list__item--unread .fd-list__title{font-weight:700}.fd-list__item--no-data .fd-list__title{text-align:center}.fd-list__item--interactive,.fd-list__item--interractive{cursor:pointer}.fd-list__item--interactive.is-hover,.fd-list__item--interactive:hover,.fd-list__item--interractive.is-hover,.fd-list__item--interractive:hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor)}.fd-list__item--interactive.is-selected,.fd-list__item--interactive[aria-selected=true],.fd-list__item--interractive.is-selected,.fd-list__item--interractive[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list__item--interactive.is-selected .fd-list__link,.fd-list__item--interactive[aria-selected=true] .fd-list__link,.fd-list__item--interractive.is-selected .fd-list__link,.fd-list__item--interractive[aria-selected=true] .fd-list__link{background:inherit}.fd-list__item--interactive.is-selected .fd-list__link.is-active,.fd-list__item--interactive.is-selected .fd-list__link:active,.fd-list__item--interactive[aria-selected=true] .fd-list__link.is-active,.fd-list__item--interactive[aria-selected=true] .fd-list__link:active,.fd-list__item--interractive.is-selected .fd-list__link.is-active,.fd-list__item--interractive.is-selected .fd-list__link:active,.fd-list__item--interractive[aria-selected=true] .fd-list__link.is-active,.fd-list__item--interractive[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list__item--interactive.is-selected.is-hover,.fd-list__item--interactive.is-selected:hover,.fd-list__item--interactive[aria-selected=true].is-hover,.fd-list__item--interactive[aria-selected=true]:hover,.fd-list__item--interractive.is-selected.is-hover,.fd-list__item--interractive.is-selected:hover,.fd-list__item--interractive[aria-selected=true].is-hover,.fd-list__item--interractive[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list__item--interactive.is-active,.fd-list__item--interactive.is-active.is-hover,.fd-list__item--interactive.is-active.is-selected,.fd-list__item--interactive.is-active.is-selected.is-hover,.fd-list__item--interactive.is-active.is-selected:hover,.fd-list__item--interactive.is-active:hover,.fd-list__item--interactive.is-active[aria-selected=true],.fd-list__item--interactive.is-active[aria-selected=true].is-hover,.fd-list__item--interactive.is-active[aria-selected=true]:hover,.fd-list__item--interactive:active,.fd-list__item--interactive:active.is-hover,.fd-list__item--interactive:active.is-selected,.fd-list__item--interactive:active.is-selected.is-hover,.fd-list__item--interactive:active.is-selected:hover,.fd-list__item--interactive:active:hover,.fd-list__item--interactive:active[aria-selected=true],.fd-list__item--interactive:active[aria-selected=true].is-hover,.fd-list__item--interactive:active[aria-selected=true]:hover,.fd-list__item--interractive.is-active,.fd-list__item--interractive.is-active.is-hover,.fd-list__item--interractive.is-active.is-selected,.fd-list__item--interractive.is-active.is-selected.is-hover,.fd-list__item--interractive.is-active.is-selected:hover,.fd-list__item--interractive.is-active:hover,.fd-list__item--interractive.is-active[aria-selected=true],.fd-list__item--interractive.is-active[aria-selected=true].is-hover,.fd-list__item--interractive.is-active[aria-selected=true]:hover,.fd-list__item--interractive:active,.fd-list__item--interractive:active.is-hover,.fd-list__item--interractive:active.is-selected,.fd-list__item--interractive:active.is-selected.is-hover,.fd-list__item--interractive:active.is-selected:hover,.fd-list__item--interractive:active:hover,.fd-list__item--interractive:active[aria-selected=true],.fd-list__item--interractive:active[aria-selected=true].is-hover,.fd-list__item--interractive:active[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Active_Background);--fdList_Item_Text_Color:var(--sapList_Active_TextColor);--fdList_Item_Border_Color:var(--sapList_Active_Background)}.fd-list__item--interactive.is-active,.fd-list__item--interactive.is-active .fd-list__byline,.fd-list__item--interactive.is-active .fd-list__byline-left,.fd-list__item--interactive.is-active .fd-list__byline-right,.fd-list__item--interactive.is-active .fd-list__byline-right--critical,.fd-list__item--interactive.is-active .fd-list__byline-right--informative,.fd-list__item--interactive.is-active .fd-list__byline-right--negative,.fd-list__item--interactive.is-active .fd-list__byline-right--neutral,.fd-list__item--interactive.is-active .fd-list__byline-right--positive,.fd-list__item--interactive.is-active .fd-list__content,.fd-list__item--interactive.is-active .fd-list__icon,.fd-list__item--interactive.is-active .fd-list__secondary,.fd-list__item--interactive.is-active .fd-list__thumbnail,.fd-list__item--interactive.is-active .fd-list__title,.fd-list__item--interactive.is-active.fd-list__link--navigation-indicator:after,.fd-list__item--interactive:active,.fd-list__item--interactive:active .fd-list__byline,.fd-list__item--interactive:active .fd-list__byline-left,.fd-list__item--interactive:active .fd-list__byline-right,.fd-list__item--interactive:active .fd-list__byline-right--critical,.fd-list__item--interactive:active .fd-list__byline-right--informative,.fd-list__item--interactive:active .fd-list__byline-right--negative,.fd-list__item--interactive:active .fd-list__byline-right--neutral,.fd-list__item--interactive:active .fd-list__byline-right--positive,.fd-list__item--interactive:active .fd-list__content,.fd-list__item--interactive:active .fd-list__icon,.fd-list__item--interactive:active .fd-list__secondary,.fd-list__item--interactive:active .fd-list__thumbnail,.fd-list__item--interactive:active .fd-list__title,.fd-list__item--interactive:active.fd-list__link--navigation-indicator:after,.fd-list__item--interractive.is-active,.fd-list__item--interractive.is-active .fd-list__byline,.fd-list__item--interractive.is-active .fd-list__byline-left,.fd-list__item--interractive.is-active .fd-list__byline-right,.fd-list__item--interractive.is-active .fd-list__byline-right--critical,.fd-list__item--interractive.is-active .fd-list__byline-right--informative,.fd-list__item--interractive.is-active .fd-list__byline-right--negative,.fd-list__item--interractive.is-active .fd-list__byline-right--neutral,.fd-list__item--interractive.is-active .fd-list__byline-right--positive,.fd-list__item--interractive.is-active .fd-list__content,.fd-list__item--interractive.is-active .fd-list__icon,.fd-list__item--interractive.is-active .fd-list__secondary,.fd-list__item--interractive.is-active .fd-list__thumbnail,.fd-list__item--interractive.is-active .fd-list__title,.fd-list__item--interractive.is-active.fd-list__link--navigation-indicator:after,.fd-list__item--interractive:active,.fd-list__item--interractive:active .fd-list__byline,.fd-list__item--interractive:active .fd-list__byline-left,.fd-list__item--interractive:active .fd-list__byline-right,.fd-list__item--interractive:active .fd-list__byline-right--critical,.fd-list__item--interractive:active .fd-list__byline-right--informative,.fd-list__item--interractive:active .fd-list__byline-right--negative,.fd-list__item--interractive:active .fd-list__byline-right--neutral,.fd-list__item--interractive:active .fd-list__byline-right--positive,.fd-list__item--interractive:active .fd-list__content,.fd-list__item--interractive:active .fd-list__icon,.fd-list__item--interractive:active .fd-list__secondary,.fd-list__item--interractive:active .fd-list__thumbnail,.fd-list__item--interractive:active .fd-list__title,.fd-list__item--interractive:active.fd-list__link--navigation-indicator:after{text-shadow:none}.fd-list__item--action{border-bottom:var(--fdList_Item_Action_Border);font-size:var(--sapFontSize);padding-block:0;padding-inline:0;text-align:center;--fdList_Item_Height:var(--sapElement_LineHeight)}.fd-list__item--action:first-child{border-top:var(--fdList_Item_Action_Border)}.fd-list__item--action .fd-list__title{background:transparent;border:var(--fdList_Item_Action_Button_Border);border-radius:var(--fdList_Item_Action_Button_Border_Radius);color:var(--sapButton_TextColor);cursor:pointer;height:var(--fdList_Item_Action_Button_Size);margin-block:var(--fdList_Item_Action_Button_Spacing);margin-inline:var(--fdList_Item_Action_Button_Spacing);padding-block:0;padding-inline:.9375rem;pointer-events:all;width:100%}.fd-list__item--action .fd-list__title.is-hover,.fd-list__item--action .fd-list__title:hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor)}.fd-list__item--action .fd-list__title.is-selected,.fd-list__item--action .fd-list__title[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list__item--action .fd-list__title.is-selected .fd-list__link,.fd-list__item--action .fd-list__title[aria-selected=true] .fd-list__link{background:inherit}.fd-list__item--action .fd-list__title.is-selected .fd-list__link.is-active,.fd-list__item--action .fd-list__title.is-selected .fd-list__link:active,.fd-list__item--action .fd-list__title[aria-selected=true] .fd-list__link.is-active,.fd-list__item--action .fd-list__title[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list__item--action .fd-list__title.is-selected.is-hover,.fd-list__item--action .fd-list__title.is-selected:hover,.fd-list__item--action .fd-list__title[aria-selected=true].is-hover,.fd-list__item--action .fd-list__title[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list__item--action .fd-list__title.is-active,.fd-list__item--action .fd-list__title.is-active.is-hover,.fd-list__item--action .fd-list__title.is-active.is-selected,.fd-list__item--action .fd-list__title.is-active.is-selected.is-hover,.fd-list__item--action .fd-list__title.is-active.is-selected:hover,.fd-list__item--action .fd-list__title.is-active:hover,.fd-list__item--action .fd-list__title.is-active[aria-selected=true],.fd-list__item--action .fd-list__title.is-active[aria-selected=true].is-hover,.fd-list__item--action .fd-list__title.is-active[aria-selected=true]:hover,.fd-list__item--action .fd-list__title:active,.fd-list__item--action .fd-list__title:active.is-hover,.fd-list__item--action .fd-list__title:active.is-selected,.fd-list__item--action .fd-list__title:active.is-selected.is-hover,.fd-list__item--action .fd-list__title:active.is-selected:hover,.fd-list__item--action .fd-list__title:active:hover,.fd-list__item--action .fd-list__title:active[aria-selected=true],.fd-list__item--action .fd-list__title:active[aria-selected=true].is-hover,.fd-list__item--action .fd-list__title:active[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Active_Background);--fdList_Item_Text_Color:var(--sapList_Active_TextColor);--fdList_Item_Border_Color:var(--sapList_Active_Background)}.fd-list__item--action .fd-list__title.is-active,.fd-list__item--action .fd-list__title.is-active .fd-list__byline,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-left,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right--critical,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right--informative,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right--negative,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right--neutral,.fd-list__item--action .fd-list__title.is-active .fd-list__byline-right--positive,.fd-list__item--action .fd-list__title.is-active .fd-list__content,.fd-list__item--action .fd-list__title.is-active .fd-list__icon,.fd-list__item--action .fd-list__title.is-active .fd-list__secondary,.fd-list__item--action .fd-list__title.is-active .fd-list__thumbnail,.fd-list__item--action .fd-list__title.is-active .fd-list__title,.fd-list__item--action .fd-list__title.is-active.fd-list__link--navigation-indicator:after,.fd-list__item--action .fd-list__title:active,.fd-list__item--action .fd-list__title:active .fd-list__byline,.fd-list__item--action .fd-list__title:active .fd-list__byline-left,.fd-list__item--action .fd-list__title:active .fd-list__byline-right,.fd-list__item--action .fd-list__title:active .fd-list__byline-right--critical,.fd-list__item--action .fd-list__title:active .fd-list__byline-right--informative,.fd-list__item--action .fd-list__title:active .fd-list__byline-right--negative,.fd-list__item--action .fd-list__title:active .fd-list__byline-right--neutral,.fd-list__item--action .fd-list__title:active .fd-list__byline-right--positive,.fd-list__item--action .fd-list__title:active .fd-list__content,.fd-list__item--action .fd-list__title:active .fd-list__icon,.fd-list__item--action .fd-list__title:active .fd-list__secondary,.fd-list__item--action .fd-list__title:active .fd-list__thumbnail,.fd-list__item--action .fd-list__title:active .fd-list__title,.fd-list__item--action .fd-list__title:active.fd-list__link--navigation-indicator:after{text-shadow:none}.fd-list__item--action .fd-list__title.is-focus,.fd-list__item--action .fd-list__title:focus{outline:var(--sapContent_FocusColor) var(--sapContent_FocusStyle) var(--sapContent_FocusWidth);outline-offset:-.125rem}.fd-list__item--action .fd-list__title.is-focus.is-active,.fd-list__item--action .fd-list__title.is-focus:active,.fd-list__item--action .fd-list__title:focus.is-active,.fd-list__item--action .fd-list__title:focus:active{outline-color:var(--fdList_Active_Outline_Color)}.fd-list__item--action .fd-list__title::-moz-focus-inner{border:0}.fd-list__item--growing{--fdList_Item_Height:var(--sapElement_LineHeight)}.fd-list__item--growing .fd-list__title{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;gap:.5rem}.fd-list__item--growing .fd-list__title-text{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:inherit;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;font-weight:var(--fdList_Growing_Font_Weight);forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;text-shadow:inherit;white-space:nowrap}.fd-list__item--growing .fd-list__title-text:after,.fd-list__item--growing .fd-list__title-text:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__item--inactive,.fd-list__item--inactive .fd-list__secondary,.fd-list__item--inactive .fd-list__title{pointer-events:none}.fd-list__item.is-selected,.fd-list__item[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list__item.is-selected .fd-list__link,.fd-list__item[aria-selected=true] .fd-list__link{background:inherit}.fd-list__item.is-selected .fd-list__link.is-active,.fd-list__item.is-selected .fd-list__link:active,.fd-list__item[aria-selected=true] .fd-list__link.is-active,.fd-list__item[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list__item.is-selected.is-hover,.fd-list__item.is-selected:hover,.fd-list__item[aria-selected=true].is-hover,.fd-list__item[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list__secondary,.fd-list__title{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--fdList_Item_Text_Color);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;pointer-events:none;pointer-events:all;text-overflow:ellipsis;white-space:nowrap}.fd-list__secondary:after,.fd-list__secondary:before,.fd-list__title:after,.fd-list__title:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__title{-webkit-box-flex:3;-ms-flex:3 3 10%;flex:3 3 10%;font-size:var(--fdList_Item_Text_Font_Size);min-height:var(--fdList_Item_Text_Font_Size)}.fd-list__title:last-child:first-child{-ms-flex-preferred-size:auto;flex-basis:auto}.fd-list__title .fd-list__title-text{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center}.fd-list__title~.fd-list__icon{-webkit-margin-end:-1rem;margin-inline-end:-1rem}.fd-list__secondary{color:var(--fdList_Status_Text_Color);font-size:var(--sapFontSize);max-width:40%;text-align:right;-webkit-padding-start:1rem;padding-inline-start:1rem}.fd-list__secondary--positive{--fdList_Status_Text_Color:var(--sapPositiveTextColor)}.fd-list__secondary--critical{--fdList_Status_Text_Color:var(--sapCriticalTextColor)}.fd-list__secondary--negative{--fdList_Status_Text_Color:var(--sapNegativeTextColor)}.fd-list__secondary--informative{--fdList_Status_Text_Color:var(--sapInformativeTextColor)}.fd-list__secondary[dir=rtl],[dir=rtl] .fd-list__secondary{text-align:left}.fd-list__icon [class*=sap-icon],.fd-list__icon[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;display:-webkit-box;display:-ms-flexbox;display:flex;font-size:inherit;line-height:1;pointer-events:none;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapContent_NonInteractiveIconColor);font-size:var(--fdList_Item_Icon_Font_Size);width:2.75rem;-webkit-box-flex:0;-ms-flex:0 0 auto;flex:0 0 auto}.fd-list__icon [class*=sap-icon]:first-child,.fd-list__icon[class*=sap-icon]:first-child{-webkit-margin-start:-1rem;margin-inline-start:-1rem}.fd-list__link{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-inline:0;-webkit-box-align:center;-ms-flex-align:center;align-items:center;--fdList_Item_Border_Color:transparent;background:var(--fdList_Item_Background_Color);border-bottom:var(--sapList_BorderWidth) solid var(--fdList_Item_Border_Color);cursor:pointer;height:100%;padding-block:0;padding-inline:.9375rem;text-decoration:none;width:100%}.fd-list__link:after,.fd-list__link:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__link.is-focus,.fd-list__link:focus{outline:none;pointer-events:all}.fd-list__link.is-focus:before,.fd-list__link:focus:before{border:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--sapContent_FocusColor);content:\"\";display:block;inset:.125rem;pointer-events:none;position:absolute}.fd-list__link.is-focus.is-active:before,.fd-list__link.is-focus:active:before,.fd-list__link:focus.is-active:before,.fd-list__link:focus:active:before{border:var(--sapContent_FocusWidth) var(--sapContent_FocusStyle) var(--fdList_Active_Outline_Color)}.fd-list__link.is-hover,.fd-list__link:hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor)}.fd-list__link.is-selected,.fd-list__link[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list__link.is-selected .fd-list__link,.fd-list__link[aria-selected=true] .fd-list__link{background:inherit}.fd-list__link.is-selected .fd-list__link.is-active,.fd-list__link.is-selected .fd-list__link:active,.fd-list__link[aria-selected=true] .fd-list__link.is-active,.fd-list__link[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list__link.is-selected.is-hover,.fd-list__link.is-selected:hover,.fd-list__link[aria-selected=true].is-hover,.fd-list__link[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list__link.is-active,.fd-list__link.is-active.is-hover,.fd-list__link.is-active.is-selected,.fd-list__link.is-active.is-selected.is-hover,.fd-list__link.is-active.is-selected:hover,.fd-list__link.is-active:hover,.fd-list__link.is-active[aria-selected=true],.fd-list__link.is-active[aria-selected=true].is-hover,.fd-list__link.is-active[aria-selected=true]:hover,.fd-list__link:active,.fd-list__link:active.is-hover,.fd-list__link:active.is-selected,.fd-list__link:active.is-selected.is-hover,.fd-list__link:active.is-selected:hover,.fd-list__link:active:hover,.fd-list__link:active[aria-selected=true],.fd-list__link:active[aria-selected=true].is-hover,.fd-list__link:active[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Active_Background);--fdList_Item_Text_Color:var(--sapList_Active_TextColor);--fdList_Item_Border_Color:var(--sapList_Active_Background)}.fd-list__link.is-active,.fd-list__link.is-active .fd-list__byline,.fd-list__link.is-active .fd-list__byline-left,.fd-list__link.is-active .fd-list__byline-right,.fd-list__link.is-active .fd-list__byline-right--critical,.fd-list__link.is-active .fd-list__byline-right--informative,.fd-list__link.is-active .fd-list__byline-right--negative,.fd-list__link.is-active .fd-list__byline-right--neutral,.fd-list__link.is-active .fd-list__byline-right--positive,.fd-list__link.is-active .fd-list__content,.fd-list__link.is-active .fd-list__icon,.fd-list__link.is-active .fd-list__secondary,.fd-list__link.is-active .fd-list__thumbnail,.fd-list__link.is-active .fd-list__title,.fd-list__link.is-active.fd-list__link--navigation-indicator:after,.fd-list__link:active,.fd-list__link:active .fd-list__byline,.fd-list__link:active .fd-list__byline-left,.fd-list__link:active .fd-list__byline-right,.fd-list__link:active .fd-list__byline-right--critical,.fd-list__link:active .fd-list__byline-right--informative,.fd-list__link:active .fd-list__byline-right--negative,.fd-list__link:active .fd-list__byline-right--neutral,.fd-list__link:active .fd-list__byline-right--positive,.fd-list__link:active .fd-list__content,.fd-list__link:active .fd-list__icon,.fd-list__link:active .fd-list__secondary,.fd-list__link:active .fd-list__thumbnail,.fd-list__link:active .fd-list__title,.fd-list__link:active.fd-list__link--navigation-indicator:after{text-shadow:none}.fd-list__group-header{background:var(--sapList_GroupHeaderBackground);border-bottom:var(--sapList_BorderWidth) solid var(--sapList_GroupHeaderBorderColor);height:var(--sapElement_LineHeight);-webkit-box-align:end;-ms-flex-align:end;align-items:flex-end}.fd-list__group-header .fd-list__title{color:var(--sapList_TableGroupHeaderTextColor);font-family:var(--sapFontHeaderFamily);font-size:var(--sapFontHeader6Size);font-weight:700;line-height:2rem;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-list__footer{background:var(--sapList_FooterBackground);color:var(--sapList_FooterTextColor);font-size:var(--sapFontSize);height:2rem}.fd-list__footer--right{-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end}.fd-list__footer--left{-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start}.fd-list__bold{font-weight:700}.fd-list__message{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;height:2rem;left:0;line-height:normal;line-height:2rem;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;position:absolute;text-overflow:ellipsis;top:0;white-space:nowrap;width:100%;-webkit-padding-start:.5rem;background-color:var(--fdList_Message_Background_Color);font-size:var(--sapFontSmallSize);padding-inline-start:.5rem}.fd-list__message:after,.fd-list__message:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list__message--error{--fdList_Message_Background_Color:var(--sapErrorBackground)}.fd-list__message--warning{--fdList_Message_Background_Color:var(--sapWarningBackground)}.fd-list__message--success{--fdList_Message_Background_Color:var(--sapSuccessBackground)}.fd-list__message--information{--fdList_Message_Background_Color:var(--sapInformationBackground)}.fd-list .fd-list__button{-webkit-margin-start:var(--fdList_Button_Spacing);margin-inline-start:var(--fdList_Button_Spacing);-ms-flex-item-align:center;align-self:center}.fd-list[class*=-compact]:not(.fd-object-list):not(.fd-list--message-view),.fd-list[class*=-condensed]:not(.fd-object-list):not(.fd-list--message-view),[class*=-compact] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view),[class*=-condensed] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view){--fdList_Item_Icon_Font_Size:1rem;--fdList_Item_Text_Font_Size:var(--sapFontSize);--fdList_Item_Height:var(--sapElement_Compact_LineHeight)}.fd-list[class*=-compact]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item--growing,.fd-list[class*=-condensed]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item--growing,[class*=-compact] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item--growing,[class*=-condensed] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item--growing{--fdList_Item_Height:var(--sapElement_LineHeight)}.fd-list[class*=-compact]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action,.fd-list[class*=-condensed]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action,[class*=-compact] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action,[class*=-condensed] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action{--fdList_Item_Height:var(--sapElement_Compact_LineHeight)}.fd-list[class*=-compact]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action .fd-list__title,.fd-list[class*=-condensed]:not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action .fd-list__title,[class*=-compact] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action .fd-list__title,[class*=-condensed] .fd-list:not([class*=-cozy]):not(.fd-object-list):not(.fd-list--message-view) .fd-list__item.fd-list__item--action .fd-list__title{height:var(--fdList_Item_Action_Button_Size_Compact)}.fd-list--no-border .fd-list__group-header,.fd-list--no-border .fd-list__item{border-bottom:0;border-top:0}.fd-list--no-border .fd-list__item.is-selected,.fd-list--no-border .fd-list__item[aria-selected=true]{border-bottom:var(--sapList_BorderWidth) solid var(--sapList_SelectionBorderColor)}.fd-list--has-message{-webkit-padding-before:2rem;padding-block-start:2rem}.fd-list__infinite-scroll{outline:none;overflow:scroll}.fd-list--dropdown.is-focus,.fd-list--dropdown:focus{outline:none;z-index:5}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header){display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;cursor:pointer;height:auto;min-height:2.5rem;padding-block:0;padding-inline:.9375rem}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor)}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected .fd-list__link,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true] .fd-list__link{background:inherit}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected .fd-list__link.is-active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected .fd-list__link:active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true] .fd-list__link.is-active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected.is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-selected:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true].is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header)[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active.is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active.is-selected,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active.is-selected.is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active.is-selected:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active[aria-selected=true],.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active[aria-selected=true].is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active[aria-selected=true]:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active.is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active.is-selected,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active.is-selected.is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active.is-selected:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active:hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active[aria-selected=true],.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active[aria-selected=true].is-hover,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Active_Background);--fdList_Item_Text_Color:var(--sapList_Active_TextColor);--fdList_Item_Border_Color:var(--sapList_Active_Background)}.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-left,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right--critical,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right--informative,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right--negative,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right--neutral,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__byline-right--positive,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__content,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__icon,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__secondary,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__thumbnail,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active .fd-list__title,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header).is-active.fd-list__link--navigation-indicator:after,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-left,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right--critical,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right--informative,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right--negative,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right--neutral,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__byline-right--positive,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__content,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__icon,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__secondary,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__thumbnail,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active .fd-list__title,.fd-list--dropdown .fd-list__item:not(.fd-list__group-header):active.fd-list__link--navigation-indicator:after{text-shadow:none}.fd-list--dropdown[class*=-compact] .fd-list__item:not(.fd-list__group-header),.fd-list--dropdown[class*=-condensed] .fd-list__item:not(.fd-list__group-header),[class*=-compact] .fd-list--dropdown:not([class*=-cozy]) .fd-list__item:not(.fd-list__group-header),[class*=-condensed] .fd-list--dropdown:not([class*=-cozy]) .fd-list__item:not(.fd-list__group-header){height:auto;min-height:2rem;padding-block:0;padding-inline:.9375rem}.fd-list--multi-input .fd-list__item{cursor:pointer;height:auto;padding-block:0;padding-inline:0 1rem}.fd-list--multi-input .fd-list__item.is-hover,.fd-list--multi-input .fd-list__item:hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor)}.fd-list--multi-input .fd-list__item.is-selected,.fd-list--multi-input .fd-list__item[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list--multi-input .fd-list__item.is-selected .fd-list__link,.fd-list--multi-input .fd-list__item[aria-selected=true] .fd-list__link{background:inherit}.fd-list--multi-input .fd-list__item.is-selected .fd-list__link.is-active,.fd-list--multi-input .fd-list__item.is-selected .fd-list__link:active,.fd-list--multi-input .fd-list__item[aria-selected=true] .fd-list__link.is-active,.fd-list--multi-input .fd-list__item[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list--multi-input .fd-list__item.is-selected.is-hover,.fd-list--multi-input .fd-list__item.is-selected:hover,.fd-list--multi-input .fd-list__item[aria-selected=true].is-hover,.fd-list--multi-input .fd-list__item[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list--multi-input .fd-list__item.is-active,.fd-list--multi-input .fd-list__item.is-active.is-hover,.fd-list--multi-input .fd-list__item.is-active.is-selected,.fd-list--multi-input .fd-list__item.is-active.is-selected.is-hover,.fd-list--multi-input .fd-list__item.is-active.is-selected:hover,.fd-list--multi-input .fd-list__item.is-active:hover,.fd-list--multi-input .fd-list__item.is-active[aria-selected=true],.fd-list--multi-input .fd-list__item.is-active[aria-selected=true].is-hover,.fd-list--multi-input .fd-list__item.is-active[aria-selected=true]:hover,.fd-list--multi-input .fd-list__item:active,.fd-list--multi-input .fd-list__item:active.is-hover,.fd-list--multi-input .fd-list__item:active.is-selected,.fd-list--multi-input .fd-list__item:active.is-selected.is-hover,.fd-list--multi-input .fd-list__item:active.is-selected:hover,.fd-list--multi-input .fd-list__item:active:hover,.fd-list--multi-input .fd-list__item:active[aria-selected=true],.fd-list--multi-input .fd-list__item:active[aria-selected=true].is-hover,.fd-list--multi-input .fd-list__item:active[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Active_Background);--fdList_Item_Text_Color:var(--sapList_Active_TextColor);--fdList_Item_Border_Color:var(--sapList_Active_Background)}.fd-list--multi-input .fd-list__item.is-active,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-left,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right--critical,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right--informative,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right--negative,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right--neutral,.fd-list--multi-input .fd-list__item.is-active .fd-list__byline-right--positive,.fd-list--multi-input .fd-list__item.is-active .fd-list__content,.fd-list--multi-input .fd-list__item.is-active .fd-list__icon,.fd-list--multi-input .fd-list__item.is-active .fd-list__secondary,.fd-list--multi-input .fd-list__item.is-active .fd-list__thumbnail,.fd-list--multi-input .fd-list__item.is-active .fd-list__title,.fd-list--multi-input .fd-list__item.is-active.fd-list__link--navigation-indicator:after,.fd-list--multi-input .fd-list__item:active,.fd-list--multi-input .fd-list__item:active .fd-list__byline,.fd-list--multi-input .fd-list__item:active .fd-list__byline-left,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right--critical,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right--informative,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right--negative,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right--neutral,.fd-list--multi-input .fd-list__item:active .fd-list__byline-right--positive,.fd-list--multi-input .fd-list__item:active .fd-list__content,.fd-list--multi-input .fd-list__item:active .fd-list__icon,.fd-list--multi-input .fd-list__item:active .fd-list__secondary,.fd-list--multi-input .fd-list__item:active .fd-list__thumbnail,.fd-list--multi-input .fd-list__item:active .fd-list__title,.fd-list--multi-input .fd-list__item:active.fd-list__link--navigation-indicator:after{text-shadow:none}.fd-list--multi-input .fd-list__label{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:inherit;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;position:relative;text-overflow:ellipsis;width:100%;-webkit-margin-end:0;margin-inline-end:0}.fd-list--multi-input .fd-list__label:after,.fd-list--multi-input .fd-list__label:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--multi-input .fd-list__label:before{margin-block:-.1875rem -.1875rem}.fd-list--multi-input .fd-list__input.is-focus,.fd-list--multi-input .fd-list__input:focus{-webkit-box-shadow:none;box-shadow:none;z-index:5}.fd-list--multi-input .fd-list__input.is-focus+.fd-list__label:after,.fd-list--multi-input .fd-list__input:focus+.fd-list__label:after{inset:.0625rem}.fd-list--multi-input .fd-list__footer{height:auto;text-align:right;-webkit-box-pack:end;-ms-flex-pack:end;background-color:var(--sapList_Background);justify-content:flex-end;line-height:1rem}.fd-list--multi-input .fd-list__footer,.fd-list--multi-input .fd-list__label{padding-block:.75rem;padding-inline:.9375rem}.fd-list--multi-input[class*=-compact] .fd-list__item,.fd-list--multi-input[class*=-condensed] .fd-list__item,[class*=-compact] .fd-list--multi-input:not([class*=-cozy]) .fd-list__item,[class*=-condensed] .fd-list--multi-input:not([class*=-cozy]) .fd-list__item{height:auto;padding-block:0;padding-inline:0}.fd-list--multi-input[class*=-compact] .fd-list__label:before,.fd-list--multi-input[class*=-condensed] .fd-list__label:before,[class*=-compact] .fd-list--multi-input:not([class*=-cozy]) .fd-list__label:before,[class*=-condensed] .fd-list--multi-input:not([class*=-cozy]) .fd-list__label:before{-webkit-margin-start:0;margin-inline-start:0;margin-top:0;-webkit-margin-after:0;margin-block-end:0}.fd-list--multi-input[class*=-compact] .fd-list__footer,.fd-list--multi-input[class*=-compact] .fd-list__label,.fd-list--multi-input[class*=-condensed] .fd-list__footer,.fd-list--multi-input[class*=-condensed] .fd-list__label,[class*=-compact] .fd-list--multi-input:not([class*=-cozy]) .fd-list__footer,[class*=-compact] .fd-list--multi-input:not([class*=-cozy]) .fd-list__label,[class*=-condensed] .fd-list--multi-input:not([class*=-cozy]) .fd-list__footer,[class*=-condensed] .fd-list--multi-input:not([class*=-cozy]) .fd-list__label{padding-block:.5rem;padding-inline:.9375rem}.fd-list--dropdown,.fd-list--multi-input{display:block;max-width:40rem;min-width:5rem}.fd-list--dropdown .fd-list__item,.fd-list--multi-input .fd-list__item{border:none;cursor:pointer}.fd-list--dropdown .fd-list__item.is-selected,.fd-list--dropdown .fd-list__item[aria-selected=true],.fd-list--multi-input .fd-list__item.is-selected,.fd-list--multi-input .fd-list__item[aria-selected=true]{border-bottom:var(--sapList_BorderWidth) solid var(--sapList_SelectionBorderColor)}.fd-list--dropdown .fd-list__secondary,.fd-list--dropdown .fd-list__title,.fd-list--multi-input .fd-list__secondary,.fd-list--multi-input .fd-list__title{font-size:var(--sapFontSize);white-space:normal;-webkit-box-flex:1;-ms-flex:auto;flex:auto;width:auto}.fd-list--dropdown .fd-list__secondary--no-wrap,.fd-list--dropdown .fd-list__title--no-wrap,.fd-list--multi-input .fd-list__secondary--no-wrap,.fd-list--multi-input .fd-list__title--no-wrap{white-space:nowrap}.fd-list--dropdown .fd-list__secondary,.fd-list--multi-input .fd-list__secondary{display:block}.fd-list--dropdown .fd-list__title,.fd-list--multi-input .fd-list__title{max-width:24rem}.fd-list--dropdown .fd-list__title:first-child:last-child,.fd-list--multi-input .fd-list__title:first-child:last-child{max-width:40rem}.fd-list--dropdown .fd-list__secondary,.fd-list--multi-input .fd-list__secondary{max-width:16rem}.fd-list--dropdown.fd-list--mobile,.fd-list--multi-input.fd-list--mobile{max-width:100%}.fd-list--dropdown .fd-list__icon,.fd-list--multi-input .fd-list__icon{line-height:1rem}.fd-list--dropdown.fd-list--large-dropdown,.fd-list--multi-input.fd-list--large-dropdown{max-width:62rem}.fd-list--dropdown.fd-list--large-dropdown .fd-list__title,.fd-list--multi-input.fd-list--large-dropdown .fd-list__title{max-width:37.2rem}.fd-list--dropdown.fd-list--large-dropdown .fd-list__title:first-child:last-child,.fd-list--multi-input.fd-list--large-dropdown .fd-list__title:first-child:last-child{max-width:62rem}.fd-list--dropdown.fd-list--large-dropdown .fd-list__secondary,.fd-list--multi-input.fd-list--large-dropdown .fd-list__secondary{max-width:24.8rem}.fd-list--dropdown.fd-list--large-dropdown.fd-list--mobile,.fd-list--multi-input.fd-list--large-dropdown.fd-list--mobile{max-width:100%}.fd-list--byline .fd-list__item{height:auto;min-height:5rem;padding-block:.9375rem;padding-inline:1rem;width:100%;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start}.fd-list--byline .fd-list__item.is-focus,.fd-list--byline .fd-list__item:focus{pointer-events:all;z-index:5}.fd-list--byline .fd-list__item .fd-list__item-counter{-ms-flex-align:center;-ms-flex-item-align:center;align-self:center;-webkit-box-pack:end;-ms-flex-pack:end;height:100%;justify-content:flex-end;min-width:2rem}.fd-list--byline .fd-list__item .fd-list__item-counter,.fd-list--byline .fd-list__thumbnail{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;align-items:center}.fd-list--byline .fd-list__thumbnail{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;pointer-events:none;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-ms-flex-align:center;-webkit-margin-end:.75rem;border-radius:.25rem;color:var(--sapContent_NonInteractiveIconColor);font-size:2rem;height:3rem;margin-inline-end:.75rem;max-height:3rem;max-width:3rem;min-height:3rem;min-width:3rem;width:3rem}.fd-list--byline .fd-list__thumbnail:after,.fd-list--byline .fd-list__thumbnail:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--byline .fd-list__thumbnail [class*=sap-icon],.fd-list--byline .fd-list__thumbnail[class*=sap-icon]{background:inherit;border-radius:inherit;color:inherit;font-size:inherit;line-height:1}.fd-list--byline .fd-list__thumbnail>svg{height:100%}.fd-list--byline .fd-list__notification{color:var(--sapAccentColor6);font-size:.375rem;left:1rem;position:absolute;top:50%;-webkit-transform:translateY(-50%);transform:translateY(-50%)}.fd-list--byline .fd-list__notification[dir=rtl],[dir=rtl] .fd-list--byline .fd-list__notification{left:auto;right:1rem}.fd-list--byline .fd-list__notification+.fd-list__link .fd-list__content .fd-list__title,.fd-list--byline .fd-list__notification~.fd-list__content .fd-list__title{font-weight:700}.fd-list--byline .fd-list__content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;pointer-events:none;-ms-flex-line-pack:justify;align-content:space-between;height:100%;min-height:3rem;min-width:3rem;-webkit-box-flex:1;-ms-flex:1 1 auto;flex:1 1 auto;padding-block:.125rem;padding-inline:0}.fd-list--byline .fd-list__content:after,.fd-list--byline .fd-list__content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--byline .fd-list__title{font-size:var(--sapFontLargeSize);min-height:1rem;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-list--byline .fd-list__byline{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1rem;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap;-webkit-padding-before:.5rem;padding-block-start:.5rem}.fd-list--byline .fd-list__byline:after,.fd-list--byline .fd-list__byline:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--byline .fd-list__byline--2-col{display:-webkit-box;display:-ms-flexbox;display:flex;pointer-events:all}.fd-list--byline .fd-list__byline--wrap .fd-list__byline-left,.fd-list--byline .fd-list__byline--wrap .fd-list__byline-right{display:inline;padding-block:0;padding-inline:0;white-space:normal;width:100%}.fd-list--byline .fd-list__byline--wrap .fd-list__byline-right{float:right;width:auto}.fd-list--byline .fd-list__link--more{pointer-events:all;text-transform:capitalize}.fd-list--byline .fd-list__byline--wrap,.fd-list--byline .fd-list__title--wrap{white-space:normal}.fd-list--byline .fd-list__byline-left{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1rem;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap;width:60%;-ms-flex-item-align:end;align-self:flex-end;-webkit-padding-end:.5rem;padding-inline-end:.5rem}.fd-list--byline .fd-list__byline-left:after,.fd-list--byline .fd-list__byline-left:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--byline .fd-list__byline-right{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;line-height:1rem;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-align:right;text-overflow:ellipsis;white-space:nowrap;width:40%;-ms-flex-item-align:end;align-self:flex-end;-webkit-padding-start:.5rem;padding-inline-start:.5rem}.fd-list--byline .fd-list__byline-right:after,.fd-list--byline .fd-list__byline-right:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--byline .fd-list__byline-right[dir=rtl],[dir=rtl] .fd-list--byline .fd-list__byline-right{text-align:left}.fd-list--byline .fd-list__byline-right--neutral{color:var(--sapNeutralTextColor)}.fd-list--byline .fd-list__byline-right--positive{color:var(--sapPositiveTextColor)}.fd-list--byline .fd-list__byline-right--critical{color:var(--sapCriticalTextColor)}.fd-list--byline .fd-list__byline-right--negative{color:var(--sapNegativeTextColor)}.fd-list--byline .fd-list__byline-right--informative{color:var(--sapInformativeTextColor)}.fd-list--byline .fd-list__group-header{height:var(--sapElement_LineHeight);max-height:var(--sapElement_LineHeight);min-height:var(--sapElement_LineHeight)}.fd-list--byline.fd-list--unread-indicator .fd-list__item{padding-inline:2.125rem 1rem}.fd-list--byline[class*=-compact] .fd-list__title,.fd-list--byline[class*=-condensed] .fd-list__title,[class*=-compact] .fd-list--byline:not([class*=-cozy]) .fd-list__title,[class*=-condensed] .fd-list--byline:not([class*=-cozy]) .fd-list__title{font-size:var(--sapFontSize)}.fd-list--byline.fd-list--no-border .fd-list__item{height:100%;max-height:5rem;padding-block:.5rem}.fd-list--byline.fd-list--no-border .fd-list__item:first-child{-webkit-padding-before:.9375rem;padding-block-start:.9375rem}.fd-list--byline.fd-list--no-border .fd-list__item:last-child{-webkit-padding-after:.9375rem;padding-block-end:.9375rem}.fd-list--subline .fd-list__item{-webkit-box-orient:horizontal;-ms-flex-direction:row;flex-direction:row;gap:.75rem;-webkit-box-align:center;-ms-flex-align:center;align-items:center;min-height:4.5rem;padding-block:.5rem;padding-inline:1rem}.fd-list--subline .fd-list__content,.fd-list--subline .fd-list__item{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-direction:normal}.fd-list--subline .fd-list__content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-ms-flex-direction:column;flex-direction:column;-webkit-box-flex:1;-ms-flex:1;flex:1;gap:.25rem;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:start;-ms-flex-align:start;align-items:flex-start;overflow:hidden}.fd-list--subline .fd-list__content:after,.fd-list--subline .fd-list__content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--subline .fd-list__title{color:var(--sapList_TextColor);font-family:var(--sapFontBoldFamily)}.fd-list--subline .fd-list__subline,.fd-list--subline .fd-list__title{font-size:var(--sapFontSize);font-style:normal;line-height:normal;max-width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;width:100%}.fd-list--subline .fd-list__subline{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-weight:400;forced-color-adjust:none;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0}.fd-list--subline .fd-list__subline:after,.fd-list--subline .fd-list__subline:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--subline .fd-list__active-indicator{color:var(--sapContent_NonInteractiveIconColor)}.fd-list--subline .fd-avatar:first-child{margin-inline:0}.fd-list--message-view{--fdListNavigationIndicatorFontSize:.75rem;--fdList_Item_Height:calc(2.75rem + var(--sapList_BorderWidth));--fdList_Message_View_Item_Byline_Height:calc(3.325rem + var(--sapList_BorderWidth));--fdList_Message_View_Title_Size:var(--sapFontHeader5Size)}.fd-list--message-view .fd-list__item{height:auto}.fd-list--message-view .fd-list__item--byline{--fdList_Item_Height:var(--fdList_Message_View_Item_Byline_Height)}.fd-list--message-view .fd-list__content{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);display:-webkit-box;display:-ms-flexbox;display:flex;font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;padding-block:0;padding-inline:0;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-flex:1;-ms-flex:1 1 auto;flex:1 1 auto;overflow:hidden;pointer-events:none;text-overflow:ellipsis;white-space:nowrap}.fd-list--message-view .fd-list__content:after,.fd-list--message-view .fd-list__content:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list--message-view .fd-list__title{color:var(--sapGroup_TitleTextColor);font-family:var(--sapFontHeaderFamily);font-size:var(--fdList_Message_View_Title_Size);font-weight:var(--sapFontHeaderWeight,normal);overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.fd-list--message-view .fd-list__subtitle{-webkit-padding-before:.25rem;color:var(--sapContent_LabelColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);overflow:hidden;padding-block-start:.25rem;text-overflow:ellipsis;white-space:nowrap}.fd-list--message-view .fd-list__link{padding-block:.5rem}.fd-list--message-view .fd-list__link.is-active .fd-list__subtitle,.fd-list--message-view .fd-list__link.is-active .fd-list__title,.fd-list--message-view .fd-list__link.is-active .fd-object-status .fd-object-status__icon,.fd-list--message-view .fd-list__link:active .fd-list__subtitle,.fd-list--message-view .fd-list__link:active .fd-list__title,.fd-list--message-view .fd-list__link:active .fd-object-status .fd-object-status__icon{color:var(--sapList_Active_TextColor)}.fd-list--message-view[class*=-compact],.fd-list--message-view[class*=-condensed],[class*=-compact] .fd-list--message-view:not([class*=-cozy]),[class*=-condensed] .fd-list--message-view:not([class*=-cozy]){--fdList_Message_View_Item_Height:calc(2rem + var(--sapList_BorderWidth));--fdList_Message_View_Title_Size:var(--sapFontHeader6Size);--fdList_Message_View_Item_Byline_Height:calc(3.25rem + var(--sapList_BorderWidth))}.fd-list--navigation .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-icon-tab-bar__list .fd-list__link{gap:.25rem}.fd-list--navigation .fd-list__link{padding-inline:var(--fdList_Navigation_Link_Padding_Left,.9375rem) var(--fdList_Navigation_Link_Padding_Right,.9375rem)}.fd-list--navigation.fd-list--unread-indicator{--fdList_Navigation_Link_Padding_Left:2.125rem;--fdList_Navigation_Link_Padding_Right:.9375rem}.fd-list--navigation.fd-list--navigation-indication{--fdList_Navigation_Link_Padding_Left:.9375rem;--fdList_Navigation_Link_Padding_Right:0}.fd-list--navigation.fd-list--selection{--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:.9375rem}.fd-list--navigation.fd-list--selection .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--selection.fd-list--navigation-indication{--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:0}.fd-list--navigation.fd-list--selection.fd-list--navigation-indication .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--byline,.fd-list--navigation.fd-list--byline.fd-list--compact{--fdList_Navigation_Link_Padding_Left:1rem;--fdList_Navigation_Link_Padding_Right:1rem}.fd-list--navigation.fd-list--byline .fd-list__item--link,.fd-list--navigation.fd-list--byline.fd-list--compact .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--byline .fd-list__link,.fd-list--navigation.fd-list--byline.fd-list--compact .fd-list__link{padding-block:.9375rem}.fd-list--navigation.fd-list--byline.fd-list--compact.fd-list--unread-indicator,.fd-list--navigation.fd-list--byline.fd-list--unread-indicator{--fdList_Navigation_Link_Padding_Left:2.125rem;--fdList_Navigation_Link_Padding_Right:1rem}.fd-list--navigation.fd-list--byline.fd-list--navigation-indication{--fdList_Navigation_Link_Padding_Left:.9375rem;--fdList_Navigation_Link_Padding_Right:0}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link .fd-list__link{padding-block:.5rem}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:first-child{-webkit-padding-before:0;padding-block-start:0}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:first-child .fd-list__link{-webkit-padding-before:1rem;padding-block-start:1rem}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:first-child .fd-list__link--navigation-indicator:after{-webkit-margin-after:.5rem;margin-block-end:.5rem}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:last-child{-webkit-padding-after:0;padding-block-end:0}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:last-child .fd-list__link{-webkit-padding-after:1rem;padding-block-end:1rem}.fd-list--navigation.fd-list--byline.fd-list--no-border .fd-list__item--link:last-child .fd-list__link--navigation-indicator:after{margin-top:.25rem}.fd-list--navigation.fd-list--byline.fd-list--selection{--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--byline.fd-list--selection[class*=-compact],.fd-list--navigation.fd-list--byline.fd-list--selection[class*=-condensed],[class*=-compact] .fd-list--navigation.fd-list--byline.fd-list--selection:not([class*=-cozy]),[class*=-condensed] .fd-list--navigation.fd-list--byline.fd-list--selection:not([class*=-cozy]){--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link,.fd-list--navigation.fd-list--byline.fd-list--selection[class*=-compact] .fd-list__item--link,.fd-list--navigation.fd-list--byline.fd-list--selection[class*=-condensed] .fd-list__item--link,[class*=-compact] .fd-list--navigation.fd-list--byline.fd-list--selection:not([class*=-cozy]) .fd-list__item--link,[class*=-condensed] .fd-list--navigation.fd-list--byline.fd-list--selection:not([class*=-cozy]) .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link .fd-list__link{padding-block:.5rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:first-child{-webkit-padding-before:0;padding-block-start:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:first-child .fd-list__link{-webkit-padding-before:1rem;padding-block-start:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:first-child .fd-list__link--navigation-indicator:after{-webkit-margin-after:.5rem;margin-block-end:.5rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:last-child{-webkit-padding-after:0;padding-block-end:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:last-child .fd-list__link{-webkit-padding-after:1rem;padding-block-end:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--no-border .fd-list__item--link:last-child .fd-list__link--navigation-indicator:after{margin-top:.25rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication{--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication[class*=-compact],.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication[class*=-condensed],[class*=-compact] .fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication:not([class*=-cozy]),[class*=-condensed] .fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication:not([class*=-cozy]){--fdList_Navigation_Link_Padding_Left:2.75rem;--fdList_Navigation_Link_Padding_Right:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link .fd-list__link{padding-block:.5rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:first-child{-webkit-padding-before:0;padding-block-start:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:first-child .fd-list__link{-webkit-padding-before:1rem;padding-block-start:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:first-child .fd-list__link--navigation-indicator:after{-webkit-margin-after:.5rem;margin-block-end:.5rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:last-child{-webkit-padding-after:0;padding-block-end:0}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:last-child .fd-list__link{-webkit-padding-after:1rem;padding-block-end:1rem}.fd-list--navigation.fd-list--byline.fd-list--selection.fd-list--navigation-indication.fd-list--no-border .fd-list__item--link:last-child .fd-list__link--navigation-indicator:after{margin-top:.25rem}.fd-list--navigation.fd-list--navigation-object{--fdList_Navigation_Link_Padding_Left:1rem;--fdList_Navigation_Link_Padding_Right:1rem}.fd-list--navigation.fd-list--navigation-object .fd-list__item--link,.fd-list--navigation.fd-list--navigation-object[dir=rtl] .fd-list__item--link,[dir=rtl] .fd-list--navigation.fd-list--navigation-object .fd-list__item--link{padding-block:0;padding-inline:0}.fd-list--navigation.fd-list--navigation-object .fd-list__link{padding-block:1rem}.fd-list--navigation-indication .fd-list:after{content:\"\";min-width:1.5rem}.fd-list--navigation-indication fd-list__item.fd-list__item--link{-webkit-padding-end:0;padding-inline-end:0}.fd-list--navigation-indication fd-list__item.fd-list__item--link:after{content:none}.fd-list--navigation-indication .fd-list__link:after{content:\"\";min-width:2.5rem}.fd-list--navigation-indication .fd-list__link--navigation-indicator:after{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;color:var(--sapContent_NonInteractiveIconColor);content:\"\\e1ed\";font-family:SAP-icons;font-size:var(--fdListNavigationIndicatorFontSize,var(--sapFontLargeSize));height:100%;text-decoration:none;text-transform:none}.fd-list--navigation-indication .fd-list__link--navigation-indicator[dir=rtl]:after,[dir=rtl] .fd-list--navigation-indication .fd-list__link--navigation-indicator:after{content:\"\\e1ee\"}.fd-list--navigation-indication .fd-list__icon:last-child,.fd-list--navigation-indication .fd-list__icon[dir=rtl]:last-child,[dir=rtl] .fd-list--navigation-indication .fd-list__icon:last-child{margin-block:0;margin-inline:0}.fd-list--navigation-indication .is-navigated{-webkit-box-shadow:inset -.1875rem 0 0 0 var(--sapList_SelectionBorderColor);box-shadow:inset -.1875rem 0 0 0 var(--sapList_SelectionBorderColor)}.fd-list--navigation-indication .is-navigated[dir=rtl],[dir=rtl] .fd-list--navigation-indication .is-navigated{-webkit-box-shadow:inset .1875rem 0 0 0 var(--sapList_SelectionBorderColor);box-shadow:inset .1875rem 0 0 0 var(--sapList_SelectionBorderColor)}.fd-list--selection .fd-list__item{cursor:pointer;padding-inline:2.75rem .9375rem}.fd-list--selection .fd-list__item.is-hover,.fd-list--selection .fd-list__item:hover{--fdList_Item_Background_Color:var(--sapList_Hover_Background)}.fd-list--selection .fd-list__item.is-selected,.fd-list--selection .fd-list__item[aria-selected=true]{--fdList_Item_Background_Color:var(--sapList_SelectionBackgroundColor);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_SelectionBorderColor)}.fd-list--selection .fd-list__item.is-selected .fd-list__link,.fd-list--selection .fd-list__item[aria-selected=true] .fd-list__link{background:inherit}.fd-list--selection .fd-list__item.is-selected .fd-list__link.is-active,.fd-list--selection .fd-list__item.is-selected .fd-list__link:active,.fd-list--selection .fd-list__item[aria-selected=true] .fd-list__link.is-active,.fd-list--selection .fd-list__item[aria-selected=true] .fd-list__link:active{--fdList_Item_Background_Color:var(--sapList_Active_Background)}.fd-list--selection .fd-list__item.is-selected.is-hover,.fd-list--selection .fd-list__item.is-selected:hover,.fd-list--selection .fd-list__item[aria-selected=true].is-hover,.fd-list--selection .fd-list__item[aria-selected=true]:hover{--fdList_Item_Background_Color:var(--sapList_Hover_SelectionBackground)}.fd-list--selection .fd-list__form-item{left:0;position:absolute;top:0;z-index:5}.fd-list--selection .fd-list__form-item[dir=rtl],[dir=rtl] .fd-list--selection .fd-list__form-item{left:auto;right:0}.fd-list--selection[class*=-compact] .fd-list__form-item,.fd-list--selection[class*=-condensed] .fd-list__form-item,[class*=-compact] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item,[class*=-condensed] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item{left:.375rem}.fd-list--selection[class*=-compact] .fd-list__form-item[dir=rtl],.fd-list--selection[class*=-condensed] .fd-list__form-item[dir=rtl],[class*=-compact] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item[dir=rtl],[class*=-condensed] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item[dir=rtl],[dir=rtl] .fd-list--selection[class*=-compact] .fd-list__form-item,[dir=rtl] .fd-list--selection[class*=-condensed] .fd-list__form-item,[dir=rtl] [class*=-compact] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item,[dir=rtl] [class*=-condensed] .fd-list--selection:not([class*=-cozy]) .fd-list__form-item{left:auto;right:.375rem}.fd-list--selection.fd-list--byline .fd-list__item{padding-inline:2.75rem 1rem}.fd-list--selection.fd-list--byline .fd-list__form-item{top:.3125rem}.fd-list--selection.fd-list--byline[class*=-compact] .fd-list__item,.fd-list--selection.fd-list--byline[class*=-condensed] .fd-list__item,[class*=-compact] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__item,[class*=-condensed] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__item{padding-inline:2.75rem 1rem}.fd-list--selection.fd-list--byline[class*=-compact] .fd-list__form-item,.fd-list--selection.fd-list--byline[class*=-condensed] .fd-list__form-item,[class*=-compact] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item,[class*=-condensed] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item{left:.375rem;top:.5rem}.fd-list--selection.fd-list--byline[class*=-compact] .fd-list__form-item[dir=rtl],.fd-list--selection.fd-list--byline[class*=-condensed] .fd-list__form-item[dir=rtl],[class*=-compact] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item[dir=rtl],[class*=-condensed] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item[dir=rtl],[dir=rtl] .fd-list--selection.fd-list--byline[class*=-compact] .fd-list__form-item,[dir=rtl] .fd-list--selection.fd-list--byline[class*=-condensed] .fd-list__form-item,[dir=rtl] [class*=-compact] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item,[dir=rtl] [class*=-condensed] .fd-list--selection.fd-list--byline:not([class*=-cozy]) .fd-list__form-item{left:auto;right:.375rem}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item{padding-block:.5rem;padding-inline:2.75rem 1rem}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:first-child{-webkit-padding-before:.9375rem;padding-block-start:.9375rem}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:last-child{-webkit-padding-after:.9375rem;padding-block-end:.9375rem}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item,.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item.fd-form-item{top:0}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item label,.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item.fd-form-item label{-webkit-padding-before:.5rem;padding-block-start:.5rem}.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item label:after,.fd-list--selection.fd-list--byline.fd-list--no-border .fd-list__item:not(:first-child) .fd-list__form-item.fd-form-item label:after{top:.375rem}.fd-list--selection.fd-list--selection-row .fd-list__item{-webkit-padding-start:1rem;padding-inline-start:1rem}:root{--fdList_Item_Background_Color:var(--sapList_Background);--fdList_Item_Text_Color:var(--sapList_TextColor);--fdList_Item_Border_Color:var(--sapList_BorderColor);--fdList_Item_Text_Font_Size:var(--sapFontLargeSize);--fdList_Item_Icon_Font_Size:1.125rem;--fdList_Item_Height:var(--sapElement_LineHeight);--fdList_Status_Text_Color:var(--sapNeutralTextColor);--fdList_Message_Background_Color:var(--sapNeutralBackground)}.fd-list__item-counter{border:0;-webkit-box-sizing:border-box;box-sizing:border-box;color:var(--sapTextColor);font-family:var(--sapFontFamily);font-size:var(--sapFontSize);font-weight:400;forced-color-adjust:none;line-height:normal;margin-block:0;margin-inline:0;overflow:hidden;padding-block:0;padding-inline:0;text-overflow:ellipsis;white-space:nowrap;-webkit-margin-start:1rem;color:var(--sapContent_MarkerTextColor);margin-inline-start:1rem}.fd-list__item-counter:after,.fd-list__item-counter:before{-webkit-box-sizing:inherit;box-sizing:inherit;font-size:inherit}.fd-list{max-width:100%!important}.fd-settings__list.fd-list.fd-list--byline .fd-list__content{height:auto}.fd-list--byline .fd-list__group-header{min-height:var(--sapElement_LineHeight);height:var(--sapElement_LineHeight);max-height:var(--sapElement_LineHeight)}\n/*! Bundled license information:\n\nfundamental-styles/dist/list.css:\n  (*!\n   * Fundamental Library Styles v0.40.1\n   * Copyright (c) 2025 SAP SE or an SAP affiliate company.\n   * Licensed under Apache License 2.0 (https://github.com/SAP/fundamental-styles/blob/main/LICENSE)\n   *)\n*/\n", ".cdk-drag-dragging{z-index:15;background-color:#fff;background-color:var(--sapList_Background, #fff);opacity:.8;transition:box-shadow .2s cubic-bezier(0,0,.2,1);box-shadow:0 3px 1px -2px #0003,0 2px 2px #00000024,0 1px 5px #0000001f}.fd-replace-indicator{position:absolute;width:100%;height:100%;top:0;left:0;pointer-events:none;border-width:.125rem;border-style:solid;background-color:transparent;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor)}.fd-replace-indicator:before{content:\"\";display:block;position:absolute;width:100%;height:100%;top:0;left:0;background-color:#0854a0;background-color:var(--sapContent_DragAndDropActiveColor, #0854a0);opacity:.5}.cdk-drag{cursor:grab}.cdk-drag.cdk-drag-dragging{cursor:grabbing}.cdk-drag-dragging{outline:none;cursor:grabbing;box-shadow:0 0 0 .0625rem #00000026,0 .625rem 1.875rem #0000004d}.cdk-drag-disabled{cursor:default}.fd-dnd-placeholder{top:0;left:0;position:absolute;opacity:.3;z-index:-1}.fd-dnd-item{position:relative;cursor:grab}.fd-dnd-item.fd-dnd-on-drag{background-color:#fff;background-color:var(--sapList_Background, #fff);z-index:15;cursor:grabbing}.drop-area__line{z-index:9999;position:absolute;background:#0854a0;background:var(--sapContent_DragAndDropActiveColor, #0854a0)}.drop-area__line--vertical{top:0;height:calc(100% - .5rem);width:2px}.drop-area__line--vertical.after{right:.2rem}.drop-area__line--vertical.before{left:-.3rem}.drop-area__line--vertical:before{background-color:#fff;background-color:var(--sapList_Background, #fff);content:\"\";position:absolute;left:-.2rem;top:-.5rem;border-radius:50%;width:.5rem;height:.5rem;border-width:.125rem;border-style:solid;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor, #0854a0)}.drop-area__line--horizontal{left:0;width:100%;height:2px}.drop-area__line--horizontal.before{top:0}.drop-area__line--horizontal.after{bottom:0}.drop-area__line--horizontal:before{background-color:#fff;background-color:var(--sapList_Background, #fff);content:\"\";position:absolute;left:0;top:-.2rem;border-radius:50%;width:.5rem;height:.5rem;border-width:.125rem;border-style:solid;border-color:#0854a0;border-color:var(--sapContent_DragAndDropActiveColor, #0854a0)}.fd-dnd-list{position:relative}\n"] }]
        }], ctorParameters: () => [{ type: i1$1.KeyboardSupportService }, { type: i2.ContentDensityObserver }], propDecorators: { dropdownMode: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list--dropdown']
            }], multiInputMode: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list--multi-input']
            }], mobileMode: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list--mobile']
            }], hasMessage: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list--has-message']
            }], noBorder: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list--no-border']
            }], navigationIndicator: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list--navigation-indication']
            }], selection: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list--selection']
            }], keyboardSupport: [{
                type: Input
            }], byline: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list--byline']
            }], subline: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.fd-list--subline']
            }], unreadIndicator: [{
                type: HostBinding,
                args: ['class.fd-list--unread-indicator']
            }, {
                type: Input
            }], focusEscapeList: [{
                type: Output
            }], hasNavigation: [{
                type: HostBinding,
                args: ['class.fd-list--navigation']
            }], role: [{
                type: Input
            }], items: [{
                type: ContentChildren,
                args: [LIST_ITEM_COMPONENT]
            }], _navItems: [{
                type: ContentChildren,
                args: [ListNavigationItemComponent]
            }], _focusItems: [{
                type: ContentChildren,
                args: [ListFocusItem]
            }], _ariaRole: [{
                type: HostBinding,
                args: ['attr.role']
            }], keyDownHandler: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }] } });

const components = [
    ListComponent,
    ListItemComponent,
    ListTitleDirective,
    ListFooterDirective,
    ListGroupHeaderDirective,
    ListSecondaryDirective,
    ListIconDirective,
    ListMessageDirective,
    ListLinkDirective,
    ListBylineDirective,
    ListBylineLeftDirective,
    ListBylineRightDirective,
    ListContentDirective,
    ListThumbnailDirective,
    ListTitleTextDirective,
    ListNavigationItemComponent,
    ListNavigationItemArrowDirective,
    ListNavigationItemTextDirective,
    ListSublineDirective
];
class ListModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.2", ngImport: i0, type: ListModule, imports: [ListComponent,
            ListItemComponent,
            ListTitleDirective,
            ListFooterDirective,
            ListGroupHeaderDirective,
            ListSecondaryDirective,
            ListIconDirective,
            ListMessageDirective,
            ListLinkDirective,
            ListBylineDirective,
            ListBylineLeftDirective,
            ListBylineRightDirective,
            ListContentDirective,
            ListThumbnailDirective,
            ListTitleTextDirective,
            ListNavigationItemComponent,
            ListNavigationItemArrowDirective,
            ListNavigationItemTextDirective,
            ListSublineDirective], exports: [ListComponent,
            ListItemComponent,
            ListTitleDirective,
            ListFooterDirective,
            ListGroupHeaderDirective,
            ListSecondaryDirective,
            ListIconDirective,
            ListMessageDirective,
            ListLinkDirective,
            ListBylineDirective,
            ListBylineLeftDirective,
            ListBylineRightDirective,
            ListContentDirective,
            ListThumbnailDirective,
            ListTitleTextDirective,
            ListNavigationItemComponent,
            ListNavigationItemArrowDirective,
            ListNavigationItemTextDirective,
            ListSublineDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListModule, imports: [ListItemComponent,
            ListNavigationItemComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.2", ngImport: i0, type: ListModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [...components],
                    exports: [...components]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { FD_LIST_COMPONENT, FD_LIST_LINK_DIRECTIVE, FD_LIST_MESSAGE_DIRECTIVE, FD_LIST_UNREAD_INDICATOR, ListBylineDirective, ListBylineLeftDirective, ListBylineRightDirective, ListComponent, ListContentDirective, ListFocusItem, ListFooterDirective, ListGroupHeaderDirective, ListIconDirective, ListItemComponent, ListLinkDirective, ListMessageDirective, ListModule, ListNavigationItemArrowDirective, ListNavigationItemComponent, ListNavigationItemTextDirective, ListSecondaryDirective, ListSublineDirective, ListThumbnailDirective, ListTitleDirective, ListTitleTextDirective, _secondaryListItemTypes };
//# sourceMappingURL=fundamental-ngx-core-list.mjs.map
